C The variables co, Delq and c are dimensionless in this program, being
C divided by the critical celerity = (qo**2/g)**1.3, i.e. the cubic eq/
C  c**3-co(c)**2+.25Delq = 0 is solved.
      PARAMETER (PI=3.14159265)
      PI2=2.*PI
1     WRITE(*,*)' Give: co,Delq'
      READ(*,*) co,Delq
      IF(co.LT.1.E-5) STOP
      ARG=3.375*Delq/co**3-1.
      IF(ARG.GT.1.) THEN
      WRITE(*,*) ' ARG out of range',ARG
      GO TO 1
      ENDIF
      THETA=ACOS(ARG)
      c=co*(1.-2.*COS((THETA+PI2)/3.))/3.
      WRITE(6,100) co,Delq,c
100   FORMAT(' co=',F8.4,' Delq=',F9.3,' c=',F9.5)
      WRITE(3,110) co,Delq,c
110   FORMAT(2F8.4,F9.5)
      GO TO 1
      END
      
