C  Solved for the 3 roots from equation gq=c**2(Vo+2co-2c) for c
C with q, Yo & Vo given.  This equation applies for channel upstream
C from control and x is positive in downstream direction
      PARAMETER (PI=3.14159265)
      REAL X(3)
      PI2=2.*PI
      PI4=4.*PI
      WRITE(*,*)' Give: Yo,Vo & g'
      READ(*,*) Yo,Vo,G
      co=SQRT(G*Yo)
      VOC=VO+2.*co
      VOCH=.5*VOC
C  qmax obtained by setting argument of ACOS to 2.
      qmax=VOCH**3/(3.375*G)
1     WRITE(*,*)' Flowrate limited to',qmax,' Give q'
      READ(*,*) q
      IF(Q.LT.0.) STOP
      co3=VOCH/3.
      THETA=ACOS(6.75*G*q/VOCH**3-1.)
      X(1)=co3*(1.-2.*COS(THETA/3.))
      X(2)=co3*(1.-2.*COS((THETA+PI2)/3.))
      X(3)=co3*(1.-2.*COS((THETA+PI4)/3.))
      WRITE(6,100) Yo,Vo,co,g,q,X
100   FORMAT(' Yo=',F7.2,' Vo=',F7.2' co=',F8.3,' g=',F8.2,' q=',F8.3,
     &/,' Roots are:',/,3F10.5)
      WRITE(3,110) q,X(2),X(2)**2/G,VOC-2.*X(2)
110   FORMAT(4F9.4)
      GO TO 1
      END