C  This program numerically solve dx/dt=v-c to obtain shape of neg. Char.
C  It is similar to C2-CHAR.FOR with the exception that dq/dt is specified
C  at origin rather than dY/dt.  In addition statements have been added to
C solve for the flow variables at x=0 and other given positions.
      COMMON Yo,DQDT,VOC,C,G,V,qo
      REAL XD(10),CDD(10)
1     WRITE(*,*)' Give: Yo,Vo,dq/dt,To,DT,g'
      READ(*,*) Yo,Vo,DQDT,To,DT,G
      IF(Yo.LT.0.) STOP
      WRITE(*,*)' Give number of x position & these x''s'
      READ(*,*) N,(XD(I),I=1,N)
      Co=SQRT(G*Yo)
      DXDTo=Co+Vo
      VOC=Vo-2.*Co
      VOC2=.5*VOC
      qo=Yo*Vo
      q=qo+To*DQDT
C Solves gq=c**2(2c+Vo-2co) using CRI method
      S=VOC2**2/9.
      S3=S**3
      T=(VOC2**3-6.75*G*q)/27.
      STS=(SQRT(T*T-S3)+ABS(T))**.33333333
      C=-T/ABS(T)*(STS+S/STS)-VOC2/3.
      V=2.*C+VOC
      DXT=V-C
      X=0.
      DTS=-.01
      Y=C*C/G
      WRITE(3,100) IFIX(To),X,C,Y,V,Y*V,DXT,C,Y,V,V*Y
100   FORMAT(I7,F8.2,4F7.3,5F8.3)
      T1=To
10    T2=T1-DT
      CALL RUKUSTF(DTS,T1,T2,1.E-5,X,XXX)
      IF(X.LT.DXDTo*T2) THEN
      CALL SLOPE(T2,X,DXT)
      Y=C*C/G
      QOR=qo+T2*DQDT
      T=(VOC2**3-6.75*G*QOR)/27.
      STS=(SQRT(T*T-S3)+ABS(T))**.33333333
      COR=-T/ABS(T)*(STS+S/STS)-VOC2/3.
      YOR=COR**2/G
      VOR=2.*COR+VOC
      WRITE(3,100) IFIX(T2),X,C,Y,V,Y*V,DXT,COR,YOR,VOR,VOR*YOR
      IF(N.GT.0) THEN
      CD=COR
      DO 20 K=1,N
      IF(DXDTo*T2.LT.XD(K)) THEN
      CD=co
      ELSE
      M=0
15    F=ABS(qo-CD**2/G*(2.*CD+VOC))/ABS(DQDT)+XD(K)/(3.*CD+VOC)-T2
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      CC=CD
      CD=1.005*CD
      GO TO 15
      ENDIF
      DIF=(CD-CC)*FF/(F-FF)
      CD=CC-DIF
      IF(ABS(DIF).GT. 1.E-6 .AND. M.LT.30) GO TO 15
      IF(M.EQ.30) WRITE(*,*)' Did not converge',DIF,K,CD
      ENDIF
20    CDD(K)=CD
      WRITE(4,120)IFIX(T2),(CDD(K),CDD(K)**2/G,2.*CDD(K)+VOC,CDD(K)**2/G
     &*(2.*CDD(K)+VOC),K=1,N)
120   FORMAT(I5,40F8.3)
      ENDIF
      XO=X
      T1=T2
      GO TO 10
      ELSE
      B=(XO-X)/DT
      A=XO-B*T1
      T2=A/(DXDTo-B)
      X=DXDTo*T2
      Y=Co*Co/G
      QOR=qo+T2*DQDT
      T=(VOC2**3-6.75*G*QOR)/27.
      STS=(SQRT(T*T-S3)+ABS(T))**.33333333
      COR=-T/ABS(T)*(STS+S/STS)-VOC2/3.
      YOR=COR**2/G
      VOR=2.*COR+VOC
      WRITE(3,110) T2,X,Co,Y,Vo,Vo*Y,Vo-Co,COR,YOR,VOR,YOR*VOR
110   FORMAT(F7.2,F8.2,4F7.3,5F8.3)
      GO TO 1
      ENDIF
      END
      SUBROUTINE SLOPE(T,X,DXT)
      COMMON Yo,DQDT,VOC,C,G,V,qo
      M=0
1     F=ABS(qo-C*C/G*(2.*C+VOC))/ABS(DQDT)+X/(3.*C+VOC)-T
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      CC=C
      C=1.005*C
      GO TO 1
      ENDIF
      DIF=(C-CC)*FF/(F-FF)
      C=CC-DIF
      IF(ABS(DIF).GT. 1.E-6 .AND. M.LT.30) GO TO 1
      IF(M.EQ.30) WRITE(*,*) ' Not conve.',T,X,C,DIF
      V=2.*C+VOC
      DXT=V-C
      RETURN
      END
