      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV,
     &ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM
      READ(*,*) Q,FN,SO,B,FM,G,X(1),X(2),Y(1),Y(2)
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      GBM=SQRT(G*B/FM)
      DELT=10.
      DELX=300.
      YMAX=1.8*(Y(1)+Y(2))*FM/B
      A1=((B+FM*Y(1))*Y(1))
      A2=((B+FM*Y(2))*Y(2))
      V(1)=Q/A1
      V(2)=Q/A2
      C(1)=SQRT(G*A1/(B+FM2*Y(1)))
      C(2)=SQRT(G*A2/(B+FM2*Y(2)))
      T(1)=0.
      T(2)=0.
      SO2=2.*SO
      CALL STAGE(YMAX)
      W(1)=GBM*FNTERP(FM*Y(1)/B)
      W(2)=GBM*FNTERP(FM*Y(2)/B)
      CALL REGUL(1,2,3)
      WRITE(*,*) Va,W(3)
      END
      SUBROUTINE REGUL(IL,IR,I)
      PARAMETER (NEQS=5)
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV,
     &ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM
      NCT=0
      XX=DELX*(C(IL)+V(IL))/C(IL)/2.
      Va(1)=X(IL)+XX
      Va(2)=.5*(T(IL)+T(IR))+XX/(C(IL)+V(IL))
      Va(3)=.5*(C(IL)+C(IR))
      Va(4)=.5*(V(IL)+V(IR))
      Va(5)=.5*(Y(IL)+Y(IR))
15    CALL FUNCT(0,IL,IR,DV)
      DO 20 J=1,NEQS
20    F1(J)=F(J)
      DO 22 J=1,NEQS
      CALL FUNCT(J,IL,IR,DV)
      DO 22 J1=1,NEQS
22    D(J1,J)=(F(J1)-F1(J1))/DV
      DO 30 L=1,NEQS-1
      DO 30 M=NEQS,L+1,-1
      IF(ABS(D(M,L)).LT. 1.E-15) GO TO 30
      FAC=D(M,L)/D(L,L)
      F1(M)=F1(M)-FAC*F1(L)
      DO 28 J=L+1,NEQS
28    D(M,J)=D(M,J)-FAC*D(L,J)
30    CONTINUE
      M=NEQS
      Z(M)=F1(M)/D(M,M)
      DIF=ABS(Z(M))
      Va(NEQS)=Va(NEQS)-Z(M)
31    M1=M-1
      SUM=0.
      DO 32 J=M,NEQS
32    SUM=SUM+Z(J)*D(M1,J)
      Z(M1)=(F1(M1)-SUM)/D(M1,M1)
      M=M1
      Va(M)=Va(M)-Z(M)
      DIF=DIF+ABS(Z(M))
      IF(M.GT.1) GO TO 31
72    NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .00001) GO TO 15
      X(I)=Va(1)
      T(I)=Va(2)
      C(I)=Va(3)
      V(I)=Va(4)
      Y(I)=Va(5)
      W(I)=GBM*FNTERP(FM*Va(5)/B)
      SF(I)=(CN*Va(4)*((B+FMS*Va(5))/((B+FM*Va(5))*Va(5)))**.6666667)**2
      RETURN
      END
      SUBROUTINE FUNCT(J,IL,IR,DV)
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV,
     &ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      Va(J)=Va(J)+DV
      ENDIF
      AM=(B+FM*Va(5))*Va(5)
      F(1)=Va(1)-X(IL)-.5*(Va(2)-T(IL))*(Va(4)+Va(3)+V(IL)+C(IL))
      SFM=(CN*Va(4)*((B+FMS*Va(5))/AM)**.66666667)**2
      F(2)=Va(4)+GBM*FNTERP(FM*Va(5)/B)-V(IL)-W(IL)-.5*(Va(2)-T(IL)
     &)*(G*(SO2-SFM-SF(IL)))
      F(3)=Va(1)-X(IR)-.5*(Va(2)-T(IR))*(Va(4)-Va(3)+V(IR)-C(IR))
      F(4)=AM/(B+FM2*Va(5))-Va(3)**2/G
      F(5)=Va(4)-GBM*FNTERP(FM*Va(5)/B)-V(IR)+W(IR)-.5*(Va(2)-T(IR)
     &)*(G*(SO2-SFM-SF(IR)))
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END
      FUNCTION FNTERP(YP)
      COMMON /CSTAGE/ W(300),RDY
      FI=RDY*(YP-.01)
      II=FI
      II1=II+1
      IF(II1.GT.298) THEN
      WRITE(*,*) YP,II1
      II1=298
      II=297
      ENDIF
      FNTERP=W(II)+(FI-FLOAT(II))*(W(II1)-W(II))
      RETURN
      END
      SUBROUTINE STAGE(YMAX)
      COMMON /CSTAGE/ W(300),RDY
      FC(YP)=SQRT((1.+2.*YP)/(YP+YP*YP))
      DY=YMAX/298.
      RDY=1./DY
      DY1=DY/10.
      DYH=DY1/2.
      N=(YMAX-.01)/DY+1
      YP=.01
      RC=FC(.01)
      W(1)=.138
      DO 10 I=2,N
      SUM=0.
      DO 5 J=1,10
      YP=YP+DY1*FLOAT(J)
      RC1=FC(YP)
      SUM=SUM+DYH*(RC+RC1)
5     RC=RC1
10    W(I)=W(I-1)+SUM
      RETURN
      END

