      PARAMETER (N=200)
      REAL X[ALLOCATABLE](:),W(N+10)
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y)) 
      WRITE(*,*)' Give: Yo,Qo,d(DQ)/dt,T2,DT,g,b,m,NL,Nd,Nu'
      READ(*,*) Yo,Qo,DDQT,T2,DT,G,B,FM,NL,ND,NU
      FM2=2.*FM
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      Co=SQRT(G*Ao/(B+FM2*Yo))
      DXDTd=Vo+Co
      DXDTu=Vo-Co
      DQF=T2*DDQT
      NP=ND+NU
      ALLOCATE (X(NP))
      WRITE(*,*)' Give:',ND,' downstr. pos. &',NU,' upstr. pos'
      READ(*,*) (X(I),I=1,NP)
1     DY=(Yo-.01)/FLOAT(N-1) 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01 
      WF1=FW(Y) 
      W(1)=0. 
      DO 6 I=2,N+10
      SUM=0. 
      DO 5 J=1,10 
      WF=FW(Y+DY2*FLOAT(J)) 
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM 
6     Y=Y+DY 
      Wo=W(N)
      WRITE(2,200) Yo,Qo,Vo,Ao,Co,Wo
200   FORMAT(' Yo=',F6.3,', Qo=',F6.1,', Vo=',F6.3,', Ao=',F7.3,/,
     &', co=',F7.3,', wo=',F7.3)
      VOW=Vo-Wo 
      VOWU=Vo+Wo
      Y=.98*Yo
      DO 10 I=1,NL
      T=DT*FLOAT(I-1)
      IF(T.LE.T2) THEN
      DQ=T*DDQT
      ELSE
      DQ=DQF
      GO TO 50
      ENDIF
      DQH=.5*DQ
7     M=0
8     A=(B+FM*Y)*Y
      IM=IFIX((Y-.01)/DY)+1
      FAC=(Y-(.01+FLOAT(IM-1)*DY))/DY
      F=DQH+A*(W(IM)+FAC*(W(IM+1)-W(IM))-Wo)
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      YT=Y
      Y=1.005*Y
      GO TO 8
      ENDIF
      DIF=(Y-YT)*FF/(F-FF)
      Y=YT-DIF
      IF(ABS(DIF).GT.2.E-6 .AND. M.LT.30) GO TO 8
      IM=IFIX((Y-.01)/DY)+1
      FAC=(Y-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      Vd=WW+VOW
      Vu=VOWU-WW
      Qd=Vd*(B+FM*Y)*Y
      CC=SQRT(G*(B+FM*Y)*Y/(B+FM2*Y))
50    WRITE(2,100) IFIX(T),DQ,Y,Vd,Vu,Qd,Qd+DQ,CC,WW
100   FORMAT(I4,F8.3,3F7.3,2F7.2,F7.3,F6.2)
      IF((T+DT).GT.(T2+.001) .AND. T.LT.(T2-.001)) THEN
      DQ=DDQT*T2
      GO TO 7
      ENDIF
      WRITE(3,105) IFIX(T),DQ
      WRITE(4,105) IFIX(T),DQ
105   FORMAT(I4,F8.3,\)
      YY=Y
      DO 30 J=1,NP
      IF(J.LE.ND) THEN
      TT=X(J)/DXDTd
      IOUT=3
      ELSE
      TT=X(J)/DXDTu
      IOUT=4
      ENDIF
      IF(T.GT.TT) THEN
      M=0
15    IM=IFIX((YY-.01)/DY)+1
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      A=(B+FM*YY)*YY
      DQQ=2.*A*(Wo-WW)
      T1=DQQ/DDQT
      CC=SQRT(G*A/(B+FM2*YY))
      IF(J.LE.ND) THEN
      DELT=X(J)/(WW+VOW+CC)
      ELSE
      DELT=X(J)/(VOWU-WW-CC)
      ENDIF
      F=T1+DELT-T
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      YT=YY
      TT1=T1
      YY=1.005*YY
      GO TO 15
      ENDIF
      DIF=(YY-YT)*FF/(F-FF)
      YY=YT-DIF
      IF(ABS(DIF).GT.2.E-6 .AND. M.LT.30) GO TO 15
      IF(TT1.GT.T2) GO TO 60
      A=(B+FM*YY)*YY
      CCC=SQRT(G*A/(B+FM2*YY))
      IM=IFIX((YY-.01)/DY)+1
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      DQQ=2.*A*(Wo-WW)
      IF(J.LE.ND) THEN
      V=WW+VOW
      IOUT=3
      ELSE
      V=VOWU-WW
      IOUT=4
      ENDIF
      Q=V*A
      YYY=YY
60    WRITE(IOUT,110) YYY,V,Q,CCC,DQQ,WW
110   FORMAT(2F6.3,F7.2,F6.2,F8.3,F6.2,\)
      ELSE
      WRITE(IOUT,110) Yo,Vo,Qo,Co,0.,Wo
      ENDIF
30    CONTINUE
      IX=T*DXDTd+.5
      WRITE(3,120) IX
120   FORMAT(I6)
      IX=T*DXDTu-.5
      WRITE(4,120) IX
10    CONTINUE
      END