      LOGICAL IV[ALLOCATABLE](:)
      INTEGER*2 INDX[ALLOCATABLE](:)
      CHARACTER*3 SYMB[ALLOCATABLE](:),CH
      REAL X[ALLOCATABLE](:),F[ALLOCATABLE](:),F1[ALLOCATABLE](:),
     &D[ALLOCATABLE](:,:),VEC[ALLOCATABLE](:)
      WRITE(*,*)' Give: (1) No. of Eqs, (2) No. of variables, (3) Input
     &unit, (4) Output unit'
      READ(*,*) N,NV,IN,IOUT
      ALLOCATE (X(NV),F(N),F1(N),D(N,N),SYMB(NV),IV(NV),INDX(N),VEC(N))
      IF(IN.EQ.0 .OR. IN.EQ.5) WRITE(IN,100) NV
100   FORMAT(' Give',I3,' Lines with:',/,3X,'(1) Symbol for var.(3 Ch)',
     &/,3X,'(2) K or U for known, or unknown and',/,3X,'(3) Value')
      J=0
      DO 10 I=1,NV
      READ(IN,110) SYMB(I),CH,X(I)
110   FORMAT(A3,1X,A1,1X,F10.0)
      IF(CH.EQ.'U' .OR.  CH.EQ.'u') THEN
      IV(I)=.TRUE.
      J=J+1
      ELSE IF(CH.EQ.'K' .OR. CH.EQ.'k') THEN
      IV(I)=.FALSE.
      ELSE
      WRITE(*,*)' Error in Input for variable',I
      STOP
      ENDIF
10    CONTINUE
      IF(J.EQ.N) GO TO 12
      WRITE(*,*)' You gave',N,' eqs., but',J,' unknowns'
      STOP
12    M=0
15    CALL FUNCT(X,F)
      J=0
      DO 30 JJ=1,NV
      IF(IV(JJ)) THEN
      XX=X(JJ)
      X(JJ)=1.005*X(JJ)
      J=J+1
      CALL FUNCT(X,F1)
      DO 20 I=1,N
20    D(I,J)=(F1(I)-F(I))/(X(JJ)-XX)
      X(JJ)=XX
      ENDIF
30    CONTINUE
      CALL SOLVEQL(N,N,D,F,INDX,VEC)
      M=M+1
      SUM=0.
      J=0
      DO 40 I=1,NV
      IF(IV(I)) THEN
      J=J+1
      X(I)=X(I)-F(J)
      SUM=SUM+ABS(F(J))
      ENDIF
40    CONTINUE
      WRITE(*,*)' m=',M,' SUM=',SUM
      IF(M.LT.20 .AND. SUM.GT. .0001) GO TO 15
      WRITE(IOUT,120)(I,SYMB(I),X(I),I=1,NV)
120   FORMAT(I5,1X,A3,' =',F10.3)
      DEALLOCATE (X,F,F1,D,SYMB,IV,INDX,VEC)
      END
      SUBROUTINE FUNCT(X,F)  !  1=Y1,2=V1,3=V2,4=Wu,5=Wd,6=V3
      REAL F(7),X(13)        !  7=Y3,8=Y2,9=Vo2,10=Yo2,11=Vo1
      G2=2.*X(13)            !  12=Yo1,13=G
      F(1)=X(1)+X(2)**2/G2-X(8)-X(3)**2/G2
      F(2)=X(2)*X(1)-X(3)*X(8)
      F(3)=(X(4)+X(11))*X(12)-(X(4)+X(2))*X(1)
      F(4)=.5*X(12)**2+(X(4)+X(11))**2*X(12)/X(13)-.5*X(1)**2-(X(4)+
     &X(2))**2*X(1)/X(13)
      F(5)=(X(3)-X(5))*X(8)-(X(6)-X(5))*X(7)
      F(6)=.5*X(8)**2+(X(3)-X(5))**2*X(8)/X(13)-.5*X(7)**2-(X(6)-X(5))
     &**2*X(7)/X(13)
      F(7)=X(6)-2.*SQRT(X(13)*X(7))-X(9)+2.*SQRT(X(13)*X(10))
      RETURN
      END