      LOGICAL IV[ALLOCATABLE](:)
      INTEGER*2 INDX[ALLOCATABLE](:)
      CHARACTER*21 FMT/'(I5,1X,A3,2H =,F12.3)'/
      CHARACTER*3 SYMB[ALLOCATABLE](:),CH
      REAL X[ALLOCATABLE](:),F[ALLOCATABLE](:),F1[ALLOCATABLE](:),
     &D[ALLOCATABLE](:,:)
      WRITE(*,*)' Give: (1) No. of Eqs, (2) No. of variables, (3) Input
     &unit, (4) Output unit'
      READ(*,*) N,NV,IN,IOUT
      ALLOCATE (X(NV),F(N),F1(N),D(N,N),SYMB(NV),IV(NV),INDX(N) )
      IF(IN.EQ.0 .OR. IN.EQ.5) WRITE(IN,100) NV
100   FORMAT(' Give',I3,' Lines with:',/,3X,'(1) Symbol for var.(3 Ch)',
     &/,3X,'(2) K or U for known, or unknown and',/,3X,'(3) Value')
      J=0
      DO 10 I=1,NV
      READ(IN,110) SYMB(I),CH,X(I)
110   FORMAT(A3,1X,A1,1X,F10.0)
      IF(CH.EQ.'U' .OR.  CH.EQ.'u') THEN
      IV(I)=.TRUE.
      J=J+1
      ELSE IF(CH.EQ.'K' .OR. CH.EQ.'k') THEN
      IV(I)=.FALSE.
      ELSE
      WRITE(*,*)' Error in Input for variable',I
      STOP
      ENDIF
10    CONTINUE
      IF(J.EQ.N) GO TO 12
      WRITE(*,*)' You gave',N,' eqs., but',J,' unknowns'
      STOP
12    NCT=0
15    CALL FUNCT(X,F)
      J=0
      DO 30 JJ=1,NV
      IF(IV(JJ)) THEN
      XX=X(JJ)
      X(JJ)=1.005*X(JJ)
      J=J+1
      CALL FUNCT(X,F1)
      DO 20 I=1,N
20    D(I,J)=(F1(I)-F(I))/(X(JJ)-XX)
      X(JJ)=XX
      ENDIF
30    CONTINUE
      CALL SOLVEQ(N,1,N,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      J=0
      DO 40 I=1,NV
      IF(IV(I)) THEN
      J=J+1
      X(I)=X(I)-F(J)
      SUM=SUM+ABS(F(J))
      ENDIF
40    CONTINUE
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM
      IF(NCT.LT.20 .AND. SUM.GT. .0001) GO TO 15
      DO 50 I=1,NV
      FMT(20:20)='3'
      IF(X(I).LT. 0.1) FMT(20:20)='6'
      IF(X(I).GT. 1000.) FMT(20:20)='1'
50    WRITE(IOUT,FMT) I,SYMB(I),X(I)
      END
      SUBROUTINE FUNCT(X,F)
      LOGICAL*2 START/.TRUE./
      REAL F(8),X(25)
C  X(1)=Q2;   X(2)=Qp;  X(3)=x;  X(4)=H;  X(5)=z;  X(6)=Sf2;  X(7)=f; X(8)=fp
C  X(9)=D;   X(10)=So2; X(11)=g;X(12)=Lw;X(13)=L2; X(14)=Zw; X(15)=So1;
C X(16)=Sf1; X(17)=Y1; X(18)=Q1;X(19)=Del;X(20)=Phe;X(21)=Lp;X(22)=Dp;
C X(23)=e;   X(24)=vis;X(25)=Cd
      IF(START) THEN
      D=X(9)
      BETA=ACOS(1.-2.*X(17)/D)
      A1=.25*D**2*(BETA-COS(BETA)*SIN(BETA))
      At=.7853982*D**2
      Ap=.7853982*X(22)**2
      FM1=.5*D*(D**2/6.*SIN(BETA)**3-A1*COS(BETA))+X(18)**2/(X(11)*A1)
      FMt=.5*D*At+X(18)**2/(X(11)*At)
      dh=(FM1-FMt)/At
      START=.FALSE.
      ENDIF
      F(1)=X(1)-X(25)*.6666667*SQRT(2.*X(11))*X(12)*X(4)**1.5
      F(2)=X(5)+D+X(10)*X(13)-X(14)-X(4)-X(6)*X(13)
      F(3)=dh+X(15)*X(3)-X(5)-X(16)*X(3)
      F(4)=X(18)-X(1)-X(2)
      F(5)=X(5)+X(19)+D-X(20)-X(8)*X(21)/X(22)*(X(2)/Ap)**2/(2.*X(11))
      F(6)=X(6)-X(7)/D*(X(1)/At)**2/(2.*X(11))
      F(7)=1./SQRT(X(7))-1.14+2.*ALOG10(X(23)/D+7.34347283*X(24)*D/(X(1)
     &*SQRT(X(7))))
      F(8)=1./SQRT(X(8))-1.14+2.*ALOG10(X(23)/X(22)+7.34347283*X(24)*
     &X(22)/(X(2)*SQRT(X(8))))
      RETURN
      END      