C Solves flow in trapezoidal channel that has a circular entrance at the reservoir.
C Equations are: Critical Flow, Energy at entrance, & Energy between 2 shapes.
C Critical flow may occur only in circular entrance
      CHARACTER*2 CX(10)/'b ','m ','D ','Q ','H ','Y1','Y2','Ke','KL',
     &'Dz'/
      CHARACTER*5 CH(0:1)/'value','guess'/
      REAL F(3),F1(3),D(3,3)
      INTEGER*2 ID(12),INDX(3)
      COMMON X(12),G,G2,ICASE
1     WRITE(*,*)' Give:g, Hend & del H'
      READ(*,*) G,H2,DELH
      G2=2.*G
      DO 10 I=1,10
      WRITE(*,'(I3,2X,A2)') I,CX(I)
10    ID(I)=0
2     WRITE(*,*)' Give three numbers for 3 unknown variables'
      READ(*,*) I1,I2,I3
      IF(I1.LT.1.OR.I1.GT.12.OR.I2.LT.1.OR.I2.GT.12.OR.I3.LT.1.OR.I3.GT.
     &12) GO TO 2
      ID(I1)=1
      ID(I2)=1
      ID(I3)=1
      DO 20 I=1,10
      WRITE(*,100) CH(ID(I)),CX(I)
100   FORMAT(' Give ',A5,' for ',A2,' = ',\)
      READ(*,*) X(I)
20    CONTINUE
25    NCT=0
30    SUM=0.
      CALL FUN(F)
      I1=0
      DO 40 I=1,10
      IF(ID(I).EQ.0) GO TO 40
      XX=X(I)
      I1=I1+1
      X(I)=1.005*X(I)
      CALL FUN(F1)
      DO 35 J=1,3
35    D(J,I1)=(F1(J)-F(J))/(X(I)-XX)
      X(I)=XX
40    CONTINUE
      CALL SOLVEQ(3,1,3,D,F,1,DD,INDX)
      I1=0
      DO 50 I=1,10
      IF(ID(I).EQ.0) GO TO 50
      I1=I1+1
      SUM=SUM+ABS(F(I1))
      X(I)=X(I)-F(I1)
50    CONTINUE
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM
      IF(NCT.LT.30 .AND. SUM.GT.3.E-5) GO TO 30
      FR22=X(4)**2*(X(1)+2.*X(7)*X(2))/(G*((X(1)+X(2)*X(7))*X(7))**3)
      WRITE(3,201) X(5),X(4),X(6),X(7),FR22
201   FORMAT(F5.2,F8.2,2F8.3,F7.2)
      X(5)=X(5)+DELH
      IF(X(5).LE.H2) GO TO 25
      END
      SUBROUTINE FUN(F)
      REAL F(3)
      COMMON X(12),G,G2,ICASE
      BETA=ACOS(1.-2.*X(6)/X(3))
      A1=.25*X(3)**2*(BETA-COS(BETA)*SIN(BETA))
      A2=(X(1)+X(2)*X(7))*X(7)
      FKe=(1.+X(8))/G2
      FKL=(1.+X(9))/G2
      F(1)=X(4)**2*X(3)*SIN(BETA)-G*A1**3
      F(2)=X(5)-X(6)-FKE*(X(4)/A1)**2
      F(3)=X(6)+(X(4)/A1)**2/G2-X(7)-FKL*(X(4)/A2)**2-X(10)
      RETURN
      END