// Solves Mannings (uniform flow) and Energy simultaneously for any 2 unknowns
// See E_UN1 to solve Q & Y and method that can be used with calculator
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
float x[8],g,fke,cu;  int itype;
extern void solveq(int n,float **d,float *f,int itype,float *dd,int *indx);
void fun(float *f){float beta,a,p;
 if(itype){beta=acos(1.-2.*x[6]/x[0]);a=.25*x[0]*x[0]*(beta-cos(beta)*sin(beta));p=x[0]*beta;}
  else {a=(x[0]+x[1]*x[6])*x[6];p=x[0]+2.*x[6]*sqrt(x[1]*x[1]+1.);}
 f[0]=x[3]*x[4]*pow(p,.6666667)-cu*pow(a,1.6666667)*sqrt(x[2]);
 f[1]=x[5]-x[6]-fke*pow(x[4]/a,2.);return;} //End of fun
void main(void){char *fmt=" %c =%9.3f\n",*ch[]={"value","guess"},*cx="bmSnQHYK";
 float f[2],f1[2],xx,sum,**d,*dd; int id[8],indx[2],i,j,i1,i2,nct;
 d=(float**)malloc(2*sizeof(float*));for(i=0;i<2;i++)d[i]=(float*)malloc(2*sizeof(float));
 printf("Give: g,entrance loss C. & 0=TRAP or 1=CIRLCE\n");scanf("%f %f %d",&g,&fke,&itype);
 if(itype){stpcpy(cx[0],"D");stpcpy(cx[1]," ");} if(g>15.) cu=1.486; else cu=1.; x[7]=fke;fke=(1.+fke)/(2.*g);
L1: for(i=0;i<7;i++){if((!itype) || ((itype)&&(i != 1)))printf("%2d  %c\n",i+1,cx[i]);id[i]=0;}
 do{printf(" Give two numbers for 2 unknown variables\n"); scanf("%d %d",&i1,&i2);
  }while((i1<1)||(i1>7)||(i2<1)||(i2>7)); id[i1-1]=1;id[i2-1]=1;
 for(i=0;i<7;i++){if((!itype) || ((itype)&&(i != 1))){printf("Give %s for %c =",ch[id[i]],cx[i]);
 scanf("%f",&x[i]);}} nct=0;
do{sum=0.; fun(f); i1=-1;for(i=0;i<7;i++){if(id[i]){xx=x[i];i1++;x[i]*=1.005;fun(f1);
  for(j=0;j<2;j++) d[j][i1]=(f1[j]-f[j])/(x[i]-xx); x[i]=xx;}}
 solveq(2,d,f,1,dd,indx); i1=-1;
 for(i=0;i<7;i++){if(id[i]){sum+=fabs(f[++i1]);x[i]-=f[i1];}}
  printf("nct= %d SUM=%f\n",nct,sum);}while((++nct<30)&&(sum>1.e-5));
 printf("Solution:\n");for(i=0;i<8;i++){if((!itype) || ((itype)&&(i != 1))){
  if(i==2)stpcpy(fmt[8],"6"); else stpcpy(fmt[8],"3");printf(fmt,cx[i],x[i]);}}
 printf("Give 1 to solve another prob. (0=STOP)\n");scanf("%d",&i2); if(i2) goto L1;}