C  Solve flow from triagular grate, B is width of grate, but area is based on
C   having a trigular gutter.
C  Same as Program GRATE except it contain a DO loop to have the product of CD
C   and FA vary.
      REAL YY(1),YTT(1)
      COMMON FM,FMS,C,FN,HM,G,Q,QS1,CD,X,SO
      EQUIVALENCE (Y,YY(1))
      WRITE(6,*)'Give:IOUT,b,m,n,So,DX,g,Qb,& beg. prod. of Cd & Fac A'
      READ(5,*) IOUT,B,FM,FN,SO,DX,G,QB,CDBEG
      WRITE(6,*)' Give No. of solutions and increment to use'
      READ(5,*) NUMBER,CDINC
      DXS=1.
      IF(G.GT.30.) THEN
      C=1.486
      ELSE
      C=1.
      ENDIF
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      G8=.125*G
      G2=2.*G
C      CD=CD*SQRT(G2)*FA*B
      YC=((QB/FM)**2/G8)**.2
      WRITE(IOUT,98) YC,QB
98    FORMAT(' Critical Depth at beg. of grate =',F8.3,', Qb =',F8.2)
      WRITE(IOUT,99) B,FM,FN,So
99    FORMAT(' b=',F8.1,' m =',F8.3,' n =',F8.4,' So =',F10.6,/,
     &'       x          Y         Q        E       q*        Fr')
      BSQG2=B*SQRT(G2)
      DO 50 I=1,NUMBER
      Y=.95*YC
      A=HM*YC*YC
      WRITE(IOUT,210) CDBEG+CDINC*FLOAT(I-1)
210   FORMAT(' For product of Cd & f=',F8.4)
      CD=(CDBEG+CDINC*FLOAT(I-1))*BSQG2
      QS1=CD*SQRT(YC)
      WRITE(IOUT,100)0.,YC,QB,YC+(QB/A)**2/G2,QS1,QB/(FM*SQRT(G8*YC**5))
100   FORMAT(F10.2,5F10.3)
      X1=0.
      Q=QB
10    X=X1+DX
      CALL RUKUST(1,DXS,X1,X,1.E-4,YY,YTT)
      QS2=CD*SQRT(Y)
      QSA=.5*(QS1+QS2)
      Q=Q-QSA*DX
      A=HM*Y**2
      WRITE(IOUT,100)X,Y,Q,Y+(Q/A)**2/G2,QSA,Q/(FM*SQRT(G8*Y**5))
      QS1=QS2
      X1=X
      IF(Y.GT. .1 .AND. Q.GT.0.) GO TO 10
50    CONTINUE
      END
      SUBROUTINE SLOPE(XX,Y,DYX)
      REAL Y(1),DYX(1)
      COMMON FM,FMS,C,FN,HM,G,Q,QS1,CD,X,SO
      A=HM*Y(1)**2
      QS=CD*SQRT(Y(1))
      QQ=Q-.5*(QS1+QS)*(XX-X)
      IF(QQ.LT.0. .OR. Y(1).LT.0.) THEN
      DYX(1)=0.
      ELSE
      SF=(FN*QQ/C*((Y(1)+FMS*Y(1))/A)**.66666667/A)**2
      DYX(1)=(SO-SF+QQ*QS/(G*A**2))/(1.-QQ*QQ*(FM*Y(1))/(G*A**3))
      ENDIF
      RETURN
      END