C  The difference between this program and GUTGRTN is that it obtains all elements
C  of the Jacobian by numerical evaluations.
      PARAMETER (MG=6,ME=3*MG)
      REAL F[ALLOCATABLE](:),D[ALLOCATABLE](:,:),FF[ALLOCATABLE](:)
      INTEGER*2 INDX[ALLOCATABLE](:)
      LOGICAL DONE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,
     &DONE,IOUT,NG,JJI
      HMIN=1.E-10
      READ(2,*) NG,IOUT,TOL,ERR,FN,FM,G
      IF(NG.LE.MG) GO TO 1
      WRITE(*,*)' Program dimensioned to only',MG,' channels'
      STOP
1     NE=3*NG
      ALLOCATE(F(NE),FF(NE),D(NE,NE),INDX(NE))
      G2=2.*G
      G8=.128*G
      FMS=1.+SQRT(FM*FM+1.)
      HM=.5*FM
      DONE=.FALSE.
      CC=1.486
      IF(G.LT.20.) CC=1.
      DO 10 I=1,NG
      READ(2,*) SOO(I),FL(I),FLG(I),QS(I),DX(I),DXG(I),B,FRAC,CD(I)
      CD(I)=CD(I)*SQRT(G2)*FRAC*B
      QT(I)=FL(I)*QS(I)
      II=3*I
10    READ(2,*) X(II-2),X(II-1),X(II)
      NCT=0
20    CALL FUN(NE,F)
      DO 24 I=1,NE
      DXX=.005*X(I)
      X(I)=X(I)+DXX
      CALL FUN(NE,FF)
      DO 25 J=1,NE
25    D(J,I)=(FF(J)-F(J))/DXX
24    X(I)=X(I)-DXX
      CALL SOLVEQ(NE,1,NE,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      WRITE(*,*) F
      WRITE(*,*) 'Give factor'
      READ(*,*) FACC
      DO 40 I=1,NE
      X(I)=X(I)-F(I)*FACC
40    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,(X(I),I=1,NE)
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,(8F10.4))
      IF(NCT.LT.30 .AND. SUM.GT.ERR) GO TO 20
      WRITE(IOUT,120)
120   FORMAT(' No    Yl     Yr    Qout  (Fr)l  (Fr)r')
      DO 50 JJ=1,NG
      II=3*JJ
      IF(JJ.EQ.1) THEN
      Frr=SQRT(QT(JJ)**2*FM*X(2)/(G*(HM*X(2)**2)**3))
      Frl=0.
      ELSE
      Frr=SQRT((QT(JJ)+X(II-3))**2*FM*X(II-1)/(G*(HM*X(II-1)**2)**3))
      Frl=SQRT(X(II-3)**2*FM*X(II-2)/(G*(HM*X(II-2)**2)**3))
      ENDIF
50    WRITE(IOUT,151) JJ,X(II-2),X(II-1),X(II),Frl,Frr
151   FORMAT(I3,5F7.3)
      DONE=.TRUE.
      CALL FUN(NE,F)
      DEALLOCATE(F,FF,D,INDX)
      END
      SUBROUTINE FUN(NE,F)
      PARAMETER (MG=6,ME=3*MG)
      LOGICAL DONE
      EXTERNAL DYX,DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(NE)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,
     &DONE,IOUT,NG,JJI
      IF(DONE) WRITE(IOUT,100)
100   FORMAT(/,'       x          Y         Q        E          A       
     & Fr       q*',/,1X,69('-'))
      DO 60 J=1,NG
      JJI=J
      I=3*J
      SO=SOO(J)
      H1=.1
      XX=0.
      Y(1)=X(I-2)
      IF(DONE) THEN
      WRITE(IOUT,111) J
111   FORMAT(' Gutter-Grate #',I3)
      A=HM*Y(1)**2
      IF(J.EQ.1) THEN
      Q=0.
      ELSE
      Q=X(I-3)
      ENDIF
      WRITE(IOUT,110) XX,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*Y(1)
     &**5))
      ENDIF
      FLM=FL(J)-1.E-6
10    XZ=XX+DX(J)
      IF(XZ.GT.FL(J)) XZ=FL(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*XZ
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*Y(1)
     &**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT.FLM) GO TO 10
      F(I-2)=X(I-1)-Y(1)
      H1=.002
      XX=0.
      Y(1)=X(I-1)
      SQSTAR=0.
      QS1=CD(J)*SQRT(Y(1))
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XX,Y(1),Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*
     &Y(1)**5)),QS1
      ENDIF
      FLM=FLG(J)-1.E-6
30    XZ=XX+DXG(J)
      IF(XZ.GT.FLG(J)) XZ=FLG(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      QS2=CD(J)*SQRT(Y(1))
      SQSTAR=SQSTAR+.5*(XZ-XX)*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*FL(J)-SQSTAR
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*Y(1)
     &**5)),QS2
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.FLM) GO TO 30
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      IF(J.LT.NG) THEN
      F(I-1)=X(I+1)-Y(1)
      F(I)=Q-X(I)-SQSTAR
      ELSE
      F(I-1)=X(I)-Y(1)
      F(I)=Q-SQSTAR
      ENDIF
60    CONTINUE
      RETURN
      END
      SUBROUTINE DYX(XP,Y,DY)
      PARAMETER (MG=6,ME=3*MG)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,
     &DONE,IOUT,NG,JJI
      YY=ABS(Y(1))
      A=HM*YY**2
      Q=QS(JJI)*XP
      IF(JJI.GT.1) Q=Q+X(3*(JJI-1))
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      IF(FR2.GT. .95) FR2=.95
      DY(1)=(SO-SF-2.*Q*QS(JJI)/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      PARAMETER (MG=6,ME=3*MG)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,
     &DONE,IOUT,NG,JJI
      YY=Y(1)
      QS2=CD(JJI)*SQRT(YY)
      A=HM*YY**2
      Q=QS(JJI)*FL(JJI)-SQSTAR-.5*(XP-XX)*(QS1+QS2)
      IF(JJI.GT.1) Q=Q+X(3*(JJI-1))
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END