C Solves the problem of side flow into a triangular gutter.
      INTEGER*2 INDX(4)
      LOGICAL DONE,UP
      REAL F(4),D(4,4),FFF(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,B,G,G2,FM2,FL,DX,TOL,
     &DONE,UP,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,b,m,L,g,DX,q*'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B,FM,FL,G,DX,QS
      DONE=.FALSE.
      FMS=2.*SQRT(FM*FM+1.)
      FM2=2.*FM
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) X(4)
      QE=QS*X(4)
      QE2=QE*QE
      YC=((QE/B)**2/G)**.3333333
      NCT=0
1     FC=QE2*(B+FM2*YC)-G*((B+FM*YC)*YC)**3
      DF=FM2*QE2-3.*G*((B+FM*YC)*YC)**2*(B+FM2*YC)
      DIF=FC/DF
      YC=YC-DIF
      NCT=NCT+1
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 1
      IF(NCT.EQ.30) WRITE(*,*)' Critical depth failed. DIF=',DIF
      X(1)=YC
      QE=QS*(FL-X(4))
      QE2=QE*QE
      NCT=0
      YC=((QE/B)**2/G)**.3333333
2     FC=QE2*(B+FM2*YC)-G*((B+FM*YC)*YC)**3
      DF=FM2*QE2-3.*G*((B+FM*YC)*YC)**2*(B+FM2*YC)
      DIF=FC/DF
      YC=YC-DIF
      NCT=NCT+1
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 2
      IF(NCT.EQ.30) WRITE(*,*)' Critical depth failed. DIF=',DIF
      X(2)=YC
      X(3)=X(1)+X(2)
      WRITE(*,*)' Guesses for x',X
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,4
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,4
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,4
20    SUM=SUM+ABS(F(I))
      WRITE(*,*)' Give Mult. factor  SUM=',SUM,' F=',F
      READ(*,*) FAC
      DO 21 I=1,4
21    X(I)=X(I)-FAC*F(I)
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,4F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(3,100) X
100   FORMAT(' Yc1=',F8.3,', Yc2=',F8.3,', Depth at Q=0',F8.3,' Xs=',
     &F8.1)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE,UP
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,B,G,G2,FM2,FL,DX,TOL,
     &DONE,UP,IOUT
      F(1)=(B+FM2*X(1))*(QS*X(4))**2-G*((B+FM*X(1))*X(1))**3
      F(2)=(B+FM2*X(2))*(QS*(FL-X(4)))**2-G*((B+FM*X(2))*X(2))**3
      HMIN=.001
      UP=.TRUE.
      IF(DONE) THEN
      A=(B+FM*X(1))*X(1)
      Q=QS*X(4)
      WRITE(IOUT,100) 0.,X(1),Q,X(1)+(Q/A)**2/G2,A,SQRT(Q*Q*(B+FM2*X(1))
     &/(G*A**3))
      ENDIF
100   FORMAT('       x          Y         Q        E        A        Fr'
     &,/,1X,57('-'),/,F10.1,5F10.3)
      H1=.1
      XX=0.
      Y(1)=1.1*X(1)
10    XZ=XX+DX
      IF(XZ.GT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=(B+FM*Y(1))*Y(1)
      Q=QS*(X(4)-XZ)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,SQRT(Q*Q*(B+FM2*Y(1))
     &/(G*A**3))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT. X(4)) GO TO 10
      F(3)=X(3)-Y(1)
      H1=-.1
      IF(DONE) THEN
      A=(B+FM*X(2))*X(2)
      Q=QS*(FL-X(4))
      WRITE(IOUT,100) FL,X(2),Q,X(2)+(Q/A)**2/G2,A,SQRT(Q*Q*(B+FM2*X(2))
     &/(G*A**3))
      ENDIF
      UP=.FALSE.
      XX=FL
      Y(1)=1.1*X(2)
20    XZ=XX-DX
      IF(XZ.LT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=(B+FM*Y(1))*Y(1)
      Q=QS*(XZ-X(4))
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,SQRT(Q*Q*(B+FM2*X(1))
     &/(G*A**3))
      ENDIF
      XX=XZ
      IF(XZ.GT. X(4)) GO TO 20
      F(4)=X(3)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE,UP
      REAL Y(1),DY(1)
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,B,G,G2,FM2,FL,DX,TOL,
     &DONE,UP,IOUT
      A=(B+FM*Y(1))*Y(1)
      Q=QS*(XX-X(4))
      SF=FN*Q/CC*((B+FMS*Y(1))/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*(B+FM2*Y(1))/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END