C  Unknowns: X(1)=Q,X(2)=Y1,X(3)=Y2,X(4)=q1,X(5)=q2 & X(6)=q3
      EXTERNAL DYX
      COMMON /TRAN/ X(6),BB,FMB,SOB,BE,FME,FN,AG1,AG2,AG3,DB,DM,DSO,G,G2
     &,FL,H,YG1,YG2,YG3,BG1,BG2,BG3,FKE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      REAL D(6,6),F(6),F1(6),Y(1),DY(1),XP(1),YP(1,1),WK1(1,13)
      INTEGER*2 INDX(6)
      WRITE(*,*)' Give:L,n,H,g,Ke,Kl,bb,mb,Sob,be,me,Soe,bg1,bg2,bg3,Cc,
     &Yg1,Yg2,Yg3'
      READ(*,*) FL,FN,H,G,FKE,FKL,BB,FMB,SOB,BE,FME,SOE,BG1,BG2,BG3,CC,
     &YG1,YG2,YG3
      YG1=CC*YG1
      YG2=CC*YG2
      YG3=CC*YG3
      G2=2.*G
      FKE=(1.+FKE)/G2
      FKL=(1.+FKL)/G2
      IF(G.GT.12.) FN=FN/1.486
      AG1=FKL/YG1**2
      AG2=FKL/YG2**2
      AG3=FKL/YG3**2
      DB=(BE-BB)/FL
      DM=(FME-FMB)/FL
      DSO=(SOE-SOB)/FL
      WRITE(*,*)' Give guesses for Q,Y1 & Y2'
      READ(*,*) (X(I),I=1,3)
      SUM=BG1*YG1+BG2*YG2+BG3*YG3
      X(4)=X(1)*YG1/SUM
      X(5)=X(1)*YG2/SUM
      X(6)=X(1)*YG3/SUM
C  Newton Method
      NCT=0
10    SUM=0.
      CALL FUNCT(F1)
      DO 20 I=1,6
      XX=X(I)
      DV=.005*XX
      X(I)=XX+DV
      CALL FUNCT(F)
      DO 15 J=1,6
15    D(J,I)=(F(J)-F1(J))/DV
20    X(I)=XX
      CALL SOLVEQ(6,1,6,D,F1,1,DD,INDX)
      DO 30 I=1,6
      X(I)=X(I)-F1(I)
30    SUM=SUM+ABS(F1(I))
      NCT=NCT+1
      IF(NCT.LT.20 .AND. SUM.GT. 0.0001) GO TO 10
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',SUM
      WRITE(3,100) X
100   FORMAT(' Solution:',/,' Q=',F8.2,/,' Y1=',F8.3,/,' Y2=',F8.3,/,
     &' q1=',F8.3,/,' q2=',F8.3,/,' q3=',F8.3)
      WRITE(*,100) X
      WRITE(*,*)' Give No. of Increments'
      READ(*,*) NX
      DELX=FL/FLOAT(NX-1)
      WRITE(3,190) 
190   FORMAT(1X,49('-'),/,'    x      b        m        So       Y      
     & V',/1X,49('-'))
      WRITE(3,200) FL,BE,FME,SOE,X(3),X(1)/((BE+FME*X(3))*X(3))
      XX=FL
      H1=-.01
      HMIN=1.E-6
      Y(1)=X(3)
      DO 50 I=2,NX
      XX1=XX-DELX
      CALL ODESOL(Y,DY,1,XX,XX1,1.E-6,H1,HMIN,1,XP,YP,WK1,DYX)
      B=BB+XX1*DB
      FM=FMB+XX1*DM
      SO=SOB+XX1*DSO
      WRITE(3,200) XX1,B,FM,SO,Y(1),X(1)/((B+FM*Y(1))*Y(1))
200   FORMAT(F7.1,2F8.3,F10.6,2F8.3)
50    XX=XX1
      END
      SUBROUTINE FUNCT(F)
      EXTERNAL DYX
      REAL F(6),Y(1),DY(1),XP(1),YP(1,1),WK1(1,13)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAN/ X(6),BB,FMB,SOB,BE,FME,FN,AG1,AG2,AG3,DB,DM,DSO,G,G2
     &,FL,H,YG1,YG2,YG3,BG1,BG2,BG3,FKE
      H1=-.01
      HMIN=1.E-6
      F(1)=H-X(2)-FKE*(X(1)/((BB+FMB*X(2))*X(2)))**2
      E3=X(3)+(X(1)/((BE+FME*X(3))*X(3)))**2/G2
      F(2)=E3-YG1-AG1*X(4)**2
      F(3)=E3-YG2-AG2*X(5)**2
      F(4)=E3-YG3-AG3*X(6)**2
      F(5)=X(1)-BG1*X(4)-BG2*X(5)-BG3*X(6)
      Y(1)=X(3)
      CALL ODESOL(Y,DY,1,FL,0.,1.E-6,H1,HMIN,1,XP,YP,WK1,DYX)
      F(6)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAN/ X(6),BB,FMB,SOB,BE,FME,FN,AG1,AG2,AG3,DB,DM,DSO,G,G2
     &,FL,H,YG1,YG2,YG3,BG1,BG2,BG3,FKE
      YY=ABS(Y(1))
      B=BB+XX*DB
      FM=FMB+XX*DM
      SO=SOB+XX*DSO
      A=(B+FM*YY)*YY
      SF=(FN*X(1)*((B+2.*SQRT(FM**2+1.)*YY)/A)**.6666667/A)**2
      FR2=X(1)**2*(B+2.*FM*YY)/(G*A**3)
      DY(1)=(SO-SF)/(1.-FR2)
      RETURN
      END      