C Inflow/outflow not allowed, but change in diameter is specified by dD/dx
      REAL Y(1),DY(1),XP(1),YP(1,1),WK1(1,13)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON/TRAS/ DB,XBEG,Q,SO,Q2,DDDX,Cu,FNQ
      WRITE(6,*)' If centerline concentric give 1, otherwise 0'
      READ(5,*) ICENTERL
1     WRITE(6,* )'GIVE IOUT,TOL,DELX,YB,Q,FN,SO,D,XBEG,XEND,g,dD/dx'
      READ(5,*) IOUT,TOL,DELX,YB,Q,FN,SO,D,XBEG,XEND,G,DDDX
      IF(IOUT.LT.0) STOP
      IF(ICENTERL.EQ.1) SO=SO+DDDX/2.
      DB=D
      H1=.01
      HMIN=1.E-5
      Y(1)=YB
      IF(G.GT. 25.) THEN
      Cu=1.486
      ELSE
      Cu=1.
      ENDIF
      G2=2.*G
      FNQ=FN*Q/Cu
      Q2=Q*Q/G
      X=XBEG
      D2=D/2.
      D6=D*D/6.
      COSB=1.-2.*Y(1)/D
      SINB=SQRT(1.-COSB*COSB)
      BETA=ACOS(COSB)
      A=.25*D*D*(BETA-COSB*SINB)
      FMOM=D2*(D6*SINB**3-A*COSB)+Q2/A
      E=Y(1)+(Q/A)**2/G2
      WRITE(IOUT,100) X,Y,BETA,A,E,FMOM,Q/A,SQRT(Q2*D*SIN(BETA)/A**3),D
2     XZ=X+DELX
      CALL ODESOL(Y,DY,1,X,XZ,TOL,H1,HMIN,1,XP,YP,WK1,DYX)
      X=XZ
      D=DB+(X-XBEG)*DDDX
      D2=D/2.
      D6=D*D/6.
      COSB=1.-2.*Y(1)/D
      SINB=SQRT(1.-COSB*COSB)
      BETA=ACOS(COSB)
      A=.25*D*D*(BETA-COSB*SINB)
      FMOM=D2*(D6*SINB**3-A*COSB)+Q2/A
      E=Y(1)+(Q/A)**2/G2
      WRITE(IOUT,100) X,Y,BETA,A,E,FMOM,Q/A,SQRT(Q2*D*SIN(BETA)/A**3),D
100   FORMAT(F8.1,2F9.3,F9.2,F8.3,F9.2,3F8.2)
      IF(DELX .LT. 0.) GO TO 8
      IF(X .LT. XEND) GO TO 2
      GO TO 1
8     IF(X .GT. XEND) GO TO 2
      END
      SUBROUTINE DYX(X,Y,DY)
      REAL Y(1),DY(1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON/TRAS/ DB,XBEG,Q,SO,Q2,DDDX,Cu,FNQ
      D=DB+(X-XBEG)*DDDX
      COSB=1.-2.*Y(1)/D
      SINB=SQRT(1.-COSB*COSB)
      BETA=ACOS(COSB)
      A=.25*D*D*(BETA-COSB*SINB)
      T=D*SINB
      P=D*BETA
      SF=(FNQ/(A/P)**.66666667/A)**2
      A3=A**3
      FR2=Q2*T/A3
      CAREA=Q2/A**3*DDDX*((BETA-SINB*COSB)*.5*D-Y(1)*SINB)
40    DY(1)=(SO-SF+CAREA)/(1.-FR2)
      RETURN
      END
