      REAL YPRIME(1),Y(1),XP(1),YP(1,1),WK1(1,13)
      EXTERNAL DYX 
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAV 
      COMMON /TRAN/ ChC,G,XO,BO,FMO,e,SO,Q,DB,DM,SFMQ,QSTA,QO,G2,UQ,
     &SQRG,G32,VIS
      WRITE(6,*)' Give kinematic viscosity'
      READ(5,*) VIS
1     WRITE(6,* )'GIVE IOUT,TOL,DELX,YB,QO,e,SO,BO,FMO,B2,FM2,XBEG,XEND 
     *,g,NPRT,QSTA,UQ,L'
      READ(5,*)IOUT,TOL,DELX,YB,QO,e,SO,BO,FMO,B2,FM2,XBEG,XEND,G,NPRT,
     *QSTA,UQ,FL
      IF(IOUT.LT.1) STOP
      SQRG=SQRT(G)
      VIS=VIS/4.
      e=e/12.
      G32=-SQRT(32.*G)
5     NCT=0
      G2=2.*G
      DB=(B2-BO)/FL
      DM=(FM2-FMO)/FL
      Y(1)=YB 
      H1=-.01 
      HMIN=.0001
      IF(DELX.LT. 0.) H1=-.01
      XO=XBEG 
      ADELX5=ABS(.5*DELX)
      SFMQ=2.*SQRT(FM*FM+1.)
      X=XBEG 
      B=BO+DB*X 
      FM=FMO+DM*X 
      AREA=(B+FM*Y(1))*Y(1)
      Q=QO+X*QSTA
      SM=(.5*B+FM*Y(1)/3.)*Y(1)*Y(1)+Q**2/(G*AREA)
      Ener=Y(1)+(Q/AREA)**2/G2
      WRITE(IOUT,110) UQ
110   FORMAT('Uq =',F6.2,/,5X,70('-'),/,
     &12X,'x       Y         Q        E         M         Fr       C',/
     &,5X,70('-'))
      FR=SQRT(Q*Q*(B+2.*FM*Y(1))/(G*AREA**3))
      WRITE(IOUT,100) X,Y,Q,Ener,SM,FR
2     XZ=X+DELX 
      CALL ODESOL(Y,YPRIME,1,X,XZ,TOL,H1,HMIN,1,XP,YP,WK1,DYX)
      XO=XZ 
      X=XZ
      B=BO+DB*X 
      FM=FMO+DM*X 
      AREA=(B+FM*Y(1))*Y(1)
      Q=QO+X*QSTA
      SM=(.5*B+FM*Y(1)/3.)*Y(1)*Y(1)+Q**2/(G*AREA)
      Ener=Y(1)+(Q/AREA)**2/G2
      NCT=NCT+1
      IF(MOD(NCT,NPRT).EQ.0) THEN
      FR=SQRT(Q*Q*(B+2.*FM*Y(1))/(G*AREA**3))
      WRITE(IOUT,100) X,Y,Q,Ener,SM,FR,ChC
      ENDIF
100   FORMAT(6X,F8.1,5F10.3,F10.2) 
      IF(DELX .LT. 0.) GO TO 8 
      IF(X .LT. XEND) GO TO 2 
      GO TO 99 
8     IF(X .GT. XEND) GO TO 2 
99    WRITE(*,*)' Give: 0=stop,1=new Uq, or 2=new problem'
      READ(*,*) INEW
      IF(INEW.EQ.0) STOP
      IF(INEW.EQ.1) THEN
      WRITE(*,*) 'Give neq Uq'
      READ(*,*) UQ
      GO TO 5
      ENDIF
      GO TO 1 
      END 
      SUBROUTINE DYX(X,Y,YPRIME) 
      REAL Y(1),YPRIME(1) 
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAV 
      COMMON /TRAN/ ChC,G,XO,BO,FMO,e,SO,Q,DB,DM,SFMQ,QSTA,QO,G2,UQ,
     &SQRG,G32,VIS
      B=BO+DB*X 
      FM=FMO+DM*X 
      A=(B+FM*Y(1))*Y(1) 
      P=B+SFMQ*Y(1)
      Q=QO+X*QSTA
      Re=Q/(VIS*P)
      IF(Re.LT.100.) THEN
      ChC=20.
      ELSEIF(Re.LT.2100.) THEN
      ChC=SQRT(G*Re/8.)
      ELSE
      C1=G32*ALOG10(e*P/A)
      NCT=0
21    ChC=G32*ALOG10(ABS(e*P/A+.884*C1/(Re*SQRG)))
      NCT=NCT+1
      IF(ABS(ChC-C1).LT. .0001 .OR. NCT.GT.30) GO TO 22
      C1=ChC
      GO TO 21
      ENDIF
22    A3=A**3
      SF=Q*Q*P/(ChC*ChC*A3)
      A2=A*A*G 
      FR2=Q*Q*(B+2.*FM*Y(1))/(A*A2) 
      DA=Y(1)*(DB+Y(1)*DM)
      FQ=(Q/A-UQ)*QSTA/(G*A)+(.5*B+FM*Y(1)/3.)*Y(1)**2/A**2*DA
      YPRIME(1)=(SO-SF-Q*QSTA/A2+Q*Q/(A*A2)*DA-FQ)/(1.-FR2) 
      RETURN 
      END