      PARAMETER (ERR=1.E-4,NMAX=20)
      EXTERNAL DXY
      COMMON Q,B,FM,e,SO,g,Q2G,FMS,FM2,SQG,QV4,SG,C
      WRITE(*,*)' Give:Q,b,m,e,VISC,So,Ybeg,Yend,XBeg,g,N,IOUT'
      READ(*,*) Q,B,FM,e,VISC,SO,YBEG,YEND,XBEG,g,N,IOUT
      e=e/12.
      FMS=2.*SQRT(FM*FM+1.)
      SG=SQRT(G)
      SQG=-SQRT(32.*G)
      QV4=4.*Q/VISC
      A=(B+FM*YBEG)*YBEG
      C=SQG*ALOG10(e/(A/(B+FMS*YBEG)))
      DY=(YEND-YBEG)/FLOAT(N)
      FM2=2.*FM
      Q2G=Q**2/g
      WRITE(IOUT,110)
110   FORMAT(5X,'Y',9X,'x',9X,'E',9X,'M',/,1X,40('-'))
      WRITE(IOUT,100) YBEG,XBEG,YBEG+(Q/A)**2/(2.*g),(.5*B+FM*YBEG/3.)*
     &YBEG**2+Q2G/A
      X=XBEG
      Y1=YBEG
      DO 10 I=1,N
      Y=YBEG+FLOAT(I)*DY
      CALL SIMPR(DXY,Y1,Y,VALUE,ERR,NMAX)
      X=X+VALUE
      A=(B+FM*Y)*Y
      WRITE(IOUT,100) Y,X,Y+(Q/A)**2/(2.*g),(.5*B+FM*Y/3.)*Y**2+Q2G/A
100   FORMAT(F10.3,F10.1,2F10.3)
10    Y1=Y
      END
      FUNCTION DXY(Y)
      COMMON Q,B,FM,e,SO,g,Q2G,FMS,FM2,SQG,QV4,SG,C
      A=(B+FM*Y)*Y
      P=B+FMS*Y
      Rh=A/P
1     C1=C
      C=SQG*ALOG10(e/Rh+.884*C/(SG*QV4/P))
      IF(ABS(C-C1).GT. 1.E-5) GO TO 1
      SF=(Q/(C*A))**2/Rh
      DXY=(1.-Q2G*(B+FM2*Y)/A**3)/(SO-SF)
      RETURN
      END 