      PARAMETER (ERR=1.E-4,NMAX=20)
      EXTERNAL DXY
      COMMON Q,D,FN,SO,g,Q2G,QN,D4
      WRITE(*,*)' Give:Q,D,n,So,Ybeg,Yend,XBeg,g,N,IOUT'
      READ(*,*) Q,D,FN,SO,YBEG,YEND,XBEG,g,N,IOUT
      DY=(YEND-YBEG)/FLOAT(N)
      D4=.25*D*D
      D34=D**3/24.
      Cu=1.486
      IF(g.LT.30.) Cu=1.
      Q2G=Q**2/g
      QN=FN*Q/Cu
      COSB=1.-2.*YBEG/D
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=D4*(BETA-COSB*SINB)
      FMOM=D34*(3.*SINB-SINB**3-3.*BETA*COSB)+Q2G/A
      WRITE(IOUT,100) YBEG,XBEG,YBEG+(Q/A)**2/(2.*g),FMOM
      X=XBEG
      Y1=YBEG
      DO 10 I=1,N
      Y=YBEG+FLOAT(I)*DY
      CALL SIMPR(DXY,Y1,Y,VALUE,ERR,NMAX)
      X=X+VALUE
      COSB=1.-2.*Y/D
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=D4*(BETA-COSB*SINB)
      FMOM=D34*(3.*SINB-SINB**3-3.*BETA*COSB)+Q2G/A
      WRITE(IOUT,100) Y,X,Y+(Q/A)**2/(2.*g),FMOM
100   FORMAT(F10.3,F10.1,2F10.3)
10    Y1=Y
      END
      FUNCTION DXY(Y)
      COMMON Q,D,FN,SO,g,Q2G,QN,D4
      BETA=ACOS(1.-2.*Y/D)
      A=D4*(BETA-COS(BETA)*SIN(BETA))
      SF=(QN*(BETA*D/A)**.6666667/A)**2
      DXY=(1.-Q2G*D*SIN(BETA)/A**3)/(SO-SF)
      RETURN
      END 