      PARAMETER (ND=4,EPS=1.E-6) 
      REAL m 
      COMPLEX C(ND+1),ROOTS(ND),AD(ND+1),Z1,Z2,Z3 
      EPS1=2.*EPS*EPS 
10    WRITE(6,*)' Give: b,m,Q,g & Y or one of conjugate depths'
      READ(5,*) b,m,Q,G,Y 
300   QP=(Q/b)**2*(m/b)**3/G
301   YP=m*Y/b 
      C(5)=CMPLX(1.,0.) 
      C(4)=CMPLX(2.5+YP,0.) 
      YP1=YP*(YP+1.) 
      C(3)=CMPLX(YP1+1.5*(YP+1.),0.) 
      C(2)=CMPLX(YP1+.5*YP-3.*QP/YP1,0.) 
      C(1)=CMPLX(-3.*QP/YP,0.) 
      DO 20 J=1,ND+1 
20    AD(J)=C(J) 
      DO 30 J=ND,1,-1 
      Z1=CMPLX(0.,0.) 
      CALL LAGU(AD,J,Z1,EPS) 
      IF(ABS(AIMAG(Z1)).LE.EPS1*ABS(REAL(Z1))) Z1=CMPLX(REAL(Z1),0.) 
      ROOTS(J)=Z1 
      Z2=AD(J+1) 
      DO 30 JJ=J,1,-1 
      Z3=AD(JJ) 
      AD(JJ)=Z2 
30    Z2=Z1*Z2+Z3 
      DO 50 J=2,ND 
      Z1=ROOTS(J) 
      DO 40 I=J-1,1,-1 
      IF(REAL(ROOTS(I)).LE.REAL(Z1)) GO TO 50 
40    ROOTS(I+1)=ROOTS(I) 
      I=0 
50    ROOTS(I+1)=Z1 
      DO 60 I=1,4 
      IF(AIMAG(ROOTS(I)).NE. 0.) GO TO 60 
      IF(REAL(ROOTS(I)).LT. 0.) GO TO 60 
      YP=REAL(ROOTS(I)) 
60    WRITE(6,70) ROOTS(I) 
70    FORMAT(2F12.4) 
      WRITE(3,310) IFIX(Q),Y,YP*b/m,(ROOTS(I),I=1,4)
310   FORMAT(I4,F5.2,F7.3,4(1X,2F8.3))
      WRITE(6,80) Y,YP*b/m 
80    FORMAT(' Conjugate depth to',F10.3,' equals ',F10.3,//) 
      WRITE(6,*)' Give 1 if to solve another problem, otherwise 0' 
      READ(5,*) I 
      IF(I.EQ.2) THEN
      WRITE(*,*)' Give new depth'
      READ(*,*) Y
      GO TO 301
      ENDIF
      IF(I.EQ.3) THEN
      WRITE(*,*)' Give new Q and Y'
      READ(*,*) Q,Y
      GO TO 300
      ENDIF
      IF(I.EQ.1) GO TO 10 
      STOP 
      END 
      SUBROUTINE LAGU(C,ND,Z1,EPS) 
      COMPLEX C(ND+1),Z1,DX,ZO,Z2,Z3,Z4,Z5,DZ,SS,Z6,Z7,Z8,ZERO,XX,FF 
      ZERO=CMPLX(0.,0.) 
      DO 20 ITER=1,50 
      Z2=C(ND+1) 
      Z3=ZERO 
      Z4=ZERO 
      DO 10 J=ND,1,-1 
      Z4=Z1*Z4+Z3 
      Z3=Z1*Z3+Z2 
10    Z2=Z1*Z2+C(J) 
      IF(CABS(Z2).LE.1.E-8) THEN 
      DX=ZERO 
      ELSE IF(CABS(Z3).LE.1.E-8.AND.CABS(Z4).LE.1.E-8) THEN 
      DX=CMPLX(CABS(Z2/C(ND+1))**(1./FLOAT(ND)),0.) 
      ELSE 
      Z5=Z3/Z2 
      Z8=Z5*Z5 
      DZ=Z8-2.*Z4/Z2 
      XX=(ND-1)*(ND*DZ-Z8) 
      YY=ABS(REAL(XX)) 
      ZZ=ABS(AIMAG(XX)) 
      IF(YY.LT.1.E-12 .AND. ZZ .LT.1.E-12) THEN 
      SS=ZERO 
      ELSE IF (YY.GE.ZZ) THEN 
      FF=(1./YY)*XX 
      SS=SQRT(YY)*CSQRT(FF) 
      ELSE 
      FF=(1./ZZ)*XX 
      SS=SQRT(ZZ)*CSQRT(FF) 
      ENDIF 
      Z6=Z5+SS 
      Z7=Z5-SS 
      IF(CABS(Z6).LT.CABS(Z7)) Z6=Z7 
      DX=FLOAT(ND)/Z6 
      ENDIF 
      ZO=Z1-DX 
      IF(Z1.EQ.ZO) RETURN 
      Z1=ZO 
      IF(CABS(DX).LE.EPS*CABS(Z1)) RETURN 
20    CONTINUE 
      WRITE(6,*)' FAILED TO CONVERGE' 
      RETURN 
      END


