      EXTERNAL DYX,FUN 
      REAL QRAT(7)/.9,.8,.7,.6,.5,.4,.3/
     &,QQ(12 )/1.,2.,3.,4.,5.,6.,7.,8.,9.,10.,11.,12./
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAV 
      COMMON /TRAN/CDG,HW,G,XO,B,FN,SO,Q,QS1,DELX,ADELX5,YB,TOL,YC,
     &QSTART,QB,IOUT
      DATA B,G,FN,SO,TOL,CD,ERR,MAX,IOUT/2.,9.81,.016,.0005,1.E-5,.45,
     &.05,15,3/
      CDG=.666667*CD*SQRT(2.*G) 
      YB=1.
      SSO=SQRT(SO)/FN
      DO 30 J=1,7
      ERR=1.2*ERR
      XBEG=1.5*XBEG0
      WRITE(*,*)' Give XBEG',XBEG
      READ(*,*) XBEG
      IF(XBEG.LT.0.) STOP
      WRITE(IOUT,110) QRAT(J)
      DELX=-XBEG/10.
      DO 20 I=1,12
      ADELX5=.5*DELX
      QSTART=QQ(I)
      YC=((QSTART/B)**2/G)**.33333333
      AC=B*YC
      SC=(FN*QSTART)**2*(B+2.*YC)**1.333333/AC**3.3333333
      HW=1.1*(YC-((G*AC*AC*(SC-SO))/(CDG*QSTART))**.6666667)
      QB=QSTART*QRAT(J)
C Mannings Eq.
      NCT=0
1     F=QB-SSO*(B*YB)**1.666667/(B+2.*YB)**.6666667
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) THEN
      DIF=.05*FF/(F-FF)
      ELSE
      FF=F
      YB=YB+.05
      GO TO 1
      ENDIF
      YB=YB-.05-DIF
      IF(NCT.LT.20 .AND. ABS(DIF).GT.1.E-5) GO TO 1
      WRITE(*,120) HW,YB,QB
120   FORMAT(3F12.5)
      QS1=CDG*(YB-HW)**1.5
C Newton Method
      FL=XBEG
      NCT=0
10    FF=FUN(FL)
      DIF=FF/(FUN(FL+1.)-FF)
      FL=FL-DIF
      NCT=NCT+1
      X=FL
c      DELX=-ABS(FL)/10.
      IF(NCT.LT.MAX .AND. ABS(DIF).GT.ERR) GO TO 10
      IF(NCT.EQ.MAX) WRITE(*,*)' Did not converge',DIF
      IF(I.EQ.1) XBEG0=FL
      WRITE(IOUT,110) QSTART,FL
      XBEG=.85*ABS(FL)
20    DELX=-XBEG/10.
110   FORMAT(2F10.2)
30    CONTINUE
      END 
      SUBROUTINE DYX(X,Y,YPRIME) 
      REAL Y(1),YPRIME(1) 
      COMMON /TRAN/CDG,HW,G,XO,B,FN,SO,QO,QS1,DELX,ADELX5,YB,TOL,YC,
     &QSTART,QB,IOUT
      A=B*Y(1) 
      P=B+2.*Y(1) 
      IF(Y(1).LT.YC) Y(1)=1.05*YC
      QS=CDG*(Y(1)-HW)**1.5
      Q=QO-.5*(X-XO)*(QS1+QS) 
      SF=(FN*Q*ABS(P/A)**.66666667/A)**2 
      A2=A*A*G 
      FR2=1.-Q*Q*B/(A*A2)
      IF(FR2.LT. .01) FR2=.2
      YPRIME(1)=(SO-SF+Q*QS/A2)/FR2 
      RETURN 
      END
      FUNCTION FUN(XX)
      EXTERNAL DYX
      REAL Y(1),XP(1),YP(1,1),WK1(1,13),YPRIME(1) 
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAV 
      COMMON /TRAN/CDG,HW,G,XO,B,FN,SO,Q,QS1,DELX,ADELX5,YB,TOL,YC,
     &QSTART,QB,IOUT
      H1=.01
      Q=QB
      XO=XX
      X=XX
      Y(1)=YB
2     XZ=X+DELX 
      IF(XZ.LT. 0.) XZ=0.
      CALL ODESOL(Y,YPRIME,1,X,XZ,TOL,H1,0.,1,XP,YP,WK1,DYX)
      IF(Y(1).LT.YC) Y(1)=1.05*YC
      QS2=CDG*(Y(1)-HW)**1.5
      XO=XZ 
      Q=Q-ADELX5*(QS1+QS2) 
      QS1=QS2  
      X=XZ 
5     IF(X .GT. 0.) GO TO 2 
99    FUN=QSTART-Q
      RETURN
      END