C This program modifies NAT-REG so that it uses cubic splines and a numerical 
C integration by SIMPR to obtain the cross-sectional data, i.e. give A and P
C as a function of the depth Y.
      CHARACTER *1 C(6,7)/'Y','Q','n','S',' ',' ','Y','Q','E','K',' ',
     &' ','Y','Q','M',' ',' ',' ','Y','Q',' ',' ',' ',' ','Y','E',' ',
     &' ',' ',' ','Y','Q','H','K','n','S','Y','Q','H','K',' ',' '/,
     &CI(0:5)/'0','1','2','3','4','5'/
      CHARACTER*4 PR(7)/'UNIF','ENER','MOME','CRIT','CRI2','E+UN',
     &'E+CR'/
      CHARACTER TX*11,FMT1*18/"(1X,A1,' =',F10.2)"/,T1*11/' 1 number  '/
      INTEGER*2 JU(2),NON(7)/4,4,3,2,2,6,4/
      REAL JAC(2,2),FF(2),FJ(2)
      LOGICAL*2 IFN
      COMMON /TRAS/ V(6),Y(26),A(26),P(26),T(26),EN1,ES1,g2,F,F1,TT,PP,
     &g,EN2,ES2,Cu,DY2,DIA,B,FM,N2,IY,ICASE,ITYPE
      N2=25
      IY=13
      EN1=.66666667
      ES1=.5
      EN2=2.*EN1
      ES2=2.*ES1
      WRITE(*,*)' Are ES = 1, or SI=2 units used (Give 1 or 2) & IOUT'
      READ(*,*) IU,IOUT
      Cu=1.486
      g=32.2
      IF(IU.EQ.2) THEN
      g=9.81
      Cu=1.
      ENDIF
      g2=2.*G
1     WRITE(*,*)' Give: 1,2 or 3 for type of channel; 1=natural, 2=trap.
     &, 3=circle'
      READ(*,*) ITYPE
      IF(ITYPE.EQ.1) THEN
      CALL CHTABLSP
      ELSE IF (ITYPE.EQ.3) THEN
      WRITE(*,*)' Give its diameter'
      READ(*,*) DIA
      ELSE
      WRITE(*,*)' Give its bottom width b, and side slope m'
      READ(*,*) B,FM
      ENDIF
5     WRITE(*,*)' Give the number for the type of Problem'
      DO 10 I=1,7
10    WRITE(*,"(I3,' ',A4)") I,PR(I)
      READ(*,*) ICASE
      TX=T1
      IF(ICASE.GT.5) TX=' 2 numbers '
      WRITE(*,"(' Give',A11,'for the unkn')") TX
      DO 20 I=1,NON(ICASE)
20    WRITE(*,"(I3,'  ',A1)") I,C(I,ICASE)
      IF(ICASE.GT.5) THEN
      READ(*,*) JU
      ELSE
      READ(*,*) IU
      ENDIF
      WRITE(*,*)' Provide values for known plus guess for unknown'
      DO 30 I=1,NON(ICASE)
      WRITE(*,"(1X,A1,' = ',\)") C(I,ICASE)
30    READ(*,*) V(I)
      NCT=0
      IF(ICASE.LT.6) THEN
40    IFN=.TRUE.
      DD=.002*V(IU)
41    CALL EQS(FF)
      IF(IFN) THEN
      F1=F
      V(IU)=V(IU)+DD
      IFN=.FALSE.
      GO TO 41
      ENDIF
      DIF=DD*F1/(F-F1)
      NCT=NCT+1
      V(IU)=V(IU)-DD-DIF
      IF(ABS(DIF).GT. .005 .AND. NCT.LT.15) GO TO 40
      IF(NCT.EQ.15) WRITE(*,*)' Failed to converge',DIF
      ELSE
C  Solves 2 equations
42    CALL EQS(FJ)
      DO 44 I=1,2
      DD=.005*V(JU(I))
      V(JU(I))=V(JU(I))+DD
      CALL EQS(FF)
      DO 43 J=1,2
43    JAC(J,I)=(FF(J)-FJ(J))/DD
44    V(JU(I))=V(JU(I))-DD
      XX=JAC(2,1)/JAC(1,1)
      JAC(2,2)=JAC(2,2)-XX*JAC(1,2)
      FJ(2)=FJ(2)-XX*FJ(1)
      F1=FJ(2)/JAC(2,2)
      V(JU(2))=V(JU(2))-F1
      F=(FJ(1)-F1*JAC(1,2))/JAC(1,1)
      V(JU(1))=V(JU(1))-F
      NCT=NCT+1
      IF(ABS(F1)+ABS(F).GT. .05 .AND. NCT.LT.15) GO TO 42
      IF(NCT.EQ.15) WRITE(*,*)' Failed to converge',F1,F
      ENDIF
      IF(IOUT.NE.6) WRITE(IOUT,*)' Solution:'
      WRITE(*,*)' Solution:'
      DO 50 I=1,NON(ICASE)
      II=5-IFIX(ALOG10(ABS(V(I)+.1)))
      IF(II.LT.0) II=0
      IF(II.GT.5) II=5
      FMT1(17:17)=CI(II)
      IF(IOUT.NE.6) WRITE(IOUT,FMT1) C(I,ICASE),V(I)
50    WRITE(*,FMT1) C(I,ICASE),V(I)
      CALL AREA(AA)
      WRITE(*,100) AA,PP,TT
100   FORMAT(' A =',F10.2,/' P =',F10.2,/' T =',F10.2)
      IF(ICASE.EQ. 4 .OR. ICASE.EQ.5) GO TO 60
      VEL=V(2)/AA
      WRITE(*,101) VEL,V(1)+VEL**2/G2,VEL*SQRT(TT/(G*AA))
101   FORMAT(' V =',F10.2,/' E =',F10.2,/' Fr =',F9.2)
      IF(IOUT.NE.6) WRITE(IOUT,101) VEL,V(1)+VEL**2/G2,VEL*SQRT(TT/
     &(G*AA))
60    WRITE(*,*)' Give: 0-stop,1-another problem same channel,2-dif. c.'
      READ(*,*) II
      IF(II.LT.1 .OR. II.GT. 2) STOP
      IF(II.EQ.1) GO TO 5
      GO TO 1
      END
      SUBROUTINE EQS(FF)
      COMMON /TRAS/ V(6),Y(26),A(26),P(26),T(26),EN1,ES1,g2,F,F1,TT,PP,
     &g,EN2,ES2,Cu,DY2,DIA,B,FM,N2,IY,ICASE,ITYPE
      REAL FF(2)
      CALL AREA(AA)
      GO TO (1,2,3,4,5,6,7),ICASE
1     F=V(3)*V(2)-Cu*AA*(AA/PP)**EN1*V(4)**ES1
      RETURN
2     F=V(3)-V(1)-(1.+V(4))*(V(2)/AA)**2/g2
      RETURN
3     F=V(3)-V(2)**2/(g*AA)-Ahcn(V(1)-DY2,AA)
      RETURN
4     F=g*AA-TT*(V(2)/AA)**2
      RETURN
5     F=V(2)-V(1)-AA/(2.*TT)
      RETURN
6     FF(1)=V(3)-V(1)-(1.+V(4))*(V(2)/AA)**2/g2
      FF(2)=V(5)*V(2)-Cu*(AA/PP)**EN1*AA*V(6)**ES1
      RETURN
7     FF(1)=V(3)-V(1)-(1.+V(4))*(V(2)/AA)**2/g2
      FF(2)=g*AA-TT*(V(2)/AA)**2
      RETURN
      END
      SUBROUTINE AREA(AA)
      COMMON /TRAS/ V(6),Y(26),A(26),P(26),T(26),EN1,ES1,g2,F,F1,TT,PP,
     &g,EN2,ES2,Cu,DY2,DIA,B,FM,N2,IY,ICASE,ITYPE
      YY=V(1)
      IF(ITYPE.EQ.1) THEN
      DO 10 WHILE (YY.GT.Y(IY+1) .AND. IY.LE.N2)
10    IY=IY+1
      DO 20 WHILE (YY.LT.Y(IY+1) .AND. IY.GT.2)
20    IY=IY-1
      IM=IY-1
      IP=IY+1
      FAC=(YY-Y(IY))/(Y(IP)-Y(IY))
      TT=T(IY)+FAC*(T(IP)-T(IY))
      PP=P(IY)+FAC*(P(IP)-P(IY))
      IF(IY.EQ.1) THEN
      AA=A(IY)+FAC*(A(IP)-A(IY))
      ELSE
      AA=(YY-Y(IY))*(YY-Y(IP))*A(IM)/((Y(IM)-Y(IY))*(Y(IM)-Y(IP)))
     &+(YY-Y(IM))*(YY-Y(IP))*A(IY)/((Y(IY)-Y(IM))*(Y(IY)-Y(IP)))
     &+(YY-Y(IM))*(YY-Y(IY))*A(IP)/((Y(IP)-Y(IM))*(Y(IP)-Y(IY)))
      ENDIF
      ELSE IF(ITYPE.EQ.3) THEN
      BETA=ACOS(1.-2.*YY/DIA)
      TT=DIA*SIN(BETA)
      PP=BETA*DIA
      AA=.25*DIA**2*(BETA-COS(BETA)*SIN(BETA))
      ELSE
      TT=B+2.*FM*YY
      PP=B+2.*SQRT(FM*FM+1.)*YY
      AA=(B+FM*YY)*YY
      ENDIF
      RETURN
      END
      SUBROUTINE CHTABLSP
      PARAMETER (NN=15)
      EXTERNAL EQUAT, EQUAT1
      REAL X(20),Z(20),DD(NN)
      COMMON /TRAS/ V(6),Y(26),AR(26),P(26),T(26),EN1,ES1,g2,F,F1,TT,PP,
     &g,EN2,ES2,Cu,DY2,DIA,B,FM,N2,IY,ICASE,ITYPE
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &NR,NL,IR,IR1,IL,IL1
      N=26
      READ(3,*) NVALUE,IOUT
      IF(NVALUE.GT.20) THEN
      WRITE(*,100)
100   FORMAT(' Program dimension to allow only 20 coordinate pairs')
      STOP
      ENDIF
      READ(3,*)(X(I),Z(I),I=1,NVALUE)
      ZSTA=Z(1)
      IMIN=1
      YMAX=ZSTA
      DO 10 I=2,NVALUE
      IF(Z(I).GE.ZSTA) GO TO 5
      ZSTA=Z(I)
      IMIN=I
5     IF(Z(I).GT.YMAX) YMAX=Z(I)
10    CONTINUE
      IF(Z(IMIN+1).LT.ZSTA+1.E-5) THEN
      T(1)=X(IMIN+1)-X(IMIN)
      P(1)=T(1)
      IR1=IMIN+1
      ELSE
      T(1)=0.
      P(1)=0.
      IR1=IMIN
      ENDIF
      AA=0.
      PP=P(1)
      AR(1)=0.
      Y(1)=0.
      NR=0
      DO 12 I=IR1,NVALUE
      NR=NR+1
      XR(NR)=X(I)
12    YR(NR)=Z(I)
      CALL SPLINESU(NR,YR,XR,D2XR,DD,0)
      NL=0
      DO 14 I=IMIN,1,-1
      NL=NL+1
      XL(NL)=X(I)
14    YL(NL)=Z(I)
      CALL SPLINESU(NL,YL,XL,D2XL,DD,0)
      IR=1
      IR1=2
      IL=1
      IL1=2
      DYY=(YMAX-ZSTA)/FLOAT(N-1)
      Y1=ZSTA
      DO 40 I=2,N
      YY=DYY*FLOAT(I-1)+ZSTA
      Y(I)=YY-ZSTA
41    IF(YY.LE.YR(IR) .OR. IR1.EQ.NR) GO TO 42
      IR=IR1
      IR1=IR1+1
      GO TO 41
42    IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 43
      IR1=IR
      IR=IR-1
      GO TO 42
43    DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
44    IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 45
      IL=IL1
      IL1=IL1+1
      GO TO 44
45    IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 46
      IL1=IL
      IL=IL-1
      GO TO 45
46    DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      T(I)=XXR-XXL
      CALL SIMPR(EQUAT,Y1,YY,AA,1.E-4,11)
      AR(I)=AR(I-1)+AA
      CALL SIMPR(EQUAT1,Y1,YY,PP,1.E-4,11)
      P(I)=P(I-1)+PP
40    Y1=YY
      WRITE(IOUT,300)
300   FORMAT(' No.    Depth      Area Perimeter   Top Width')
      DO 50 I=1,N
50    WRITE(IOUT,311) I,Y(I),AR(I),P(I),T(I)
311   FORMAT(I4,5F10.3)
      RETURN
      END
      FUNCTION EQUAT(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &NR,NL,IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      EQUAT=XXR-XXL
      RETURN
      END
      FUNCTION EQUAT1(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &NR,NL,IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      DX=XR(IR1)-XR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XR(IR)-(3.*B*B-1.)*D2XR(IR1))*DY/6.
      EQUAT1=SQRT(Z**2+1.)
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      DX=XL(IL1)-XL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XL(IL)-(3.*B*B-1.)*D2XL(IL1))*DY/6.
      EQUAT1=EQUAT1+SQRT(Z**2+1.)
      RETURN
      END
      FUNCTION Ahcn(YY,AA)
      COMMON /TRAS/ V(6),Y(26),A(26),P(26),T(26),EN1,ES1,g2,F,F1,TT,PP,
     &g,EN2,ES2,Cu,DY2,DIA,B,FM,N2,IY,ICASE,ITYPE
      IF(ITYPE.EQ.2) THEN
      Ahcn=(.5*B+FM*YY/3.)*YY**2
      ELSE IF(ITYPE.EQ.3) THEN
      COSB=1.-2.*YY/DIA
      BETA=ACOS(COSB)
      Ahcn=.5*DIA*(DIA**2/6.*SIN(BETA)**3-AA*COSB)
      ELSE
      AASS=0.
      A1=0.
      DO 10 K=1,IY
      AASS=AASS+(YY-Y(K))*(A(K)-A1)
10    A1=A(K)
      Ahcn=AASS+(V(1)-(V(1)-Y(IY))/2.)*(AA-A1)
      ENDIF
      RETURN
      END
