      INTEGER*2 INDX(3)
      REAL F1(3),F2(3),DD(3,3)
      COMMON X(3),FMOM1,A1,V1,B,B2,FM,FM3,H,G2,G,AD,FK
      WRITE(*,*)' Give: H,b,m,n,So,K,Yg1,DelYg,Cc,g,N'
      READ(*,*) H,B,FM,FN,SO,FK,YG1,DELYG,CC,G,N
      FMS=2.*SQRT(FM*FM+1.)
      B2=.5*B
      FM3=FM/3.
      Cu=1.486
      IF(G.LT.20.) Cu=1.
      G2=2.*G
      FSO=Cu/FN*SQRT(SO)
C  Solves initial steady state
      YD=CC*YG1
      AD=(B+FM*YD)*YD
      FAC=FK/(G2*AD**2)
      Y1=3.*YG1
      NCT=0
1     A1=(B+FM*Y1)*Y1
      Q=FSO*A1*(A1/(B+FMS*Y1))**.6666667
      F=Y1+(Q/A1)**2/G2+FAC*Q**2-H
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 2
      YY=Y1
      FF=F
      Y1=1.005*Y1
      GO TO 1
2     DIF=(Y1-YY)*FF/(F-FF)
      Y1=YY-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.40) GO TO 1
      IF(NCT.EQ.40) WRITE(*,*)' Did not converge'
      A1=(B+FM*Y1)*Y1
      Q=FSO*A1*(A1/(B+FMS*Y1))**.6666667
      WRITE(3,100) Y1,Q
100   FORMAT(' Initial Steady-State Depth =',F8.3,' Q =',F10.3,/,
     &'  Yg     Yd      Y        Q         v        A       Ad',/
     &,1X,57('-'))
      FMOM1=(B2+FM3*Y1)*Y1**2
      V1=Q/A1
      X(1)=1.1*Y1
      X(2)=3.*(Q/A1)
      X(3)=1.1*Q
      DO 20 I=1,N
      NCT=0
      YG=YG1+FLOAT(I)*DELYG
      YD=Cc*YG
      AD=(B+FM*YD)*YD
4     CALL FUN(F1)
      DO 8 J=1,3
      XX=X(J)
      X(J)=1.005*X(J)
      CALL FUN(F2)
      DO 5 K=1,3
5     DD(K,J)=(F2(K)-F1(K))/(X(J)-XX)
8     X(J)=XX
      CALL SOLVEQ(3,1,3,DD,F1,1,DET,INDX)
      SUM=0.
      DO 10 J=1,3
      X(J)=X(J)-F1(J)
10    SUM=SUM+ABS(F1(J))
      NCT=NCT+1
      IF(SUM.GT.1.E-5 .AND. NCT.LT.20) GO TO 4
      IF(NCT.EQ.20) WRITE(*,*)' Did not converge for I=',I
      AA=(B+FM*X(1))*X(1)
20    WRITE(3,110) YG,YD,X,AA,AD
110   FORMAT(F5.2,F7.2,3F9.3,2F9.2)
      END
      SUBROUTINE FUN(F)
      REAL F(3)
      COMMON X(3),FMOM1,A1,V1,B,B2,FM,FM3,H,G2,G,AD,FK
      A=(B+FM*X(1))*X(1)
      V=X(2)/A
      F(1)=H-FK*(X(2)/AD)**2/G2-X(1)-V**2/G2
      F(2)=(X(3)-V)*A-(X(3)-V1)*A1
      F(3)=(B2+FM3*X(1))*X(1)**2+(X(3)-V)**2*A/G-FMOM1-(X(3)-V1)**2*A1/G
      RETURN
      END