      INTEGER*2 INDX(6)
      REAL F(6),FF(6),D(6,6)
      COMMON B1,FM1,e1,SO1,FMS1,B2,FM2,e2,SO2,FMS2,G,G2,SG,SQG,X(6)
      WRITE(*,*)' Give kinematic viscosity'
      READ(*,*) VIS
      WRITE(*,*)'Give:b1,m1,e1,So1,b2,m2,e2,So2,g & guess:Q,Y1,Y2,Y3,C1,
     &C2'
      READ(*,*) B1,FM1,e1,SO1,B2,FM2,e2,SO2,G,X
      G2=2.*G
      e1=e1/12.
      e2=e2/12.
      SG=SQRT(32.*G)
      SQG=.221*VIS/SQRT(G)
      FMS1=2.*SQRT(FM1**2+1.)
2     FMS2=2.*SQRT(FM2**2+1.)
      M=0
4     CALL FUN(F)
      DO 8 I=1,6
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN(FF)
      DO 6 J=1,6
6     D(J,I)=(FF(J)-F(J))/(X(I)-XX)
8     X(I)=XX
      CALL SOLVEQ(6,1,6,D,F,1,DD,INDX)
      M=M+1
      SUM=0.
      DO 10 I=1,6
      X(I)=X(I)-F(I)
10    SUM=SUM+ABS(F(I))
      IF(SUM.GT.1.E-6 .AND. M.LT.30) GO TO 4
      Q2G=X(1)**2/G
      FR1=SQRT(Q2G*(B1+2.*FM1*X(2))/((B1+FM1*X(2))*X(2))**3)
      FR2=SQRT(Q2G*(B2+2.*FM2*X(3))/((B2+FM2*X(3))*X(3))**3)
      FR3=SQRT(Q2G*(B2+2.*FM2*X(4))/((B2+FM2*X(4))*X(4))**3)
      WRITE(3,100) FM2,X,FR1,FR2,FR3
100   FORMAT(F7.4,F9.2,3F8.3,5F8.2)
      WRITE(*,*)' Give new value for m2 (Neg=STOP) & FAC'
      READ(*,*) FM2,FAC
      IF(FM2.LT.0.) STOP
      IF(FAC.LT.0.) THEN
      WRITE(*,*)' Give guesses for: Q,Y1,Y2,Y3,C1,C2'
      READ(*,*) X
      ELSE
      DO 20 I=1,6
20    X(I)=FAC*X(I)
      ENDIF
      GO TO 2
      END
      SUBROUTINE FUN(F)
      REAL F(6)
      COMMON B1,FM1,e1,SO1,FMS1,B2,FM2,e2,SO2,FMS2,G,G2,SG,SQG,X(6)
      A1=(B1+FM1*X(2))*X(2)
      P1=B1+X(2)*FMS1
      A2=(B2+FM2*X(3))*X(3)
      A3=(B2+FM2*X(4))*X(4)
      P3=B2+X(4)*FMS2
      F(1)=X(1)-X(5)*A1*SQRT(SO1*A1/P1)
      F(2)=X(2)+(X(1)/A1)**2/G2-X(3)-(X(1)/A2)**2/G2
      F(3)=.5*B2*X(3)**2+FM2*X(3)**3/3.-.5*B2*X(4)**2-FM2*X(4)**3/3.+
     &X(1)**2/G*(1./A2-1./A3)
      F(4)=X(1)-X(6)*A3*SQRT(SO2*A3/P3)
      F(5)=X(5)+SG*ALOG10(e1*P1/A1+SQG*X(5)*P1/X(1))
      F(6)=X(6)+SG*ALOG10(e2*P3/A3+SQG*X(6)*P3/X(1))
      RETURN
      END