      PARAMETER (NC=6,NP=5,NU=24)
      REAL F(24),FF(24),DJ(24,24)
      INTEGER*2 INDX(24)
      COMMON X(24),B(6),FM(6),FM2(6),FMS(6),FL(6),SO(6),SOS(6),D(5),PL(5
     &),AP(5),ED(5),FRI(5),WS,Yd4,ELEV,QJe,QJ1,QJ2,QJ3,PI4,H4,FNC,H,FKe,
     &FKL,FKP,G,G2,SO5,BB,FMM,FMMS,SOO,FNQ,QG2,TWOM,VIS
      WRITE(*,*)' Give input & output unit nos.'
      READ(*,*) IN,IOUT
      PI4=.78539816
      ERR=1.E-4
      IF(IN.EQ.5) WRITE(*,*)' Give:G,VISC,ELEV,H,WS,Yd4,Ke,KL,Kp,QJe,QJ1
     &,QJ2,QJ3,H4'
      READ(IN,*) G,VIS,ELEV,H,WS,Yd4,FKe,FKL,FKP,QJe,QJ1,QJ2,QJ3,H4
      G2=2.*G
      VIS=7.3434728*VIS
      FKe=FKe+1.
      FKL=FKL+1.
      FNC=.013/1.486
      IF(IN.EQ.5) WRITE(*,*)' For',NC,' Channels give: b,m,L,So'
      DO 10 I=1,NC
      READ(IN,*) B(I),FM(I),FL(I),SO(I)
      FM2(I)=2.*FM(I)
      SOS(I)=SQRT(SO(I))
10    FMS(I)=2.*SQRT(FM(I)**2+1.)
      SO5=SOS(5)
      EP=.0025
      IF(IN.EQ.5) WRITE(*,*)' For',NP,' Pipes give: D & L'
      DO 20 I=1,NP
      READ(IN,*) D(I),PL(I)
      ED(I)=EP/D(I)
      FRI(I)=8.
      D(I)=D(I)/12.
20    AP(I)=PI4*D(I)**2
      IF(IN.EQ.5)WRITE(*,*)' Give guesses for',NU,' Unknowns:Q1 .. Q11'
      IF(IN.EQ.5)WRITE(*,*)' Y11,Y12,Y21,Y31,Y32,Y41,Y42,Y5,Y61,Y62,H1,H
     &2,H3'
      READ(IN,*) X
      NCT=0
30    SUM=0.
40    CALL FUN(F)
      DO 50 J=1,NU
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(FF)
      DO 45 I=1,NU
45    DJ(I,J)=(FF(I)-F(I))/DX
50    X(J)=X(J)-DX
      CALL SOLVEQ(NU,1,NU,DJ,F,1,DD,INDX)
      DO 60 I=1,NU
      X(I)=X(I)-F(I)
60    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,110) NCT,SUM
110   FORMAT(' NCT=',I2,' SUM=',E12.5)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 30
      WRITE(IOUT,120) X
120   FORMAT(' Solution:',/' Flowrates in Channels',/,6F10.3,/,
     &' Flowrates in Pipes',/,5F10.3,/' Depths in Channels',/
     &10F8.3,/,' Nodal Heads',/,3F10.3)
      END
      SUBROUTINE FUN(F)
      REAL F(24)
      INTEGER*2 IX(6)/13,15,16,18,19,21/
      COMMON X(24),B(6),FM(6),FM2(6),FMS(6),FL(6),SO(6),SOS(6),D(5),PL(5
     &),AP(5),ED(5),FRI(5),WS,Yd4,ELEV,QJe,QJ1,QJ2,QJ3,PI4,H4,FNC,H,FKe,
     &FKL,FKP,G,G2,SO5,BB,FMM,FMMS,SOO,FNQ,QG2,TWOM,VIS
      F(1)=H-X(12)-FKE*(X(1)/((B(1)+FM(1)*X(12))*X(12)))**2/G2
      F(2)=X(1)-X(2)-X(3)-X(6)
      E12=X(13)+(X(1)/((B(1)+FM(1)*X(13))*X(13)))**2/G2
      F(3)=E12-X(14)-FKL*(X(2)/((B(2)+FM(2)*X(14))*X(14)))**2/G2
      F(4)=E12-X(15)-FKL*(X(3)/((B(3)+FM(3)*X(15))*X(15)))**2/G2
      F(5)=E12-X(20)-FKL*(X(6)/((B(6)+FM(6)*X(20))*X(20)))**2/G2
      F(6)=X(3)-X(4)-X(5)
      E32=X(16)+(X(3)/((B(3)+FM(3)*X(16))*X(16)))**2/G2
      F(7)=E32-X(17)-FKL*(X(4)/((B(4)+FM(4)*X(17))*X(17)))**2/G2
      F(8)=E32-X(19)-FKL*(X(5)/((B(5)+FM(5)*X(19))*X(19)))**2/G2
      DO 10 I=1,6
      IF(I.EQ.5) THEN
      F(I+8)=FNC*X(I)*(B(I)+FMS(I)*X(19))**.6666667-SO5*((B(I)+FM(I)*X(
     *19))*X(19))**1.6666667
      ELSE
      IF(I.EQ.2) THEN
      Y=WS
      ELSE
      Y=X(IX(I))
      ENDIF
      BB=B(I)
      FMM=FM(I)
      SOO=SO(I)
      FNQ=FNC*X(I)
      TWOM=2.*FM(I)
      FMMS=FMS(I)
      Q2G=X(I)**2/G
      DXS=-1.
      CALL RUKUSTF(DXS,FL(I),0.,1.E-5,Y,YT)
      F(I+8)=X(IX(I)-1)-Y
      ENDIF
10    CONTINUE
      F(15)=X(18)-Yd4+((X(4)/((B(4)+FM(4)*X(18))*X(18)))**2-(X(4)/((
     &B(4)+FM(4)*Yd4)*Yd4))**2)/G2
      F(16)=X(6)-X(7)-QJe
      F(17)=ELEV+X(21)-(FKP+Fr(1)*PL(1)/D(1))*(X(7)/AP(1))**2/G2-X(22)
      F(18)=X(22)-X(23)-Fr(2)*PL(2)/D(2)*(X(8)/AP(2))**2/G2
      F(19)=X(22)-X(24)-Fr(3)*PL(3)/D(3)*(X(9)/AP(3))**2/G2
      F(20)=X(23)-X(24)-Fr(4)*PL(4)/D(4)*(X(10)/AP(4))**2/G2
      F(21)=X(24)-H4-Fr(5)*PL(5)/D(5)*(X(11)/AP(5))**2/G2
      F(22)=X(7)-X(8)-X(9)-QJ1
      F(23)=X(8)-X(10)-QJ2
      F(24)=X(9)+X(10)-QJ3-X(11)
      RETURN
      END
      SUBROUTINE SLOPE(XX,Y,DYX)
      COMMON X(24),B(6),FM(6),FM2(6),FMS(6),FL(6),SO(6),SOS(6),D(5),PL(5
     &),AP(5),ED(5),FRI(5),WS,Yd4,ELEV,QJe,QJ1,QJ2,QJ3,PI4,H4,FNC,H,FKe,
     &FKL,FKP,G,G2,SO5,BB,FMM,FMMS,SOO,FNQ,QG2,TWOM,VIS
      A=(BB+FMM*Y)*Y
      SF=(FNQ*((BB+FMMS*Y)/A)**.66666667/A)**2
      DYX=(SOO-SF)/(1.-QG2*(BB+TWOM*Y)/A**3)
      RETURN
      END
      FUNCTION FR(I)
      COMMON X(24),B(6),FM(6),FM2(6),FMS(6),FL(6),SO(6),SOS(6),D(5),PL(5
     &),AP(5),ED(5),FRI(5),WS,Yd4,ELEV,QJe,QJ1,QJ2,QJ3,PI4,H4,FNC,H,FKe,
     &FKL,FKP,G,G2,SO5,BB,FMM,FMMS,SOO,FNQ,QG2,TWOM,VIS
      VDQ=VIS*D(I)/X(I+6)
      FRS=FRI(I)
10    FRS1=FRS
      FRS=1.14-2.*ALOG10(ED(I)+VDQ*FRS1)
      IF(ABS(FRS-FRS1).GT. 1.E-6) GO TO 10
      FRI(I)=FRS
      FR=1./(FRS*FRS)
      RETURN
      END