      DATA So/.0008/,Cu/1./,B/4./,FN/.013/,FM/1.4/,G/9.81/,D/5./
      FMS=2.*SQRT(FM*FM+1.)
      SSo=SQRT(So)*Cu
      DD=.25*D*D
1     READ(3,100,END=99) H,Y1,Y2,Q,Fr1,Fr2
100   FORMAT(F6.2,2F8.3,F8.1,2F7.2)
      BETA=ACOS(1.-2.*Y1/D)
      E1=Y1+(Q/(DD*(BETA-COS(BETA)*SIN(BETA))))**2/(2.*G)
      IF(Fr1.LT.1.) THEN
      WRITE(4,110) H,Y1,Y2,Q,Fr1,Fr2,E1
110   FORMAT(F6.2,2F8.3,F8.1,2F7.2,F8.3,' No Jump occurs')
      ELSE
      Yo=Y1
      NCT=0
2     F=FN*Q*(B+FMS*Yo)**.666667-SSo*((B+FM*Yo)*Yo)**1.666667
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 3
      FF=F
      Yo=Yo+.005
      GO TO 2
3     DIF=.005*FF/(F-FF)
      Yo=Yo-DIF-.005
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.40) GO TO 2
      IF(NCT.EQ.40) WRITE(*,*) 'Did not converge',H,DIF
      Eo=Yo+(Q/((B+FM*Yo)*Yo))**2/(2.*G)
      Sn=(FN*Q*(B+FMS*Y2)**.666667/(((B+FM*Y2)*Y2)**1.666667*CU))**2
      WRITE(4,120) H,Y1,Y2,Q,Fr1,Fr2,E1,Yo,Eo,E1-Eo,Sn
120   FORMAT(F6.2,2F8.3,F8.1,2F7.2,4F8.3,F8.6)
      ENDIF
      GO TO 1
99    STOP
      END