      PARAMETER (N=6,M=14)
      LOGICAL*2 IPERM
      REAL F(M),F1(M),D(M,M),FN(N),SO(N),L(N),B(N),FM(N),DZ(N),X(M)
      INTEGER*2 INDX(M),ITYP(N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN,SO,L,B,FM,DZ,X,G,G2,CC,TOL,PERM,TOPW,QN,Q2G,IPERM,
     &YGATE,YRES,H,ITYP,JI
      DATA IN,IOUT/2,3/
C  Program designed just to solve problem with configuration of 76.
C 1=Q1, 2=Q2, 3=Q3, 4=Q4, 5=Q5 6=Yu1, 7=Yu2,  8=Yu3,  9=Yu4,  10=Yu5, 11=Yu6,
C  12=Yd1,  13=Yd2,  14=Yd3
      READ(IN,*) (ITYP(I),B(I),FM(I),FN(I),SO(I),L(I),DZ(I),I=1,6)
      NEQS=14
      READ(IN,*) TOL,ERR,G,H,YGATE,YRES
      READ(IN,*)(X(I),I=1,NEQS) ! GUESSES (5 Q'S 1ST, then Yu next,Yd1..Yd3
      IF(G.GT. 30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      NCT=0
20    CALL FUN(F)
      DO 30 J=1,NEQS
      DX=.015*X(J)
      X(J)=X(J)+DX
      CALL FUN(F1)
      DO 25 I=1,NEQS
25    D(I,J)=(F1(I)-F(I))/DX
      X(J)=X(J)-DX
30    CONTINUE
      CALL SOLVEQ(NEQS,1,M,D,F,1,DD,INDX)
      DIF=0.
      DO 40 I=1,NEQS
      X(I)=X(I)-F(I)
40    DIF=DIF+ABS(F(I))
      NCT=NCT+1
      WRITE(*,101) NCT,DIF,(X(I),I=1,NEQS)
101   FORMAT(' NCT =',I3,' SUM =',E12.5,/(8F10.3))
      IF(NCT.LT.30 .AND. DIF.GT.ERR) GO TO 20
      WRITE(IOUT,100) 
100   FORMAT(' Solution to 6 Channel at Junction',/,1X,65('-'),/,
     &' No      b    m     n      So      L    dz     Yu     Yd       Q'
     &,/,1X,65('-'))
      DO 50 I=1,6
      Q=X(I)
      IF(I.EQ.6) Q=X(2)
      IF(I.EQ.4 .OR. I.EQ.5) THEN
      YDOW=X(11)
      ELSE IF( I.EQ.6) THEN
      YDOW=YRES
      ELSE
      YDOW=X(I+11)
      ENDIF
50    WRITE(IOUT,110) I,B(I),FM(I),FN(I),SO(I),L(I),DZ(I),X(I+5),YDOW,Q
110   FORMAT(I3,F7.2,F5.2,F6.3,F8.6,F7.0,F6.2,2F7.3,F8.2)
      END
      SUBROUTINE FUN(F)
      PARAMETER (N=6,M=14)
      EXTERNAL DYX
      LOGICAL*2 IPERM
      REAL F(M),FN(N),SO(N),L(N),B(N),FM(N),DZ(N),X(M),Y(1),DY(1),
     &W(1,13),XP(1),YP(1,1)
      INTEGER*2 ITYP(N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN,SO,L,B,FM,DZ,X,G,G2,CC,TOL,PERM,TOPW,QN,Q2G,IPERM,
     &YGATE,YRES,H,ITYP,JI
      H1=-.05
      HMIN=.0000001
      IPERM=.FALSE.
      F(1)=H-X(6)-(X(1)/AR(1,X(6)))**2/G2
      F(2)=X(1)-X(2)-X(3)
      F(3)=X(2)-X(4)-X(5)
      EN=X(12)+(X(1)/AR(1,X(12)))**2/G2
      F(4)=EN-X(7)-(X(2)/AR(2,X(7)))**2/G2
      F(5)=EN-X(8)-(X(3)/AR(3,X(8)))**2/G2
      EN=X(13)+(X(2)/AR(2,X(13)))**2/G2
      F(6)=EN-X(9)-(X(4)/AR(4,X(9)))**2/G2
      F(7)=EN-X(10)-(X(5)/AR(5,X(10)))**2/G2
      F(8)=X(14)+(X(3)/AR(3,X(14)))**2/G2-YGATE-(X(3)/AR(3,YGATE))**2/G2
      DO 20 I=1,6
      JI=I
      XX=L(I)
      XZ=0.
      IPERM=.TRUE.
      QQ=X(I)
      IF(I.EQ.6) QQ=X(2)
      IF(I.EQ.4 .OR. I.EQ.5) THEN
      Y(1)=X(11)
      ELSE IF(I.EQ.6) THEN
      Y(1)=YRES
      ELSE
      Y(1)=X(I+11)
      ENDIF
      QN=(FN(I)*QQ/CC)**2
      Q2G=QQ**2/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
20    F(I+8)=X(I+5)-Y(1)
      RETURN
      END
      FUNCTION AR(I,YY)
      PARAMETER (N=6,M=14)
      LOGICAL*2 IPERM
      REAL FN(N),SO(N),L(N),B(N),FM(N),DZ(N),X(M)
      INTEGER*2 ITYP(N)
      COMMON /TRAS/FN,SO,L,B,FM,DZ,X,G,G2,CC,TOL,PERM,TOPW,QN,Q2G,IPERM,
     &YGATE,YRES,H,ITYP,JI
      IF(ITYP(I).EQ.1) THEN
      AR=(B(I)+FM(I)*YY)*YY
      IF(IPERM) THEN
      PERM=B(I)+2.*YY*SQRT(1.+FM(I)**2)
      TOPW=B(I)+2.*FM(I)*YY
      ENDIF
      ELSE
      COSB=1.-2.*YY/B(I)
      BETA=ACOS(COSB)
      AR=.25*B(I)**2*(BETA-SIN(BETA)*COSB)
      IF(IPERM) THEN
      PERM=BETA*B(I)
      TOPW=B(I)*SIN(BETA)
      ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      PARAMETER (N=6,M=14)
      LOGICAL*2 IPERM
      REAL FN(N),SO(N),L(N),B(N),FM(N),DZ(N),X(M),Y(1),DY(1)
      INTEGER*2 ITYP(N)
      COMMON /TRAS/FN,SO,L,B,FM,DZ,X,G,G2,CC,TOL,PERM,TOPW,QN,Q2G,IPERM,
     &YGATE,YRES,H,ITYP,JI
      AA=AR(JI,Y(1))
      A3=AA**3
      SF=QN*(ABS(PERM/AA)**.666666667/AA)**2
      DY(1)=(SO(JI)-SF)/(1.-Q2G*TOPW/A3)
      RETURN
      END