      REAL F(11),F1(11),D(11,11),L(4),KL(4)
      INTEGER*2 INDX(11)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN(4),SO(4),L,B(4),FM(4),KL,X(11),H,G,G2,CC,TOL,QN,
     &Q2G,YD4,YD5,IC
      DATA IN,IOUT/2,3/
      READ(IN,*) (B(I),FM(I),FN(I),SO(I),L(I),KL(I),I=1,4)
      READ(IN,*) TOL,ERR,H,G,YD4,YD5
      IF(G.GT. 30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      DO 6 I=1,4
6     KL(I)=(KL(I)+1.)/G2
C  guess for unknowns:Q1,Q2,Q3,Q4,Q5,Y1,Y2,Y3,Y4,Y5,Y6           
      READ(IN,*) X
      NCT=0
15    CALL FUN(F)
      DO 20 J=1,11
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(F1)
      DO 10 I=1,11
10    D(I,J)=(F1(I)-F(I))/DX
20    X(J)=X(J)-DX
      CALL SOLVEQ(11,1,11,D,F,1,DD,INDX)
      DIF=0.
      DO 30 I=1,11
      X(I)=X(I)-.2*F(I)
30    DIF=DIF+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,DIF
      WRITE(*,221) X
221   FORMAT(10F8.2)
      IF(NCT.LT.30 .AND. DIF.GT.ERR) GO TO 15
      WRITE(IOUT,100) 
100   FORMAT(' Solution to 91 Channel Problem')
      WRITE(IOUT,110) X
110   FORMAT(5F10.2,/,6F10.3)
      END
      SUBROUTINE FUN(F)
      EXTERNAL DYX
      REAL KL(4),L(4),F(11),Y(1),DY(1),W(1,13),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN(4),SO(4),L,B(4),FM(4),KL,X(11),H,G,G2,CC,TOL,QN,
     &Q2G,YD4,YD5,IC
      F(1)=X(1)-X(2)-X(3)
      F(2)=X(3)-X(4)-X(5)
      F(3)=H-X(6)-KL(1)*(X(1)/((B(1)+FM(1)*X(6))*X(6)))**2
      E2=X(7)+(X(1)/((B(1)+FM(1)*X(7))*X(7)))**2/G2
      F(4)=E2-X(8)-KL(2)*(X(2)/((B(2)+FM(2)*X(8))*X(8)))**2
      F(5)=E2-X(9)-KL(3)*(X(3)/((B(3)+FM(3)*X(9))*X(9)))**2
      E3=X(10)+(X(3)/((B(3)+FM(3)*X(10))*X(10)))**2/G2
      F(6)=E3-X(11)-KL(4)*(X(3)/(B(4)*X(11)))**2
      E4=X(11)+(X(3)/(B(4)*X(11)))**2/G2
      F(7)=E4-YD4-(X(4)/(4.*YD4))**2/G2
      F(8)=E4-YD5-(X(5)/(4.*YD5))**2/G2
      F(9)=FN(2)*X(2)*(B(2)+2.*X(8)*SQRT(FM(2)**2+1.))**.66666667-CC*
     &((B(2)+FM(2)*X(8))*X(8))**1.6666667*SQRT(SO(2))
      XX=L(3)
      XZ=0.
      Y(1)=X(10)
      QN=(FN(3)*X(3)/CC)**2
      Q2G=X(3)**2/G
      II=10
      I1=9
      IC=3
30    H1=-.05
      HMIN=.00001
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      F(II)=X(I1)-Y(1)
      II=II+1
      IF(II.EQ.11) THEN
      I1=6
      IC=1
      Y(1)=X(7)
      QN=(FN(1)*X(1)/CC)**2
      Q2G=X(1)**2/G
      GO TO 30
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL KL(4),L(4),Y(1),DY(1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN(4),SO(4),L,B(4),FM(4),KL,X(11),H,G,G2,CC,TOL,QN,
     &Q2G,YD4,YD5,IC
      AA=(B(IC)+FM(IC)*Y(1))*Y(1)
      PERM=B(IC)+2.*Y(1)*SQRT(FM(IC)**2+1.)
      TOPW=B(IC)+2.*Y(1)*FM(IC)
      A3=AA**3
      SF=QN*(ABS(PERM/AA)**.666666667/AA)**2
      DY(1)=(SO(IC)-SF)/(1.-Q2G*TOPW/A3)
      RETURN
      END