C This program designs a supercritical rectangular transition
      REAL F(7),D(7,7),X(7),KN(5)
      INTEGER*2 INDX(10),N/7/
      EQUIVALENCE (FL,X(1)),(THETA,X(2)),(Y2,X(3)),(BETA,X(4)),(BETAP,
     &X(5)),(XP,X(6)),(Z,X(7)),(b1,KN(1)),(b2,KN(2)),(FR1,KN(3)),(Y1,KN(
     &4)),(Y3,KN(5))
      WRITE(*,*)' Give: Q,b1,So1,n1,b2,So2,n2,g,IOUT'
      READ(*,*) Q,B1,SO1,FN1,B2,SO2,FN2,G,IOUT
      Cu=1.486
      IF(G.LT. 20.) Cu=1.
      WRITE(*,*)' Give guesses for Y1 & Y3'
      READ(*,*) Y1,Y3
      CALL SOLMANN(B1,Cu,Q,SO1,FN1,Y1)
      FR1=SQRT((Q/B1)**2/(G*Y1**3))
      CALL SOLMANN(B2,Cu,Q,SO2,FN2,Y3)
      WRITE(6,*) ' Provide guesses for: L,Theta,Y2,Beta,Beta'',x,z'
      READ(5,*) X
      NCT=0
1     DO 10 I=1,N
      F(I)=FUN(I,X,DX,0,N,KN)
      DO 10 J=1,N
      DX=.005*X(J)
10    D(I,J)=(FUN(I,X,DX,J,N,KN)-F(I))/DX
      CALL SOLVEQ(N,1,7,D,F,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 20 I=1,N
      DIF=DIF+ABS(F(I))
20    X(I)=X(I)-F(I)
      IF(NCT .LT. 20 .AND. DIF .GT. .0001) GO TO 1
      IF(NCT .EQ. 20) WRITE(6,*)' DID NOT CONVERGE',DIF
      WRITE(IOUT,100) (I,X(I),I=1,N),Y1,Y3,FR1
100   FORMAT(' SOLUTION',/10('-'),/(7(' ,X(',I2,')=',F10.4)),/,' Y1=',
     &F8.3,' Y3=',F8.3,' Fr1=',F7.3)
      END
      FUNCTION FUN(I,X1,DX,J,N,KN)
      REAL X(10),X1(10),KN(20)
      DO 10 K=1,N
10    X(K)=X1(K)
      IF(J .GT. 0) X(J)=X(J)+DX
      RY=X(3)/KN(4)
      GO TO (1,2,3,4,5,6,7),I
1     FUN=SIN(X(4))-SQRT(.5*RY*(RY+1.))/KN(3)
      GO TO 50
2     FUN=TAN(X(2))-(RY-1.)*TAN(X(4))/(RY+TAN(X(4))**2)
      GO TO 50
3     FUN=X(1)-.5*(KN(1)-KN(2))/TAN(X(2))
      GO TO 50
4     FUN=X(1)-X(6)-X(7)
      GO TO 50
5     FUN=.5*KN(2)-X(7)*TAN(X(5)-X(2))
      GO TO 50
6     FUN=.5*KN(1)-X(6)*TAN(X(4))
      GO TO 50
7     FUN=KN(5)/X(3)-TAN(X(5))/TAN(X(5)-X(2))
50    RETURN
      END
      SUBROUTINE SOLMANN(B,Cu,Q,SO,FN,Y)
      NCT=0
10    F=FN*Q*(B+2.*Y)**.6666667-Cu*(B*Y)**1.6666667*SQRT(SO)
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 20
      FF=F
      YY=Y
      Y=1.01*Y
      GO TO 10
20    DIF=(Y-YY)*FF/(F-FF)
      Y=YY-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT.1.E-5) GO TO 10
      RETURN
      END