      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,B2,FKL,FM,G,DV,DELT,H,FEK,VaN,N
     &,II,IOUT,LINEAR,ITYPE,MAXFL
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      REAL GIVTIM(40),GIVDWS(40),KE
      WRITE(*,*)' Give input and output units: IN & IOUT'
      READ(*,*) IN,IOUT
      READ(IN,*) NT,N,LINEAR,DELT,Q,FN,SO,B,FM,B2,G,FL,H,KE,FKL
      READ(IN,*) (YK(I),I=N,1,-1)
C      READ(IN,*) (YK(I),I=1,N)
      READ(IN,*) ITYPE,MGIV,(GIVTIM(I),GIVDWS(I),I=1,MGIV)
C  ITYPE=1 then Y(N)-given; ITYPE=2 then V(N)-given; ITYPE=3 then Q(N)-given
C  ITYPE=4 height of gate at downstream end specified.
C Unknowns: Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=XR, Va(5)=VL, Va(6)=VR, 
C   Va(7)=YL, Va(8)=YR.
C For upstream BC Va(1)=V, Va(2)=Y, Va(3)=XR, Va(4)=VR, Va(5)=YR
C For downstream BC Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=VL, Va(5)=YL
      DT2=DELT/2.
      DTG2=G*DELT
      DX=FL/FLOAT(N-1)
      DELTDX=DELT/DX
      FEK=(KE+1.)/(2.*G)
      FKL=.5*(1.+FKL)+1.
      MAXFL=0
      CN=FN
      IF(G.GT.30.) CN=CN/1.486
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      ITAB=100
      IF(FM.GT. 0.) CALL STAGE
      DO 5 I=1,N
      Y(I)=YK(I)
      VK(I)=Q/((B+FM*Y(I))*Y(I))
5     V(I)=VK(I)
      WRITE(IOUT,100) 0,0.
      WRITE(IOUT,101) (Y(I),I=1,N)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(Q,I=1,N)
      IGIV=2
      write(*,*)' Give frequency of writing plot data'
      read(*,*) nplfr
      DO 50 K=1,NT
      KKK=0
      TIME=DELT*FLOAT(K)
10    IF(GIVTIM(IGIV).GE.TIME .OR. IGIV.EQ.MGIV) GO TO 20
      IGIV=IGIV+1
      GO TO 10
20    IG=IGIV-1
      VaN=GIVDWS(IG)+(TIME-GIVTIM(IG))/(GIVTIM(IGIV)-GIVTIM(IG))*
     &(GIVDWS(IGIV)-GIVDWS(IG))
22    CALL SOLVE
      IF(KKK.EQ.K) GO TO 28
      IF(MAXFL.EQ.1) THEN
      IF(ITYPE-2) 23,24,25
23    IF(Y(N).GT.VaN) GO TO 28
      GO TO 26
24    IF(V(N).LT.VaN) GO TO 28
      GO TO 26
25    IF(V(N)*(B+FM*Y(N))*Y(N) .LT. VaN) GO TO 28
26    WRITE(*,103) VaN,TIME,Y(N),V(N)
103   FORMAT(' Specified amount',F8.2,' can be accomodated again. TIME='
     &F8.1,' Y(N)=',F8.2,' V(N)=',F8.2)
      MAXFL=0
      KKK=K
      GO TO 22
      ELSE
      QN=V(N)*(B+FM*Y(N))*Y(N)
      EC2=FKL*((QN/B2)**2/G)**.33333333
      E2=Y(N)+V(N)**2/2./G
      IF(E2.GE.EC2) GO TO 28
      WRITE(*,104) TIME,E2,EC2,Y(N),V(N),QN
104   FORMAT(' Downst. rect. ch. cannot handle specified amount at time'
     &,F8.1,/,' E2=',F8.2,', EC2=',F8.2,', Y(N)=',F8.2,', V(N)=',F8.2,
     &', Q=',F8.2,/,' Flowrate at end will be reduced as necessary')
      MAXFL=1
      KKK=K
      GO TO 22
      ENDIF
28    WRITE(IOUT,100) K,TIME
100   FORMAT(/,' K=',I3,', Depth, Velocity & Flowrate for Time=',F8.1,
     &' sec.')
      WRITE(IOUT,101) (Y(I),I=1,N)
101   FORMAT(1X,16F7.2)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(V(I)*(B+FM*Y(I))*Y(I),I=1,N)
102   FORMAT(1X,16F7.1)
      if(mod(K-1,nplfr).EQ.0) write(4,*)' '
      DO 40 I=1,N
      YA=V(I)
      if(mod(K-1,nplfr).eq.0) write(4,333) dx*float(i-1),Y(I),YA,
     &V(I)*(B+FM*Y(I))*Y(I)
333   format(f6.1,2f8.3,f9.2)
      V(I)=2.*YA-VK(I)
      VK(I)=YA
      YA=Y(I)
      Y(I)=2.*YA-YK(I)
40    YK(I)=YA
50    CONTINUE
      END
      SUBROUTINE SOLVE
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,B2,FKL,FM,G,DV,DELT,H,FEK,VaN,N
     &,II,IOUT,LINEAR,ITYPE,MAXFL
      DO 50 I=1,N
      II=I
      IP=I+1
      IM=I-1
      NCT=0
      Va(1)=V(I)
      Va(2)=Y(I)
C  Va(3) IS (XL-Xi-1)/Dx, or  XL=X(I-1)+Dx*Va(3)
C  Va(4) IS (XR-Xi)/Dx, or  XR=X(I)+Dx*Va(4)
      IF(I.EQ.1) THEN
      NEQ=5
      Va(3)=(SQRT(G*(B+FM*Y(1))*Y(1)/(B+FM2*Y(1)))-V(1))*DELTDX
      Va(4)=V(1)+Va(3)*(V(2)-V(1))
      Va(5)=Y(1)+Va(3)*(Y(2)-Y(1))
      ELSE IF(I.EQ.N) THEN
      NEQ=5
      Va(3)=1.-(V(N)+SQRT(G*(B+FM*Y(N))*Y(N)/(B+FM2*Y(N))))*DELTDX
      Va(4)=V(N-1)+(1.-Va(3))*(V(N)-V(N-1))
      Va(5)=Y(N-1)+(1.-Va(3))*(Y(N)-Y(N-1))
      ELSE
      NEQ=8
      IF(I.EQ.2) THEN
      Va(3)=1.-(V(2)+SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2))))*DELTDX
      Va(4)=(SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2)))-V(2))*DELTDX
      ENDIF
      Va(5)=VK(IM)+Va(3)*(VK(I)-VK(IM))
      Va(7)=YK(IM)+Va(3)*(YK(I)-YK(IM))
      Va(6)=VK(I)+Va(4)*(VK(IP)-VK(I))
      Va(8)=YK(I)+Va(4)*(YK(IP)-YK(I))
      ENDIF
15    CALL FUNCT(0)
      DO 20 J=1,NEQ
20    F1(J)=F(J)
      DO 22 J=1,NEQ
      CALL FUNCT(J)
      DO 22 J1=1,NEQ
22    D(J1,J)=(F(J1)-F1(J1))/DV
      DO 30 L=1,NEQ-1
      DO 30 M=NEQ,L+1,-1
      IF(ABS(D(M,L)).LT. 1.E-15) GO TO 30
      FAC=D(M,L)/D(L,L)
      F1(M)=F1(M)-FAC*F1(L)
      DO 28 J=L+1,NEQ
28    D(M,J)=D(M,J)-FAC*D(L,J)
30    CONTINUE
      M=NEQ
      Z(M)=F1(M)/D(M,M)
      DIF=ABS(Z(M))
      Va(M)=Va(M)-Z(M)
31    M1=M-1
      SUM=0.
      DO 32 J=M,NEQ
32    SUM=SUM+Z(J)*D(M1,J)
      IF(ABS(D(M1,M1)).LT.1.E-10) THEN
      Z(M1)=0.
      ELSE
      Z(M1)=(F1(M1)-SUM)/D(M1,M1)
      ENDIF
      M=M1
      Va(M)=Va(M)-Z(M)
      DIF=DIF+ABS(Z(M))
      IF(M.GT.1) GO TO 31
      NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .00001) GO TO 15
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',I,DIF
      V(I)=Va(1)
50    Y(I)=Va(2)
      RETURN
      END
      SUBROUTINE FUNCT(J)
      PARAMETER (EX=.66666667)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,B2,FKL,FM,G,DV,DELT,H,FEK,VaN,N
     &,I,IOUT,LINEAR,ITYPE,MAXFL
      IM=I-1
      IP=I+1
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      IF(ABS(DV).LT. 1.E-5) DV=SIGN(1.E-5,DV)
      Va(J)=Va(J)+DV
      ENDIF
      A=(B+FM*Va(2))*Va(2)
      C=SQRT(G*A/(B+FM2*Va(2)))
      SF=(CN*Va(1)*((B+FMS*Va(2))/A)**EX)**2
      IF(I.EQ.1) THEN
C Upstream BC H=Y+(1+Ke)V**2/(2g)
      AR=(B+FM*Va(5))*Va(5)
      CR=SQRT(G*AR/(B+FM2*Va(5)))
      SFR=(CN*Va(4)*((B+FMS*Va(5))/AR)**EX)**2
      F(1)=DT2*(C-Va(1)+CR-Va(4))-DX*Va(3)
      F(2)=Va(1)-WSTAGE(Va(2))-Va(4)+WSTAGE(Va(5))-DTG2*(SO-.5*(SF+SFR))
      F(3)=H-Va(2)-FEK*Va(1)**2
      IF(LINEAR.EQ.1) THEN
      F(4)=Va(4)-VK(1)-Va(3)*(VK(2)-VK(1))
      F(5)=Va(5)-YK(1)-Va(3)*(YK(2)-YK(1))
      ELSE
      F(4)=Va(4)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     & VK(3)-VK(2)))
      F(5)=Va(5)-YK(1)-.5*Va(3)*((3.-Va(3))*(YK(2)-YK(1))+(Va(3)-1.)*(
     & YK(3)-YK(2)))
      ENDIF
      ELSE IF(I.EQ.N) THEN
C Downstream BC 
      AL=(B+FM*Va(5))*Va(5)
      CL=SQRT(G*AL/(B+FM2*Va(5)))
      SFL=(CN*Va(4)*((B+FMS*Va(5))/AL)**EX)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+C+Va(4)+CL)
      F(2)=Va(1)+WSTAGE(Va(2))-Va(4)-WSTAGE(Va(5))-DTG2*(SO-.5*(SF+SFL))
      IF(MAXFL.EQ.1) THEN
      F(3)=Va(2)+Va(1)**2/2./G-FKL*((Va(1)*(B+FM*Va(2))*Va(2)/B2)**2/G
     &)**.33333333
      ELSE
      GO TO(1,2,3,6),ITYPE
1     F(3)=Va(2)-VaN
      GO TO 4
2     F(3)=Va(1)-VaN
      GO TO 4
3     F(3)=VaN-A*Va(1)
      GO TO 4
6     F(3)=Va(2)-VaN+(Va(1)**2-(Va(1)*(B+FM*Va(2))*Va(2)/(B2*VaN))**2)/
     &2./G
      ENDIF
4     IF(LINEAR.EQ.1) THEN
      F(4)=Va(4)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(5)=Va(5)-YK(IM)-Va(3)*(YK(I)-YK(IM))
      ELSE
      F(4)=Va(4)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(5)=Va(5)-YK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(YK(IM)-YK(I-2))+Va(3
     &)*(YK(I)-YK(IM)))
      ENDIF
      ELSE
C Regular points
      AL=(B+FM*Va(7))*Va(7)
      CL=SQRT(G*AL/(B+FM2*Va(7)))
      SFL=(CN*Va(5)*((B+FMS*Va(7))/AL)**EX)**2
      AR=(B+FM*Va(8))*Va(8)
      CR=SQRT(G*AR/(B+FM2*Va(8)))
      SFR=(CN*Va(6)*((B+FMS*Va(8))/AR)**EX)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+C+Va(5)+CL)
      WS=WSTAGE(Va(2))
      F(2)=Va(1)+WS-Va(5)-WSTAGE(Va(7))-DTG2*(SO-.5*(SF+SFL))
      F(3)=DT2*(C-Va(1)+CR-Va(6))-DX*Va(4)
      F(4)=Va(1)-WS-Va(6)+WSTAGE(Va(8))-DTG2*(SO-.5*(SF+SFR))
      IF(LINEAR.EQ.1) THEN
      F(5)=Va(5)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(7)=Va(7)-YK(IM)-Va(3)*(YK(I)-YK(IM))
      ELSE
      IF(I.EQ.2) THEN
      F(5)=Va(5)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     &VK(3)-VK(2)))
      F(7)=Va(7)-YK(1)-.5*Va(3)*((3.-Va(3))*(YK(2)-YK(1))+(Va(3)-1.)*(
     &YK(3)-YK(2)))
      ELSE
      F(5)=Va(5)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(7)=Va(7)-YK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(YK(IM)-YK(I-2))+Va(3
     &)*(YK(I)-YK(IM)))
      ENDIF
      ENDIF
      IF(LINEAR.EQ.1) THEN
      F(6)=Va(6)-VK(I)-Va(4)*(VK(IP)-VK(I))
      F(8)=Va(8)-YK(I)-Va(4)*(YK(IP)-YK(I))
      ELSE
      IF(IP.EQ.N) THEN
      F(6)=Va(6)-VK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(VK(I)-VK(IM))+Va(4)*
     &(VK(N)-VK(I)))
      F(8)=Va(8)-YK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(YK(I)-YK(IM))+Va(4)*
     &(YK(N)-YK(I)))
      ELSE
      F(6)=Va(6)-VK(I)-.5*Va(4)*((3.-Va(4))*(VK(IP)-VK(I))+(Va(4)-1.)*(
     &VK(I+2)-VK(IP)))
      F(8)=Va(8)-YK(I)-.5*Va(4)*((3.-Va(4))*(YK(IP)-YK(I))+(Va(4)-1.)*(
     &YK(I+2)-YK(IP)))
      ENDIF
      ENDIF
      ENDIF
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END
      FUNCTION WSTAGE(YY)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,B2,FKL,FM,G,DV,DELT,H,FEK,VaN,N
     &,II,IOUT,LINEAR,ITYPE,MAXFL
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      IF(FM.LT.1.E-5) THEN
      WSTAGE=2.*SQRT(G*YYY)
      ELSE
      YYY=FM*YY/B
      IF(ITAB.LT.398) THEN
      I1=ITAB+1
      ELSE
      ITAB=398
      I1=399
      ENDIF
      IF(YYY.LT.YST(I1)) THEN
 10   IF(YYY.LT.YST(ITAB)) THEN
      ITAB=ITAB-1
      IF(ITAB.GT.1) GO TO 10
      ENDIF
      I1=ITAB+1
      ELSE
20    IF(YYY.GT. YST(I1)) THEN
      I1=I1+1
      IF(I1.LT.400) GO TO 20
      ENDIF
      ITAB=I1-1
      ENDIF
      WSTAGE=W(ITAB)+(YYY-YST(ITAB))/(YST(I1)-YST(ITAB))*(W(I1)-W(ITAB))
      WSTAGE=SQRT(G*B/FM)*WSTAGE
      ENDIF
      RETURN
      END
      SUBROUTINE STAGE
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      FC(YP)=SQRT((1.+2.*YP)/(YP+YP*YP))
      DY=.005
      DY1=DY/10.
      DYH=DY1/2.
      N=(2.-.01)/DY+1
      YST(1)=.01
      RC=FC(.01)
      W(1)=.138
      DO 10 I=2,N
      SUM=0.
      DO 5 J=1,10
      YP=YST(I-1)+DY1*FLOAT(J)
      RC1=FC(YP)
      SUM=SUM+DYH*(RC+RC1)
5     RC=RC1
      YST(I)=YP
10    W(I)=W(I-1)+SUM
      RETURN
      END