      PARAMETER (Cc=.65,FK=1.05,G2=64.4)
      COMMON X(5),Y3O(12)
      REAL Q(12),YY(12)
      QQ=1.
      Y3=.5
      IJ=0
      DO 20 I=1,46
      IF(I.EQ.8) IJ=1
      IF(I.EQ.15) IJ=2
      IF(I.EQ.25) IJ=3
      YI=3.+FLOAT(I-1)
      YF=YI/12.
      WRITE(3,120) IFIX(YI),YF
      WRITE(4,120) IFIX(YI),YF
120   FORMAT(' For upstream Depth =',I2,' inches (',F5.3,' ft)')
      X(4)=YF
      YB=.5*YF
      YE=.9*YF
      DY=(YE-YB)/12.
      DO 7 J=1,12
7     YY(J)=YB+DY*FLOAT(J-1)
      WRITE(3,130)(12.*YY(J),J=1,12)
      WRITE(4,130)(12.*YY(J),J=1,12)
130   FORMAT(' Down. Y(in)',F6.2,11F7.2)
      WRITE(3,131)(YY(J),J=1,12)
      WRITE(4,131)(YY(J),J=1,12)
131   FORMAT(' Down. Y(ft)',F6.3,11F7.3)
      DO 15 K=1,I-IJ
      YG=FLOAT(K)/12.
      X(3)=Cc*YG
      DO 10 J=1,12
      IF(K.EQ.1) THEN
      IF(J.EQ.1) THEN
      X(2)=Y3
      X(1)=QQ
      ENDIF
      ELSE
      X(2)=Y3O(J)
      ENDIF
      X(5)=YY(J)
      CALL SOLSUBM(J)
      IF(K.EQ.1 .AND. J.EQ.1) THEN
      QQ=X(1)
      Y3=ABS(X(2))
      ENDIF
      Y3O(J)=X(2)
10    Q(J)=6.*X(1)
      WRITE(4,100) 12.*YG,YG,(Y3O(J),J=1,12)
15    WRITE(3,100) 12.*YG,YG,(Q(J),J=1,12)
100   FORMAT(F5.1,F6.3,12F7.2)
20    CONTINUE
      END
      SUBROUTINE SOLSUBM(J)
      REAL F(2),F1(2),D(2,2)
      COMMON X(5),Y3O(12)
      NCT=0
20    CALL FUN(F)
      DO 30 I=1,2
      XX=X(I)
      X(I)=1.01*X(I)
      CALL FUN(F1)
      D(1,I)=(F1(1)-F(1))/(X(I)-XX)
      D(2,I)=(F1(2)-F(2))/(X(I)-XX)
30    X(I)=XX
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      F(2)=F(2)-FAC*F(1)
      DIF=F(2)/D(2,2)
      SUM=ABS(DIF)
      X(2)=X(2)-DIF
      IF(X(2).LT.0.) THEN
      WRITE(*,*) J,X(2),Y3O(J)
      READ(*,*) X(2)
      ENDIF
      DIF=(F(1)-D(1,2)*DIF)/D(1,1)
      X(1)=X(1)-DIF
      SUM=SUM+ABS(DIF)
      NCT=NCT+1
C      WRITE(*,110) NCT,SUM,X(1),X(2)
C110   FORMAT(' NCT=',I2,E12.5,2F9.3)
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 20
      IF(NCT.EQ.30) WRITE(*,*)' Did not converge',SUM,X
      END
      SUBROUTINE FUN(F)
      REAL F(2)
      COMMON X(5),Y3O(12)
      Q2G=X(1)**2/32.2
      F(1)=X(4)-X(5)-.5*Q2G/X(3)**2
      F(2)=Q2G-.5*(X(2)**2-X(5)**2)*X(3)*X(2)/(X(2)-X(3))
      RETURN
      END