C  Solve flow from triagular grate with a flat bottom. b is width of grate,
C as well as the width of the bottom in computing the area, perimeter & top width
C This program uses the same geometry for grates channel as RGUTTER use for the
C are of a gutter.  z is the vertical rise on the side with the slope m.
      REAL YY(1),YTT(1),QEND(2),YCEND(2)
      COMMON FM,FMS,C,FN,HM,G,Q,QS1,CD,X,SO,B,Z,ZM,G3
      EQUIVALENCE (Y,YY(1))
      WRITE(6,*)'Give:IOUT,b,m,z,n,So,DX,g,Cd,Fac A,Length Gutter'
      READ(5,*) IOUT,B,FM,Z,FN,SO,DX,G,CD,FA,FL
      IOU1=IOUT+1
      DXS=.05
      IF(G.GT.30.) THEN
      C=1.486
      ELSE
      C=1.
      ENDIF
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      ZM=Z*(SQRT(FM*FM+1.)-1.)
      G2=2.*G
      G3=3.*G
      CD=CD*SQRT(G2)*FA*B
2     READ(2,*,END=200) QS,YCEND,YS,XS
      QEND(1)=QS*XS
      QEND(2)=QS*(FL-XS)
      DO 20 K=1,2
      QB=QEND(K)
      YC=CRITY(QB,QEND(K))
      WRITE(IOUT,98) YC,QB
98    FORMAT(' Critical Depth at beg. of grate =',F8.3,', Qb =',F8.2)
      Y=.95*YC
      WRITE(IOUT,99) FM,FN,So,B,Z,QS
99    FORMAT(' m =',F8.3,', n =',F8.4,', So =',F10.6,', b=',F8.3,', z=',
     &F8.3,', q*=',F8.4/,'       x          Y         Q        E       q
     &*        Fr')
      IF(YC.GT.Z) THEN
      A=B*YC+HM*(YC-Z)**2
      T=B+FM*(YC-Z)
      ELSE
      A=B*YC
      T=B
      ENDIF
      WRITE(IOUT,100) 0.,YC,QB,YC+(QB/A)**2/G2,A,QB*SQRT(T/(G*A**3))
100   FORMAT(F10.2,5F10.3)
      QS1=CD*SQRT(YC)
      X1=0.
      Q=QB
10    X=X1+DX
      CALL RUKUST(1,DXS,X1,X,1.E-4,YY,YTT)
      QS2=CD*SQRT(Y)
      QSA=.5*(QS1+QS2)
      Q=Q-QSA*DX
      IF(Y.GT.Z) THEN
      A=B*Y+HM*(Y-Z)**2
      T=B+FM*(Y-Z)
      ELSE
      A=B*Y
      T=B
      ENDIF
      WRITE(IOUT,100)X,Y,Q,Y+(Q/A)**2/G2,QSA,Q*SQRT(T/(G*A**3))
      QS1=QS2
      X1=X
      IF(Y.GT. .1 .AND. Q.GT.0.) GO TO 10
      IF(K.EQ.1) XLEFT=X
      IF(K.EQ.2)WRITE(IOU1,'(F8.4,7F8.3)')QS,QEND,YCEND,XLEFT,X,XLEFT+X
20    CONTINUE
      GO TO 2
200   STOP
      END
      SUBROUTINE SLOPE(XX,Y,DYX)
      REAL Y(1),DYX(1)
      COMMON FM,FMS,C,FN,HM,G,Q,QS1,CD,X,SO,B,Z,ZM,G3
      IF(Y(1).GT.Z) THEN
      A=B*Y(1)+HM*(Y(1)-Z)**2
      T=B+FM*(Y(1)-Z)
      P=B+FMS*Y(1)-ZM
      ELSE
      A=B*Y(1)
      T=B
      P=B+2.*Y(1)
      ENDIF
      QS=CD*SQRT(Y(1))
      QQ=Q-.5*(QS1+QS)*(XX-X)
      IF(QQ.LT.0. .OR. Y(1).LT.0.) THEN
      DYX(1)=0.
      ELSE
      SF=(FN*QQ/C*(P/A)**.66666667/A)**2
      DYX(1)=(SO-SF+QQ*QS/(G*A**2))/(1.-QQ*QQ*T/(G*A**3))
      ENDIF
      RETURN
      END
      FUNCTION CRITY(QQ,YY)
      COMMON FM,FMS,C,FN,HM,G,Q,QS1,CD,X,SO,B,Z,ZM,G3
      Y=YY
      Q2=QQ*QQ
      M=0
1     A=B*Y+HM*(Y-Z)**2
      T=B+FM*(Y-Z)
      DIF=(Q2*T-G*A**3)/(Q2*FM-G3*A**2*T)
      Y=ABS(Y-DIF)
      M=M+1
      IF(M.LT.30 .AND. ABS(DIF).GT. 1.E-6) GO TO 1
      IF(M.EQ.30) WRITE(*,*)' CRITY did not converge',DIF
      CRITY=Y
      RETURN
      END