C Solves the problem of side flow into a triangular gutter with a flat bottom
C  One side is vertical, the other rises z and then has a side slope m, so the
C area A =bY+b(Y-z)+m(Y-z)**2/2
      INTEGER*2 INDX(4)
      LOGICAL DONE
      REAL F(4),D(4,4),FFF(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &DONE,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,b,m,z,L,g,DX,q*'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B,FM,Z,FL,G,DX,QS
      IOU1=IOUT+1
      DONE=.FALSE.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      ZM=Z*(SQRT(FM*FM+1.)-1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      G3=3.*G
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) X(4)
      GM2=.125*G*FM*FM
6     X(1)=CRITY(QS*X(4),((QS*X(4))**2/GM2)**.2)
      X(2)=CRITY(QS*(FL-X(4)),((QS*(FL-X(4)))**2/GM2)**.2)
      X(3)=X(1)+X(2)
      WRITE(*,*)' Guesses for x',X
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,4
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,4
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,4
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,4F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(*,*)' Give: 1= only Sol., 2=only profile, 3=both'
      READ(*,*) NCT
      IF(NCT.EQ.2) GO TO 30
      WRITE(IOU1,111) QS,X
111   FORMAT(F9.4,3F8.3,F8.2)
      IF(NCT.EQ.1) GO TO 40
30    WRITE(IOUT,100) X,QS
100   FORMAT(' Yc1=',F8.3,', Yc2=',F8.3,', Depth at Q=0',F8.3,', Xs=',
     &F8.1,' q*=',F8.4)
      DONE=.TRUE.
      CALL FUN(F)
      DONE=.FALSE.
40    WRITE(*,*)' q*=',QS,' To STOP give 0, otherwise new q*'
      READ(*,*) QS
      IF(QS.GT.0.) GO TO 6
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &DONE,IOUT
      YZ=X(1)-Z
      F(1)=(B+FM*YZ)*(QS*X(4))**2-G*(B*X(1)+HM*YZ**2)**3
      YZ=X(2)-Z
      F(2)=(B+FM*YZ)*(QS*(FL-X(4)))**2-G*(B*X(2)+HM*YZ**2)**3
      HMIN=1.E-5
      IF(DONE) THEN
      A=B*X(1)+HM*(X(1)-Z)**2
      T=B+FM*(X(1)-Z)
      Q=QS*X(4)
      WRITE(IOUT,100) 0.,X(1),Q,X(1)+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
      ENDIF
100   FORMAT('       x          Y         Q        E        A        Fr'
     &,/,1X,57('-'),/,F10.1,5F10.3)
      H1=.1
      XX=0.
      Y(1)=1.1*X(1)
10    XZ=XX+DX
      IF(XZ.GT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=B*Y(1)+HM*(Y(1)-Z)**2
      T=B+FM*(Y(1)-Z)
      Q=QS*(X(4)-XZ)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT. X(4)) GO TO 10
      F(3)=X(3)-Y(1)
      H1=-.1
      IF(DONE) THEN
      A=B*X(2)+HM*(X(2)-Z)**2
      T=B+FM*(X(2)-Z)
      Q=QS*(FL-X(4))
      WRITE(IOUT,100) FL,X(2),Q,X(2)+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
      ENDIF
      XX=FL
      Y(1)=1.1*X(2)
20    XZ=XX-DX
      IF(XZ.LT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=B*Y(1)+HM*(Y(1)-Z)**2
      T=B+FM*(Y(1)-Z)
      Q=QS*(XZ-X(4))
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
      ENDIF
      XX=XZ
      IF(XZ.GT. X(4)) GO TO 20
      F(4)=X(3)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &DONE,IOUT
      A=B*Y(1)+HM*(Y(1)-Z)**2
      Q=QS*(XX-X(4))
      SF=FN*Q/CC*ABS((B+FMS*Y(1)-ZM)/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*(B+FM*ABS(Y(1)-Z))/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END
      FUNCTION CRITY(Q,Y)
      LOGICAL DONE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &DONE,IOUT
      Q2=Q*Q
      M=0
1     A=B*Y+HM*(Y-Z)**2
      T=B+FM*(Y-Z)
      DIF=(Q2*T-G*A**3)/(Q2*FM-G3*A**2*T)
      Y=Y-DIF
      M=M+1
      IF(M.LT.30 .AND. ABS(DIF).GT. 1.E-6) GO TO 1
      IF(M.EQ.30) WRITE(*,*)' CRITY didnot converge',DIF
      CRITY=Y
      RETURN
      END