// Solves 3 roots from the momentum function iteratively adjusting q & m
//  The channel is circular and uses the same approach as ROOTMTR for a trap.
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
void main(void){ int nct,itype;
float pi=3.14159265,radius,d,q,g,mom,r2,d26,q2g,pii,yy,y,beta,cosb,sinb,a,bav,c,qg,f,ff,theta;
L1:printf("Give: Q,D,g,Mom,0=subcr. or 1=supercr.\n");
 scanf("%f %f %f %f %d",&q,&d,&g,&mom,&itype);
 if(q<1.e-5) exit(0);
 radius=d/2.; r2=radius*radius; d26=d*d/6.; q2g=q*q/g; 
 if(itype){ pii=4.*pi; yy=.3*d;} else {pii=2.*pi;yy=.7*d;}  nct=0;
do{ y=yy; cosb=1.-y/radius; beta=acos(cosb); sinb=sin(beta); a=r2*(beta-cosb*sinb);
 bav=a/y; c=y/(d*(d26/a*pow(sinb,3.)-cosb));qg=c*pow(q/bav,2.)/g;
 f=c*mom/bav; ff=2.*sqrt(.6666667*f); theta=acos(qg/pow(.6666667*f,1.5));
 yy=-ff*cos((theta+pii)/3.); printf("%d %f %f\n",nct,yy,y);
} while ((++nct<30) && (fabs(y-yy)>1.e-4));
printf(" Q=%8.3f D=%8.3f\n Mom=%8.3f g=%8.3f\nDepth=%9.3f Froude No.=%8.2f\n", \
 q,d,mom,g,yy,sqrt(q2g*d*sinb/pow(a,3.))); goto L1;
}

