C Solves 3 roots from the momentum function iteratively adjusting q & m
      PARAMETER (PI=3.14159265)
1     WRITE(*,*)' Give: Q,D,g,Mom,0=subcr. or 1=supercr.'
      READ(*,*) Q,D,g,FTOT,ITYPE
      IF(Q.LT.1.E-5) STOP
      RADIUS=D/2.
      R2=RADIUS**2
      D26=D*D/6.
      Q2G=Q**2/G
      IF(ITYPE.EQ.0) THEN
      PII=2.*PI
      YY=.7*D
      ELSE
      PII=4.*PI
      YY=.3*D
      ENDIF
      NCT=0
8     Y=YY
      COSB=1.-Y/RADIUS
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=R2*(BETA-COSB*SINB)
      Bav=A/Y
      C=Y/(D*(D26/A*SINB**3-COSB))
      qg=C*(Q/Bav)**2/g
      F=C*FTOT/Bav
      FF=2.*SQRT(.6666667*F)
      THETA=ACOS(qg/(.6666667*f)**1.5)
      YY=-FF*COS((THETA+PII)/3.)
      NCT=NCT+1
      WRITE(*,*) NCT,YY,Y
      IF(ABS(Y-YY).GT. 1.E-4 .AND. NCT.LT.30) GO TO 8
      WRITE(6,100)Q,D,FTOT,g,YY,SQRT(Q2G*D*SINB/A**3)
100   FORMAT(' Q=',F8.3,' D=',F8.3,/,' Mom=',F8.3,' g=',F8.2,
     &/,' Depth=',F9.3,' Froude No.=',F8.2,/)
      GO TO 1
      END