C Iteratively solve for subcr. or supercr. depth in a 
C trapezoidal channel for a given E
      PARAMETER (PI=3.14159265)
1     WRITE(*,*)' Give: Q,b,m,E,g & 1=SUBCR. or 2=SUPERCR.'
      READ(*,*) Q,B,FM,E,g,ITYPE
      IF(Q.LT.1.E-5) STOP
      NCT=0
      IF(ITYPE.EQ.1) THEN
      PII=2.*PI
      ELSE
      PII=4.*PI
      ENDIF
      AW1=(1.+.5*FM)*B
      E3=E/3.
2     AW=AW1
      qs=Q/AW
      THETA=ACOS(((6.75*qs*qs/g-E**3)/27.)/E3**3)
      Y=E3*(1.-2.*COS((THETA+PII)/3.))
      NCT=NCT+1
      AW1=B+FM*Y
C      WRITE(*,*) NCT,AW,AW1,qs
      IF(ABS(AW1-AW).GT.1.E-4 .AND. NCT.LT.40) GO TO 2
      WRITE(6,100) Q,B,FM,E,g,Y
100   FORMAT(' Q=',F8.3,' b=',F8.3,' m=',F8.2,/,' E=',F8.3,' g=',F8.2,
     &' Depth Y=',F9.3)
      GO TO 1
      END