C  Solves GVF through transition upstream from gate
      PARAMETER (N=3)
      INTEGER*2 ITYP(N)
      REAL F(N),F1(N),D(N,N),KL1,KE1,Y(1),YW(1)
      COMMON /TRAS/B1,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS,FLT,DBX,DMX,G
      WRITE(*,*)'Give:b1,m1,n,So,H,Ke,KL,g,L,LT,b2,TOL,ERR,Cc,Yg1,dYg,N'
      READ(*,*) B1,FM1,FN,SO,H,KE1,KL1,G,FL,FLT,B2,TOL,ERR,CC,YG1,DYG,
     &NGATE
      CU=1.486
      FM2=2.*FM1
      FMS=2.*SQRT(FM1*FM1+1.)
      IF(G.LT. 30.) CU=1.
      G2=2.*G
      KL1=1.+KL1
      KE1=1.+KE1
      DBX=(B1-B2)/FLT
      DMX=FM1/FLT
      WRITE(*,*)' Give guess for: Q,Y1 & Y2'
      READ(*,*) X
      Yo=.98*X(2)
      CALL OPEN(Yo,Qo)
      WRITE(3,110) H,KE1-1.,B1,FM1,FN,SO,B2,KL1-1.,FL,FLT,Yo,Qo
110   FORMAT(' H =',F7.1,', Ke =',F6.3,', b1 =',F8.1,', m1 =',F7.2,', n 
     &=',F8.4,',',/,' So =',F9.6,', b2 =',F8.1,', KL =',F6.3,', L =',F8.
     &1,', LT =',F6.1,/,' No gate-Uniform Flow: Yo =',F8.3,', Qo ='
     &,F8.2,/1X,61('-'),/,4X,'YG',4X,'Yd',7X,'Q',6X,'Y1',6X,'Y2',6X,'Yu'
     &,6X,'Yo',6X,'Yc',/,1X,61('-') )
      DO 50 KK=1,NGATE
      YG=YG1+DYG*FLOAT(KK-1)
      Yd=CC*YG
      Ad=(B2*Yd)**2
      NCT=0
1     SUM=0.
      CALL FUN(F1)
      DO 10 J=1,N
      XX=X(J)
      X(J)=1.005*X(J)
      CALL FUN(F)
      DO 5 I=1,N
5     D(I,J)=(F(I)-F1(I))/(X(J)-XX)
10    X(J)=XX
      CALL SOLVEQ(N,1,N,D,F1,1,DET,ITYP)
      DO 15 I=1,N
      X(I)=X(I)-F1(I)
15    SUM=SUM+ABS(F1(I))
      NCT=NCT+1
      IF(SUM.GT.ERR .AND. NCT.LT.20) GO TO 1
      IF(NCT.EQ.20) WRITE(*,*)' Did not Converge',SUM
      DXS=-1.
      Y(1)=X(3)
      CALL RUKUST(1,DXS,FL,FLT,TOL,Y,YW)
50    WRITE(3,100) YG,Yd,X(1),X(2),Y(1),X(3),YNORM(X(1)),((X(1)/B2)**2/G
     &)**.33333333
100   FORMAT(2F7.2,F8.2,5F8.3)
      END
      SUBROUTINE FUN(F)
      REAL F(3),KL1,KE1,Y(1),YW(1)
      COMMON /TRAS/B1,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS,FLT,DBX,DMX,G
      QN=(FN*X(1)/CU)**2
      Q2G=X(1)**2/G2
      F(1)=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      F(2)=X(3)+Q2G/(B2*X(3))**2-Yd-KL1*Q2G/Ad
      Y(1)=X(3)
      DXS=-1.
      CALL RUKUST(1,DXS,FL,0.,TOL,Y,YW)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE SLOPE(XX,Y,DY)
      REAL Y(1),DY(1),KL1,KE1
      COMMON /TRAS/B1,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS,FLT,DBX,DMX,G
      IF(XX.LE.FLT) THEN
      AREA=(B1+FM1*Y(1))*Y(1)
      SF=QN*(B1+FMS*Y(1))**1.33333333/AREA**3.3333333
      DY(1)=(SO-SF)/(1.-.5*Q2G*(B1+FM2*Y(1))/AREA**3)
      ELSE
      BB=B2+DBX*(XX-FLT)
      FMM=DMX*(XX-FLT)
      AREA=(BB+FMM*Y(1))*Y(1)
      DQX=X(1)**2/(G*AREA**3)*(DBX+DMX*Y(1))*Y(1)
      SF=QN*(BB+2.*SQRT(FMM**2+1.)*Y(1))**1.33333333/AREA**3.3333333
      DY(1)=(SO-SF-DQX)/(1.-.5*Q2G*(BB+2.*FMM*Y(1))/AREA**3)
      ENDIF
      RETURN
      END
      FUNCTION YNORM(Q)
      COMMON /TRAS/B1,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS,FLT,DBX,DMX,G
      QQ=CU*SQRT(SO)/FN
      Y=X(2)
      M=0
1     F=Q-QQ*((B1+FM1*Y)*Y)**1.6666667/(B1+FMS*Y)**.666667
      Y1=1.005*Y
      DIF=(Y1-Y)*F/(Q-QQ*((B1+FM1*Y1)*Y1)**1.6666667/(B1+FMS*Y1)
     &**.666667-F)
      Y=Y-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' YNORM failed to converge'
      YNORM=Y
      RETURN
      END
      SUBROUTINE OPEN(Yo,Qo)
      COMMON /TRAS/B1,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS,FLT,DBX,DMX,G
      M=0
      QQ=Cu*SQRT(SO)/FN
1     AREA=(B1+FM1*Yo)*Yo
      Qo=QQ*AREA**1.66666667/(B1+FMS*Yo)**.66666667
      F=H-Yo-FKE1*(Qo/AREA)**2/G2
      Y1=1.005*Yo
      A=(B1+FM1*Y1)*Y1
      DIF=(Y1-Yo)*F/(H-Y1-FKE1*(QQ*A**1.6666667/(B1+FMS*Y1)**.6666667/A
     &)**2/G2-F)
      Yo=Yo-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' OPEN failed to converge'
      Qo=QQ*AREA**1.66666667/(B1+FMS*Yo)**.66666667
      RETURN
      END