C This program allow for lateral inflow over a lenth of the channel from positio
C XQSTAB and XQSTAE.
C Solves problem of flow into a mild channel from a reservoir that has a
C gate at its downstream end a position L downstream therefrom.
C  This program is the same as SOLGVFG with added statement to give the GVF
C  solution at specified increments along the channel.
      EXTERNAL DYX
      REAL F(3),D(3,3),X(3),KL2,KE1,KL,KE,W(1,13),Y(1),DY(1),XP(1),
     &YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,Y3,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QNU,Q2GU,
     &QND,Q2GD,X,XQSTAB,XQSTAE,QSTA,QSTAT,QD
      EQUIVALENCE (QU,X(1)),(Y1,X(2)),(Y2,X(3))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B1,FM1,B2,Y3,H,L,g,KL,KE,XQSTA
     &B,SQSTAE,QSTA'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B1,FM1,B2,Y3,H,FL,G,KL,KE,XQSTAB,
     &XQSTAE,QSTA
      QSTAT=QSTA*(XQSTAE-XQSTAB)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KL2=1.+KL
      KE1=1.+KE
      FM2=2.*FM1
      WRITE(*,*)' GIVE guess for: Q,Y1,Y2'
      READ(*,*) X
      QD=QU+QSTAT
      NCT=0
1     DO 10 I=1,3
      F(I)=FUN(I)
      DO 10 J=1,3
      DX=.005*X(J)
      X(J)=X(J)+DX
      IF(J.EQ.1) QD=QU+QSTAT
      D(I,J)=(FUN(I)-F(I))/DX
      IF(J.EQ.1) QD=QD-DX
10    X(J)=X(J)-DX
      FAC=D(3,1)/D(1,1)
      D(3,2)=D(3,2)-FAC*D(1,2)
      D(3,3)=D(3,3)-FAC*D(1,3)
      F(3)=F(3)-FAC*F(1)
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      D(2,3)=D(2,3)-FAC*D(1,3)
      F(2)=F(2)-FAC*F(1)
      FAC=D(3,2)/D(2,2)
      D(3,3)=D(3,3)-FAC*D(2,3)
      F(3)=F(3)-FAC*F(2)
      DIF1=F(3)/D(3,3)
      Y2=Y2-DIF1
      DIF=(F(2)-DIF1*D(2,3))/D(2,2)
      Y1=Y1-DIF
      SUM=ABS(DIF1)+ABS(DIF)
      DIF=(F(1)-D(1,2)*DIF-D(1,3)*DIF1)/D(1,1)
      SUM=SUM+ABS(DIF)
      QU=QU-DIF
      QD=QU+QSTAT
      NCT=NCT+1
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,100) X
100   FORMAT(' Q =',F10.3,', Y1 =',F10.3,', Y2 =',F10.3,/1X,50('-'),/,
     &'    x         Y       A        V        E       Fr',/,1X,50('-'))
      WRITE(*,*)' Give Delx x for GVF solution'
      READ(*,*) DELX
      H1=-.05
      HMIN=.001
      Y(1)=X(3)
      Q2GU=X(1)*X(1)/G2
      QNU=(FN*X(1)/CC)**2
      Q2GD=QD*QD/G2
      QND=(FN*QD/CC)**2
      XX=FL
      A=(B1+FM1*Y(1))*Y(1)
      V=QD/A
      WRITE(IOUT,110) FL,Y,A,V,Y(1)+V**2/G2,V/SQRT(G*A/(B1+FM2*Y(1)))
20    XZ=XX-DELX
      IF(XZ.LT.0.) XZ=0.
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      A=(B1+FM1*Y(1))*Y(1)
      IF(XZ.GE.XQSTAE) THEN
      V=QD/A
      ELSEIF(XZ.GE.XQSTAB) THEN
      V=(QU+(XQSTAE-XZ)*QSTA)/A
      ELSE
      V=X(1)/A
      ENDIF
      WRITE(IOUT,110) XZ,Y,A,V,Y(1)+V**2/G2,V/SQRT(G*A/(B1+FM2*Y(1)))
110   FORMAT(F8.1,F9.4,F8.2,F9.4,2F8.3)
      XX=XZ
      IF(XZ.GT.0.) GO TO 20
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(3),W(1,13),KL2,KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,Y3,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QNU,Q2GU,
     &QND,Q2GD,X,XQSTAB,XQSTAE,QSTA,QSTAT,QD
      H1=-.05
      HMIN=.001
      Q2GU=X(1)*X(1)/G2
      Q2GD=QD*QD/G2
      GO TO (1,2,3),II
1     FUN=X(3)+Q2GD/((B1+FM1*X(3))*X(3))**2-Y3-KL2*Q2GD/(B2*Y3)**2
      RETURN
2     FUN=H-X(2)-KE1*Q2GU/((B1+FM1*X(2))*X(2))**2
      RETURN
3     Y(1)=X(3)
      XX=FL
      XZ=0.
      QNU=(FN*X(1)/CC)**2
      QND=(FN*QD/CC)**2
      Q2GU=X(1)*X(1)/G
      Q2GD=QD*QD/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KL2,KE1,X(3)
      COMMON /TRAS/B1,FM1,B2,Y3,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QNU,Q2GU,
     &QND,Q2GD,X,XQSTAB,XQSTAE,QSTA,QSTAT,QD
      EQUIVALENCE (QU,X(1)),(Y1,X(2)),(Y2,X(3))
      P=B1+2.*SQRT(FM1*FM1+1.)*Y(1)
      A=(B1+FM1*Y(1))*Y(1)
      T=B1+2.*FM1*Y(1)
      IF(XX.GE.XQSTAE) THEN
      SF=QND*((P/A)**.666666667/A)**2
      DY(1)=(SO-SF)/(1.-Q2GD*T/A**3)
      ELSEIF(XX.GT.XQSTAB) THEN
      Q=QU+(XX-XQSTAB)*QSTA
      SF=(FN*Q/CC)**2*((P/A)**.666666667/A)**2
      DY(1)=(SO-SF-Q*QSTA/(A*A*G)-(Q/A)*QSTA/(G*A))/(1.-Q*Q*T/(G*A**3))
      ELSE
      SF=QNU*((P/A)**.666666667/A)**2
      DY(1)=(SO-SF)/(1.-Q2GU*T/A**3)
      ENDIF
      RETURN
      END
      
      
