C  Program to solve jump downstream from break in grade and upstream from gate.
C It is a modification of program SOLJMP.FOR that uses Chezy's equation.
      PARAMETER (N=4)
      EXTERNAL DYX
      CHARACTER*3 UNK(N)/'Y1u','Y1d','Y3 ','x  '/
      REAL F(N),F1(N),D(N,N),X(N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,FM,FM2,FMS,e,So,FL,G,G2,TOL,X,Y4,A4,QSG,Q1,YC,SG,
     &SQG,QV4
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,b,m,e,visc,So,L,Q1,Y4,g,Yc'
      READ(*,*) IOUT,TOL,ERR,B,FM,e,VISC,So,FL,Q1,Y4,G,YC
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      G2=2.*G
      A4=G2*((B+FM*Y4)*Y4)**2
      WRITE(*,*)' GIVE guess for:'
      DO 2 I=1,N
      WRITE(*,3) UNK(I)
2     READ(*,*) X(I)
3     FORMAT(1X,A3,' =',\)
      e=e/12.
      SG=SQRT(G)
      SQG=-SQRT(32.*G)
      QV4=4.*Q1/VISC
      C=SQG*ALOG10(e/(((B+FM*X(3))*X(3))/(B+FM2*X(3))))
50    NCT=0
1     CALL FUN(F)
      DO 10 J=1,N
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(F1)
      DO 5 I=1,N
5     D(I,J)=(F1(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(N,1,N,D,F,1,DD,INDX)
      SUM=0.
      DO 15 I=1,N
      X(I)=X(I)-F(I)
15    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I2,' SUM=',E12.5,4F10.4)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,*)' Solution:'
      DO 20 I=1,N
20    WRITE(IOUT,100) UNK(I),X(I)
100   FORMAT(1X,A3,' =',F10.3)
      END
      SUBROUTINE FUN(F)
      EXTERNAL DYX
      REAL X(4),F(4),W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,FM,FM2,FMS,e,So,FL,G,G2,TOL,X,Y4,A4,QSG,Q1,YC,SG,
     &SQG,QV4
      HMIN=.00001
      QSG=Q1*Q1/G
      DO 10 I=1,2
      IF(I.EQ.1) THEN
      H1=1.
      XX=0.
      XZ=X(4)
      YY=X(1)
      Y(1)=YC
      ELSE
      H1=-1.
      XX=FL
      XZ=X(4)
      YY=X(2)
      Y(1)=X(3)
      ENDIF
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
10    F(I)=YY-Y(1)
      F(3)=X(3)+(Q1/((B+FM*X(3))*X(3)))**2/G2-Y4-Q1*Q1/A4
      F(4)=.5*B*(X(1)**2-X(2)**2)+FM*(X(1)**3-X(2)**3)/3.+QSG*(1./((
     &B+FM*X(1))*X(1))-1./((B+FM*X(2))*X(2)))
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(4)
      COMMON /TRAS/B,FM,FM2,FMS,e,So,FL,G,G2,TOL,X,Y4,A4,QSG,Q1,YC,SG,
     &SQG,QV4
      YY=Y(1)
      IF(YY.LT. 0.05) YY=.1
      P=B+FMS*YY
      A=(B+FM*YY)*YY
      Rh=A/P
1     C1=C
      C=SQG*ALOG10(e/Rh+.884*C/(SG*QV4/P))
      IF(ABS(C-C1).GT. 1.E-4) GO TO 1
      SF=(Q1/(C*A))**2/Rh
      SoSf=So-SF
      FRM1=1.-QSG*(B+FM2*YY)/A**3
      IF(ABS(FRM1).LT. .01) THEN
      IF(ABS(FRM1).LT. 5.*ABS(SoSf)) THEN
      DY(1)=.2
      RETURN
      ENDIF
      ENDIF
      DY(1)=SoSf/FRM1
      RETURN
      END