      PARAMETER (N2=4,N=12,M=25)
      LOGICAL*2 IPERM,NTRAN
      REAL F(M),F1(M),D(M,M),FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),
     &X(M),QOUT(N2),LT
      INTEGER*2 INDX(M),ITYP(N),ICTL
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/NJ,NO,NOM,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL,QL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M),NODOWN(N)
      DATA IN,IOUT/2,3/
      IPERM=.FALSE.
      NTRAN=.TRUE.
C NJ=No. of Jun. minus 1 (jun. to last channel not counted), NO=No. channels
C  ITYP = 1 for trapezoidal channels, otherwise channel is circular.
C ICTL = 1,2 OR 3 for types of downstream controls, gate=1,critical=2, reser=3
C NODOWN is the downstr. chan. whose upstr. depth equals this channel's downst.
C  depth.  If NODOWN=0 then downstr. depth for this channel is unknown.
C YG is depth behind gate for gate; = 0 for critical;res. depth if
C reservoir.   DB and DFM are changes (+ or -) across transition of b and m.
C IN UNKNOWN VECTOR X (NO-1) Q's COMES 1ST; (NO) UPSTREAM DEPTHS NEXT & 
C NJ DOWNSTREAM DEPTHS (for 1st upstr. channel at each jun.+last ch.)
C i.e. Q(I)=X(I) for I=1 to NO-1;YU(I)=X(I+NO-1) for I=1 to NO; 
C YD(1)=X(NEQS-1 & YD(2)=X(NEQS).  Note other YD's = YU(NO).
      READ(IN,*) NJ,NO,(ITYP(I),B(I),FM(I),FN(I),SO(I),L(I),DZ(I),KL(I),
     &NODOWN(I),I=1,NO),LT,DB,DFM,YG,ICTL
      NOM=NO-1
      NEQS=2*NO+NJ
      NO2=NEQS-NJ-1
      READ(IN,*) TOL,ERR,H,G
      NI(1)=0
      II=1
      QOUTS=0.
      DO 2 J=1,NJ
      READ(IN,*) JI,(JN(I),I=II,II+JI-1),QOUT(J)
      QOUTS=QOUTS+QOUT(J)
      II=II+JI
2     NI(J+1)=II-1
      READ(IN,*)(X(I),I=1,NEQS) ! GUESSES (NO-1 Q'S 1ST, Yu next,Yd(1),Yd(NO)
      IF(G.GT. 30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      QL=X(1)-QOUTS
      DO 10 I=1,NO
10    KL(I)=(KL(I)+1.)/G2
      NCT=0
20    CALL FUN(F)
      DO 30 J=1,NEQS
      DX=.015*X(J)
      IF(J.EQ.1) QL=QL+DX
      X(J)=X(J)+DX
      CALL FUN(F1)
      DO 25 I=1,NEQS
25    D(I,J)=(F1(I)-F(I))/DX
      X(J)=X(J)-DX
      IF(J.EQ.1) QL=QL-DX
30    CONTINUE
      CALL SOLVEQ(NEQS,1,M,D,F,1,DD,INDX)
      DIF=0.
      DO 40 I=1,NEQS
      X(I)=X(I)-F(I)
40    DIF=DIF+ABS(F(I))
      QL=X(1)-QOUTS
      NCT=NCT+1
      WRITE(*,101) NCT,DIF,(X(I),I=1,NEQS)
101   FORMAT(' NCT =',I3,' SUM =',E12.5,/(8F10.3))
      IF(NCT.LT.30 .AND. DIF.GT.ERR) GO TO 20
      WRITE(IOUT,100) NO
100   FORMAT(' Solution to',I3,' Channel at Junction',/,1X,65('-'),/,
     &' No      b    m     n      So      L    dz     Yu     Yd       Q'
     &,/,1X,65('-'))
      DO 50 I=1,NO
      IF(I.EQ.NO) THEN
      YD=X(NEQS)
      QQ=QL
      ELSE IF(I.EQ.1) THEN
      III=NO2+1
      YD=X(III)
      QQ=X(1)
      ELSE
      IF(NODOWN(I).EQ.0) THEN
      III=III+1
      YD=X(III)
      ELSE
      YD=X(NOM+NODOWN(I))
      ENDIF
      QQ=X(I)
      ENDIF
50    WRITE(IOUT,110) I,B(I),FM(I),FN(I),SO(I),L(I),DZ(I),X(I+NOM),YD,
     &QQ
110   FORMAT(I3,F7.2,F5.2,F6.3,F8.6,F7.0,F6.2,2F7.3,F8.2)
      END
      SUBROUTINE FUN(F)
      PARAMETER (N2=4,N=12,M=25)
      EXTERNAL DYX
      LOGICAL*2 IPERM,NTRAN
      REAL F(M),FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),X(M),Y(1),DY(1),
     &W(1,13),XP(1),YP(1,1),LT,QOUT(N2)
      INTEGER*2 ITYP(N),ICTL
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/NJ,NO,NOM,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL,QL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M),NODOWN(N)
      H1=-.05
      HMIN=.0000001
      IPERM=.FALSE.
      II=1
      F(II)=H-X(NO)-KL(1)*(X(1)/AR(1,X(NO)))**2
      DO 10 I=1,NJ
      I1=NI(I)+1
      I2=NI(I+1)
      II=II+1
      JI=JN(I1)
      II1=II
      F(II1)=X(JI)-QOUT(I)
      EN=X(NO2+I)+(X(JI)/AR(JI,X(NO2+I)))**2/G2
      DO 10 J=I1+1,I2
      JI=JN(J)
      II=II+1
      F(II)=EN-X(NOM+JI)-KL(JI)*(X(JI)/AR(JI,X(NOM+JI)))**2-DZ(JI)
10    F(II1)=F(II1)-X(JI)
      DO 20 I=1,NO
      JI=I
      II=II+1
      XX=L(I)
      XZ=0.
      IPERM=.TRUE.
      IF(I.EQ.1) THEN
      QQ=X(1)
      III=NO2+1
      Y(1)=X(III)
      IF(ICTL.EQ.2) Y(1)=1.2*Y(1)
      ELSE IF(I.EQ.NO) THEN
      XX=XX+LT-1.E-5
      QQ=QL
      Y(1)=X(NEQS)
      ELSE
      IF(NODOWN(I).EQ.0) THEN
      III=III+1
      Y(1)=X(III)
      ELSE
      Y(1)=X(NOM+NODOWN(I))
      ENDIF
      QQ=X(I)
      ENDIF
      QN=(FN(I)*QQ/CC)**2
      Q2G=QQ**2/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
20    F(II)=X(NOM+I)-Y(1)
      II=II+1
      NTRAN=.FALSE.
      BB=B(NO)+DB
      FMM=FM(NO)+DFM
      IF(ICTL.EQ.1) THEN
      F(II)=X(NEQS)+(QL/AR(NO,X(NEQS)))**2/G2-YG-KL(NO)*
     &(QL/AR(NO,YG))**2
      NTRAN=.TRUE.
      ELSE IF(ICTL.EQ.2) THEN
      AA=AR(NO,X(NEQS))
      F(II)=QL**2*TOPW-G*AA**3
      ELSE
      F(II)=X(NEQS)-YG
      ENDIF
      NTRAN=.TRUE.
      RETURN
      END
      FUNCTION AR(I,YY)
      PARAMETER (N2=4,N=12,M=25)
      LOGICAL*2 IPERM,NTRAN
      REAL FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),X(M),LT,QOUT(N2)
      INTEGER*2 ITYP(N),ICTL
      COMMON /TRAS/NJ,NO,NOM,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL,QL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M),NODOWN(N)
      IF(ITYP(I).EQ.1) THEN
      IF(NTRAN) THEN
      BB=B(I)
      FMM=FM(I)
      ENDIF
      AR=(BB+FMM*YY)*YY
      IF(IPERM) THEN
      PERM=BB+2.*YY*SQRT(1.+FMM*FMM)
      TOPW=BB+2.*FMM*YY
      ENDIF
      ELSE
      COSB=1.-2.*YY/B(I)
      BETA=ACOS(COSB)
      AR=.25*B(I)**2*(BETA-SIN(BETA)*COSB)
      IF(IPERM) THEN
      PERM=BETA*B(I)
      TOPW=B(I)*SIN(BETA)
      ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      PARAMETER (N2=4,N=12,M=25)
      LOGICAL*2 IPERM,NTRAN
      REAL FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),X(M),Y(1),DY(1),LT,
     &QOUT(N2)
      INTEGER*2 ITYP(N),ICTL
      COMMON /TRAS/NJ,NO,NOM,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL,QL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M),NODOWN(N)
      IF(XX.LE.L(JI)) THEN
      NTRAN=.TRUE.
      DAX=0.
      ELSE
      NTRAN=.FALSE.
      FLEN=(XX-L(JI))/LT
      BB=B(JI)+FLEN*DB
      FMM=FM(JI)+FLEN*DFM
      DAX=Q2G*Y(1)*(DB+Y(1)*DFM)/LT
      ENDIF
      AA=AR(JI,Y(1))
      A3=AA**3
      SF=QN*(ABS(PERM/AA)**.666666667/AA)**2
      DY(1)=(SO(JI)-SF+DAX/A3)/(1.-Q2G*TOPW/A3)
      RETURN
      END