C Solves problem of max> flow in a mild channel between two reservoirs
C critical flow occurs at the end of this channel.
      REAL F(3),D(3,3),X(3),KL2,KE1,KL,KE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B1,FM1,H,L,g,KL,KE'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B1,FM1,H,FL,G,KL,KE
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KL2=.5*KL+1.5
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Y1,Yc'
      READ(*,*) X
      NCT=0
1     DO 10 I=1,3
      F(I)=FUN(I)
      DO 10 J=1,3
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(3,1)/D(1,1)
      D(3,2)=D(3,2)-FAC*D(1,2)
      D(3,3)=D(3,3)-FAC*D(1,3)
      F(3)=F(3)-FAC*F(1)
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      D(2,3)=D(2,3)-FAC*D(1,3)
      F(2)=F(2)-FAC*F(1)
      FAC=D(3,2)/D(2,2)
      D(3,3)=D(3,3)-FAC*D(2,3)
      F(3)=F(3)-FAC*F(2)
      DIF1=F(3)/D(3,3)
      Y2=Y2-DIF1
      DIF=(F(2)-DIF1*D(2,3))/D(2,2)
      Y1=Y1-DIF
      SUM=ABS(DIF1)+ABS(DIF)
      DIF=(F(1)-D(1,2)*DIF-D(1,3)*DIF1)/D(1,1)
      SUM=SUM+ABS(DIF)
      Q=Q-DIF
      NCT=NCT+1
      WRITE(*,110) NCT,SUM, X
110   FORMAT(' NCT=',I5,' SUM=',E12.6,3X,3F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,100) X
100   FORMAT(' Q =',F10.2,' Y1 =',F10.3,' Y2 =',F10.3)
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(3),W(1,13),KL2,KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X
      Q2G=X(1)*X(1)/G2
      GO TO (1,2,3),II
C   Applies only to rectangular channels
1     FUN=(X(1)/B1)**2-G*X(3)**3
      RETURN
2     FUN=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      RETURN
3     IF((X(1)/B1)**2/(G*X(3)**3).GT.1.)X(3)=((X(1)/B1)**2/G)**.3333+.02
      Y(1)=X(3)+.02
      XX=FL
      XZ=0.
      H1=-.05
      HMIN=.001
      QN=(FN*X(1)/CC)**2
      Q2G=X(1)*X(1)/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KL2,KE1,X(3)
      COMMON/TRAS/B1,FM1,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3))
      YY=Y(1)
      IF(YY.LT.0.01) YY=.01
      P=B1+2.*SQRT(FM1*FM1+1.)*YY
      A=(B1+FM1*YY)*YY
      SF=QN*((P/A)**.666666667/A)**2
      T=B1+2.*FM1*YY
      DY(1)=(SO-SF)/(1.-Q2G*T/A**3)
      RETURN
      END

