C The flow is assumed to be critical at beginning of side weir and downstream
C channel is mild and gate exists at end.  Unknowns: Qd (downstream flowrate),
C  Y1 (depth at beginning of side weir), & Y21 depth at beg. & Y22 depth at end
C  of the downstream channel.
C  X(1) = Qd; X(2) = Y1 (upstr. jump); X(3) = Y2 (downs. jump), X(4) =Y21
C  (depth upst in dows channel); X(5) = x (position of jump); X(6)=Y22 (depth
C  dows in dows channel)
      LOGICAL DONE,UPST
      INTEGER*2 INDX(6)
      REAL F(6),D(6,6),X(6),FFF(6)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,Y1,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XX,X,IPRNT,DONE,UPST,IOUT,Ygd,FL2
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,Qu,Y1,FN,SO,B1,FM1,B2,FM2,L,W,Cd,g,P
     &RNT,PRNTM,Ygd,FL2'
      READ(*,*) IOUT,TOL,ERR,Qu,Y1,FN,SO,B1,FM1,B2,FM2,FL,W,Cd,G,IPRNT,
     &IPRMOR,Ygd,FL2
      DONE=.FALSE.
      FMSQ=2.*SQRT(FM2*FM2+1.)
      DB=(B1-B2)/FL
      DM=(FM1-FM2)/FL
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      CS=CC*SQRT(SO)
      G2=2.*G
      CDG=Cd*SQRT(G2)
      WRITE(*,*)' GIVE guess for: Qd,Y1,Y2,Y21,x,Y22'
      READ(*,*) X
      NCT=0
      IF(IPRMOR.GT.1) DONE=.TRUE.
1     CALL FUN(F)
      DO 10 J=1,6
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(FFF)
      DO 9 I=1,6
9     D(I,J)=(FFF(I)-F(I))/DX
10    X(J)=X(J)-DX
      IF(IPRMOR.GT.0) THEN
      DO 11 I=1,6
11    WRITE(*,333)(D(I,J),J=1,6),F(I)
333   FORMAT(6F10.3)
      ENDIF
      CALL SOLVEQ(6,1,6,D,F,1,DD,INDX)
      IF(IPRMOR.GT.0) WRITE(*,334) (F(I),I=1,6)
334   FORMAT(' sol',6F10.3)
      NCT=NCT+1
      DIF=0.
      DO 20 I=1,6
      X(I)=X(I)-F(I)
20    DIF=DIF+ABS(F(I))
      WRITE(*,110) NCT,DIF,X
110   FORMAT(' NCT=',I3,' DIF=',E12.6,/,6F10.3)
      IF(NCT.LT.30 .AND. DIF.GT. ERR) GO TO 1
      DONE=.TRUE.
      CALL FUN(FFF)
      WRITE(IOUT,100) X
100   FORMAT(' Qd =',F10.2,' Y1 =',F10.3,' Y2 =',F10.3,' Y21 =',F10.3,
     &/,' x =',F10.2,' Y22 =',F10.3)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE,UPST
      EXTERNAL DYX,DYXD
      REAL X(6),WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(6)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,Y1,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XX,X,IPRNT,DONE,UPST,IOUT,Ygd,FL2
      H1=-.05
      HMIN=.00001
      Y(1)=X(6)
      CALL ODESOL(Y,DY,1,FL2,0.,TOL,H1,HMIN,1,XP,YP,WW,DYXD)
      F(1)=X(4)-Y(1)
      IF(X(5).LT.0.) THEN
      SQSTAU=0.
      GO TO 3
      ENDIF
      H1=.05
      Y(1)=Y1
      XX=0.
      UPST=.FALSE.
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
100   FORMAT('     x       Y    acc. q*  av. q*           X1        X2
     &      Q',/,1X,67('-'))
      ENDIF  
      SQSTAR=0.
      IF(Y(1).LT.W) THEN
      QSTAR1=0.
      ELSE
      QSTAR1=CDG*(Y(1)-W)**1.5
      ENDIF
2     XZ=XX+1.
      IF(XZ.GT.X(5)) XZ=X(5)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(Y(1).LT.W) THEN
      QSTAR2=0.
      ELSE
      QSTAR2=CDG*(Y(1)-W)**1.5
      ENDIF
      SQSTAR=SQSTAR+(XZ-XX)*(QSTAR1+QSTAR2)/2.
      QSTAR1=QSTAR2
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. ABS(XZ-X(5)).LT. .001) THEN
      QQ=Qu-SQSTAR
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ,QQ
110   FORMAT(F8.2,F8.3,2F8.3,'  betw.',F8.2,' &',F8.2,F10.2)
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      XX=XZ
      IF(XZ.LT. X(5)-.001) GO TO 2
      SQSTAU=SQSTAR
      F(2)=X(2)-Y(1)
3     H1=-.05
      HMIN=.00001
      Y(1)=X(4)
      IF(X(5).GT.FL) GO TO 8
      XX=FL
      UPST=.TRUE.
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
      ENDIF  
      SQSTAR=0.
      IF(Y(1).LT.W) THEN
      QSTAR1=0.
      ELSE
      QSTAR1=CDG*(Y(1)-W)**1.5
      ENDIF
4     XZ=XX-1.
      IF(XZ.LT.X(5)) XZ=X(5)
      IF(XZ.LT.0.) XZ=0.
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(Y(1).LT.W) THEN
      QSTAR2=0.
      ELSE
      QSTAR2=CDG*(Y(1)-W)**1.5
      ENDIF
      SQSTAR=SQSTAR+(XX-XZ)*(QSTAR1+QSTAR2)/2.
      QSTAR1=QSTAR2
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. ABS(XZ-X(5)).LT. .001) THEN    
      QQ=X(1)+SQSTAR
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ,QQ
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      XX=XZ
      IF(XZ.GT. X(5)+.001 .AND. XZ.GT. 0.) GO TO 4
      SQSTAD=SQSTAR
8     F(3)=X(3)-Y(1)
      B=B1+DB*X(5)
      FM=FM1+DM*X(5)
      FMM1=(B/2.+X(2)*FM/3.)*X(2)**2+(Qu-SQSTAU)**2/G/((B+X(2)*FM)*X(2))
      FMM2=(B/2.+X(3)*FM/3.)*X(3)**2+(Qu-SQSTAU)**2/G/((B+X(3)*FM)*X(3))
      F(4)=FMM1-FMM2
      F(5)=Qu-X(1)-SQSTAU-SQSTAD
      F(6)=X(6)+(X(1)/((B2+FM2*X(6))*X(6)))**2/G2-Ygd-(X(1)/((B2+FM2*Ygd
     &)*Ygd))**2/G2
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(6)
      LOGICAL DONE,UPST
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,Y1,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XXB,X,IPRNT,DONE,UPST,IOUT,Ygd,FL2
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      B=B1+DB*XX
      FM=FM1+DM*XX
      P=B+2.*SQRT(FM*FM+1.)*YY
      A=(B+FM*YY)*YY
      IF(YY.LT.W) THEN
      QSTAR=0.
      ELSE
      QSTAR=CDG*(YY-W)**1.5
      ENDIF
      IF(UPST) THEN
      QQ=X(1)+SQSTAR+ABS(XXB-XX)*(QSTAR+QSTAR1)/2.
      ELSE
      QQ=Qu-SQSTAR-ABS(XX-XXB)*(QSTAR+QSTAR1)/2.
      ENDIF
      SF=(FN*QQ/CC*(P/A)**.666666667/A)**2
      T=B+2.*FM*YY
      A3=A**3
      QQS=QQ*QQ
      FR1=1.-QQS*T/G/A3
      IF(ABS(FR1) .LT. .01) THEN
      DY(1)=0.
      ELSE
      DY(1)=(SO-SF+QQ*QSTAR/(G*A*A)+QQS/(G*A3)*(DB+YY*DM)*YY)/FR1
      ENDIF
      RETURN
      END
      SUBROUTINE DYXD(XX,Y,DY)
      REAL Y(1),DY(1),X(6)
      LOGICAL DONE,UPST
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,Y1,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XXB,X,IPRNT,DONE,UPST,IOUT,Ygd,FL2
      A=(B2+FM2*Y(1))*Y(1)
      SF=(FN*X(1)*((B2+FMSQ*Y(1))/A)**.666667/A)**2
      DY(1)=(SO-SF)/(1.-X(1)**2*(B2+2.*FM2*Y(1))/(G*A**3))
      RETURN
      END