      COMMON NGOOD,NBAD,KMAX,KCOUNT,DXSAVE
      COMMON/TRAS/V(5,10),YG(10),BG(10),B(11),FM(11),FN(11),FL(11),
     &So(11),H,FKE,TOL,QN,HMIN,H1,SOC,BC,FMC,FMS,FM2,Q2G,Y1,YE,G,Q,Cu,
     &QS(11),G2,NGATE,IBCE,NEQ,NC
      REAL FF(57),F(57),DJ(57,57)
      INTEGER*2 INDX(57)
      READ(2,*) NGATE,IBCE,G,Q,H,FKE,Y1,YE,TOL
      NC=NGATE+1
C For each gate V(1,I)=Yd, V(2,I)=Y3, V(3,I)=Y, V(4,I)=Y1, V(5,I)=Yu
C IBCE=1 (Long downstream channel so YE is uniform depth & V(1,NGATE)=YE
C IBCE=2 (Downstream reservoir with w.s. elevation = YE (specified))
C IBCE=3 (Critical depth at end of channel NC, YE = Critical depth)
      READ(2,*)(YG(I),BG(I),I=1,NGATE)
C QS(I) is the outflow from the channel just upstream from the gate after
C transition; positive values are out, and inflows are negative values.
      READ(2,*)(B(I),FM(I),FN(I),FL(I),So(I),QS(I),I=1,NC)
C  Guesses depths Y1,Y,Y3 for each gate
      DO 10 I=1,NGATE
      READ(2,*) V(4,I),V(3,I),V(2,I)
      V(5,I)=1.005*V(4,I)
10    V(1,I)=1.005*V(2,I)
      IF(G.LT.25.) THEN
      Cu=1
      ELSE
      Cu=1.486
      ENDIF
      G2=2.*G
      FKE=1.+FKE
      H1=-.05
      HMIN=.0005
      NEQ=5*NGATE+2
      IF(IBCE.EQ.3) NEQ=NEQ+1
      NCT=0
      WT=.2
20    SUM=0.
      CALL FUNCT(F)
      DO 40 I=1,NGATE
      DO 40 J=1,5
      IJ=5*(I-1)+J
      XX=V(J,I)
      V(J,I)=1.005*XX
      CALL FUNCT(FF)
      DO 30 K=1,NEQ
30    DJ(K,IJ)=(FF(K)-F(K))/(V(J,I)-XX)
40    V(J,I)=XX
      IJ=IJ+1
      XX=Y1
      Y1=1.005*Y1
      CALL FUNCT(FF)
      DO 45 K=1,NEQ
45    DJ(K,IJ)=(FF(K)-F(K))/(Y1-XX)
      Y1=XX
      IJ=IJ+1
      XX=Q
      Q=1.005*Q
      CALL FUNCT(FF)
      DO 50 K=1,NEQ
50    DJ(K,IJ)=(FF(K)-F(K))/(Q-XX)
      Q=XX
      IF(IBCE.GT.2) THEN
      XX=YE
      YE=1.005*YE
      CALL FUNCT(FF)
      DO 55 K=1,NEQ
55    DJ(K,NEQ)=(FF(K)-F(K))/(YE-XX)
      YE=XX
      ENDIF
      CALL SOLVEQ(NEQ,1,57,DJ,F,1,DD,INDX)
      DO 60 I=1,NGATE
      DO 60 J=1,5
      IJ=5*(I-1)+J
      V(J,I)=V(J,I)-WT*F(IJ)
60    SUM=SUM+ABS(F(IJ))
      IJ=IJ+1
      Y1=Y1-WT*F(IJ)
      SUM=SUM+ABS(F(IJ))
      IJ=IJ+1
      Q=Q-WT*F(IJ)
      SUM=SUM+ABS(F(IJ))
      IF(IBCE.EQ.3) THEN
      YE=YE-F(NEQ)
      SUM=SUM+ABS(F(NEQ))
      ENDIF
      NCT=NCT+1 
      IF(SUM.LT.5.) WT=1.
      WRITE(*,200) NCT,SUM,((V(J,I),J=1,5),I=1,NGATE),Y1,Q,YE
200   FORMAT(' NCT=',I4,' SUM=',E12.3,/(10F8.3))
      IF(WT.LT.1.) THEN
      WRITE(*,*)' Current Weight factor=',WT,' Give new one'
      READ(*,*) WT
      ENDIF
      IF(NCT.LT.40 .AND. SUM.GT. 1.E-4) GO TO 20
      DO 70 I=1,NGATE
70    WRITE(3,100) I,(V(J,I),J=1,5)
      IF(IBCE.EQ.1) YE=V(1,NGATE)
      WRITE(3,101) Y1,Q,YE
100   FORMAT(I4,5F8.3)
101   FORMAT(' Y1=',F8.3,' Q=',F10.3,' Ye=',F8.3)
      END
      SUBROUTINE FUNCT(F)
      REAL F(57)
      COMMON NGOOD,NBAD,KMAX,KCOUNT,DXSAVE
      COMMON/TRAS/V(5,10),YG(10),BG(10),B(11),FM(11),FN(11),FL(11),
     &So(11),H,FKE,TOL,QN,HMIN,H1,SOC,BC,FMC,FMS,FM2,Q2G,Y1,YE,G,Q,Cu,
     &QS(11),G2,NGATE,IBCE,NEQ,NC
      REAL Y(1),DY(1),W(1,13),XP(1),YP(1,1)
      EXTERNAL DYX
      QQ=Q
      Q2G=Q*Q/G2
      F(1)=H-Y1-FKE*Q2G/((B(1)+FM(1)*Y1)*Y1)**2
      DO 10 I=1,NGATE
      J=I+1
      IG=5*(I-1)+1
      BC=B(I)
      FMC=FM(I)
      FM2=2.*FM(I)
      FMS=2.*SQRT(FM(I)**2+1.)
      SOC=So(I)
      QN=(FN(I)*QQ/Cu)**2
      QQ=QQ-QS(I)
      Q2GN=QQ*QQ/G2
      QS1=(QQ/BG(I))**2/G2 
      QMG=2.*QS1
      Y2=(.59+.022*YG(I)/V(4,I))*YG(I)
      H11=V(4,I)+QS1/V(4,I)**2
      F(IG+1)=V(5,I)+Q2G/((BC+FMC*V(5,I))*V(5,I))**2-H11
      F(IG+2)=H11-V(3,I)-QS1/Y2**2
      F(IG+3)=.5*(V(3,I)**2-V(2,I)**2)+QMG/Y2-QMG/V(2,I)
      F(IG+4)=V(2,I)+QS1/V(2,I)**2-V(1,I)-Q2GN/((B(J)+FM(J)*V(1,I))*V(1,
     &I))**2
      Y(1)=V(5,I)
      CALL ODESOL(Y,DY,1,FL(I),0.,TOL,H1,HMIN,1,XP,YP,W,DYX)
      IF(I.EQ.1) THEN
      F(IG+5)=Y1-Y(1)
      ELSE
      F(IG+5)=V(1,I-1)-Y(1)
      ENDIF
10    Q2G=Q2GN
      QQ=QQ-QS(NC)
      IF(IBCE.EQ.1) THEN
      IG=IG+6
      F(IG)=FN(NC)*QQ*(B(NC)+2.*V(1,NGATE)*SQRT(FM(NC)**2+1.))**.6666667
     &-Cu*((B(NC)+FM(NC)*V(1,NGATE))*V(1,NGATE))**1.666667*SQRT(So(NC))
      ELSE
      Y(1)=YE
      Q2G=QQ*QQ/G2
      IF(IBCE.EQ.3) F(NEQ-1)=.5*Q2G*(B(NC)+2.*FM(NC)*YE)-G*((B(NC)+FM(NC
     &)*YE)*YE)**3
      BC=B(NC)
      FMC=FM(NC)
      FM2=2.*FM(NC)
      FMS=2.*SQRT(FM(NC)**2+1.)
      SOC=So(NC)
      QN=(FN(NC)*QQ/Cu)**2
      CALL ODESOL(Y,DY,1,FL(NC),0.,TOL,H1,HMIN,1,XP,YP,W,DYX)
      F(NEQ)=V(1,NGATE)-Y(1)
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(X,Y,DY)
      REAL Y(1),DY(1)
      COMMON/TRAS/V(5,10),YG(10),BG(10),B(11),FM(11),FN(11),FL(11),
     &So(11),H,FKE,TOL,QN,HMIN,H1,SOC,BC,FMC,FMS,FM2,Q2G,Y1,YE,G,Q,Cu,
     &QS(11),G2,NGATE,IBCE,NEQ,NC
      P=BC+FMS*Y(1)
      A=(BC+FMC*Y(1))*Y(1)
      SF=QN*((P/A)**.6666667/A)**2
      DY(1)=(SOC-SF)/(1.-2.*Q2G*(BC+FM2*Y(1))/A**3)
      RETURN
      END