      WRITE(*,*)' Give: Q,n1,So1,n2,So2,b1,m1,b2,m2,z1,L,KL,G,NSTA'
      READ(*,*) Q,Fn1,So1,Fn2,So2,B1,FM1,B2,FM2,Z1,FL,FKL,G,NSTA
      Cu=1.486
      IF(G.LT.20.) Cu=1.
      Yo1=.5*B1
      Yo2=.5*B2
      CALL YNORMAL(Yo1,Fn1,So1,B1,FM1,Q,Cu)
      CALL YNORMAL(Yo2,Fn2,So2,B2,FM2,Q,Cu)
      WRITE(3,130) Yo1,Yo2
130   FORMAT(' Normal Depths Yo1=',F9.3,' Yo2=',F9.3)
      FNSTM=FLOAT(NSTA)/2.
      DX=FL/FLOAT(NSTA)
      G2=2.*G
      A1=(B1+FM1*YO1)*YO1
      A2=(B2+FM2*YO2)*YO2
      VH1=(Q/A1)**2/G2
      VH2=(Q/A2)**2/G2
      HL=FKL*ABS(VH1-VH2)
      WS1=Z1+YO1
      EL1=WS1+VH1
      EL2=EL1-HL
      WS2=EL2-VH2
      DEL=HL/FLOAT(NSTA)
      DWS=(WS2-WS1)/2.
      DB=(B2-B1)/2.
      DM=(FM2-FM1)/FLOAT(NSTA)
      WRITE(3,100)
100   FORMAT(' Sta   x       m       b     elev-EL     EL-ws   Vel.H   
     &  V      A       Y       z')
      WRITE(3,110) 'Beg',0.,FM1,B1,EL1,WS1,VH1,SQRT(G2*VH1),A1,YO1,Z1
110   FORMAT(1X,A3,F6.1,2F8.3,2F10.3,5F8.3)
      DO 10 I=2,NSTA-1
      FM=FM1+FLOAT(I-1)*DM
      EL=EL1-FLOAT(I-1)*DEL
      IF(I.LE.NSTA/2) THEN
      B=B1+(FLOAT(I-1)/FNSTM)**2*DB
      WS=WS1+(FLOAT(I-1)/FNSTM)**2*DWS
      ELSE
      B=B2-(FLOAT(NSTA-I)/FNSTM)**2*DB
      WS=WS2-(FLOAT(NSTA-I)/FNSTM)**2*DWS
      ENDIF
      VH=EL-WS
      V=SQRT(G2*VH)
      A=Q/V
      Y=(SQRT(B*B+4.*FM*A)-B)/(2.*FM)
      Z=WS-Y
10    WRITE(3,120) I,DX*FLOAT(I-1),FM,B,EL,WS,VH,V,A,Y,Z
120   FORMAT(I4,F6.1,2F8.3,2F10.3,5F8.3)
      WRITE(3,110)'End',FL,FM2,B2,EL2,WS2,VH2,SQRT(G2*VH2),
     &(B2+FM2*YO2)*YO2,YO2,WS2-YO2
      END
      SUBROUTINE YNORMAL(Yo,Fn,So,B,FM,Q,C)
      M=0
      C1=Fn*Q
      C2=C*SQRT(So)
      FMS=2.*SQRT(FM*FM+1.)
1     F=C1*(B+FMS*Yo)**.6666667-C2*((B+FM*Yo)*Yo)**1.6666667
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      F1=F
      Yoo=Yo
      Yo=1.005*Yo
      GO TO 1
      ENDIF
      DIF=(Yo-Yoo)*F1/(F-F1)
      Yo=Yoo-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. M.LT.30) GO TO 1
      RETURN
      END