#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
float b1,fm1,fn1,so1,q,fms1,q2g,fm12,c;
float simpr(float xb,float xe,float err,int max);
float ynormal(float yo,float n,float so,float b, float m){ int nct;
 float c1,c2,fms,f,f1,yoo,dif;
 nct=0; c1=n*q; c2=c*sqrt(so); fms=2.*sqrt(m*m+1.);
 do{L1: f=c1*pow(b+fms*yo,.66666667)-c2*pow((b+m*yo)*yo,1.666667); nct++;
 if(nct%2){f1=f; yoo=yo; yo*=1.005; goto L1;}
 dif=(yo-yoo)*f1/(f-f1); yo=yoo-dif; } while ((fabs(dif)>1.e-5) && (nct<30));
 return yo; }  // End ynormal
float equat(float y){ float a,sf;
 a=(b1+fm1*y)*y; sf=pow(fn1*q*pow(b1+fms1*y,.6666667)/(c*pow(a,1.6666667)),2.);
 return ((1.-q2g*(b1+fm12*y)/pow(a,3.))/(so1-sf)); } // End equat
void main(void){ int i,nq,nct;  FILE *filo; char fname[20]; char type[3];
 float yo1,yo2,fn2,so2,b2,fm2,x,dz,dq,g,g2,kl,qb,c2,f,f1,y1,dif,y11,fr2;
 printf("Give name of output file\n");scanf("%s",fname);
 if((filo=fopen(fname,"w"))==NULL){printf("Cannot open file");exit(0);}
 printf("Give: b1,m1,n1,So1,b2,m2,n2,So2,Kl,Delz,Q,DelQ,g,NQ\n");
 scanf("%f %f %f %f %f %f %f %f %f %f %f %f %f %d", \
   &b1,&fm1,&fn1,&so1,&b2,&fm2,&fn2,&so2,&kl,&dz,&qb,&dq,&g,&nq);
 fm12=2.*fm1; fms1=sqrt(fm1*fm1+1.); c=1.486; if(g<20.) c=1.; yo1=.5*b1; yo2=.5*b2;
 kl=1.-kl; g2=2.*g;
 fprintf(filo,"   Q       Yo1     Yo2      Y1    del Y      x     Fr**2\n");
 for(i=0;i<nq;i++){ q=qb+dq*(float) i; q2g=q*q/g;
 yo1=ynormal(yo1,fn1,so1,b1,fm1); yo2=ynormal(yo2,fn2,so2,b2,fm2);
 c2=dz-yo2-kl*pow(q/((b2+fm2*yo2)*yo2),2.)/g2; y1=yo1; nct=0;
 do{L10:f=y1+kl*pow(q/((b1+fm1*y1)*y1),2.)/g2+c2;
  if(++nct%2){f1=f;y11=y1;y1*=1.005;goto L10;}
 dif=(y1-y11)*f1/(f-f1); y1=y11-dif;}while((fabs(dif)>1.e-5) &&(nct<30));
 if(y1>=yo1){ y11=1.01*yo1; stpcpy(type,"M-1");
  if(y11>=y1) x=0.; else x=simpr(y1,y11,1.e-5,20);} else {
 y11=.99*yo1; stpcpy(type,"M-2"); if(y11<=y1) x=0.; else x=simpr(y1,y11,1.e-5,20);}
 fr2=q2g*(b1+fms1*y1)/pow((b1+fm1*y1)*y1,3.);
 fprintf(filo,"%8.1f %7.3f %7.3f %7.3f %7.3f %8.1f %7.3f %s\n",q,yo1,yo2,y1,y1-yo1,fabs(x),fr2,type);}
fclose(filo);} // End main
float simpr(float xb,float xe,float err,int max){
 float ev=-1.e30,ev1=-1.e30,delx,sum,x,value,valu1;
 int m=1,i=1,j;
 valu1=.5*(xe-xb)*(equat(xb)+equat(xe));
 do{ i++;
  delx=(xe-xb)/(float)m;
  x=xb+.5*delx; sum=0;
  for(j=0;j<m;j++){sum+=equat(x); x+=delx;}
  valu1=.5*(valu1+(xe-xb)*sum/(float)m); m*=2;
  value=(4.*valu1-ev1)/3.;
  if(fabs(value-ev)<err*fabs(ev)) return value;
  ev=value; ev1=valu1;
 }while(i<max);
 printf("Failed to satisfy error req. %f\n",value-ev);
 return value;
}