      EXTERNAL EQUAT
      COMMON B1,FM1,FN1,So1,Q,FMS1,Q2G,FM12,Cu
      CHARACTER*3 TYPE
      WRITE(*,*)' Give: b1,m1,n1,So1,b2,m2,n2,So2,Kl,Delz,Q,DelQ,g,NQ'
      READ(*,*) B1,FM1,FN1,SO1,B2,FM2,FN2,SO2,FKL,DZ,QB,DQ,G,NQ
      FM12=2.*FM1
      Cu=1.486
      IF(G.LT.20.) Cu=1.
      Yo1=.5*B1
      Yo2=.5*B2
      FKL=1.-FKL
      G2=2.*G
      FMS1=SQRT(FM1*FM1+1.)
      WRITE(3,100)
100   FORMAT('   Q       Yo1     Yo2      Y1    del Y      x     Fr**2')
      DO 50 I=1,NQ
      Q=QB+DQ*FLOAT(I-1)
      Q2G=Q*Q/G
      CALL YNORMAL(Yo1,Fn1,So1,B1,FM1,Q,Cu)
      CALL YNORMAL(Yo2,Fn2,So2,B2,FM2,Q,Cu)
      C2=DZ-Yo2-FKL*(Q/((B2+FM2*Yo2)*Yo2))**2/G2
      Y1=Yo1
      M=0
10    F=Y1+FKL*(Q/((B1+FM1*Y1)*Y1))**2/G2+C2
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 20
      F1=F
      Y11=Y1
      Y1=1.005*Y1
      GO TO 10
20    DIF=(Y1-Y11)*F1/(F-F1)
      Y1=Y11-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. M.LT.30) GO TO 10
      IF(Y1.GE.Yo1) THEN
      Y11=1.01*Yo1
      TYPE='M-1'
      IF(Y11.GE.Y1) THEN
      X=0.
      ELSE
      CALL SIMPR(EQUAT,Y1,Y11,X,1.E-5,20)
      ENDIF
      ELSE
      Y11=.99*Yo1
      TYPE='M-2'
      IF(Y11.LE.Y1) THEN
      X=0.
      ELSE
      CALL SIMPR(EQUAT,Y1,Y11,X,1.E-5,20)
      ENDIF
      ENDIF
      FR2=Q2G*(B1+FMS1*Y1)/((B1+FM1*Y1)*Y1)**3
50    WRITE(3,110) Q,Yo1,Yo2,Y1,Y1-Yo1,ABS(X),FR2,TYPE
110   FORMAT(F8.1,4F8.3,F9.1,F8.3,A6)
      END
      FUNCTION EQUAT(Y)
      COMMON B1,FM1,FN1,So1,Q,FMS1,Q2G,FM12,Cu
      A=(B1+FM1*Y)*Y
      SF=(FN1*Q*(B1+FMS1*Y)**.666667/(Cu*A**1.666667))**2
      EQUAT=(1.-Q2G*(B1+FM12*Y)/A**3)/(So1-SF)
      RETURN
      END
      SUBROUTINE YNORMAL(Yo,Fn,So,B,FM,Q,C)
      M=0
      C1=Fn*Q
      C2=C*SQRT(So)
      FMS=2.*SQRT(FM*FM+1.)
1     F=C1*(B+FMS*Yo)**.6666667-C2*((B+FM*Yo)*Yo)**1.6666667
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      F1=F
      Yoo=Yo
      Yo=1.005*Yo
      GO TO 1
      ENDIF
      DIF=(Yo-Yoo)*F1/(F-F1)
      Yo=Yoo-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. M.LT.30) GO TO 1
      RETURN
      END