C Solves UCW with upstream gate instantly raised with GVF downstream with Y3 given
C If Y3 is negative then free overfall occurs at end of channel
C  Uses the implicit method
      INTEGER*2 INDX(4)
      REAL F(4),F1(4),D(4,4),Y(1),YTT(1)
      COMMON B,FM,FM2,FMS,FM3,BH,Yb,FL,DL,Qo,G,G2,Qb,DXS,XPOS,X(4),CUN
     &,SO,DT5,WV1,Yi(15),INIT
      INIT=0
      WRITE(*,*)' Give: g,b,m,n,So,Qo,L & downst. Y3 (if<0,free overf.)'
      READ(*,*) G,B,FM,FN,SO,Qo,FL,Y3
      BH=.5*B
      FM3=FM/3.
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      G2=2.*G
      CU=1.486
      IF(G.LT.20.) CU=1.
      CUN=FN/CU
      ICRIT=0
      IF(Y3.GT.0.) GO TO 15
      Y3=ABS(Y3)
      QS2=Qo*Qo      
      NCT=0
10    FF=QS2*(B+FM2*Y3)-G*((B+FM*Y3)*Y3)**3
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 12
      FF1=FF
      YY=Y3
      Y3=1.005*Y3
      GO TO 10
12    DIF=(Y3-YY)*FF1/(FF-FF1)
      Y3=YY-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.20) GO TO 10
      WRITE(3,100) Y3,Qo
      WRITE(6,100) Y3,Qo
100   FORMAT(' Critical depth at end=',F8.3,', Qo=',F8.1)
      ICRIT=1
15    DL=FL/14.
      Yi(15)=Y3
      Y(1)=Y3
      DXS=-2.
      IF(ICRIT.GT.0) THEN
      Y(1)=1.025*Y(1)
      DXS=-.01
      ENDIF
      XX=FL
      DO 16 I=14,1,-1
      XX1=XX-DL
      CALL RUKUST(1,DXS,XX,XX1,1.E-4,Y,YTT)
      Yi(I)=Y(1)
16    XX=XX1
      WRITE(3,101)(DL*FLOAT(I-1),Yi(I),I=1,15)
      WRITE(6,101)(DL*FLOAT(I-1),Yi(I),I=1,15)
101   FORMAT(' Initial GVF Profile',/,(5(F8.1,F8.3)))
      INIT=1
      Yo=Yi(1)
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      HCA1=(BH+FM3*Yo)*Yo*Yo
      WRITE(*,*)' Give: New Q2, Dt, NT & Guess for Yb'
      READ(*,*) Qb,DT,NT,Yb
      DT5=.5*DT
      HC1=HCA1/Ao
      NCT=0
17    A=(B+FM*Yb)*Yb
      HCA2=(BH+FM3*Yb)*Yb*Yb
      FF=G*(HCA2/Ao-HC1)/(1.-Ao/A)-((Qb-Qo)/(A-Ao)-Vo)**2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 18
      FF1=FF
      Yb2=Yb
      Yb=1.005*Yb
      GO TO 17
18    DIF=(Yb-Yb2)*FF1/(FF-FF1)
      Yb=Yb2-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.30) GO TO 17
C  v=X(1); Y2=X(2); Q2=X(3); Position of wave x=X(4)
      A=(B+FM*Yb)*Yb
      X(1)=(Qb-Qo)/(A-Ao)
      WRITE(6,105) Qb,Yb,A,SQRT(ABS(G*A/(B+FM2*Yb))),X(1)
      WRITE(3,105) Qb,Yb,A,SQRT(G*A/(B+FM2*Yb)),X(1)
105   FORMAT(' For New Q=',F8.2,/' Starting Depth Yb=',F8.3,' A=',F8.2,
     &' Celerity=',F8.3,' Wave Velocity=',F8.3)
      X(2)=Yb
      X(3)=.5*(Qo+Qb)
      X(4)=DT*X(1)
      WRITE(3,108)
108   FORMAT(/' Time Wave V.    Y2     Q2       x       Y1      V1      
     &Fr1     Fr2'/,1X,69('-'))
      WRITE(3,110) 0,X(1),Yb,Qb,0.0,Yo,Vo,(X(1)-Vo)/SQRT(G*Ao/(B+FM2*Yo)
     &),(X(1)-Qb/A)/SQRT(G*A/(B+FM2*Yb))
      DXS=.5
      XPOS=0.
      WV1=X(1)
      DO 50 K=1,NT
      NCT=0
20    SUM=0.
      CALL FUN(F)
      DO 22 I=1,4
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN(F1)
      DO 21 J=1,4
21    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
22    X(I)=XX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      DO 24 I=1,4
      X(I)=X(I)-F(I)
24    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM,X
      IF(SUM.GT. 5.E-4 .AND. NCT.LT.20) GO TO 20
      M=X(4)/DL+1
      IF(M.GT.14) THEN
      Yo=Yi(15)
      ELSE
      FAC=(X(4)-DL*FLOAT(M-1))/DL
      Yo=Yi(M)+FAC*(Yi(M+1)-Yi(M))
      ENDIF
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      A=(B+FM*X(2))*X(2)
      FR1=(X(1)-Vo)/SQRT(G*Ao/(B+FM2*Yo))
      FR2=(X(1)-X(3)/A)/SQRT(G*A/(B+FM2*X(2)))
      WRITE(3,110) IFIX(DT*FLOAT(K)),X,Yo,Vo,FR1,FR2
      WV1=X(1)
      XPOS=X(4)
      IF(X(4).GT. FL) STOP
      X(4)=X(4)+DT*WV1
110   FORMAT(I5,2F8.3,F8.2,F8.1,4F8.3)
      IF(FR1.LT.1.07 .AND. K.LT.NT) THEN
      WRITE(*,*)' Froude No. close to 1.  Give 1 to try another step, 0=
     &STOP'
      READ(*,*) NCT
      IF(NCT.NE.1) STOP
      ENDIF
50    CONTINUE
      END
      SUBROUTINE FUN(F)
      REAL F(4),Y(1),YTT(1)
      COMMON B,FM,FM2,FMS,FM3,BH,Yb,FL,DL,Qo,G,G2,Qb,DXS,XPOS,X(4),CUN
     &,SO,DT5,WV1,Yi(15),INIT
      M=X(4)/DL+1
      IF(M.GT.14) THEN
      Yo=Yi(15)
      ELSE
      FAC=(X(4)-DL*FLOAT(M-1))/DL
      Yo=Yi(M)+FAC*(Yi(M+1)-Yi(M))
      ENDIF
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      A2=(B+FM*X(2))*X(2)
      F(1)=(X(1)-Vo)*Ao-X(1)*A2+X(3)
      F(2)=(BH+FM3*Yo)*Yo*Yo+(X(1)-Vo)**2*Ao/G-(BH+FM3*X(2))*X(2)**2-
     &(X(1)-X(3)/A2)**2*A2/G
      Y(1)=Yb
      CALL RUKUST(1,DXS,0.,X(4),1.E-4,Y,YTT)
      F(3)=X(2)-Y(1)
      F(4)=XPOS+DT5*(WV1+X(1))-X(4)
      RETURN
      END
      SUBROUTINE SLOPE(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON B,FM,FM2,FMS,FM3,BH,Yb,FL,DL,Qo,G,G2,Qb,DXS,XPOS,X(4),CUN
     &,SO,DT5,WV1,Yi(15),INIT
      A=(B+FM*Y(1))*Y(1)
      IF(INIT.GT.0) GO TO 10
      SF=(Qo*CUN*((B+FMS*Y(1))/A)**.6666667/A)**2
      DY(1)=(SO-SF)/(1.-Qo**2*(B+FM2*Y(1))/(G*A**3))
      RETURN
10    qs=(Qb-X(3))/X(4)
      Q=Qb+XX/X(4)*(X(3)-Qb)
      SF=(Q*CUN*((B+FMS*Y(1))/A)**.6666667/A)**2
      DY(1)=(SO-SF+Q*qs/(G*A**2))/(1.-Q**2*(B+FM2*Y(1))/(G*A**3))
      RETURN
      END