C PROGRAM IS DESIGNED ONLY FOR DISPERSIVE WAVES IN WHICH THE DEPTH DECREASES
C  i.e.  values of the stage f. w generated only up to Yo
      PARAMETER (N=200) 
      REAL W(N),X(20) 
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y)) 
      WRITE(6,*)' Give:Yo,Qo,b,m,dQ/dt,Tstart,Tend,Dt,g,IOUT,Stations' 
      READ(5,*) YO,QO,B,FM,DQT,TST,TE,DT,G,IOUT,NSTA 
      IF(NSTA.LT.1) GO TO 1 
      WRITE(6,*)' Give x distances for',NSTA 
      READ(5,*)(X(I),I=1,NSTA) 
1     DY=(YO-.01)/FLOAT(N-1) 
      FM2=2.*FM 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01 
      WF1=FW(Y) 
      W(1)=0. 
      DO 10 I=2,N 
      SUM=0. 
      DO 5 J=1,10 
      WF=FW(Y+DY2*FLOAT(J)) 
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM 
10    Y=Y+DY 
      VO=QO/((B+FM*YO)*YO) 
      VOW=VO-W(N) 
      WRITE(IOUT,110) 
      IM=N-1 
      NT=(TE-TST)/DT+1.99 
      DO 40 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      Q=QO+DQT*T 
      F=(B+FM*YO)*YO-Q/(W(N)+VOW) 
20    F1=F 
      Y=.01+FLOAT(IM-1)*DY 
      F=(B+FM*Y)*Y-Q/(W(IM)+VOW) 
      IF(VO.GT.0.) THEN
      IF(F.LE.0.) GO TO 30 
      ELSE
      IF(F.GT.0.) GO TO 30
      ENDIF
      IM=IM-1 
      IF(IM.GT.0) GO TO 20 
30    FAC=F/(F1-F) 
      YY=Y-FAC*DY 
      V=W(IM)-FAC*(W(IM+1)-W(IM))+VOW 
40    WRITE(IOUT,100) IT,Q,YY,V 
100   FORMAT(I8,F8.1,2F8.3) 
110   FORMAT(' Time(s)',5X,'Q',7X,'Y',7X,'V'
     *,/,1X,32('-')) 
      DXO=VO+SQRT(G*(((B+FM*YO)*YO)/(B+FM2*YO))) 
      DO 60 K=1,NSTA 
      IM=N 
      WRITE(IOUT,*)' For Station at x =',X(K) 
      F=X(K)/DXO-TST 
      DO 60 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      IF(T*DXO.LE.X(K)) THEN 
      WRITE(IOUT,100) IT,QO,YO,VO 
      ELSE 
45    F1=F 
      V=W(IM)+VOW 
      Y=.01+FLOAT(IM-1)*DY 
      A=(B+FM*Y)*Y 
      Q=V*A 
      F=ABS(QO-Q)/ABS(DQT)+X(K)/(V+SQRT(G*A/(B+FM2*Y)))-T
      IF(F.GT.0.) GO TO 48 
      IM=IM-1 
      IF(IM.GT.0) GO TO 45 
48    FAC=F/(F1-F) 
      YY=Y-FAC*DY 
      V=W(IM)-FAC*(W(IM+1)-W(IM))+VOW 
      Q=V*(B+FM*YY)*YY 
      WRITE(IOUT,100) IT,Q,YY,V 
      ENDIF 
60    CONTINUE 
      STOP 
      END