C PROGRAM IS DESIGNED ONLY FOR DISPERSIVE WAVES IN WHICH THE DEPTH DECREASES
C  i.e.  values of the stage f. w generated only up to Yo
C boundary condition is dY/dt rather than dQ/dt as in program YTIMEX.FOR
C  To make this program work for positive waves w must be generated for larger
C valued of Y to allow the depth to increase.  See Program YTIMEDYI.FOR that
C integrated using Simpson's rule as needed.
      PARAMETER (N=200) 
      CHARACTER*2 UN/'ft'/
      REAL W(N),X(20) 
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y)) 
      WRITE(6,*)' Give:Yo,(1 & Vo or 2 & Qo),b,m,dY/dt,Tstart,Tend,Dt,g,
     &IOUT,Stations' 
      READ(5,*) YO,I,QO,B,FM,DYT,TST,TE,DT,G,IOUT,NSTA
      IF(G.LT. 20.) UN='m '
      IF(I.EQ.1) THEN
      VO=QO
      QO=QO*(B+FM*YO)*YO
      ELSE
      VO=QO/((B+FM*YO)*YO)
      ENDIF
      IF(NSTA.LT.1) GO TO 1 
      WRITE(6,*)' Give x distances for',NSTA 
      READ(5,*)(X(I),I=1,NSTA) 
1     DY=(YO-.01)/FLOAT(N-1) 
      FM2=2.*FM 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01 
      WF1=FW(Y) 
      W(1)=0. 
      DO 10 I=2,N 
      SUM=0. 
      DO 5 J=1,10 
      WF=FW(Y+DY2*FLOAT(J)) 
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM 
10    Y=Y+DY 
      VOW=VO-W(N) 
      WRITE(IOUT,110) 0.,UN
      IM=N-1 
      NT=(TE-TST)/DT+1.99 
      DO 40 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      Y=YO+DYT*T 
      IF(IT.EQ.0) THEN
      V=VO
      ELSE
      IM=IFIX((Y-.01)/DY)+1
      FAC=(Y-(.01+FLOAT(IM)*DY))/DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      ENDIF
      Q=V*(B+FM*Y)*Y
40    WRITE(IOUT,100) IT,Y,V,Q 
100   FORMAT(I8,2F8.3,F9.2) 
110   FORMAT(' For Station at x =',F8.0,A3,/,1X,33('-'),/,
     &' Time(s)',5X,'Y',7X,'V',8X,'Q',/,1X,33('-')) 
      DXO=VO+SQRT(G*(((B+FM*YO)*YO)/(B+FM2*YO))) 
      DO 60 K=1,NSTA 
      IM=N 
      WRITE(IOUT,*)
      WRITE(IOUT,110) X(K),UN
      F=X(K)/DXO-TST 
      DO 60 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      IF(T*DXO.LE.X(K)) THEN 
      WRITE(IOUT,100) IT,YO,VO,QO 
      ELSE 
45    F1=F 
      V=W(IM)+VOW 
      Y=.01+FLOAT(IM-1)*DY 
      A=(B+FM*Y)*Y 
      Q=V*A 
      F=ABS(YO-Y)/ABS(DYT)+X(K)/(V+SQRT(G*A/(B+FM2*Y)))-T
      IF(F.GT.0.) GO TO 48 
      IM=IM-1 
      IF(IM.GT.0) GO TO 45 
48    FAC=F/(F1-F) 
      YY=Y-FAC*DY 
      V=W(IM)-FAC*(W(IM+1)-W(IM))+VOW 
      Q=V*(B+FM*YY)*YY 
      WRITE(IOUT,100) IT,YY,V,Q 
      ENDIF 
60    CONTINUE 
      STOP 
      END