C PROGRAM IS DESIGNED ONLY FOR DISPERSIVE WAVES IN WHICH THE DEPTH DECREASES
C  i.e.  values of the stage f. w generated only up to Yo
C  It differs from YTIMEX in that the stage function w is numerically integrated
C  using Simpson's rule whenever needed.
      EXTERNAL FW
      REAL X(20) 
      COMMON B,FM,FM2,G
      WRITE(6,*)' Give:Yo,Qo,b,m,dQ/dt,Tstart,Tend,Dt,g,IOUT,Stations' 
      READ(5,*) YO,QO,B,FM,DQT,TST,TE,DT,G,IOUT,NSTA 
      FM2=2.*FM
      IF(NSTA.LT.1) GO TO 1 
      WRITE(6,*)' Give x distances for',NSTA 
      READ(5,*)(X(I),I=1,NSTA) 
1     CALL SIMPR(FW,.01,YO,Wo,1.E-5,50)
      VO=QO/((B+FM*YO)*YO) 
      VOW=VO-Wo
      WRITE(IOUT,110) 
      NT=(TE-TST)/DT+1.99 
      Y=.95*YO
      DO 40 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      Q=QO+DQT*T 
      M=0
20    CALL SIMPR(FW,.01,Y,W,1.E-5,50)
      F=(B+FM*Y)*Y-Q/(W+VOW)
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 22
      FF=F
      YT=Y
      WW=W
      Y=1.005*Y
      GO TO 20
22    DIF=(Y-YT)*FF/(F-FF)
      Y=YT-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 20
      V=WW+VOW
40    WRITE(IOUT,100) IT,Q,Y,V 
100   FORMAT(I8,F8.1,2F8.3) 
110   FORMAT(' Time(s)',5X,'Q',7X,'Y',7X,'V'
     *,/,1X,32('-')) 
      DXO=VO+SQRT(G*(((B+FM*YO)*YO)/(B+FM2*YO))) 
      DO 60 K=1,NSTA 
      Y=.97*Yo
      WRITE(IOUT,*)' For Station at x =',X(K) 
      DO 60 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      IF(T*DXO.LE.X(K)) THEN 
      WRITE(IOUT,100) IT,QO,YO,VO 
      ELSE 
      M=0
45    CALL SIMPR(FW,.01,Y,W,1.E-5,50)
      V=W+VOW 
      A=(B+FM*Y)*Y 
      Q=V*A 
      F=ABS(QO-Q)/ABS(DQT)+X(K)/(V+SQRT(G*A/(B+FM2*Y)))-T
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 48
      FF=F
      YT=Y
      WW=W
      Y=.995*Y
      GO TO 45
48    DIF=(YT-Y)*FF/(FF-F)
      Y=YT-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 45
      IF(M.EQ.30) WRITE(*,*)' Not converge',T,Y,DIF
      V=WW+VOW
      Q=V*(B+FM*Y)*Y
      WRITE(IOUT,100) IT,Q,Y,V 
      ENDIF 
60    CONTINUE 
      STOP 
      END
      FUNCTION FW(Y)
      COMMON B,FM,FM2,G
      FW=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y))
      RETURN
      END