%This script solves the Example No. 3 in Appendix C, similiar to the
% Fortran Program APPEC3.FOR.  It uses the MATLAB built in function
% ode45 to solve the differential equation dY/dx=(So-Sf)/(1-Fr2)
disp('Give the following input values');
DELX=input('DELX = '); YB=input('YB = '); Q=input('Q = '); FN=input('n =');
SO=input('So ='); B=input('b =');FM=input('m = ');XBEG=input('beg x =');
XEND=input('end x ='); Cu=input('Cu =');  FNQ=FN*Q/Cu;
if Cu==1.
    g=9.81;
else
    g=32.2;
end
Q2=Q^2/g; 
fid=input('Should output be written to file? (2=yes,1=no)');
if fid>1 
    FILN=input('Give name of this file');
    fid=fopen(FILN,'w');
end
Y(1)=YB; X=XBEG;
fprintf('      x         Y\n');
fprintf(fid,'%10.3f %10.3f\n',X,Y(1));
ICONT=1; II=0;
while ICONT==1
    II=II+1;  XZ=XBEG+DELX*II;
    [xx,yy]=ode45(@ayprime,[X XZ],[Y]',[],B,FM,FN,SO,Q2,FNQ);
    X=XBEG+DELX*II;
    nn=size(xx);
    Y(1)=yy(nn(1));
    fprintf(fid,'%10.3f %10.3f\n',X,Y(1));
     if DELX<0
        if X <= XEND
            ICONT=0;
        end
    else
        if X>= XEND
            ICONT=0;
        end
    end
end
