% This MATLAB script is designed to solve Example Problem 1 in
% APPENDIX A using the four difference methods discussed.
% A= is the area from the first method, A2 is from the 2nd method,
% A3 is from the 3rd method, and A4 is from the 4th method.
Y=1.2; D=1.8; R=D/2; R2=2/R; RS=1/R^2;
beta=acos(1-Y/R)
A=R^2*(beta-cos(beta)*sin(beta))
A2=D*R*quad(inline('sin(x).^2','x'),0,beta)
fa2=inline('sqrt(R2.*x-RS.*x.^2)','x','R2','RS');
A3=D*quad(@(x)fa2(x,R2,RS),0,1.2)
A4=R*D*quad(inline('sqrt(2*x-x.^2)','x'),0,4/3)
