% This script utilizes quad to integrate to obtain the first moment of
% area for Example Problem 2 in Appendix B
Y=1.2; D=1.8; cosb=1-2*Y/D; beta=acos(cosb);
A=D^2/4*(beta-cosb*sin(beta))
Ahc=D/2*(D^2/6*sin(beta)^3-A*cosb)
fahc=inline('(cos(x)-cosb).*sin(x).^2','x','cosb');
Ahc2=D^3/4*quad(@(x)fahc(x,cosb),0,beta)
