% This script that uses the MATLAB quad function to carry out the numerical
% integration required in Example Problem 2 in Appendix B.  Notice that the
% problem solved by the Fortran program SIMP1.FOR does not use the 1/2
% times 1-cos(x).  The 2nd group of statements carries out the solution
% without the 1/2 = 0.5
area=quad(inline('6-x-0.5.*(1-cos(x))','x'),0,3);
xarea=quad(inline('x.*(6-x-0.5.*(1-cos(x)))','x'),0,3);
xc=xarea/area;
disp(['area = ' num2str(area) ' xarea = ' num2str(xarea) ' xc =' num2str(xc)]);
% Solution with bottom defined by x+1-cos(x)
area=quad(inline('6-x-(1-cos(x))','x'),0,3);
xarea=quad(inline('x.*(6-x-(1-cos(x)))','x'),0,3);
xc=xarea/area;
disp(['area = ' num2str(area) ' xarea = ' num2str(xarea) ' xc =' num2str(xc)]);