% This script solves problem such #10 in "Problem: (For you to work) that
% are given in Appendix A.  In other words is solve for one of the following
% variables: A, b, m or Y given the other three.
var='AbmY'; u=zeros(1,4);
 % The vector u represent the variables as follows:
 % u(1) = A (area)
 % u(2) = b (bottom width)
 % u(3) = m (side slope)
 % u(4) = Y (depth)
for i=1:4
    disp([var(i) ' = ' num2str(i) ' ']);
end
ic=input(' Give the number for the unknown;');
disp(' Give value to known variables');
for i=1:4
    if i ~= ic
    u(i)=input([var(i) ' = ']);
    end
end
switch ic
    case 1
        u(1)=(u(2)+u(3)*u(4))*u(4);
    case 2
        u(2)=u(1)/u(4)-u(3)*u(4);
    case 3
        u(3)=u(1)/u(4)^2-u(2)/u(4)
    case 4
        u(4)=(sqrt(u(2)^2+4*u(3)*u(1))-u(2))/(2*u(3))
end
fprintf(1,'unknown %c = % 10.4f\n',var(ic),u(ic));
P=u(2)+sqrt(u(3)^2+1)*u(4); T=u(2)+2*u(3)*u(4); Rh=u(1)/P;
fprintf(1,'P =%8.4f, T =%8.4f, Rh =%8.4f\n',P,T,Rh);