%This script read in the data that defines the cross-section of #15, and
%uses "spline" to interpolate 30 equally spaced depths from this data and
%plots the cross-section.
fprintf(1,'Give no. of pts, and then this many pairs\n');
N=input('N=');
FILN=input('Give file name containing input data ');
fid=fopen(FILN);
XY=fscanf(fid,'%f %f\n');
for i=1:N
    XX(i)=XY(2*i-1,1); YY(i)=XY(2*i,1);
end
fclose(fid);
 x=linspace(0,XX(N),30);
for i=1:30
    y(i)=-spline(XX,YY,x(i));
end
plot(x,y)
