% This script solves problem such #8 in "Problem: (For you to work) that
% are given in Appendix A.  To solve this problem you would give D = 12
% Q = 100,  V = 3 & w.s.-elev = 4500.  The solution you should get is:
%A = 33.3333, beta = 1.2361, Y = 4.0294, P = 14.8337, T = 11.3343,
% Rh = 2.2471, bottomelev = 4.4960e+003
D=input('D = '); Q=input('Q = '); V=input('V = '); wse=input('w.s.-elev = ');
beta=pi/2;
A=Q/V
feq=inline('D^2/4*(beta-cos(beta)*sin(beta))-A','beta','D','A');
option=optimset('display','off');
beta=fsolve(feq,beta,option,D,A)
Y=D/2*(1-cos(beta))
P=D*beta
T=D*sin(beta)
Rh=A/P
bottomelev=wse-Y