%This script solve the Darcy-Weisbach and Colebrook-White eqs. for
% Sf and f.
disp('Give the following:');
Q=input('Q = ');D=input('D = ');e=input('e = ');Y=input('Y = ');
g2=2*input('g = ');vis=input('vis = ');
sf=7.1;
for i=1:10
    sf=1.14-2*log10(e/D+7.34347283*vis*D*sf/Q);
end
f=1/sf^2
beta=acos(1-2*Y/D)
A=D^2/4*(beta-cos(beta)*sin(beta))
Sf=f/D*(Q/A)^2/g2
    