% This script solves Example Problem 13 in Chapter 1 for the 5 unknowns
% Q2,Q3,f,Y1 & p3, which are needed prior to applying the momentum
% principle.  The solution is: Q2=322.0 cfs, Q3=128.0 cfs, f=0.030337,
% Y1=5.962 ft, p3=32.42 psf.  The function fepq3ch1 defines the 5
% equations that are being solved simultaneously.
init=[220 230 .03 6 33];
option=optimset('display','off');
SQY=fsolve('fep13ch1',init,option)