% This script solves Example Problem 14 in Chapter 2 by utilizing the 
% MATLAB built in function fsolve.  The variables to define the problem are
% global, and are request by the input.  The initialization of the 6
% unknown variables is provided by the vector init and its values are 
% given within this script.  One might change this script to read these
% values in.  It is important to provide guesses to the 3 Q's and 3 Y's
% so the solution does not produce supercritial flow in Channel 3.  The 
% input and solution obtained in the MATLAB command windown are given
% below.  Note that the equations in the text defind delta z positive if
% a drop looking from the downstream to the upstreaam channel. We are 
% taking the view of looking at the downstream channel so the sign in front
% of delta z in Eq. 4 is negative, and 1.8 m is given for delta z.
%Give the following:
%g = 9.81
%H = 4.5
%Delta z = 1.8
%KL = .12
%b1 = 10
%b2 = 4
%m2 = 1.5
%n2 = .015
%So2 = .0008
%D3 = 3
%n3 = .013
%So3 = .0014
%SQY =
% 127.6717  122.0134    5.6583    3.8828    3.9336    2.3997
global H Dz KL g Cu b1 b2 m2 n2 So2 D3 n3 So3
fprintf(1,'Give the following:\n');
g=input('g = '); H=input('H = '); Dz=input('Delta z = '); KL=input('KL = ');
b1=input('b1 = '); b2=input('b2 = '); m2=input('m2 = '); n2=input('n2 = ');
So2=input('So2 = '); D3=input('D3 = '); n3=input('n3 = ');
So3=input('So3 = ');
if g<20
    Cu=1;
else
    Cu=1.486;
    
end
init=[130 115 15 3.8 3.9 2.3];
option=optimset('display','off');
SQY=fsolve('fep14ch2',init,option)