% This script solves Example Problem 16 in Chapter 2 by utilizing the 
% MATLAB built in function fsolve.  The variables to define the problem are
% global, and are request by the input.  The initialization of the 4
% unknown variables is provided by the vector init and its values are 
% given within this script.  One might change this script to read these
% values in.
% The dialog from the MATLAB command window to solve this problem is as 
% follows:
%>>ep16ch2
%Give the following:
%g = 9.81
%H = 3.5
%KL = .09
%b1 = 10
%m1 = 1.5
%b2 = 6
%m2 = 0
%b3 = 4
%n3 = 0
%Cc = .6
%Depth downstream gate CH.2 = 1.
%Depth downstream gate CH.3 = 1.5
%SQY =  3.4896   52.7897   27.1180   25.6717

global H KL g b1 m1 b2 m2 b3 m3 Y2d Y3d
fprintf(1,'Give the following:\n');
g=input('g = '); H=input('H = ');  KL=input('KL = ');
b1=input('b1 = '); m1=input('m1 = '); b2=input('b2 = '); m2=input('m2 = '); 
b3=input('b3 = '); m3=input('n3 = '); Cc=input('Cc = ');
Y2d=input('Depth downstream gate CH.2 = ')*Cc;
Y3d=input('Depth downstream gate CH.3 = ')*Cc;
init=[3.3 50 15 35];
option=optimset('display','off');
SQY=fsolve('fep16ch2',init,option)