function QY=fep14ch2(X)
global H Dz KL g Cu b1 b2 m2 n2 So2 D3 n3 So3
% X(1)=Q1,  X(2)=Q2, X(3)=Q3, X(4)=Y1, X(5)=Y2, X(6)=Y3
A1=b1*X(4);  A2=(b2+m2*X(5))*X(5); P2=b2+2*X(5)*sqrt(m2^2+1);
beta=acos(1-X(6)/D3);
A3=D3^2/4*(beta-cos(beta)*sin(beta)); P3=D3*beta;
QY=[X(1)-X(2)-X(3); H-X(4)-(1+KL)*(X(1)/A1)^2/(2*g) 
   X(4)-X(5)+((X(1)/A1)^2-(X(2)/A2)^2)/(2*g)
   X(4)-X(6)-Dz+((X(1)/A1)^2-(X(3)/A3)^2)/(2*g)
   X(2)-(Cu/n2)*A2*(A2/P2)^0.6666667*sqrt(So2)
   X(3)-(Cu/n3)*A3*(A3/P3)^0.6666667*sqrt(So3)];
