% This script solves Mannings Eq. for any of the variable in either a
% trapezoidal or circular channel.  When the variable is implicit within
% the equation the MATLAB built-in function fsolve is used.
UNT='nQSYbm'; UNC='nQSYD';
IT=input('Give:1=trap.,2=cir. for channel type ');
KU=input('Give:1=ES or 2=SI units ');  Cu=1;
if KU==1
    Cu=1.486;
end
if IT==1
  UN=UNT; I2=6;
else
    UN=UNC; I2=5;
end
disp('Give the number for the unknown:');
for i=1:I2
     disp([UN(i) ' = ' num2str(i)]);
 end
 IU=input(' Number = ');
 UNA=UN(IU:IU);  UNN=UN;
 UN(IU:IU)=[];
 disp('Give value to known variables and guess for unknown');
 j=0;
 for i=1:I2-1
     j=j+1;
     if i==IU
         j=j+1;
     end
      X(j)=input([UN(i) ' = ']);
  end
 if IU<4
     if IT==1
         A=(X(5)+X(6)*X(4))*X(4);
         P=X(5)+2*sqrt(X(6)^2+1)*X(4);
     else
         cosb=1-2*X(4)/X(5); beta=acos(cosb);
         A=X(5)^2/4*(beta-cosb*sin(beta));
         P=beta*X(5);
     end
    if IU==1
         X(1)=Cu/X(2)*A*(A/P)^0.66666667*sqrt(X(3));
     elseif IU==2
         X(2)=Cu/X(1)*A*(A/P)^0.66666667*sqrt(X(3));
     else
         X(3)=(X(1)*X(2)*(P/A)^0.66666667/Cu/A)^2;
     end
 else
     XU=input([' Provide guess for unknown ' UNA ' = ']);
     opt=optimset('display','off');
     XX=fsolve('fmanning',XU,opt,Cu,IT,IU,X);
     X(IU)=XX;
 end
     disp(['Unknown ' UNN(IU) ' = ' num2str(X(IU))]);
    for i=1:I2
       disp([UNN(i) ' = ' num2str(X(i))]);
    end  
