% This script solve Example Problem 12 in Chapter 3 and does this
% by using MATLAB built-in function fsolve.  In looking over this
% script you will note the 6 equations that are being solve for the
% 6 unknowns.  The dialog in the command windown to solve this 
% problem follows.
%>>ep12ch3
%Give the following:
%g = 32.2
%Pipe dia. 3.5
%n for pipe .012
%Bottom slope of pipe .15
%Bottom width of Ch. 2
%Side slope of Ch. .8
%n for Ch. .013
%Bottom slope of Ch. .000006
%Position where pipe flows full 3
%Pipes e (inch) .002
%Q=  146.90
%Sf= 0.01151
%d=  10.007
%Y1=   1.425
%Y2=  13.923
%f= 0.01113
global D1 n1 So1 b2 m2 n2 So2 L e Cu At g g2
disp('Give the following:');
g=input('g = '); D1=input('Pipe dia. '); n1=input('n for pipe ');
So1=input('Bottom slope of pipe '); b2=input('Bottom width of Ch. ');
m2=input('Side slope of Ch. '); n2=input('n for Ch. ');
So2=input('Bottom slope of Ch. '); g2=2*g;
L=input('Position where pipe flows full ');e=input('Pipes e (inch) ')/12;
if g2<40
    Cu=1;
else
    Cu=1.486;
end
At=pi*D1^2/4; 
init=[140 .012 10 1.5 14 .025]; 
option=optimset('display','off','TolX',1.e-4);
sol=fsolve('fep12ch3',init,option);
fprintf(1,'Q=%8.2f\nSf=%8.5f\nd=%8.3f\nY1=%8.3f\nY2=%8.3f\nf=%8.5f\n'...
    ,sol);