function f=fgutter(X)
global So m ms qs Cu n hm g g2 g5 L dx gm2 done Xs
Xs=X(4);
f(1)=m*X(1)*(qs*Xs)^2-gm2*X(1)^6;
f(2)=m*X(2)*(qs*(L-Xs))^2-gm2*X(2)^6;
if done
    A=hm*X(1)^2; Q=qs*Xs;E=X(1)+(Q/A)^2/g2;Fr=Q/(m*sqrt(g5*X(1)^5));
    fprintf('       x         Y         Q         E         A        Fr\n');
    fprintf('------------------------------------------------------------\n');
    fprintf('%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n',0.,X(1),Q,E,A,Fr);
end
Y=1.1*X(1);  XX=0; N=Xs/dx;
 for i=1:N, j=i; end;
if j*dx<Xs, j=j+1; end;
for i=1:j
    XZ=XX+dx;  if XZ>Xs, XZ=Xs; end;
    [x1,Y1]=ode45('dYxgutter',[XX XZ],Y);
    Y=Y1(size(x1,1)); XX=XZ;
    if done
        A=hm*Y^2;Q=qs*(Xs-XZ); E=Y+(Q/A)^2/g2;Fr=Q/(m*sqrt(g5*Y^5));
        fprintf('%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n',XZ,Y,Q,E,A,Fr);
    end
end
f(3)=X(3)-Y;
if done
    A=hm*X(2)^2; Q=qs*(L-Xs);E=X(2)+(Q/A)^2/g2;Fr=Q/(m*sqrt(g5*X(2)^5));
    fprintf('\n');
    fprintf('       x         Y         Q         E         A        Fr\n');
    fprintf('------------------------------------------------------------\n');
      fprintf('%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n',L,X(2),Q,E,A,Fr);
end
Y=1.1*X(2); XX=L; N1=(L-Xs)/dx; 
for i=1:N1, j=i; end;
if j*dx<(L-Xs), j=j+1; end;
for i=1:j
    XZ=XX-dx; if XZ<Xs, XZ=Xs; end;
    [x1,Y1]=ode45('dYxgutter',[XX XZ],Y);
    Y=Y1(size(x1,1)); XX=XZ;
    if done
        A=hm*Y^2;Q=qs*(XZ-Xs); E=Y+(Q/A)^2/g2;Fr=Q/(m*sqrt(g5*Y^5));
        fprintf('%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n',XZ,Y,Q,E,A,Fr);
    end
end
f(4)=X(3)-Y;