function F=fsolinf2a(X)
global b m m2 fms n Cu qs Uqs L L1 So1 So2 ss1 ss2 g Q1 IBC WS
A1=(b+m*X(3))*X(3); P1=b+m2*X(3); A2=(b+m*X(4))*X(4); P2=b+m2*X(4);
F(1)=X(2)-X(1)-qs*L;
if IBC==1
    F(2)=X(1)^2*(b+m2*X(5))-g*((b+m*X(5))*X(5))^3;
elseif IBC==2
    F(2)=WS-X(5);
else
    F(2)=n*X(1)*(b+fms*X(5))^.6666667-Cu*((b+m*X(5))*X(5))^1.666667*ss1;
end
F(3)=n*X(2)-Cu*A2*(A2/P2)^.66666667*ss2;  Q1=X(1);
[xx,Y1ODE]=ode45('fdyxinf2',[L1 0],X(3)); %GVF in upstream channel.
F(4)=X(5)-Y1ODE(size(xx,1));
[xx,Y2ODE]=ode45('fdyxinf',[0 L],X(3)); %GVF is solved across inflow sec.
F(5)=X(4)-Y2ODE(size(xx,1));