%This script is designed to solve problems like Example Problem 9 in
%Chapter 5.  All the variables for this problem are given in the text.  You
%might want to let these be input to solve problems with different
%quantities.  The dialog in the command window to solve this problem is:
%>>ep9ch5
%Fr1 =
%    0.2629
%Y2 =
%    1.0200
%q =
%   16.6807
%y3 =
%    0.7275
%Y3 =
%    3.6377
Cc=.6; YG=1.7; Y1=5; g=32.2;
y2=Cc*YG/Y1;
Fr12=2*y2^2/(1+y2);
Fr1=sqrt(Fr12)
Y2=y2*Y1
q=sqrt(g*Y1^3*Fr12)
eq61=inline('(y3^2-y2^2)/2+2*y2/(1+y2)*(y2/y3-1)','y3','y2');
opt=optimset('display','off');
y3=fsolve(eq61,.7,opt,y2)
Y3=y3*Y1
