%This script uses the same approach as Fortran Program EPRB6_2A.FOR, i.e.
% obtains the solution to Eq. 19 with the method given in the CRC handbook.
Vo=input('Give Vo = ');Yo=input('Give Yo = ');g=input('Give g =');
co=sqrt(g*Yo);q1=input('Give starting q ');N=input('Give number of q '); 
VOC=(.5*Vo-co); S=VOC^2/9; q=linspace(q1,0,N);
fprintf('    q        c        Y         V     dx/dt\n');
fprintf(' -------------------------------------------\n');
for i=1:N
    T=(VOC^3-6.75*g*q(i))/27; STS=(sqrt(T^2-S^3)+abs(T))^.33333333;
    c=-T/abs(T)*(STS+S/STS)-VOC/3; Y=c^2/g; V=q(i)/Y; dxdt=V+c;
fprintf('%8.2f %8.4f %8.4f %8.4f %8.4f\n',q(i),c,Y,V,dxdt);
end