      EXTERNAL SLOPE 
      REAL X(2),DXDT(2),WK1(2,13) 
      COMMON NGOOD,NBAD,NBETW,IBETW,DXBETW,SF,ED,
     &RE95,H12,D5
      NBETW=0 
      READ (*,*) P1,P2,T2,X(1),FL2,NT,DELT,ANOZ,
     &E,D 
      P1=P1+14.7 
      P2=P2+14.7 
      T2=T2+460 
      D12=D/12. 
      ED=E/D 
      D5=.5/D
      DXBETW=DELT 
      SF=6. 
      FL=X(1)+FL2 
      A=.785398*D12**2 
      RHOO=144.*P2/(1715.*T2) 
      P20=P2 
      TM=RHOO*A*FL 
      X(2)=0. 
      T20=T2 
      TIME=0. 
      DO 10 I=1,NT 
      TIME1=DELT*FLOAT(I) 
      IF(P2.GT.27.84) THEN 
      PS=.528*P2 
      TS=.833*T2 
      ELSE 
      PS=14.7 
      TS=T2*(14.7/P2)**.2857 
      ENDIF 
      RHOS=.083965*PS/TS 
      T2=T20*(P2/P20)**.2857 
      X(2)=SQRT(12005.*(1.-TS/T2)) 
      G=ANOZ*X(2)*RHOS 
      TM=TM-G*DELT*X(2) 
      H12=2.3077*(P1-P2) 
      IF(X(2).EQ. 0.) THEN 
      RE95=.1 
      ELSE 
      RE95=1.122E-4/(D12*X(2)) 
      ENDIF 
      CALL ODESOL(X,DXDT,2,TIME,TIME1,.00001,
     &.2*DELT,TMIN,1,XP,YP,WK1,SLOPE) 
      TIME=TIME1 
      FL2=FL-X(1) 
      RHO=TM/(A*FL2) 
      T2=T20*(RHO/RHOO)**.4 
      P2=P20*(T2/T20)**3.5 
10    WRITE(*,100)TIME,X,RHO,TM,PS-14.7,TS-460.,
     &G,T2-460.,P2-14.7
100   FORMAT(F8.1,2F8.2,F7.5,F8.3,2F8.2,F8.6,2F8.2) 
      STOP
      END 
      SUBROUTINE SLOPE(T,X,DXDT) 
      COMMON NGOOD,NBAD,NBETW,IBETW,DXBETW,SF,ED,
     &RE95,H12,D5 
      REAL X(2),DXDT(2) 
      DXDT(1)=X(2) 
5     SF1=1.14-2.*ALOG10(ED+RE95*SF) 
      IF(ABS(SF-SF1).LT.1.E-6) GO TO 10 
      SF=SF1 
      GO TO 5 
10    F5=D5/(SF*SF) 
      DXDT(2)=32.2/X(1)*H12-F5*X(2)*X(2) 
      RETURN 
      END