      REAL X[ALLOCATABLE](:),F[ALLOCATABLE](:),F1[ALLOCATABLE](:),
     &D[ALLOCATABLE](:,:),DZ[ALLOCATABLE](:),KLOS[ALLOCATABLE](:)
      INTEGER*2 IT[ALLOCATABLE](:),INDX[ALLOCATABLE](:),
     &IV[ALLOCATABLE](:)
      LOGICAL*1 STEEP[ALLOCATABLE](:),KEYB
      CHARACTER*2 CU[ALLOCATABLE](:)
      CHARACTER*6 S(2)/'SQYbmn','SQYDn '/
      CHARACTER*1 CH
      CHARACTER*38  FMT/"(1X,A1,' =',F8.6,/,(1X,A1,' =',F8.3))"/
      COMMON CMAN,G,G2,YGA(5),EYG(5),IYG(5),IGATE(6),NGATE
      WRITE(*,*)' Give: (1) 1=ES, 2=SI; (2) No. channels; (3) No. gates
     &(4) IN-unit; (5) OUT-unit'
      KEYB=.FALSE.                          !  Trapezodial    Circular
      READ(*,*) II,NC,NGATE,IN,IOUT         ! -------------   ---------
      IGATE(NGATE+1)=NC+1                   !  H  = x(1)       H  = x(1)
      IF(IN.EQ.0 .OR. IN.EQ.5) KEYB=.TRUE.  !  Q1 = x(2)       Q1 = x(2)
      IF(II.EQ.2) THEN                      !  Y1 = x(3)       Y1 = x(3)
      G=9.81                                !  b1 = x(4)       D1 = x(4)
      CMAN=1.                               !  m1 = x(5)       n1 = x(5)
      ELSE                                  !  n1 = x(6)
      G=32.2                                !  So2= x(7)       So2= x(6)
      CMAN=1.486                            !  Q2 = x(8)       Q2= x(7)
      ENDIF                                 !  Y2 = x(9)       Y2 = x(8)
      G2=2.*G                               !  b2 = x(10)      D2 = x(9)
      N=2*NC                                !  m2 = x(11)      n2 = x(10)
      ALLOCATE(IT(NC),KLOS(NC),DZ(NC),F(N),F1(N),D(N,N),CU(N),STEEP(NC))      
      IF(KEYB) WRITE(*,*)' For each channel give 1 = trap., or 2 = cir.'
      NV=0
      DO 10 I=1,NC
      IF(KEYB) WRITE(*,"(' Channel #',I2,' = ',\)") I
      READ(IN,*) IT(I)
10    NV=NV-IT(I)+7
      ALLOCATE(X(NV),IV(N),INDX(N))
      II=0
      DO 30 I=1,NC
      STEEP(I)=.FALSE.
      IF(KEYB) THEN
      WRITE(*,"(' Give variables for Channel',I2)") I
      DO 20 J=1,7-IT(I)
      CH=S(IT(I))(J:J)
      IF(I.EQ.1 .AND. J.EQ.1) CH='H'
      WRITE(*,"(5X,A1,' = ',\)") CH
20    READ(*,*) X(J+II)
      WRITE(*,"(' Loss Coef =',\)")
      READ(*,*) KLOS(I)
      IF(I.GT.1) THEN
      WRITE(*,"(' Change in bottom position =',\)")
      READ(*,*) DZ(I)
      ENDIF
      ELSE
      IF(I.EQ.1) THEN
      READ(IN,*)(X(J),J=1,7-IT(I)),KLOS(I)
      ELSE
      READ(IN,*)(X(J+II),J=1,7-IT(I)),KLOS(I),DZ(I)
      IF(X(II+1).GT. .008) STEEP(I)=.TRUE.
      ENDIF
      ENDIF
30    II=II+7-IT(I)  
      IF(NGATE.GT.0) THEN
      IF(KEYB) WRITE(*,*)' Give pairs of values: channel no. and depth d
     &owns. from gate(s)'
      READ(IN,*) (IGATE(I),YGA(I),I=1,NGATE)
      ENDIF
      IF(KEYB) WRITE(*,*)' Give symbols for',N,' Unknowns, i.e. Y1 Q1 b2
     & etc.'
      READ(IN,120) (CU(I),I=1,N)
120   FORMAT(26(A2,1X))
      IU=0
      DO 40 I=1,N
      II=ICHAR(CU(I)(2:2))-48
      DO 35 J=1,7-IT(II)
      IF(S(IT(II))(J:J).NE.CU(I)(1:1)) GO TO 35
      IU=IU+1
      IPOS=0
      DO 36 K=1,II-1
36    IPOS=IPOS+7-IT(K)
      IV(IU)=IPOS+J
      GO TO 40
35    CONTINUE
      WRITE(*,*)' Do not have ',CU(I),' as a variable'
      STOP
40    CONTINUE
      WRITE(*,*) ' IU=',IU
      WRITE(*,*) ' IV=',(IV(I),I=1,IU)
      NCT=0
42    CALL FUNCT(NC,N,NV,IT,STEEP,X,F,DZ,KLOS)
      DO 50 J=1,N
      XX=X(IV(J))
      X(IV(J))=1.005*X(IV(J))
      CALL FUNCT(NC,N,NV,IT,STEEP,X,F1,DZ,KLOS)
      DO 45 I=1,N
45    D(I,J)=(F1(I)-F(I))/(X(IV(J))-XX)
50    X(IV(J))=XX
      CALL SOLVEQ(N,1,N,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 60 I=1,N
      X(IV(I))=X(IV(I))-F(I)
60    SUM=SUM+ABS(F(I))
      WRITE(*,*)' Iteration=',NCT,' SUM=',SUM
      IF(NCT.LT.20 .AND. SUM.GT. .0005) GO TO 42
      DO 65 I=1,NGATE
      NCT=2
      II=IYG(I)
63    FF=EYG(I)-X(II)-(X(II-1)/((X(II+1)+X(II+2)*X(II))*X(II)))**2/G2
      IF(MOD(NCT,2) .NE. 0) GO TO 64
      NCT=NCT+1
      F11=FF
      XX=X(II)
      X(II)=1.005*X(II)
      GO TO 63
64    NCT=NCT+1
      DIF=(X(II)-XX)*F11/(FF-F11)
      X(II)=XX-DIF
      WRITE(*,*)' NCT=',NCT,'  DIF=',DIF
      IF(NCT.LT. 40 .AND. ABS(DIF).GT. .0001) GO TO 63
      IF(NCT.GE.40) WRITE(*,*)' Failed to converge with gates',DIF
65    CONTINUE
      II=0
      S(IT(1))(1:1)='H'
      FMT(16:16)='3'
      DO 70 I=1,NC
      WRITE(IOUT,"(' For Channel',I2)") I
      WRITE(IOUT,FMT)(S(IT(I))(J:J),X(J+II),J=1,7-IT(I))
      IF(I.EQ.1) S(IT(1))(1:1)='S'
      FMT(16:16)='6'
70    II=II-IT(I)+7
      END
      SUBROUTINE FUNCT(NC,N,NV,IT,STEEP,X,F,DZ,KLOS)
      REAL X(NV),F(N),DZ(N),KLOS(N)
      INTEGER IT(NC)
      LOGICAL*1 STEEP(NC)
      COMMON CMAN,G,G2,YGA(5),EYG(5),IYG(5),IGATE(6),NGATE
      II=0
      IG=1
      DO 20 I=1,NC
      IF(IT(I).EQ.1) THEN
      A=(X(II+4)+X(II+5)*X(II+3))*X(II+3)
      IF(STEEP(I)) THEN
      T=X(II+4)+2.*X(II+5)*X(II+3)
      ELSE
      P=X(II+4)+2.*SQRT(X(II+5)**2+1.)*X(II+3)
      ENDIF
      ELSE
      ARG=1.-2.*X(II+3)/X(II+4)
      BETA=ACOS(ARG)
      A=.25*X(II+4)**2*(BETA-SIN(BETA)*ARG)
      IF(STEEP(I)) THEN
      T=X(II+4)*SIN(BETA)
      ELSE
      P=BETA*X(II+4)
      ENDIF
      ENDIF
      IF(I.EQ.1) THEN
      E1=X(3)+(X(2)/A)**2/G2
      F(1)=X(1)-E1-KLOS(1)*(X(2)/A)**2/G2
      F(2)=X(2)
      JJ=7-IT(1)
      DO 10 J=2,NC
      F(2)=F(2)-X(JJ+2)
10    JJ=JJ+7-IT(J)
      ELSE
      IF(I.EQ.IGATE(IG)) THEN
      F(2*I-1)=E1-YGA(IG)-(1.+KLOS(I))*(X(II+2)/((X(II+4)+X(II+5)*YGA(IG
     &))*YGA(IG)))**2/G2-DZ(I)
      EYG(IG)=E1
      IYG(IG)=II+3
      IG=IG+1
      ELSE
      F(2*I-1)=E1-X(II+3)-(1.+KLOS(I))*(X(II+2)/A)**2/G2-DZ(I)
      ENDIF
      IF(STEEP(I)) THEN
      F(2*I)=T*X(II+2)**2-G*A**3
      ELSE
      F(2*I)=X(II+7-IT(I))*X(II+2)-CMAN*A*(A/P)**.66666667*SQRT(X(II+1))
      ENDIF
      ENDIF
20    II=II+7-IT(I)
      RETURN
      END