      CHARACTER*2 UNIT
      LOGICAL SWITCH
      REAL E(1),C(24),W(2,9)
      EXTERNAL DEX
      COMMON QN,B1,FM1,B,FM,FN,Y,Q2G,SO,X1,DB,DFM,XBEG,SWITCH
      DATA NN,IND,NW/1,1,2/
C  Note since dimensionless position XX=1.-(X-X1)/(XBEG-X1) that B1, etc.
C is the downstr. width at position XBEG.
      WRITE(6,*)' GIVE: UNIT,IOUT,TOL,DELX1,DELX2,YB,Q,FN,SO,B1,FM1,B2,
     &FM2,XBEG,XEND,X1'
      READ(5,*)UNIT,IOUT,TOL,DELX1,DELX2,YB,Q,FN,SO,B1,FM1,B2,FM2,XBEG,
     &XEND,X1
      SWITCH=.FALSE.
      CC=1.
      G2=19.62
      IF(UNIT .EQ. 'SI') GO TO 10
      CC=1.486
      G2=64.4
10    Y=YB
      QN=(FN*Q/CC)**2
      Q2G=Q*Q/G2
      Q2=2.*Q2G
      DB=B2-B1
      DFM=FM2-FM1
      B=B1
      FM=FM1
      DELX=DELX1
      X=XBEG
      A=(B+FM*YB)*YB
      E(1)=Y+Q2G/A**2
      WRITE(IOUT,15) Q,SO,FN,B1,FM1,B2,FM2
15    FORMAT(' SOLUTION TO GRADUALLY VARIED FLOW WITH',/
     &,' Q=',F10.2, ' SO=',F10.6,' n=',F7.4,/,' B1=',F8.1,' m1=',F8.2,
     &/,' B2=',F8.1, ' m2=',F8.2,/1X,40('-'),/,
     *'     x         Y         E         M',/,1X,40('-'))
      FUNM=Y**2*(.5*B+FM*Y/3.)+Q2/A
      WRITE(IOUT,40) X,Y,E,FUNM
20    IF(X.GT.X1) GO TO 30
      IF(SWITCH) GO TO 30
      SWITCH=.TRUE.
      DELX=DELX2
      B=B2
      FM=FM2 
30    XZ=X+DELX
      CALL DVERK(NN,DEX,X,E,XZ,TOL,IND,C,NW,W)
      IF(IND.LT.1) GO TO 50
      CALL YSOL(E,X)
      FUNM=Y**2*(.5*B+FM*Y/3.)+Q2/((B+FM*Y)*Y)
      WRITE(IOUT,40) X,Y,E,FUNM
40    FORMAT(3F10.3,F10.2)
      IF(X.GT.XEND) GO TO 20
      STOP
50    WRITE(6,*)' ERROR TERMINATION',IND 
      END
      SUBROUTINE DEX(N,X,E,EPRIME)
      LOGICAL SWITCH
      REAL E(N),EPRIME(N)
      COMMON QN,B1,FM1,B,FM,FN,Y,Q2G,SO,X1,DB,DFM,XBEG,SWITCH
      CALL YSOL(E,X)
      P=B+2.*SQRT(FM*FM+1.)*Y
      A=(B+FM*Y)*Y
      SF=QN*((P/A)**.6666667/A)**2
      EPRIME(1)=SO-SF
      RETURN
      END
      SUBROUTINE YSOL(E,X)
      REAL E(1)
      LOGICAL SWITCH
      COMMON QN,B1,FM1,B,FM,FN,Y,Q2G,SO,X1,DB,DFM,XBEG,SWITCH
      IF(Y.LT.E(1).AND.Y.GT..6*E(1)) GO TO 10
      Y=.9*E(1)
10    NCT=0
20    NT=0
30    IF(SWITCH) GO TO 40
      XX=1.-(X-X1)/(XBEG-X1)
      B=B1+DB*XX
      FM=FM1+DFM*XX
40    A=(B+FM*Y)*Y
      F=E(1)-Y-Q2G/A**2
      IF(NT.GT.0) GO TO 50
      F1=F
      Y=Y-.001
      NT=1
      GO TO 30
50    Y=Y+.001
      DIF=.001*F1/(F1-F)
      NCT=NCT+1
      Y=Y-DIF
      IF(NCT.LT.15.AND.ABS(DIF).GT. .000001) GO TO 20
      IF(NCT.EQ.15) WRITE(6,*)' DID NOT CONVERGE'
      RETURN
      END