#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "odesol.h"
#define sqr(a) (a*a)
#define N 4
float f[N],d[N][N],x[N],kl1,ke1,kl,ke,b1,fm1,b2,h,g=9.81,g2=19.62,fn,
   so,cc=1.,qn,q2g,y4,a4,qsg,tol,err,fl;
float fun(int ii,float dx,int j){ float h1=-.05,hmin=.001,x1[N]; int i;
  float *y;
 y=(float *)calloc(nv,sizeof(float));
 for(i=0;i<4;i++) x1[i]=x[i];
 if(j > -1) x1[j]+=dx;q2g=sqr(x1[0])/g2;
 switch (ii){
  case 0:return(h-x1[1]-kl1*q2g/sqr((b1+fm1*x1[1])*x1[1]));
  case 1:return(x1[2]+q2g/sqr((b1+fm1*x1[2])*x1[2])-x1[3]-kl1*q2g/sqr(b2*x1[3]));
  case 2:return(x1[3]+q2g/sqr(b2*x1[3])-y4-q2g/a4);
  case 3: y[0]=x1[2];qn=sqr(fn*x1[0]/cc); qsg=sqr(x1[0])/g;
   odesolc(y,fl,0.,tol,h1,hmin,nstor);  return(x1[1]-y[0]); }
} /* end of fun*/
void slope(float x,float *y,float *dydx) { float p,a,sf,t;
 p=b1+2.*sqrt(fm1*fm1+1.)*y[0];  a=(b1+fm1*y[0])*y[0];
 sf=sqr(qn*pow(p/a,0.666666667)/a); t=b1+2.*fm1*y[0];
 dydx[0]=(so-sf)/(1.-qsg*t/(a*sqr(a))); return;
} /* end of slope */
void main(void) { int iout,ns,step,nct,k,i,j;
 float yg,yg2,dyg,cco,dx=0.,fac,sum;  char filena[12];
 FILE *fil;
 cprintf("GIVE:IOUT,TOL,ERR,n,So,b1,m1,b2,H,L,YG,g,KL,KE,Cc,Ns,YG2\r\n");
 scanf("%d %f %f %f %f %f %f %f %f %f %f %f %f %f %f %d %f",
  &iout,&tol,&err,&fn,&so,&b1,&fm1,&b2,&h,&fl,&yg,&g,&kl,&ke,&cco,&ns,&yg2);
 if(iout !=6){cprintf("Give filename for solution data\r\n");scanf("%s",filena);
 fil=fopen(filena,"w");
 fprintf(fil,"  Gate  Flowrate      Depths (meters)\n");
 fprintf(fil,"   (m)  (m**3/s) at Beg.C. at End C. at End T.\n");}
 dyg=(yg-yg2)/(ns-1);  if(g>30.) cc=1.486;
 g2=2.*g; kl1=1.+kl; ke1=1.+ke;
 cprintf("Give guess for:Q,Y1,Y2,Y3\r\n");
 scanf("%f %f %f %f",&x[0],&x[1],&x[2],&x[3]);
 for(step=1;step<=ns;step++) {y4=cco*yg;a4=sqr(y4*b2); nct=0;
  do { for(i=0;i<N;i++){f[i]=fun(i,dx,-1);
    for(j=0;j<N;j++){dx=.005*x[j];
     d[i][j]=(fun(i,dx,j)-f[i])/dx;}}
/* Solves system of equations using Gaussian Elimination */
  for(j=0;j<N-1;j++) {
   for(i=j+1;i<N;i++){fac=d[i][j]/d[j][j]; f[i]=f[i]-fac*f[j];
    for(k=j+1;k<N;k++) d[i][k]=d[i][k]-fac*d[j][k];}  }  j=N-1;
  f[j]=f[j]/d[j][j]; x[j]=x[j]-f[j]; sum=fabs(f[j]);
  for(i=N-2;i>=0;i--){fac=0.;for(j=i+1;j<N;j++) fac=fac+d[i][j]*f[j];
   f[i]=(f[i]-fac)/d[i][i]; x[i]=x[i]-f[i];sum+=fabs(f[i]);} nct++;
 cprintf("%3d %11.2f %9.4f %9.4f %9.4f %9.4f\r\n",nct,sum,x[0],x[1],x[2],x[3]);
} while (nct<30 && sum>err);
if(iout!=6) fprintf(fil,"%6.2f %9.3f %9.3f %9.3f %9.3f\n",yg,x[0],x[1],x[2],x[3]);
 else cprintf("%6.2f %9.3f %9.3f %9.3f %9.3f\r\n",yg,x[0],x[1],x[2],x[3]);
yg-=dyg;  } /* end of step */ if(iout!=6) fclose(fil);
}