// Solves Mannings (uniform flow) and Energy simultaneously for any 2 unknowns
// See E_UN1 to solve Q & Y and method that can be used with calculator
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
float x[12],g,g2,cu;
extern void solveq(int n,float **d,float *f,int itype,float *dd,int *indx);
void fun(float *f){float beta,a1,a2,p2,fke,fkl;
 beta=acos(1.-2.*x[8]/x[2]);a2=.25*x[2]*x[2]*(beta-cos(beta)*sin(beta));p2=beta*x[2];
 a1=(x[0]+x[1]*x[7])*x[7];fke=(1.+x[9])/g2;fkl=(1.+x[10])/g2;
 f[0]=x[4]*x[5]*pow(p2,.6666667)-cu*pow(a2,1.6666667)*sqrt(x[3]);
 f[1]=x[6]-x[7]-fke*pow(x[5]/a1,2.);
 f[2]=x[7]+pow(x[5]/a1,2.)/g2-x[8]-fkl*pow(x[5]/a2,2.)-x[11]; return;} //End of fun
void main(void){char *fmt=" %s =%9.3f\n",*ch[]={"value","guess"},*c1="222531222332";
char *cx[]={"b ","m ","D ","So","n ","Q ","H ","Y1","Y2","Ke","KL","Dz"};
 float f[3],f1[3],xx,sum,**d,*dd; int id[12],indx[3],i,j,i1,i2,i3,nct;
 d=(float**)malloc(3*sizeof(float*));for(i=0;i<3;i++)d[i]=(float*)malloc(3*sizeof(float));
 printf("Give: g\n");scanf("%f",&g); g2=2.*g; if(g>15.) cu=1.486; else cu=1.;
L1: for(i=0;i<12;i++){printf("%2d  %s\n",i+1,cx[i]);id[i]=0;}
 do{printf(" Give three numbers for 3 unknown variables\n"); scanf("%d %d %d",&i1,&i2,&i3);
  }while((i1<1)||(i1>12)||(i2<1)||(i2>12)||(i3<1)||(i3>12)); id[i1-1]=1;id[i2-1]=1;id[i3-1]=1;
 for(i=0;i<12;i++){printf("Give %s for %s =",ch[id[i]],cx[i]);
 scanf("%f",&x[i]);} nct=0;
do{sum=0.; fun(f); i1=-1;for(i=0;i<12;i++){if(id[i]){xx=x[i];i1++;x[i]*=1.005;fun(f1);
  for(j=0;j<3;j++) d[j][i1]=(f1[j]-f[j])/(x[i]-xx); x[i]=xx;}}
 solveq(3,d,f,1,dd,indx); i1=-1;
 for(i=0;i<12;i++){if(id[i]){sum+=fabs(f[++i1]);x[i]-=f[i1];}}
  printf("nct= %d SUM=%f\n",nct,sum);}while((++nct<30)&&(sum>3.e-5));
 printf("Solution:\n");for(i=0;i<12;i++){fmt[8]=c1[i];printf(fmt,cx[i],x[i]);}
 printf("Give 1 to solve another prob. (0=STOP)\n");scanf("%d",&i2); if(i2) goto L1;}