      PARAMETER (MG=6,ME=3*MG)
      REAL F[ALLOCATABLE](:),D[ALLOCATABLE](:),FF(3)
      LOGICAL DONE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J
      READ(2,*) NG,IOUT,TOL,ERR,FN,FM,G
      IF(NG.LE.MG) GO TO 1
      WRITE(*,*)' Program dimensioned to only',MG,' channels'
      STOP
1     NE=3*NG
      ALLOCATE(F(NE),D(9*NG-3))
      HMIN=1.E-5
      G2=2.*G
      G8=.128*G
      FMS=1.+SQRT(FM*FM+1.)
      HM=.5*FM
      DONE=.FALSE.
      CC=1.486
      IF(G.LT.20.) CC=1.
      DO 10 I=1,NG
      READ(2,*) SOO(I),FL(I),FLG(I),QS(I),DX(I),DXG(I),B,FRAC,CD(I)
      CD(I)=CD(I)*SQRT(G2)*FRAC*B
      QT(I)=FL(I)*QS(I)
      II=3*I
10    READ(2,*) X(II-2),X(II-1),X(II)
      NCT=0
20    CALL FUN(NE,F,FF,0)
      DO 22 I=1,9*NG-3
22    D(I)=0.
C Determines Jacobian for first channel-grate
      DXX=.005*X(1)
      X(1)=X(1)+DXX
      CALL FUN(NE,F,FF,1)
      D(2)=(FF(1)-F(1))/DXX
      X(1)=X(1)-DXX
      DXX=.005*X(2)
      X(2)=X(2)+DXX
      CALL FUN(NE,F,FF,2)
      D(4)=(FF(2)-F(2))/DXX
      D(5)=(FF(3)-F(3))/DXX
      X(2)=X(2)-DXX
C Determines Jacobian for rest of channel-grates
      DO 30 JJ=2,NG
Changes Qo(i-1)
      II=3*JJ-3
      IJ=9*(JJ-1)
      D(IJ-3)=-1.
      DXX=.005*X(II)
      X(II)=X(II)+DXX
      CALL FUN(NE,F,FF,II+3)
      D(IJ-2)=(FF(1)-F(II+1))/DXX
      D(IJ-1)=(FF(2)-F(II+2))/DXX
      D(IJ)=(FF(3)-F(II+3))/DXX
      X(II)=X(II)-DXX
Changes Yl(i) - diagonal element
      II=II+1
      DXX=.005*X(II)
      X(II)=X(II)+DXX
      CALL FUN(NE,F,FF,II)
      D(IJ+2)=(FF(1)-F(II))/DXX
      X(II)=X(II)-DXX
Changes Yr(i)
      II=II+1
      DXX=.005*X(II)
      X(II)=X(II)+DXX
      CALL FUN(NE,F,FF,II)
      D(IJ+4)=(FF(2)-F(II))/DXX
      D(IJ+5)=(FF(3)-F(II+1))/DXX
30    X(II)=X(II)-DXX
      CALL SOLBANDS(NG,F,D)
      NCT=NCT+1
      SUM=0.
      DO 40 I=1,NE
      X(I)=X(I)-F(I)
40    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,(X(I),I=1,NE)
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,(8F10.4))
      IF(NCT.LT.30 .AND. SUM.GT.ERR) GO TO 20
      WRITE(IOUT,120)
120   FORMAT(' No    Yl     Yr    Qout  (Fr)l  (Fr)r')
      DO 50 JJ=1,NG
      II=3*JJ
      IF(JJ.EQ.1) THEN
      Frr=SQRT(QT(JJ)**2*FM*X(2)/(G*(HM*X(2)**2)**3))
      Frl=0.
      ELSE
      Frr=SQRT((QT(JJ)+X(II-3))**2*FM*X(II-1)/(G*(HM*X(II-1)**2)**3))
      Frl=SQRT(X(II-3)**2*FM*X(II-2)/(G*(HM*X(II-2)**2)**3))
      ENDIF
50    WRITE(IOUT,151) JJ,X(II-2),X(II-1),X(II),Frl,Frr
151   FORMAT(I3,5F7.3)
      DONE=.TRUE.
      CALL FUN(NE,F,FF,0)
      END
      SUBROUTINE FUN(NE,F,FF,K)
      PARAMETER (MG=6,ME=3*MG)
      LOGICAL DONE
      EXTERNAL DYX,DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(NE),FF(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J
      IF(DONE) WRITE(IOUT,100)
100   FORMAT(/,'       x          Y         Q        E          A       
     & Fr       q*',/,1X,69('-'))
      IF(K.EQ.0) THEN
      J1=1
      J2=NG
      IODE=0
      ELSE
      J1=(K-1)/3+1
      J2=J1
      IODE=MOD(K,3)
      ENDIF
      DO 60 J=J1,J2
      I=3*J
      SO=SOO(J)
      IF(IODE.EQ.2) GO TO 20
      H1=.1
      XX=0.
      Y(1)=X(I-2)
      IF(DONE) THEN
      WRITE(IOUT,111) J
111   FORMAT(' Gutter-Grate #',I3)
      A=HM*Y(1)**2
      Q=0.
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,110) XX,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
      ENDIF
      FLM=FL(J)-1.E-8
10    XZ=XX+DX(J)
      IF(XZ.GT.FL(J)) XZ=FL(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*XZ
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT.FLM) GO TO 10
      IF(K.EQ.0) THEN
      F(I-2)=X(I-1)-Y(1)
      ELSE
      FF(1)=X(I-1)-Y(1)
      ENDIF
      IF(IODE.EQ.1) RETURN
20    H1=.002
      XX=0.
      Y(1)=X(I-1)
      SQSTAR=0.
      QS1=CD(J)*SQRT(Y(1))
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XX,Y(1),Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5
     &)),QS1
      ENDIF
      FLM=FLG(J)-1.E-8
30    XZ=XX+DXG(J)
      IF(XZ.GT.FLG(J)) XZ=FLG(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      QS2=CD(J)*SQRT(Y(1))
      SQSTAR=SQSTAR+.5*ABS(XZ-XX)*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*FL(J)-SQSTAR
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5)),
     &QS2
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.FLM) GO TO 30
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      IF(J.LT.NG) THEN
      IF(K.EQ.0) THEN
      F(I-1)=X(I+1)-Y(1)
      F(I)=Q-X(I)-SQSTAR
      ELSE
      FF(2)=X(I+1)-Y(1)
      FF(3)=Q-X(I)-SQSTAR
      ENDIF
      ELSE
      IF(K.EQ.0) THEN
      F(I-1)=X(I)-Y(1)
      F(I)=Q-SQSTAR
      ELSE
      FF(2)=X(I)-Y(1)
      FF(3)=Q-SQSTAR
      ENDIF
      ENDIF
60    CONTINUE
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      PARAMETER (MG=6,ME=3*MG)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,ZZ,HMIN,SQSTAR,DONE
     &,IOUT,NG,J
      YY=ABS(Y(1))
      A=HM*YY**2
      Q=QS(J)*XX
      IF(J.GT.1) Q=Q+X(3*(J-1))
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS(J)/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      PARAMETER (MG=6,ME=3*MG)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J
      YY=Y(1)
      QS2=CD(J)*SQRT(YY)
      A=HM*YY**2
      Q=QS(J)*FL(J)-SQSTAR-.5*(XP-XX)*(QS1+QS2)
      IF(J.GT.1) Q=Q+X(3*(J-1))
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE SOLBANDS(N,F,D)
      REAL F(3*N),D(9*N-3)
      N1=N-1
C  eliminates D(9),D(18), .. D(9i) .. D(9(n-1))
      DO 10 I=1,N1
      I9=9*I
      FAC=D(I9)/D(I9-1)
      D(I9+5)=D(I9+5)-FAC*D(I9+4)
      IF(I.LT.N1) D(I9+10)=-FAC
10    F(3*I+3)=F(3*I+3)-FAC*F(3*I+2)
      D(9*N-3)=-FAC
C eliminates D(8),D(17)..D(9i-1)..D(9(n-1)-1) & adds D(12),D(21)..D(9(i-1)+3)
      DO 20 I=1,N1
      I9=9*I
      FAC=D(I9-1)/D(I9-2)
      D(I9+3)=-FAC*D(I9+2)
      D(I9+4)=D(I9+4)-FAC
20    F(3*I+2)=F(3*I+2)-FAC*F(3*I+1)
C eliminates elements just below diagonal & adds D(10),D(19)..D(9(i-1)+1)
      DO 30 I=1,N1
      I9=9*(I-1)
      IJ=3*(I-1)+1
      DO 30 J=1,3
      FAC=D(I9+2*J+1)/D(I9+2*J)
      IF(J.EQ.1) THEN
      D(I9+4)=D(I9+4)-FAC
      ELSE IF(J.EQ.2) THEN
      D(I9+10)=D(I9+10)-FAC
      ELSE
      D(I9+11)=D(I9+11)-FAC*D(I9+10)
      ENDIF
30    F(IJ+J)=F(IJ+J)-FAC*F(IJ+J-1)
C elimiates elements for last gutter-grate
      I9=9*N1
      FAC=D(I9+3)/D(I9+2)
      D(I9+4)=D(I9+4)-FAC
      N3=3*N
      F(N3-1)=F(N3-1)-FAC*F(N3-2)
      FAC=D(I9+5)/D(I9+4)
      D(I9+6)=D(I9+6)-FAC
      F(N3)=F(N3)-FAC*F(N3-1)
C     back substitution
      F(N3)=F(N3)/D(I9+6)
      F(N3-1)=(F(N3-1)-F(N3))/D(I9+4)
      F(N3-2)=(F(N3-2)-F(N3-1))/D(I9+2)
      DO 40 I=N1,1,-1
      I9=9*(I-1)
      I3=3*I
      F(I3)=(F(I3)-D(I9+10)*F(I3+1))/D(I9+6)
      F(I3-1)=(F(I3-1)-F(I3+1))/D(I9+4)
40    F(I3-2)=(F(I3-2)-F(I3-1))/D(I9+2)
      RETURN
      END