// Solves the problem of side flow into a triangular gutter
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
float x[4],so,fm,fms,qs,cc,fn,hm,g,g2,g8,fl,dx,gm2,tol;  int done;
FILE *filo;
extern void solveq(int n,float **a,float *b,int itype,float *dd,int *indx);
extern void rukust(int ne,float *dxs,float xbeg,float xend,float err,float *y,float *ytt);
void slope(float xx,float *yp,float *dy){ float a,q,sf,fr2,yy;  yy=*yp;
 a=hm*yy*yy; q=qs*(xx-x[3]);
 sf=fn*q/cc*pow(fms*yy/a,.66666667)/a; sf*=fabs(sf);fr2=q*q*fm*yy/(g*pow(a,3.));
 *dy=(so-sf-2.*q*qs/(g*a*a))/(1.-fr2);
return; }  // End slope
void fun(float *f){float y[1],ytt[1],dxs[1],a,q,xx,xz;  int i;
f[0]=fm*x[0]*pow(qs*x[3],2.)-gm2*pow(x[0],6.);
f[1]=fm*x[1]*pow(qs*(fl-x[3]),2.)-gm2*pow(x[1],6.);
if(done){a=hm*x[0]*x[0];q=qs*x[3];
 fprintf(filo,"       x          Y         Q        E        A        Fr\n");
 for(i=0;i<57;i++) fprintf(filo,"-");fprintf(filo,"\n");
 fprintf(filo,"%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n",0.,x[0],q,x[0]+pow(q/a,2.)/g2,a,q/(fm*sqrt(g8*pow(x[0],5.))));}
 dxs[0]=.1;xx=0.;y[0]=1.1*x[0];
L10: xz=xx+dx; if(xz>x[3]) xz=x[3]; rukust(1,dxs,xx,xz,tol,y,ytt);
if(done){a=hm*y[0]*y[0];q=qs*(x[3]-xz);
 fprintf(filo,"%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n",xz,y[0],q,y[0]+pow(q/a,2.)/g2,a,q/(fm*sqrt(g8*pow(y[0],5.))));}
 xx=xz; if(xz<(x[3]-1.e-6)) goto L10;  f[2]=x[2]-y[0];
 dxs[0]=-.1; if(done){a=hm*x[1]*x[1]; q=qs*(fl-x[3]);
 fprintf(filo,"%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n",fl,x[1],q,x[1]+pow(q/a,2.)/g2,a,q/(fm*sqrt(g8*pow(x[1],5.))));}
 xx=fl; y[0]=1.1*x[1];
L20:xz=xx-dx;if(xz<x[3]) xz=x[3]; rukust(1,dxs,xx,xz,tol,y,ytt);
if(done){a=hm*y[0]*y[0];q=qs*(xz-x[3]);
 fprintf(filo,"%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f\n",xz,y[0],q,y[0]+pow(q/a,2.)/g2,a,q/(fm*sqrt(g8*pow(y[0],5.))));}
 xx=xz; if(xz>(x[3]+1.e-6)) goto L20;  f[3]=x[2]-y[0];
return; }  // End of fun
void main(void){char fname[20]; int i,j,nct,indx[4];float err,sum,dxx,dd[1];
 float f[4],**d,fff[4];
 d=(float**)malloc(4*sizeof(float*));for(i=0;i<4;i++)d[i]=(float*)malloc(4*sizeof(float));
 printf("Give name of output file\n");scanf("%s",fname);
 if((filo=fopen(fname,"w"))==NULL){printf("Cannot open file");exit(0);}
 printf("GIVE:TOL,ERR,n,So,m,L,g,DX,q*\n");
 scanf("%f %f %f %f %f %f %f %f %f",&tol,&err,&fn,&so,&fm,&fl,&g,&dx,&qs);
 done=0;hm=.5*fm;fms=1.+sqrt(fm*fm+1.); if(g>20.) cc=1.486; else cc=1.;
 g2=2.*g;g8=.125*g;gm2=g8*fm*fm;
 printf("GIVE guess for Position Xs\n"); scanf("%f",&x[3]);
 x[0]=pow(pow(qs*x[3],2.)/gm2,0.2); x[1]=pow(pow(qs*(fl-x[3]),2.)/gm2,0.2);
 x[2]=x[0]+x[1];printf("Guesses for x %f %f %f %f\n",x[0],x[1],x[2],x[3]);
 gm2*=fm; nct=0;
do{ fun(f);printf("nct=%d, %f %f %f %f\n",nct,f[0],f[1],f[2],f[3]);
for(j=0;j<4;j++){dxx=.005*x[j];x[j]+=dxx; fun(fff); for(i=0;i<4;i++)d[i][j]=(fff[i]-f[i])/dxx;
 x[j]-=dxx;} solveq(4,d,f,1,dd,indx); nct++;sum=0.;
 for(i=0;i<4;i++){x[i]-=f[i];sum+=fabs(f[i]);}
 printf("nct= %d, sum= %f\n %10.3f %10.3f %10.3f %10.3f\n",nct,sum,x[0],x[1],x[2],x[3]);
}while((nct<30) && (sum>err));
fprintf(filo," Yc1= %8.3f, Yc2= %8.3f ,Depth at Q=0 %8.3f, Xs= %8.1f\n",x[0],x[1],x[2],x[3]);
done=1; fun(f);  fclose(filo); exit(0);
}