      PARAMETER (N=26)
      REAL SE(1),DE(1),XP(1),YP(1,1),WK1(1,13)
      CHARACTER*2 UNIT
      LOGICAL*2 LINEAR
      EXTERNAL DEX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRANS/ QN,FN,SO
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,Q2G,LINEAR,IP1,IP2,IR,IR1,IL,IL1,IOTAB
      WRITE(*,*)' GIVE:UNIT,IOUT,IOTAB,NSTAT,TOL,DELX,YB,Q,FN,XBEG,XEND'
      READ(*,*) UNIT,IOUT,IOTAB,NSTAT,TOL,DELX,YB,Q,FN,XBEG,XEND
      LINEAR=.TRUE.
      H1=-.1
      HMIN=1.E-4
      CC=1.486
      G=32.2
      IF(UNIT.EQ.'SI' .OR. UNIT.EQ.'si') THEN
      CC=1.
      G=9.81
      ENDIF
      G2=2.*G
      QN=(FN*Q/CC)**2
      Q2G=Q*Q/G2
      XS=XBEG
      CALL CHTABL(1,1)
      CALL CHTABL(2,2)
      NSTA=2
      SO=(ZSTA2-ZSTA1)/(XSTA1-XSTA2)
      YY=YB
      IP1=N/2
      IP2=N/2
      CALL INTERP(XS,YY,.TRUE.)
      SE(1)=YY+Q2G/ASTA**2
      WRITE(IOUT,15) Q,FN
15    FORMAT(' Solution to Gradually Varied Flow in natural channel with
     &',/,' Q =',F10.2,' n =',F7.4,/,1X,71('-'),/,6X,'X'
     &,11X,'Y',9X,'E','   Perimeter      Area  Velocity  Bot. Slope',
     &/,1X,71('-'))
      WRITE(IOUT,40) XS,YY,SE(1),PSTA,ASTA,Q/ASTA,SO
40    FORMAT(1X,6F10.2,F10.7)
20    XZ=XS+DELX
      CALL ODESOL(SE,DE,1,XS,XZ,TOL,H1,HMIN,1,XP,YP,WK1,DEX)
      WRITE(IOUT,40) XZ,YY,SE(1),PSTA,ASTA,Q/ASTA,SO
      XS=XZ
      IF(XZ.LE.XSTA2 .AND. NSTA.LT.NSTAT) THEN
      DO 30 I=1,N
      Y(I,1)=Y(I,2)
      A(I,1)=A(I,2)
      P(I,1)=P(I,2)
30    E(I,1)=E(I,2)
      ZSTA1=ZSTA2
      XSTA1=XSTA2
      IP1=IP2
      NSTA=NSTA+1
      CALL CHTABL(NSTA,2)
      SO=(ZSTA2-ZSTA1)/(XSTA1-XSTA2)
      ENDIF
      IF(XZ.GT.XEND) GO TO 20
      STOP
      END
      SUBROUTINE DEX(X,SE,EPRIME)
      PARAMETER (N=26)
      REAL SE(1),EPRIME(1)
      LOGICAL*2 LINEAR
      COMMON /TRANS/ QN,FN,SO
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,Q2G,LINEAR,IP1,IP2,IR,IR1,IL,IL1,IOTAB
      CALL INTERP(X,SE(1),.FALSE.)
      SF=QN*(ABS(PSTA/ASTA)**.666666667/ASTA)**2
      EPRIME(1)=SO-SF
      RETURN
      END
      SUBROUTINE CHTABL(NOSEC,M)
      PARAMETER (N=26)
      LOGICAL*2 LINEAR,IBOTSC
      REAL X(20),H(20)
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,Q2G,LINEAR,IP1,IP2,IR,IR1,IL,IL1,IOTAB
      READ(3,*) NSTA,NVALUE,XSTA,LINEAR
      IF(M.EQ.1) THEN
      XSTA1=XSTA
      ELSE
      XSTA2=XSTA
      ENDIF
      IF(NVALUE.GT.20) THEN
      WRITE(*,100)
100   FORMAT(' Program dimension to allow only 20 coordinate pairs')
      STOP
      ENDIF
      IF(NSTA.NE.NOSEC) THEN
      WRITE(*,110) NSTA,NOSEC
110   FORMAT(' Next station with data is',I4,/,' Expecting data for stat
     *ion',I5)
      STOP
      ENDIF
      READ(3,*)(X(I),H(I),I=1,NVALUE)
      ZSTA=H(1)
      IMIN=1
      YMAX=ZSTA
      DO 10 I=2,NVALUE
      IF(H(I).GE.ZSTA) GO TO 5
      ZSTA=H(I)
      IMIN=I
5     IF(H(I).GT.YMAX) YMAX=H(I)
10    CONTINUE
      IF(H(IMIN+1).LT.ZSTA+1.E-5) THEN
      T(1,M)=X(IMIN+1)-X(IMIN)
      P(1,M)=T(1,M)
      IR1=IMIN+1
      XR1=X(IMIN+1)
      ELSE
      T(1,M)=0.
      P(1,M)=0.
      IR1=IMIN
      XR1=X(IMIN)
      ENDIF
      XL1=X(IMIN)
      AA=0.
      PP=P(1,M)
      A(1,M)=0.
      Y(1,M)=0.
      IL1=IMIN
      IL=IL1-1
      IR=IR1+1
      DY=(YMAX-ZSTA)/FLOAT(N-1)
      DY2=.5*DY
      DYS=DY*DY
      ILM=1
      IRM=NVALUE
      IF(.NOT.LINEAR) THEN
      IRM=IRM-1
      ILM=2
      ENDIF
      IF(M.EQ.1) THEN
      ZSTA1=ZSTA
      ELSE
      ZSTA2=ZSTA
      ENDIF
      DO 40 I=2,N
      Y(I,M)=DY*FLOAT(I-1)
      YZ=Y(I,M)+ZSTA
      DO 20 WHILE (IR.LT.IRM .AND. H(IR).LT.YZ)
      IR1=IR
20    IR=IR+1
      DO 30 WHILE (IL.GT.ILM .AND. H(IL).LT.YZ)
      IL1=IL
30    IL=IL-1
      IF(LINEAR) THEN
      XR=X(IR1)+(YZ-H(IR1))/(H(IR)-H(IR1))*(X(IR)-X(IR1))
      XL=X(IL1)+(YZ-H(IL1))/(H(IL)-H(IL1))*(X(IL)-X(IL1))
      ELSE
      ILP=IL-1
      IRP=IR+1
      XR=(YZ-H(IR))*(YZ-H(IRP))*X(IR1)/((H(IR1)-H(IR))*(H(IR1)-H(IRP)))+
     &(YZ-H(IR1))*(YZ-H(IRP))*X(IR)/((H(IR)-H(IR1))*(H(IR)-H(IRP)))+
     &(YZ-H(IR1))*(YZ-H(IR))*X(IRP)/((H(IRP)-H(IR1))*(H(IRP)-H(IR)))
      XL=(YZ-H(IL))*(YZ-H(ILP))*X(IL1)/((H(IL1)-H(IL))*(H(IL1)-H(ILP)))+
     &(YZ-H(IL1))*(YZ-H(ILP))*X(IL)/((H(IL)-H(IL1))*(H(IL)-H(ILP)))+
     &(YZ-H(IL1))*(YZ-H(IL))*X(ILP)/((H(ILP)-H(IL1))*(H(ILP)-H(IL)))
      ENDIF
      T(I,M)=XR-XL
      AA=AA+DY*(XR1-XL1)+DY2*(XR-XR1+XL1-XL)
      A(I,M)=AA
      IF(AA.LT. 1.E-5) GO TO 35
      VS=Q2G/AA**2
      IF(VS.GT. 5.*Y(I,M)) GO TO 35
      E(I,M)=Y(I,M)+VS
      GO TO 36
35    E(I,M)=0.
36    PP=PP+SQRT(DYS+(XR-XR1)**2)+SQRT(DYS+(XL1-XL)**2)
      P(I,M)=PP
      XR1=XR
40    XL1=XL
      IF(IOTAB.GT.0) THEN
      IOTT=IOTAB
      IBOTSC=.FALSE.
      IF(IOTAB.GT.20) THEN
      IOTT=IOTAB-20
      IBOTSC=.TRUE.
      ENDIF
      IF(IBOTSC) WRITE(*,312) NSTA,XSTA,ZSTA
      WRITE(IOTT,312) NSTA,XSTA,ZSTA
312   FORMAT(/,' Station no.=',I4,' Position, x =',F10.1,' Elev. Bot=',
     &F8.2,/,' No.     Depth      Area Perimeter Top Width S. Energy',/
     &,1X,55('-') )
      DO 310 I=1,N
      IF(IBOTSC) WRITE(*,311) I,Y(I,M),A(I,M),P(I,M),T(I,M),E(I,M)
310   WRITE(IOTT,311) I,Y(I,M),A(I,M),P(I,M),T(I,M),E(I,M)
311   FORMAT(I4,5F10.3)
      IF(IOTAB.EQ.6 .OR.IBOTSC) READ(*,*)
      ENDIF
      RETURN
      END
      SUBROUTINE INTERP(X,SE,KNWY)
      PARAMETER (N=26)
      LOGICAL*2 LINEAR,KNWY,TWICE
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,Q2G,LINEAR,IP1,IP2,IR,IR1,IL,IL1,IOTAB
      NCT=0
      TWICE=.FALSE.
      FAX=(X-XSTA1)/(XSTA2-XSTA1)
      IF(FAX.GT. .99) FAX=1.
      IF(FAX.LT. .01) FAX=0.
      JP1=IP1-1
      JP2=IP2-1
10    IF(IP1.GE.N .OR. Y(IP1,1).GE.YY) GO TO 20
      JP1=IP1
      IP1=IP1+1
      GO TO 10
20    IF(IP1.LT.3 .OR. Y(JP1,1).LE.YY) GO TO 30
      IP1=IP1-1
      JP1=IP1-1
      GO TO 20
30    IF(FAX.LT.1.E-5) GO TO 50
      IF(IP2.GE.N .OR. Y(IP2,2).GE.YY) GO TO 40
      JP2=IP2
      IP2=IP2+1
      GO TO 30
40    IF(IP2.LT.3 .OR. Y(JP2,2).LE.YY) GO TO 50
      IP2=IP2-1
      JP2=IP2-1
      GO TO 40
50    FA1=(YY-Y(JP1,1))/(Y(IP1,1)-Y(JP1,1))
      FA2=(YY-Y(JP2,2))/(Y(IP2,2)-Y(JP2,2))
      ASTA=(1.-FAX)*(A(JP1,1)+FA1*(A(IP1,1)-A(JP1,1)))+FAX*(A(JP2,2)+FA2
     &*(A(IP2,2)-A(JP2,2)))
      PSTA=(1.-FAX)*(P(JP1,1)+FA1*(P(IP1,1)-P(JP1,1)))+FAX*(P(JP2,2)+FA2
     &*(P(IP2,2)-P(JP2,2)))
      IF(KNWY) GO TO 70
      F=SE-YY-Q2G/ASTA**2
      IF(TWICE) GO TO 60
      TWICE=.TRUE.
      F1=F
      YY=YY-.01
      GO TO 50
60    DIF=.01*F1/(F1-F)
      NCT=NCT+1
      TWICE=.FALSE.
      YY=YY+.01-DIF
      IF(NCT.LT.10 .AND. ABS(DIF).GT. .00001) GO TO 10
      IF(NCT.EQ.10) WRITE(*,80) DIF,YY,SE,Q2G
80    FORMAT(' Failed to converge, DIF=',E10.4,' YY=',3E10.4)
70    RETURN
      END