#include <math.h>
#include <conio.h>
#include <stdio.h>
#define sqr(x) (x*x)
float yst[400],w[400]; int itab;
void stage(void){ float dy,dy1,dyh,rc,sum,rc1,yp; int i,j,n;
#define fc(yp) ( sqrt((1.+2.*yp)/(yp+yp*yp)) )
 dy=.005; dy1=dy/10.; dyh=dy1/2.; n=(2.-.01)/dy+1.;
 yst[0]=.01; rc=fc(.01); w[0]=.138;
 for(i=1;i<n;i++){ sum=0.;
  for(j=1;j<11;j++){yp=yst[i-1]+dy1*(float)j; rc1=fc(yp);
   sum+=dyh*(rc+rc1); rc=rc1;}
 yst[i]=yp; w[i]=w[i-1]+sum;}
} /* end stage */
float v[51],y[51],vk[51],yk[51],va[8],f[8],f1[8],d[8][8],z[8],fms,dtg2,fm2,
  deltdx,cn,q,dx,dt2,So,b,fm,fn,g,dv,delt,h,fek,VaN;
short n,nm,nt,ii,linear=0,itype,mgiv;
float wstage(float yy){ int it1; float yyy;
 if(fm<1.e-5) return 2.*sqrt(g*yy); else { yyy=fm*yy/b;
 it1=itab+1;
 if(yyy<yst[it1]){ while ((yyy<yst[itab]) && (itab>0)) itab--;
 it1=itab+1;} else {
 if(yyy>yst[it1]) while ((yyy>yst[it1]) && (it1<398)) it1++;
 itab=it1-1;}
 return sqrt(g*b/fm)*(w[itab]+(yyy-yst[itab])/(yst[it1]-yst[itab])*(w[it1]-w[itab]));}
} /* end wstage */
void funct(int j) { int i,im,ip; float a,c,sf,al,ar,cl,cr,sfr,sfl,ws,ex=.6666667;
 i=ii; im=i-1; ip=i+1;
 if(j>(-1)) {dv=0.001*va[j];if(fabs(dv)<1.e-5) dv=1.e-5;va[j]+=dv;}
 a=(b+fm*va[1])*va[1]; c=sqrt(g*a/(b+fm2*va[1]));
   sf=sqr(cn*va[0]*pow((b+fms*va[1])/a,ex));
 if(i==0){ /* upstream BC H=Y+(1+Ke)V*V/(2g) */
  ar=(b+fm*va[4])*va[4]; cr=sqrt(g*ar/(b+fm2*va[4]));
  sfr=sqr(cn*va[3]*pow((b+fms*va[4])/ar,ex));
  f[0]=dt2*(c-va[0]+cr-va[3])-dx*va[2];
  f[1]=va[0]-wstage(va[1])-va[3]+wstage(va[4])-dtg2*(So-.5*(sf+sfr));
  f[2]=h-va[1]-fek*sqr(va[0]);
  if(linear){
  f[3]=va[3]-vk[0]-va[2]*(vk[1]-vk[0]);
  f[4]=va[4]-yk[0]-va[2]*(yk[1]-yk[0]);} else {
  f[3]=va[3]-vk[0]-.5*va[2]*((3.-va[2])*(vk[1]-vk[0])-(va[2]-1.)*(vk[2]-vk[1]));
  f[4]=va[4]-yk[0]-.5*va[2]*((3.-va[2])*(yk[1]-yk[0])-(va[2]-1.)*(yk[2]-yk[1]));}}
 else if(i==nm){  /* downstream BC  */
  al=(b+fm*va[4])*va[4]; cl=sqrt(g*al/(b+fm2*va[4]));
  sfl=sqr(cn*va[3]*pow((b+fms*va[4])/al,ex));
  f[0]=dx*(1.-va[2])-dt2*(va[0]+c+va[3]+cl);
  f[1]=va[0]+wstage(va[1])-va[3]-wstage(va[4])-dtg2*(So-.5*(sf+sfl));
  if(itype==1) f[2]=va[1]-VaN; else if(itype==2) f[2]=va[0]-VaN; else
  f[2]=VaN-a*va[0];
  if(linear){
  f[3]=va[3]-vk[im]-va[2]*(vk[i]-vk[im]);
  f[4]=va[4]-yk[im]-va[2]*(yk[i]-yk[im]);} else {
  f[3]=va[3]-vk[i-2]-.5*(va[2]+1.)*((2.-va[2])*(vk[im]-vk[i-2])+va[2]*(vk[i]-vk[im]));
  f[4]=va[4]-yk[i-2]-.5*(va[2]+1.)*((2.-va[2])*(yk[im]-yk[i-2])+va[2]*(yk[i]-yk[im]));}
 } else { /* regular points  */
  al=(b+fm*va[6])*va[6]; cl=sqrt(g*al/(b+fm2*va[6]));
  sfl=sqr(cn*va[4]*pow((b+fms*va[6])/al,ex));
  ar=(b+fm*va[7])*va[7]; cr=sqrt(g*ar/(b+fm2*va[7]));
  sfr=sqr(cn*va[5]*pow((b+fms*va[7])/ar,ex));
  f[0]=dx*(1.-va[2])-dt2*(va[0]+c+va[4]+cl); ws=wstage(va[1]);
  f[1]=va[0]+ws-va[4]-wstage(va[6])-dtg2*(So-.5*(sf+sfl));
  f[2]=dt2*(c-va[0]+cr-va[5])-dx*va[3];
  f[3]=va[0]-ws-va[5]+wstage(va[7])-dtg2*(So-.5*(sf+sfr));
  if(linear){
  f[4]=va[4]-vk[im]-va[2]*(vk[i]-vk[im]);
  f[6]=va[6]-yk[im]-va[2]*(yk[i]-yk[im]); } else {
   if(i==1){
    f[4]=va[4]-vk[0]-.5*va[2]*((3.-va[2])*(vk[1]-vk[0])+(va[2]-1.)*(vk[2]-vk[1]));
    f[6]=va[6]-yk[0]-.5*va[2]*((3.-va[2])*(yk[1]-yk[0])+(va[2]-1.)*(yk[2]-yk[1]));}
   else {
  f[4]=va[4]-vk[i-2]-.5*(va[2]+1.)*((2.-va[2])*(vk[im]-vk[i-2])+va[2]*(vk[i]-vk[im]));
  f[6]=va[6]-yk[i-2]-.5*(va[2]+1.)*((2.-va[2])*(yk[im]-yk[i-2])+va[2]*(yk[i]-yk[im]));}}
  if(linear){
  f[5]=va[5]-vk[i]-va[3]*(vk[ip]-vk[i]);
  f[7]=va[7]-yk[i]-va[3]*(yk[ip]-yk[i]);}  else {
   if(ip==nm) {
    f[5]=va[5]-vk[im]-.5*(va[3]+1.)*((2.-va[3])*(vk[i]-vk[im])+va[3]*(vk[nm]-vk[i]));
    f[7]=va[7]-yk[im]-.5*(va[3]+1.)*((2.-va[3])*(yk[i]-yk[im])+va[3]*(yk[nm]-yk[i]));}
 else {f[5]=va[5]-vk[i]-.5*va[3]*((3.-va[3])*(vk[ip]-vk[i])+(va[3]-1.)*(vk[i+2]-vk[ip]));
  f[7]=va[7]-yk[i]-.5*va[3]*((3.-va[3])*(yk[ip]-yk[i])+(va[3]-1.)*(yk[i+2]-yk[ip]));}}}
 if(j>=0) va[j]-=dv;
}  /* end funct  */
void solve(void){int ik,ip,im,j,j1,m,l,m1,neq,nct; float dif,sum,fac;
 for(ik=0;ik<n;ik++){ ii=ik; ip=ik+1; im=ik-1; nct=0;
 va[0]=v[ik]; va[1]=y[ik];
 if(ik==0){neq=5;va[2]=(sqrt(g*(b+fm*y[0])*y[0]/(b+fm2*y[0]))-v[0])*deltdx;
va[3]=v[0]+va[2]*(v[1]-v[0]);va[4]=y[0]+va[2]*(y[1]-y[0]);}
 else if(ik==nm){neq=5;
   va[2]=1.-(v[nm]+sqrt(g*(b+fm*y[nm])*y[nm]/(b+fm2*y[nm])))*deltdx;
   va[3]=v[n-2]+(1.-va[2])*(v[nm]-v[n-2]);va[4]=y[n-2]+(1.-va[2])*(y[nm]-y[n-2]);}
   else {neq=8;   if(ik==1){
    va[2]=1.-(v[1]+sqrt(g*(b+fm*y[1])*y[1]/(b+fm2*y[1])))*deltdx;
    va[3]=(sqrt(g*(b+fm*y[1])*y[1]/(b+fm2*y[1]))-v[1])*deltdx; }
   va[4]=vk[im]+va[2]*(vk[ik]-vk[im]);va[6]=yk[im]+va[2]*(yk[ik]-yk[im]);
   va[5]=vk[ik]+va[3]*(vk[ip]-vk[ik]);va[7]=yk[ik]+va[3]*(yk[ip]-yk[ik]);}
 do {funct(-1);  for(j=0;j<neq;j++) f1[j]=f[j];
  for(j=0;j<neq;j++){ funct(j);for(j1=0;j1<neq;j1++)d[j1][j]=(f[j1]-f1[j1])/dv;}
  for(l=0;l<neq-1;l++){ for(m=neq-1;m>l;m--){if(fabs(d[m][l]) > 1.e-15){
    fac=d[m][l]/d[l][l];f1[m]=f1[m]-fac*f1[l];
     for(j=l+1;j<neq;j++) d[m][j]=d[m][j]-fac*d[l][j];}}}
  m=neq-1; z[m]=f1[m]/d[m][m]; dif=fabs(z[m]); va[m]-=z[m];
  do {m1=m-1;sum=0.; for(j=m;j<neq;j++) sum+=z[j]*d[m1][j];
   if(fabs(d[m1][m1])<1.e-10) z[m1]=0; else z[m1]=(f1[m1]-sum)/d[m1][m1];
   m=m1;va[m]-=z[m];dif+=fabs(z[m]); } while (m>0);
  nct++;} while((nct<20) && (dif> 0.00001));
 if(nct==20) cprintf("Failed to converge %d %f\r\n",nct,dif);
  /* << "Failed to converge" <<nct <<dif <<"\n";  */
 v[ik]=va[0];y[ik]=va[1];
 }  } /* end of solve */
void main(void) {
 float givtim[40],givdws[40],ke,time,ya,fl,c;
 short i,k,ig,igiv;
 FILE *fil;
 fil=fopen("hartree.in","rt");
fscanf(fil,"%d %d %d %f %f %f %f %f %f %f %f %f %f",&nt,&n,&linear,&delt,&q,&fn,
  &So,&b,&fm,&g,&fl,&h,&ke);  nm=n-1;
 for(i=nm;i>=0;i--) fscanf(fil,"%f",&yk[i]);
fscanf(fil,"%d %d",&itype,&mgiv);for(i=0;i<mgiv;i++)fscanf(fil,"%f %f",&givtim[i],&givdws[i]);
/* itype=1 then y[n]-given; itype=2 then v[n]-given; itype=3 then q[n]-given
   Unknowns: va[0]=V,va[1]=Y,va[2]=XL,va[3]=XR,va[4]=VL,va[5]=VR,va[6]=YL,va[7]=YR
   For upstream BC va[0]=V,va[1]=Y,va[2]=XR,va[3]=VR,va[4]=YR
   For downstream BC  va[0]=V,va[1]=Y,va[2]=XL,va[3]=VL,va[4]=YL  */
 dt2=delt/2.;dtg2=g*delt;dx=fl/(float)(nm);fek=(ke+1.)/(2.*g);
 deltdx=delt/dx;  cn=fn; if(g>30.) cn=cn/1.486;
 fm2=2.*fm; fms=2.*sqrt(fm*fm+1.); itab=100;
 if(fm>0.) stage();
 for(i=0;i<n;i++){y[i]=yk[i];vk[i]=q/((b+fm*y[i])*y[i]);v[i]=vk[i];}
 cprintf("K=0  Depth, Velocity & Flowrate for time- 0.0 sec.\r\n");
 for(i=0;i<n;i++){if((i%10)==0) cprintf("\r\n"); cprintf("%8.3f",y[i]); }
 for(i=0;i<n;i++){ if((i%10)==0) cprintf("\r\n"); cprintf("%8.3f",v[i]);}
 for(i=0;i<n;i++){if((i%10)==0) cprintf("\r\n"); cprintf("%8.3f",q); }
 c=sqrt(g*(b+fm*y[1])*y[1]/(b+fm2*y[1]));
 va[2]=1.-(v[1]+c)*delt/dx;
 va[3]=(c-v[1])*delt/dx;
 igiv=1;
 for(k=1;k<=nt;k++){
 time=delt*(float)k;
 while ((givtim[igiv]<time) && (igiv<mgiv)) igiv++; ig=igiv-1;
 VaN=givdws[ig]+(time-givtim[ig])/(givtim[igiv]-givtim[ig])*(givdws[igiv]-givdws[ig]);
 solve();
 cprintf("\r\nK= %d Depth, Velocity & Flowrate for time=%8.1f sec.",k,time);
 for(i=0;i<n;i++){ if((i%10)==0) cprintf("\r\n"); cprintf("%8.3f",y[i]);}
 for(i=0;i<n;i++){if((i%10)==0) cprintf("\r\n"); cprintf("%8.3f",v[i]); }
 for(i=0;i<n;i++){  if((i%10)==0) cprintf("\r\n");cprintf("%8.3f",v[i]*(b+fm*y[i])*y[i]);}
 for(i=0;i<n;i++){ya=v[i]; v[i]=2.*ya-vk[i];vk[i]=ya;
  ya=y[i]; y[i]=2.*ya-yk[i]; yk[i]=ya;}
} } /* end of main program  */