      COMMON Y(41),Q(41),B(41),FM(41),FN(41),SO(41),SMS(41),QGIU(0:100),
     &QGID(0:100),DELX,DELT,RDT,G,H,W,ERR,G2,CMAN,DXT,NX,NT,NXM,NTBETW,
     &MAX,IOUT,IUBC,IDBC,NUSD,NDSD
      DATA ONE/-1./
      READ(2,*) IOUT,NFORW,NX,NT,NTBETW,DELT,DELX,G,W,ERR,MAX,IUBC,IDBC
C IUBC & IDBE are Upst. & Downst B.C. according to: 1-DEPTH known(given in
C  QGIU or QGID;  2-FLOWRATE known(given in QGIU or QGDD);  3-STAGE-DISCHARGE
C  given as pairs Y and Q in QGIU or QGID; 4-H(t)=y+Q*Q/(2gA*A) given in
C  QGIU and VELOCITY known for downstr. B.C. & given in QGID.
      DELT=DELT/FLOAT(NTBETW)
      G2=2.*G
      CMAN=1.
      IF(G.GT.30.) CMAN=1.486
      DXT=DELX/DELT
      RDT=1./DELT  
      NXM=NX-1
      DO 10 I=2,NX
      Q(I)=ONE
      B(I)=ONE
      FM(I)=ONE
      FN(I)=ONE
10    SO(I)=ONE
      DO 12 I=1,NT
      QGIU(I)=ONE
12    QGID(I)=ONE
      READ(2,*) (Q(I),I=1,NX)
      READ(2,*) (B(I),I=1,NX)
      READ(2,*) (FM(I),I=1,NX)
      READ(2,*) (FN(I),I=1,NX)
      READ(2,*) (SO(I),I=1,NX)
      READ(2,*) (QGIU(I),I=0,NT)
      READ(2,*) (QGID(I),I=0,NT)
      DO 20 I=2,NX
      IM=I-1
      IF(Q(I).EQ.ONE) Q(I)=Q(IM)
      IF(B(I).EQ.ONE) B(I)=B(IM)
      IF(FM(I).EQ.ONE) FM(I)=FM(IM)
      IF(FN(I).EQ.ONE) FN(I)=FN(IM)
      IF(SO(I).EQ.ONE) SO(I)=SO(IM)
20    SMS(I)=1.33333333*SQRT(FM(I)**2+1.)
      SMS(1)=1.33333333*SQRT(FM(1)**2+1.)
      NUSD=0
      NDSD=0
      DO 22 I=1,NT
      IF(QGIU(I).EQ.ONE) THEN
      IF(IUBC.NE.3) THEN
      QGIU(I)=QGIU(I-1)
      ELSE IF(NUSD.EQ.0) THEN
      NUSD=I-2
      ELSE
      GO TO 18
      ENDIF
      ENDIF
18    IF(QGID(I).EQ.ONE) THEN
      IF(IDBC.NE.3) THEN
      QGID(I)=QGID(I-1)
      ELSE IF(NDSD.EQ.0) THEN
      NDSD=I-2
      ELSE
      GO TO 22
      ENDIF
      ENDIF
22    CONTINUE
      IF(NFORW.EQ.1) THEN
      READ(2,*)(Y(I),I=1,NX)
      ELSE
      READ(2,*)(Y(I),I=NX,1,-1)
      ENDIF
      H=Y(1)+(Q(1)/((B(1)+FM(1)*Y(1))*Y(1)))**2/G2
      CALL SOR
      END
      SUBROUTINE SOR
      COMMON Y(41),Q(41),B(41),FM(41),FN(41),SO(41),SMS(41),QGIU(0:100),
     &QGID(0:100),DELX,DELT,RDT,G,H,W,ERR,G2,CMAN,DXT,NX,NT,NXM,NTBETW,
     &MAX,IOUT,IUBC,IDBC,NUSD,NDSD
      REAL D1(41),D2(41),D3(41),D4(41),E1(41),F1(41),F2(41),A(41),P(41),
     &T(41),V(41),SF(41)
      TIME=0.0
      JDSD=0
      JUSD=0
      DO 5 I=1,NX
      A(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V(I)=Q(I)/A(I)
      P(I)=B(I)+1.5*SMS(I)*Y(I)
      T(I)=B(I)+2.*FM(I)*Y(I)
5     SF(I)=(FN(I)*Q(I)/(CMAN*A(I)))**2*(P(I)/A(I))**1.33333333
      WRITE(IOUT,110) 0.
110   FORMAT(///1X,'Solution for time=',F8.2/1X,65('-')/,4X,'x',7X,'Y',
     &7X,'V',7X,'Sf',7X,'P',7X,'Q',7X,'A',5X,'TOP'/1X,65('-'))
      WRITE(IOUT,120) (DELX*FLOAT(I-1),Y(I),V(I),SF(I),P(I),Q(I),A(I),
     &T(I),I=1,NX)
120   FORMAT(F8.1,2F8.3,F8.5,4F8.3)
      K=0
10    K=K+1
      IF(IUBC.NE.3) THEN
      QGIU1=QGIU(K-1)
      DQGIU=(QGIU(K)-QGIU(K-1))/FLOAT(NTBETW)
      ENDIF
      IF(IDBC.NE.3) THEN
      QGID1=QGID(K-1)
      DQGID=(QGID(K)-QGID(K-1))/FLOAT(NTBETW)
      ENDIF
      DO 80 K10=1,NTBETW
      IF(IUBC.NE.3) QGIUI=QGIU1+DQGIU
      IF(IDBC.NE.3) QGIDI=QGID1+DQGID
      IF(IUBC.EQ.1) Y(1)=QGIUI
      IF(IUBC.EQ.2) Q(1)=QGIUI
      IF(IDBC.EQ.1) Y(NX)=QGIDI
      IF(IDBC.EQ.2) Q(NX)=QGIDI
      TIME=TIME+DELT
      DO 50 I=2,NXM
      C2=G*A(I)/T(I)
      E1(I)=T(I)*DXT
      F1(I)=E1(I)*Y(I)
      D1(I)=T(I)*(C2-V(I)**2)/(2.*DELX)
      D2(I)=V(I)/DELX
      D3(I)=G2*SF(I)*(SMS(I)*A(I)/P(I)-1.6666667*T(I))
      D4(I)=RDT+G2*SF(I)*A(I)/Q(I)
50    F2(I)=Q(I)/DELT+Y(I)*(D3(I)+V(I)**2*(B(I+1)-B(I-1)+Y(I)*(FM(I+1)-
     &FM(I-1)))/(2.*DELX))+G*A(I)*(SO(I)+SF(I))
      C=SQRT(G*A(1)/T(1))        
      VMC=V(1)-C
      VPC=V(1)+C
      FK=CMAN*A(1)**1.6666667/(FN(1)*P(1)**0.6666667)
      GAQK=G*A(1)*ABS(Q(1))/FK**2
      PKY=FK/A(1)*(1.6666667*T(1)-SMS(1)*A(1)/P(1))
      A1=-T(1)*VPC*(RDT-VMC/DELX)+2.*GAQK*Q(1)*PKY/FK
      A2=RDT-VMC/DELX-2.*GAQK
      A3=-T(1)*VPC*VMC/DELX
      A4=VMC/DELX
      F4=T(1)*SO(1)*C**2+(A(2)-A(1))/DELX*V(1)**2-GAQK*Q(1)+
     &2.*GAQK*(-Q(1)+Q(1)*PKY*Y(1)/FK)+(Q(1)-T(1)*VPC*Y(1))/DELT
      C=SQRT(G*A(NX)/T(NX))        
      VMC=V(NX)-C
      VPC=V(NX)+C
      FK=CMAN*A(NX)**1.6666667/(FN(NX)*P(NX)**0.6666667)
      GAQK=G*A(NX)*ABS(Q(NX))/FK**2
      PKY=FK/A(NX)*(1.6666667*T(NX)-SMS(NX)*A(NX)/P(NX))
      B1=T(NX)*VMC*VPC/DELX
      B2=-VPC/DELX
      B3=-T(NX)*VMC*(RDT+VPC/DELX)+2.*GAQK*Q(NX)*PKY/FK
      B4=RDT+VPC/DELX-2.*GAQK
      F5=T(NX)*SO(NX)*C**2+(A(NX)-A(NXM))/DELX*V(NX)**2-GAQK*Q(NX)+
     &2.*GAQK*(-Q(NX)+Q(NX)*PKY*Y(NX)/FK)+(Q(NX)-T(NX)*VMC*Y(NX))/DELT
      M=0
60    SUM=0.0
      GO TO (61,62,65,64),IDBC
61    QT=(F5-B1*Y(NXM)-B2*Q(NXM)-B3*Y(NX))/B4
      DIF=QT-Q(NX)
c      Q(NX)=Q(NX)+W*DIF
      Q(NX)=QT+W*DIF
      SUM=SUM+DIF*DIF
      GO TO 66
62    YT=(F5-B1*Y(NXM)-B2*Q(NXM)-B4*Q(NX))/B3
      GO TO 63
64    QT=QGIDI*(B(NX)+FM(NX)*Y(NX))
      YT=(F5-B1*Y(NXM)-B2*Q(NXM))/(B3+QT*B4)
      Q(NX)=QT*YT
63    DIF=YT-Y(NX)
      Y(NX)=YT+W*DIF
      SUM=SUM+DIF*DIF
      GO TO 66
65    CALL STAGE(NX,Y,Q,B3,B4,B1,B2,F5,SUM,JDSD,NDSD,QGID)
66    DO 70 I=NXM,2,-1
      YT=(F1(I)+0.5*Q(I-1)-0.5*Q(I+1))/E1(I)
      DIF=YT-Y(I)
c      Y(I)=Y(I)+W*DIF
      Y(I)=YT+W*DIF
      SUM=SUM+DIF*DIF
      QT=(F2(I)+D1(I)*Y(I-1)+D2(I)*Q(I-1)-D3(I)*Y(I)-D1(I)*Y(I+1)-
     &   D2(I)*Q(I+1))/D4(I)
      DIF=QT-Q(I)
c      Q(I)=Q(I)+W*DIF
      Q(I)=QT+W*DIF
70    SUM=SUM+DIF*DIF
C Newton method to solve Energy & C+ characteristic eqs. simultaneously
      IF(IUBC.EQ.4) THEN
      FF1=A1*Y(1)+A2*Q(1)+A3*Y(2)+A4*Q(2)-F4
      AR=(B(1)+FM(1)*Y(1))*Y(1)
      FF2=QGIUI-Y(1)-(Q(1)/AR)**2/G2
      FAC=((Q(1)/AR)**2/(G*AR)-1.)/A1
      D22=-Q(1)/(G*AR**2)-FAC*A2
      FF2=FF2-FF1*FAC
      DIF=FF2/D22
      Q(1)=Q(1)-DIF
      SUM=SUM+DIF*DIF
      DIF=(FF1-A2*DIF)/A1
      Y(1)=Y(1)-DIF
      SUM=SUM+DIF*DIF
      GO TO 75
      ENDIF
      IF(IUBC.EQ.1) GO TO 72
      IF(IUBC.EQ.3) THEN
      CALL STAGE(1,Y,Q,A1,A2,A3,A4,F4,SUM,JUSD,NUSD,QGIU)
      GO TO 75
      ENDIF
71    YT=(F4-A2*Q(1)-A3*Y(2)-A4*Q(2))/A1
      DIF=YT-Y(1)
      Y(1)=YT+W*DIF
      SUM=SUM+DIF*DIF
      IF(IUBC.EQ.4) THEN
      IF(Y(1).GE.QGIUI) THEN
      Q(1)=0.
      ELSE
      Q(1)=(B(1)+FM(1)*Y(1))*Y(1)*SQRT(G2*(QGIUI-Y(1)))
      ENDIF
      ENDIF
      GO TO 75
72    QT=(F4-A1*Y(1)-A3*Y(2)-A4*Q(2))/A2
      DIF=QT-Q(1)
      Q(1)=QT+W*DIF
      SUM=SUM+DIF*DIF
75    M=M+1
      IF(SUM.GT.ERR.AND.M.LE.MAX) GO TO 60
      DO 78 I=1,NX
      A(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V(I)=Q(I)/A(I)
      P(I)=B(I)+1.5*SMS(I)*Y(I)
      T(I)=B(I)+2.*FM(I)*Y(I)
78    SF(I)=(FN(I)*Q(I)/(CMAN*A(I)))**2*(P(I)/A(I))**1.33333333
      IF(K10.EQ.NTBETW) THEN
      WRITE(IOUT,110) TIME
      WRITE(IOUT,120) (DELX*FLOAT(I-1),Y(I),V(I),SF(I),P(I),Q(I),A(I),
     &T(I),I=1,NX)
      ENDIF
      QGIU1=QGIUI
80    QGID1=QGIDI
      IF(K.GE.NT) STOP
      IF(M.GE.MAX) GO TO 90
      GO TO 10
90    WRITE(*,130) TIME,SUM
130   FORMAT(//' Failed to converge.  Time=',F8.2,'  SUM=',E12.4)
      IF(SUM.LT. .001) GO TO 10
      WRITE(*,*)' Give 0 to continue'
      READ(*,*) III
      IF(III.EQ.0) GO TO 10
      END
      SUBROUTINE STAGE(I,Y,Q,A1,A2,A3,A4,F4,SUM,JJ,M,QGIV)
      REAL QGIV(0:100),Y(41),Q(41)
      IF(I.EQ.1) THEN
      I1=2
      ELSE
      I1=I-1
      ENDIF
10    IF(QGIV(JJ).GT.Y(I) .AND. JJ.GT.1) THEN
      JJ=JJ-2
      GO TO 10
      ENDIF
20    IF(QGIV(JJ+2).LE.Y(I) .AND. JJ.LT.M) THEN
      JJ=JJ+2
      GO TO 20
      ENDIF
      DQ=(QGIV(JJ+3)-QGIV(JJ+1))/(QGIV(JJ+2)-QGIV(JJ))
30    FF1=A1*Y(I)+A2*Q(I)+A3*Y(I1)+A4*Q(I1)-F4
      FF2=QGIV(JJ+1)+DQ*(Y(I)-QGIV(JJ))-Q(I)
      FAC=DQ/A1
      D22=-1.-FAC*A2
      FF2=FF2-FAC*FF1
      DIF=FF2/D22
      Q(I)=Q(I)-DIF
      SUM=SUM+DIF*DIF
      DIF=(FF1-A2*DIF)/A1
      Y(I)=Y(I)-DIF
      SUM=SUM+DIF*DIF
      RETURN
      END