      PARAMETER (EPS=1.E-6)  
      REAL CO(10)
      COMPLEX C(11),ROOTS(10),AD(11),Z1,Z2,Z3 
      EPS1=2.*EPS*EPS 
10    WRITE(6,*)' ND, C0,C1,C2,..CND'
      READ(5,*) ND,(CO(I),I=1,ND+1)
      DO 15 I=1,ND+1
15    C(I)=CMPLX(CO(ND+2-I),0.) 
      DO 20 J=1,ND+1 
20    AD(J)=C(J) 
      DO 30 J=ND,1,-1 
      Z1=CMPLX(0.,0.) 
      CALL LAGU(AD,J,Z1,EPS) 
      IF(ABS(AIMAG(Z1)).LE.EPS1*ABS(REAL(Z1))) Z1=CMPLX(REAL(Z1),0.) 
      ROOTS(J)=Z1 
      Z2=AD(J+1) 
      DO 30 JJ=J,1,-1 
      Z3=AD(JJ) 
      AD(JJ)=Z2 
30    Z2=Z1*Z2+Z3 
      DO 50 J=2,ND 
      Z1=ROOTS(J) 
      DO 40 I=J-1,1,-1 
      IF(REAL(ROOTS(I)).LE.REAL(Z1)) GO TO 50 
40    ROOTS(I+1)=ROOTS(I) 
      I=0 
50    ROOTS(I+1)=Z1 
      DO 60 I=1,ND
      IF(AIMAG(ROOTS(I)).NE. 0.) GO TO 60 
      IF(REAL(ROOTS(I)).LT. 0.) GO TO 60 
      YP=REAL(ROOTS(I)) 
      WRITE(6,65) YP
65    FORMAT(' A positive real root is',F10.3)
60    WRITE(6,70) ROOTS(I) 
70    FORMAT(2F14.8) 
      END 
      SUBROUTINE LAGU(C,ND,Z1,EPS) 
      COMPLEX C(ND+1),Z1,DX,ZO,Z2,Z3,Z4,Z5,DZ,SS,Z6,Z7,Z8,ZERO,XX,FF 
      ZERO=CMPLX(0.,0.) 
      DO 20 ITER=1,50 
      Z2=C(ND+1) 
      Z3=ZERO 
      Z4=ZERO 
      DO 10 J=ND,1,-1 
      Z4=Z1*Z4+Z3 
      Z3=Z1*Z3+Z2 
10    Z2=Z1*Z2+C(J) 
      IF(CABS(Z2).LE.1.E-8) THEN 
      DX=ZERO 
      ELSE IF(CABS(Z3).LE.1.E-8.AND.CABS(Z4).LE.1.E-8) THEN 
      DX=CMPLX(CABS(Z2/C(ND+1))**(1./FLOAT(ND)),0.) 
      ELSE 
      Z5=Z3/Z2 
      Z8=Z5*Z5 
      DZ=Z8-2.*Z4/Z2 
      XX=(ND-1)*(ND*DZ-Z8) 
      YY=ABS(REAL(XX)) 
      ZZ=ABS(AIMAG(XX)) 
      IF(YY.LT.1.E-12 .AND. ZZ .LT.1.E-12) THEN 
      SS=ZERO 
      ELSE IF (YY.GE.ZZ) THEN 
      FF=(1./YY)*XX 
      SS=SQRT(YY)*CSQRT(FF) 
      ELSE 
      FF=(1./ZZ)*XX 
      SS=SQRT(ZZ)*CSQRT(FF) 
      ENDIF 
      Z6=Z5+SS 
      Z7=Z5-SS 
      IF(CABS(Z6).LT.CABS(Z7)) Z6=Z7 
      DX=FLOAT(ND)/Z6 
      ENDIF 
      ZO=Z1-DX 
      IF(Z1.EQ.ZO) RETURN 
      Z1=ZO 
      IF(CABS(DX).LE.EPS*CABS(Z1)) RETURN 
20    CONTINUE 
      WRITE(6,*)' FAILED TO CONVERGE' 
      RETURN 
      END