      PARAMETER (EX=.6666667,EX1=1.6666667)
      CHARACTER*1 VAR(6)/'Q','n','S','y','b','m'/,UNK
      CHARACTER*33 FMT/"(' Solution for ',A1,' = ',F10.3)"/
      REAL X(6),ns,neq,C/1.486/
C  X(1)=Q, X(2)=n, X(3)=S, X(4)=y, X(5)=b, X(6)=m
      LOGICAL R /.FALSE./
      WRITE(*,*)'Give 0 if ES; 1 if SI units'
      READ(*,*) IUNIT
      IF(IUNIT.EQ.1) C=1.
      WRITE(*,*)'Is the section: 1 - trapzoidal, or 2 - circular?'
      READ(*,*) ISECT
      IF(ISECT.EQ.2) THEN
      NVAR=5
      VAR(5)='D'
      ELSE
      NVAR=6
      ENDIF
      WRITE(*,*)'Give value to variables'
      DO 10 I=1,NVAR
      WRITE(*,"(2X,A1,' = '\)") VAR(I)
      IF(I.EQ.2 .AND. ISECT.EQ.1) THEN
      WRITE(*,"(' (1st for sides=) ')")
      READ(*,*) ns
      WRITE(*,"(' (now for bottom=) ')")
      ENDIF
10    READ(*,*) X(I)
15    WRITE(*,*)'Give symbol for unknown'
      READ(*,'(A1)') UNK
      IUNK=1
      DO 20 WHILE (VAR(IUNK).NE.UNK.AND.IUNK.LE.NVAR)
20    IUNK=IUNK+1
      IF(IUNK.GT.NVAR) GO TO 15
      DO 30 I=1,20
25    IF(ISECT.EQ.2) THEN
      COSB=1.-2.*X(4)/X(5)
      B=ACOS(COSB)
      A=.25*X(5)*X(5)*(B-COSB*SIN(B))
      P=B*X(5)
      F=X(2)*X(1)-C*SQRT(X(3))*A*(A/P)**EX
      ELSE
      P=X(5)+2.*X(4)*SQRT(X(6)**2+1.)
      neq=X(5)/P*X(2)+2.*X(4)*SQRT(X(6)**2+1.)/P*ns
      F=neq*X(1)*P**EX-C*SQRT(X(3))*((X(5)+X(6)*X(4))*X(4))**EX1
      ENDIF
      IF(R) GO TO 28
      XX=X(IUNK)
      X(IUNK)=1.005*X(IUNK)
      F1=F
      R=.TRUE.
      GO TO 25
28    DIF=F1*(X(IUNK)-XX)/(F-F1)
      X(IUNK)=XX-DIF
      IF(ABS(DIF).LT. .000001) GO TO 40
30    CONTINUE
40    IF(IUNK.EQ.2)FMT(32:32)='4'
      IF(IUNK.EQ.3)FMT(32:32)='7'
      WRITE(*,FMT) VAR(IUNK),X(IUNK)
      END