#include <stdlib.h>
#include <math.h>
void rkfehlsg(int (*slope)(float x,float *y, float *dxt),int n,float *dxs,float x1,float x2,float error,float *y,float *ytt){
const float F2=.25,F31=.375,F32=.09375,F33=.28125,F41=.92307692,F42=.87938097,F43=-3.27719618,\
  F44=3.3208921,F51=2.0324074,F52=-8.,F53=7.1734893,F54=-.2058967,F61=-.2962963,F63=-1.3816764,\
  F64=.4529727,F65=-.275,Y1=.1185185,Y3=.51898635,Y4=.50613149,Y5=-.18,Y6=.036363636,E3=-.02994152,E4=-.029199894;
int j,irep; float err,error1,dx,x,dy1[4],dy2[4],dy3[4],dy4[4],dy5[4],dy6[4],yt[4];
 error1=1.;x=x1; dx=*dxs;
do{
do{ for(j=0;j<n;j++) ytt[j]=y[j]; irep=0;
L2:slope(x,y,dy1); for(j=0;j<n;j++) yt[j]=y[j]+.25*dx*dy1[j];
  slope(x+F2*dx,yt,dy2); for(j=0;j<n;j++) yt[j]=y[j]+dx*(F32*dy1[j]+F33*dy2[j]);
  slope(x+F31*dx,yt,dy3); for(j=0;j<n;j++) yt[j]=y[j]+dx*(F42*dy1[j]+F43*dy2[j]+F44*dy3[j]);
  slope(x+F41*dx,yt,dy4); for(j=0;j<n;j++) yt[j]=y[j]+dx*(F51*dy1[j]+F52*dy2[j]+F53*dy3[j]+F54*dy4[j]);
  slope(x+dx,y,dy5); for(j=0;j<n;j++) yt[j]=y[j]+dx*(F61*dy1[j]+2.*dy2[j]+F63*dy3[j]+F64*dy4[j]+F65*dy5[j]);
  slope(x+.5*dx,yt,dy6); err=0; for(j=0;j<n;j++){
   y[j]+=dx*(Y1*dy1[j]+Y3*dy3[j]+Y4*dy4[j]+Y5*dy5[j]+Y6*dy6[j]);
   err+=dx*(dy1[j]/360.+E3*dy3[j]+E4*dy4[j]+dy5[j]/50.+Y6*dy6[j]);}
  if(fabs(err) > error) {dx/=2.;irep=1;*dxs=dx; for(j=0;j<n;j++)y[j]=ytt[j];}
}while (irep); if(err+error1 < .001*error){dx*=2.;*dxs=dx;}
 error1=err; x+=dx; if(fabs(x+dx)>fabs(x2)) dx=x2-x;
}while (fabs(x-x2)>1.e-7);  return;
}   /* End of function rkfehlsg */