      SUBROUTINE RKFEHLSG(SLOPE,N,DXS,X1,X2,ERROR,Y,YYT)
      PARAMETER(F2=.25,F31=.375,F32=.09375,F33=.28125,F41=.92307692,F42=
     &.87938097,F43=-3.27719618,F44=3.3208921,F51=2.0324074,F52=-8.,
     &F53=7.1734893,F54=-.2058967,F61=-.2962963,F63=-1.3816764,
     &F64=.4529727,F65=-.275,Y1=.1185185,Y3=.51898635,Y4=.50613149,
     &Y5=-.18,Y6=.036363636,E3=-.02994152,E4=-.029199894,M=4)
      REAL Y(N),YYT(N),DY1(M),DY2(M),DY3(M),DY4(M),DY5(M),DY6(M),YT(M)
      IF(DXS.EQ.0.) STOP ' DXS cannot be 0'
      IF(X2.LT.X1 .AND. DXS.GT.0.) DXS=-DXS
      ERROR1=1.
      DX=DXS
      X=X1
1     DO 2 J=1,N
2     YYT(J)=Y(J)
3     IF(ABS(X+DX).GT.ABS(X2)) DX=X2-X
      CALL SLOPE(X,Y,DY1)
      DO 4 J=1,N
4     YT(J)=Y(J)+.25*DX*DY1(J)
      CALL SLOPE(X+F2*DX,YT,DY2)
      DO 5 J=1,N
5     YT(J)=Y(J)+DX*(F32*DY1(J)+F33*DY2(J))
      CALL SLOPE(X+F31*DX,YT,DY3)
      DO 6 J=1,N
6     YT(J)=Y(J)+DX*(F42*DY1(J)+F43*DY2(J)+F44*DY3(J))
      CALL SLOPE(X+F41*DX,YT,DY4)
      DO 7 J=1,N
7     YT(J)=Y(J)+DX*(F51*DY1(J)+F52*DY2(J)+F53*DY3(J)+F54*DY4(J))
      CALL SLOPE(X+DX,YT,DY5)
      DO 8 J=1,N
8     YT(J)=Y(J)+DX*(F61*DY1(J)+2.*DY2(J)+F63*DY3(J)+F64*DY4(J)+F65*DY5
     &(J))
      CALL SLOPE(X+.5*DX,YT,DY6)
      ERR=0.
      DO 9 J=1,N
      Y(J)=Y(J)+DX*(Y1*DY1(J)+Y3*DY3(J)+Y4*DY4(J)+Y5*DY5(J)+Y6*DY6(J))
9     ERR=ERR+DX*(DY1(J)/360.+E3*DY3(J)+E4*DY4(J)+DY5(J)/50.+Y6*DY6(J))
      IF(ABS(ERR).GT.ERROR) THEN
      DX=DX/2.
      DXS=DX
      DO 10 J=1,N
10    Y(J)=YYT(J)
      GO TO 3
      ENDIF
      X=X+DX
      IF(ABS(X-X2).LT.1.E-7) RETURN
      IF(ABS(ERR+ERROR1).LT. .001*ERROR) THEN
      DX=2.*DX
      DXS=DX
      ENDIF
      ERROR1=ERR
      GO TO 1
      END