C Implements the NEWTON method in solving 3 eqs. 
      REAL X(3),F(3),D(3,7) 
      DATA N,N1/3,4/,DX/.001/,MAX/15/,ERR/.0001/ 
      WRITE(5,*)' GIVE: V1,Y1,Y3,Y2,V2,V' 
      READ(5,*)V1,Y1,Y3,X 
      M=0 
    1 NT=0 
    5 F(1)=X(1)+X(2)**2/64.4-Y3-(X(1)*X(2))**2/(64.4*Y3*Y3) 
      F(2)=(X(3)+V1)*Y1-(X(3)+X(2))*X(1) 
      F(3)=.5*(Y1*Y1-X(1)*X(1))-((V1+X(3))*Y1)**2/32.2*(1./X(1)-1./Y1) 
      IF(NT.NE.0) GO TO 15 
      DO 10 I=1,N 
   10 D(I,N1)=F(I) 
      X(1)=X(1)-DX 
      NT=1 
      GO TO 5 
   15 X(NT)=X(NT)+DX 
      DO 20 I=1,N 
   20 D(I,NT)=(D(I,N1)-F(I))/DX 
      NT=NT+1 
      IF(NT.GT.N) GO TO 30 
      X(NT)=X(NT)-DX 
      GO TO 5 
   30 CALL INVERM(D,N) 
      DIF=0. 
      DO 40 I=1,N 
      DIF=DIF+ABS(D(I,N1)) 
  40  X(I)=X(I)-D(I,N1) 
      M=M+1 
      IF(DIF.GT. ERR .AND. M.LT.MAX) GO TO 1 
      WRITE(5,*)' SOL IS',X 
      END 
      SUBROUTINE INVERM(A,N) 
      REAL A(3,7) 
      N1=N+1 
      N2=N+2 
      M=2*N+1 
      DO 2 I=1,N 
      DO 1 J=N2,M 
  1   A(I,J)=0. 
  2   A(I,I+N1)=1. 
      DO 10 I=1,N-1 
      DIAG=A(I,I) 
      A(I,I)=1. 
      DO 5 J=I+1,M 
    5 A(I,J)=A(I,J)/DIAG 
      DO 7 K=I+1,N 
      FAC=A(K,I) 
      A(K,I)=0. 
      DO 7 J=I+1,M 
 7    A(K,J)=A(K,J)-FAC*A(I,J) 
  10  CONTINUE 
      DIAG=A(N,N) 
      A(N,N)=1. 
      DO 12 J=N1,M 
  12  A(N,J)=A(N,J)/DIAG 
      DO 20 I=N,2,-1 
      DO 17 K=I-1,1,-1 
      FAC=A(K,I) 
      A(K,I)=0. 
      DO 17 J=N1,M 
  17  A(K,J)=A(K,J)-FAC*A(I,J) 
  20  CONTINUE 
      DO 40 I=1,N 
      DO 40 J=1,N 
 40   A(I,J)=A(I,J+N1) 
      RETURN 
      END