      SUBROUTINE ODESOL(YBEG,DYDX,NV,X1,X2,ERR,H1,HMIN,NSTOR,XP,YP,WK1,
     * SLOPE)
      EXTERNAL SLOPE
      LOGICAL NFIRST
      DIMENSION YBEG(NV),DYDX(NV),WK1(NV,13),XZ1(11),FX(7),
     *NSEQ(11),XP(NSTOR),YP(NV,NSTOR),YDUMY(20),DYDUMY(20)
C DIM OF 7 IN FX & 7-13 IN WK1 MUST AGREE WITH NTRIES
      COMMON NGOOD,NBAD,NBETW,IBETW,DXBETW
      DATA NSEQ /2,4,6,8,12,16,24,32,48,64,96/,NFIRST/.TRUE./
      NTRIES=7
      NTRIES1=NTRIES-1
      NBETW1=NBETW-1
      XSIGN=X2-X1
      X=X1
      IF(NFIRST) THEN
      DXSTA=SIGN(H1,XSIGN)
      ELSE
      DXSTA=SIGN(DXDID,XSIGN)
      ENDIF
      NGOOD=0
      NBAD=0
      IBETW=0
      DO 10 I=1,NV
10    WK1(I,1)=YBEG(I)
      XBETW=X-2.*DXBETW
      DO 230 NSTP=1,10000
      CALL SLOPE(X,WK1,DYDX)
      DO 20 I=1,NV
20    WK1(I,2)=ABS(WK1(I,1))+ABS(DXSTA*DYDX(I))+1.E-25
      IF(NBETW.LT.1) GO TO 40
      IF(ABS(X-XBETW).LE.ABS(DXBETW)) GO TO 40
      IF(IBETW.GE.NBETW1) GO TO 40
      IBETW=IBETW+1
      XP(IBETW)=X
      DO 30 I=1,NV
30    YP(I,IBETW)=WK1(I,1)
      XBETW=X
40    IF((X+DXSTA-X2)*(X+DXSTA-X1).GT. 0.) DXSTA=X2-X
      H=DXSTA
      XBETW=X
      DO 50 I=1,NV
      WK1(I,4)=WK1(I,1)
50    WK1(I,5)=DYDX(I)
60    DO 180 I=1,11
      HE=H/FLOAT(NSEQ(I))
      DO 70 JI=1,NV
      WK1(JI,6)=WK1(JI,4)
70    YDUMY(JI)=WK1(JI,4)+HE*WK1(JI,5)
      X1X=XBETW+HE
      CALL SLOPE(X1X,YDUMY,DYDUMY)
      H2=2.*HE
      DO 90 N=2,NSEQ(I)
      DO 80 JI=1,NV
      YSTOR=WK1(JI,6)+H2*DYDUMY(JI)
      WK1(JI,6)=YDUMY(JI)
80    YDUMY(JI)=YSTOR
      X1X=X1X+HE
90    CALL SLOPE(X1X,YDUMY,DYDUMY)
      DO 100 JI=1,NV
100   DYDUMY(JI)=.5*(WK1(JI,6)+YDUMY(JI)+HE*DYDUMY(JI))
      XEST=(H/FLOAT(NSEQ(I)))**2
      XZ1(I)=XEST
      IF(I.NE.1) GO TO 120
      DO 110 J=1,NV
      WK1(J,1)=DYDUMY(J)
      WK1(J,7)=DYDUMY(J)
110   WK1(J,3)=DYDUMY(J)
      GO TO 160
120   MMN=MIN(I,NTRIES)
      DO 130 K=1,MMN-1
130   FX(K+1)=XZ1(I-K)/XEST
      DO 150 J=1,NV
      YENTE=DYDUMY(J)
      DVV=WK1(J,7)
      CC1C=YENTE
      WK1(J,7)=YENTE
      DO 140 K=2,MMN
      KK=K+6
      BINTER=FX(K)*DVV
      BBB=BINTER-CC1C
      IF(BBB.NE.0.) THEN
      BBB=(CC1C-DVV)/BBB
      DUMYX=CC1C*BBB
      CC1C=BINTER*BBB
      ELSE
      DUMYX=DVV
      ENDIF
      DVV=WK1(J,KK)
      WK1(J,KK)=DUMYX
140   YENTE=YENTE+DUMYX
      WK1(J,3)=DUMYX
150   WK1(J,1)=YENTE 
160   ERRORM=0.
      DO 170 J=1,NV
      IF(ABS(WK1(J,3)/WK1(J,2)).GT.ERRORM) ERRORM=ABS(WK1(J,3)/WK1(J,2))
170   CONTINUE
      IF(ERRORM.GE. ERR) GO TO 180
      X=X+H
      HDID=H
      IF(I.EQ.NTRIES) THEN
      DXDID=.95*H
      ELSE IF(I.EQ.NTRIES1) THEN
      DXDID=1.2*H
      ELSE
      DXDID=H*FLOAT(NSEQ(NTRIES1))/FLOAT(NSEQ(I))
      ENDIF
      GO TO 190
180   CONTINUE
      H=.0625*H
      IF(X+H.EQ.X) STOP 'INCR. = 0.'
      GO TO 60
190   IF(HDID.EQ.DXSTA) THEN
      NGOOD=NGOOD+1
      ELSE
      NBAD=NBAD+1
      ENDIF
      IF((X-X2)*XSIGN.LT. 0.) GO TO 220
      DO 200 I=1,NV
200   YBEG(I)=WK1(I,1)
      IF(NBETW.GT.0) GO TO 205
      NFIRST=.FALSE.
      RETURN
205   IBETW=IBETW+1
      XP(IBETW)=X
      DO 210 I=1,NV
210   YP(I,IBETW)=WK1(I,1)
      NFIRST=.FALSE.
      RETURN
220   IF(ABS(DXDID).LT.HMIN) STOP 'INCREMENT < MIN.'
230   DXSTA=DXDID
      STOP 'ALLOWABLE INCREMENTS EXCEEDED'
      END
