C This program solves Example Problem 3 in Appendix as does PRESFOR.FOR but
C it call on the ODE solver RUKU4A that uses the Runge Kutta method.
      EXTERNAL EQUAT
      COMMON /TRAS/ H,YO,YBEF,X1,DX,II
      WRITE(*,*)' Give: X1,X2,H,YO,GAMMA,ERR,MAX,NSTEP'
      READ(*,*) X1,X2,H,YO,GAMMA,ERR,MAX,NSTEP
      AREA=0.
      YBEF=YO
      II=0
      DX=(X2-X1)/FLOAT(NSTEP)
      DO 1 I=1,NSTEP
      XE=X1+DX
      CALL SIMPR(EQUAT,X1,XE,VALUE,ERR,MAX)
      YBEF=YO
      II=1
      DUM=EQUAT(XE)
      II=0
      AREA=AREA+VALUE
1     X1=XE
      WRITE(*,"(' Area=',F10.3,/,' Force =',F10.3)") AREA,AREA*GAMMA 
      END
      FUNCTION EQUAT(X)
      COMMON /TRAS/ H,YO,YBEF,X1,DX,II
      Y=YBEF
      CALL RUKU4A(X,X-X1,Y)
      EQUAT=H+0.7071068*X-Y ! for 1st moments of area this statement is
      IF(II.EQ.1) YO=Y
      RETURN              ! EQUAT=X*(H+0.7071068*X-Y)
      END
      FUNCTION SLOPE(X,Y)
      SLOPE=X+.5*Y
      RETURN
      END
