#include <stdlib.h>
#include <math.h>
float dyx(float x,float y){return x+y;}
void rkfehl(float (*dyx)(float x,float y),float *dx,float error, float x,float *y){
const float F2=.25,F31=.375,F32=.09375,F33=.28125,F41=.92307692,F42=.87938097,F43=-3.27719618,\
 F44=3.3208921,F51=2.0324074,F52=-8.,F53=7.1734893,F54=-.2058967,F61=-.2962963,F63=-1.3816764,\
 F64=.4529727,F65=-.275,Y1=.1185185,Y3=.51898635,Y4=.50613149,Y5=-.18,Y6=.036363636,E3=-.02994152,E4=.029199894;
float yy,dy1,dy2,dy3,dy4,dy5,dy6,dx1,yy1,err; int i,n;
 dx1=*dx;yy1=*y; n=1;
L1:for(i=0;i<n;i++){
yy=*y;dy1=dx1*dyx(x,yy); yy=*y+.25*dy1; dy2=dx1*dyx(x+F2*dx1,yy);
yy=*y+F32*dy1+F33*dy2; dy3=dx1*dyx(x+F31*dx1,yy);
yy=*y+F42*dy1+F43*dy2+F44*dy3; dy4=dx1*dyx(x+F41*dx1,yy);
yy=*y+F51*dy1+F52*dy2+F53*dy3+F54*dy4; dy5=dx1*dyx(x+dx1,yy);
yy=*y+F61*dy1+2.*dy2+F63*dy3+F64*dy4+F65*dy5; dy6=dx1*dyx(x+.5*dx1,yy);
*y+=Y1*dy1+Y3*dy3+Y4*dy4+Y5*dy5+Y6*dy6;
err=dy1/360.+E3*dy3+E4*dy4+dy5/50.+Y6*dy6;if(fabs(err)>error){*dx/=2.;*y=yy1;n=dx1/(*dx);goto L1;}}
}   /* End of function rkfehl */
void main(void){  int i,j,n,m;  float x,*y,yo,*dx,error,dxs,x1;
 printf("Give: Xo,Yo,DX,ERROR,N\n"); scanf("%f %f %f %f %d",&x,&yo,&dxs,&error,&n);
 *dx=dxs; *y=yo; printf("%8.2f %9.5f\n",x,yo);
 for(i=0;i<n;i++) {
  rkfehl(dyx,dx,error,x,y);
  if((*dx) < dxs) { m=dxs/(*dx)+.5; for(j=1;j<(m-1);j++){x1=x+(*dx)*(j-1);rkfehl(dyx,dx,error,x1,y);}}
 x+=dxs; printf("%8.2f %9.5f\n",x,*y);}
}