#include <math.h>
#include <stdlib.h>
extern void slope(float x,float *y,float *dy);
float yt[1],dy1[1],dyt[1],dym[1];
void ruku4sf(float x,float dx, float *y){
/*  x=indep. var., dx=inc. ind. var;
    y=dep. var. (i.e. pointer)
    yt,dy1,dyt & dym must be global pointers */
 float dx5,xh;  int i;
 dx5=.5*dx; xh=x+dx5;
 slope(x,y,dy1);    /*  1st sub-step */
 yt[0]=y[0]+dx5*dy1[0];
 slope(xh,yt,dyt);   /* 2nd sub-step */
 yt[0]=y[0]+dx5*dyt[0];
 slope (xh,yt,dym);   /* 3rd sub-step  */
 yt[0]=y[0]+dx*dym[0];dym[0]+=dyt[0];
 slope (x+dx,yt,dyt);    /* 4th sub-step   */
 y[0]+=dx*((dy1[0]+dyt[0])/6.+dym[0]/3.);
}   /*  End of function ruku4sf  */
void rukustf(float *dxs,float xbeg,float xend,float error,float *y,float *ytt){
float errm,dx,x,dx5,x1,yori[1];
 x1=xbeg; dx=*dxs;
L1:ytt[0]=y[0]; yori[0]=y[0]; x=x1; if(fabs(x+dx)>fabs(xend)) dx=xend-x;
L2: dx5=.5*dx;
 ruku4sf(x,dx5,y); /* Solve with 1/2 inc. */
 ruku4sf(x+dx5,dx5,y);
 x1=x+dx; if(fabs(x1)>fabs(xend)-1.e-8) return;
 ruku4sf(x,dx,ytt); /* Solve with full inc. */
 errm=0.; x1=x+dx; ytt[0]=y[0]-ytt[0]; errm=max(errm,fabs(ytt[0]/y[0]));
 if(errm==0.){dx*=5.;*dxs=dx;goto L1;} else {errm/=error; dx/=pow(errm,.2);*dxs=dx;
  if(errm > 1.){ytt[0]=yori[0];y[0]=yori[0];  goto L2;} }
 y[0]+=ytt[0]/15.; goto L1;
}  /* End of function rukust */