#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define TINY 1.0e-20;
void dcompos(float **a,int n,int *indx,float *d) {
int i,imax,j,k;
float aamax,dum,sum,temp;
float *vv;
vv=(float*)calloc(n,sizeof(float)); *d=1.0;
 for(i=0;i<n;i++) {aamax=0.0;
  for(j=0;j<n;j++) if ((temp=fabs(a[i][j])) > aamax) aamax=temp;
  if (aamax == 0.0) printf("Singular matrix in routine DCOMPOS\n");vv[i]=1.0/aamax;}
 for(j=0;j<n;j++) {for(i=0;i<j;i++) {sum=a[i][j];
  for(k=0;k<i;k++) sum -= a[i][k]*a[k][j];a[i][j]=sum;}
 aamax=0.0;
 for(i=j;i<n;i++) {sum=a[i][j];for(k=0;k<j;k++)sum -= a[i][k]*a[k][j];
  a[i][j]=sum;if ( (dum=vv[i]*fabs(sum)) >= aamax) {aamax=dum;imax=i;}}
  if (j != imax) {for(k=0;k<n;k++) {dum=a[imax][k];a[imax][k]=a[j][k];
    a[j][k]=dum;}
  *d = -(*d);vv[imax]=vv[j];}
  indx[j]=imax;
    if (a[j][j] == 0.0) a[j][j]=TINY;
  if (j != n) {dum=1.0/(a[j][j]);for(i=j+1;i<n;i++) a[i][j] *= dum;}} free(vv);
}
#undef TINY
void finsol(float **a,int n,int *indx,float *b)
 {int i,ii,ip,j;  float sum;  ii=-1;
for(i=0;i<n;i++) {ip=indx[i];sum=b[ip];b[ip]=b[i];
if (ii != -1){for(j=ii;j<i;j++) sum -= a[i][j]*b[j];} else if (sum!=0.) ii=i;
 b[i]=sum;}
for(i=n-1;i>=0;i--) {sum=b[i];if(i<(n-1)){for(j=i+1;j<n;j++) sum -= a[i][j]*b[j];}
  b[i]=sum/a[i][i];}
}
void solveq(int n,float **a,float *b,int itype,float *dd,int *indx)
{int detrm=0,eqsol=0,invsol=0,i,j; FILE *fil;
if((itype==3)||(itype>4)) detrm=1;
if((itype==1)||(itype==4)||(itype==6)) eqsol=1;
if((itype==2)||(itype>3)) invsol=1;
dcompos(a,n,indx,dd);
if(detrm) for(i=0;i<n;i++) (*dd)*=a[i][i];
if(eqsol) finsol(a,n,indx,b);
if(invsol){ if(eqsol){printf("\nSolution Vector\n");
 for(i=0;i<n;i++){printf("%10.3f",b[i]);if (!(i%8)) printf("\n");}}
if((fil=fopen("TEMP.DAT","wt"))==NULL)
   printf("Data file TEMP.DAT cannot be opened\n");
for(j=0;j<n;j++){ for(i=0;i<n;i++) b[i]=0; b[j]=1; finsol(a,n,indx,b);
 for(i=0;i<n;i++) fprintf(fil,"%15.7f",b[i]); }  rewind(fil);
for(j=0;j<n;j++) for(i=0;i<n;i++) fscanf(fil,"%15.7f",&a[i][j]);
fclose(fil); remove("TEMP.DAT"); }   return; }