C Solves UCW with upstream gate instantly raised with uniform flow downstream
C  Uses the implicit method
      INTEGER*2 INDX(4)
      REAL F(4),F1(4),D(4,4)
      COMMON B,FM,FM2,FMS,FM3,BH,Yb,Vo,Ao,HCA1,G,G2,Qb,DXS,XPOS,X(4),CUN
     &,SO,DT5,WV1
      WRITE(*,*)' Give: g,b,m,n,So,Qo & Guess for Yo'
      READ(*,*) G,B,FM,FN,SO,Qo,Yo
      BH=.5*B
      FM3=FM/3.
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      G2=2.*G
      CU=1.486
      IF(G.LT.20.) CU=1.
      CUN=FN/CU
      QN=FN*Qo
      CUS=CU*SQRT(So)
      NCT=0
10    FF=QN*(B+FMS*Yo)**.6666667-CUS*((B+FM*Yo)*Yo)**1.6666667
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 15
      FF1=FF
      YY=Yo
      Yo=1.005*Yo
      GO TO 10
15    DIF=(Yo-YY)*FF1/(FF-FF1)
      Yo=YY-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.20) GO TO 10
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      HCA1=(BH+FM3*Yo)*Yo*Yo
      WRITE(3,100) Qo,Yo,Vo
      WRITE(6,100) Qo,Yo,Vo
100   FORMAT(' Qo =',F8.1,',  Normal Depth Yo =',F8.3,', Vo =',F8.3)
      WRITE(*,*)' Give: New Q2, Dt, NT & Guess for Yb'
      READ(*,*) Qb,DT,NT,Yb
      DT5=.5*DT
      HC1=HCA1/Ao
      NCT=0
17    A=(B+FM*Yb)*Yb
      HCA2=(BH+FM3*Yb)*Yb*Yb
      FF=G*(HCA2/Ao-HC1)/(1.-Ao/A)-((Qb-Qo)/(A-Ao)-Vo)**2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 18
      FF1=FF
      Yb2=Yb
      Yb=1.005*Yb
      GO TO 17
18    DIF=(Yb-Yb2)*FF1/(FF-FF1)
      Yb=Yb2-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.30) GO TO 17
C  v=X(1); Y2=X(2); Q2=X(3); Position of wave x=X(4)
      A=(B+FM*Yb)*Yb
      X(1)=(Qb-Qo)/(A-Ao)
      WRITE(6,105) Qb,Yb,A,SQRT(ABS(G*A/(B+FM2*Yb))),X(1)
      WRITE(3,105) Qb,Yb,A,SQRT(G*A/(B+FM2*Yb)),X(1)
105   FORMAT(' For New Q=',F8.2,/' Starting Depth Yb=',F8.3,' A=',F8.2,
     &' Celerity=',F8.3,' Wave Velocity=',F8.3)
      X(2)=Yb
      X(3)=.5*(Qo+Qb)
      X(4)=DT*X(1)
      WRITE(3,108)
108   FORMAT(/' Time Wave V.    Y2     Q2       x      Fr1     Fr2'/,1X,
     &53('-'))
      WRITE(3,110) 0,X(1),Yb,Qb,0.0,(X(1)-Vo)/SQRT(G*Ao/(B+FM2*Yo)),
     &(X(1)-Qb/A)/SQRT(G*A/(B+FM2*Yb))
      DXS=.5
      XPOS=0.
      WV1=X(1)
      DO 50 K=1,NT
      NCT=0
20    SUM=0.
      CALL FUN(F)
      DO 22 I=1,4
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN(F1)
      DO 21 J=1,4
21    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
22    X(I)=XX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      DO 24 I=1,4
      X(I)=X(I)-F(I)
24    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM,X
      IF(SUM.GT. 5.E-4 .AND. NCT.LT.20) GO TO 20
      A=(B+FM*X(2))*X(2)
      FR1=(X(1)-Vo)/SQRT(G*Ao/(B+FM2*Yo))
      FR2=(X(1)-X(3)/A)/SQRT(G*A/(B+FM2*X(2)))
      WRITE(3,110) IFIX(DT*FLOAT(K)),X,FR1,FR2
      WV1=X(1)
      XPOS=X(4)
      X(4)=X(4)+DT*WV1
110   FORMAT(I5,2F8.3,F8.2,F8.1,2F8.3)
      IF(FR1.LT.1.07 .AND. K.LT.NT) THEN
      WRITE(*,*)' Froude No. close to 1.  Give 1 to try another step, 0=
     &STOP'
      READ(*,*) NCT
      IF(NCT.NE.1) STOP
      ENDIF
50    CONTINUE
      END
      SUBROUTINE FUN(F)
      REAL F(4),Y(1),YTT(1)
      COMMON B,FM,FM2,FMS,FM3,BH,Yb,Vo,Ao,HCA1,G,G2,Qb,DXS,XPOS,X(4),CUN
     &,SO,DT5,WV1
      A2=(B+FM*X(2))*X(2)
      F(1)=(X(1)-Vo)*Ao-X(1)*A2+X(3)
      F(2)=HCA1+(X(1)-Vo)**2*Ao/G-(BH+FM3*X(2))*X(2)**2-(X(1)-X(3)/A2)**
     &2*A2/G
      Y(1)=Yb
      CALL RUKUST(1,DXS,0.,X(4),1.E-4,Y,YTT)
      F(3)=X(2)-Y(1)
      F(4)=XPOS+DT5*(WV1+X(1))-X(4)
      RETURN
      END
      SUBROUTINE SLOPE(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON B,FM,FM2,FMS,FM3,BH,Yb,Vo,Ao,HCA1,G,G2,Qb,DXS,XPOS,X(4),CUN
     &,SO,DT5,WV1
      qs=(Qb-X(3))/X(4)
      Q=Qb+XX/X(4)*(X(3)-Qb)
      A=(B+FM*Y(1))*Y(1)
      SF=(Q*CUN*((B+FMS*Y(1))/A)**.6666667/A)**2
      DY(1)=(SO-SF+Q*qs/(G*A**2))/(1.-Q**2*(B+FM2*Y(1))/(G*A**3))
      RETURN
      END