      PARAMETER (N=200) 
      REAL W(N+100)
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y))
      WRITE(*,*)' Give: Trap. =0, Circular=1 and output unit no.'
      READ(*,*) ICIR,IUNIT
50    IF(ICIR.GT.0) THEN
      WRITE(*,*)' Give: Yo,Qo,D,Yb,Ye,No,g'
      READ(*,*) Yo,Qo,D,Yb,Ye,No,G
      SGD=SQRT(G*D)
      ELSE
      WRITE(*,*)' Give: Yo,Qo,b,m,Yb,Ye,No,g'
      READ(*,*) Yo,Qo,B,FM,Yb,Ye,No,G
      ENDIF
      IF(Yo.LT.0.) STOP
      IF(ICIR.GT.0) THEN
      RAD=.5*D
      SRAD=RAD*RAD
      BETA=ACOS(1.-Yo/RAD)
      Ao=SRAD*(BETA-SIN(BETA)*COS(BETA))
      co=SQRT(G*Ao/(D*SIN(BETA)))
      ELSE
      FM2=2.*FM
      Ao=(B+FM*Yo)*Yo
      co=SQRT(G*Ao/(B+FM2*Yo))
      ENDIF
      Vo=Qo/Ao
1     DY=(Yo-.01)/FLOAT(N-1) 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01
      IF(ICIR.GT.0) THEN
      B1=ACOS(1.-Y/RAD)
      WF1=SGD*FWC(B1)
      ELSE
      WF1=FW(Y) 
      ENDIF
      W(1)=0. 
      DO 6 I=2,N+100
      SUM=0. 
      IF(ICIR.GT.0) THEN
      B2=ACOS(1.-(Y+DY)/RAD)
      DB=(B2-B1)/10.
      DYH=.5*DB
      ENDIF
      DO 5 J=1,10 
      IF(ICIR.GT.0) THEN
      WF=SGD*FWC(B1+DB*FLOAT(J))
      ELSE
      WF=FW(Y+DY2*FLOAT(J))
      ENDIF
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM
      Y=Y+DY
6     B1=B2
      VOW=Vo-W(N)
      IF(IUNIT.NE.0 .AND. IUNIT.NE.6) THEN
      IF(ICIR.GT.0) THEN
      WRITE(IUNIT,101) Yo,Qo,D,G,Ao,Vo,co
      ELSE
      WRITE(IUNIT,100) Yo,Qo,B,FM,G,Ao,Vo,co
      ENDIF
      ENDIF
100   FORMAT(' Yo=',F8.2,' Qo=',F8.1,' b=',F7.1,' m=',F7.1,
     &' g=',F7.2,/,' Ao=',F9.2,' Vo=',F8.3,' co=',F8.3)
101   FORMAT(' Yo=',F8.2,' Qo=',F8.1,' D=',F7.1,
     &' g=',F7.2,/,' Ao=',F9.2,' Vo=',F8.3,' co=',F8.3)
C  Determine Critical Conditions
      IF(Qo.LT.0.) THEN
      VWA=ABS(VOW)
      I=N
      c=10.
4     I=I-1
      C1=c
      Y=.01+DY*FLOAT(I-1)
      IF(ICIR.GT.0) THEN
      BETA=ACOS(1.-Y/RAD)
      c=SQRT(G*SRAD*(BETA-COS(BETA)*SIN(BETA))/(D*SIN(BETA)))
      ELSE
      c=SQRT(G*(B+FM*Y)*Y/(B+FM2*Y))
      ENDIF
      IF(W(I)+c .GT. VWA) GO TO 4
      FAC=(VWA-W(I)-c)/(W(I+1)+C1-W(I)-c)
      Y=Y+FAC*DY
      WW=W(I)+FAC*(W(I+1)-W(I))
      V=WW+VOW
      WRITE(*,*) I,Y,FAC,VWA,W(I),W(I+1),c,C1,V
      IF(ICIR.GT.0) THEN
      BETA=ACOS(1.-Y/RAD)
      A=SRAD*(BETA-COS(BETA)*SIN(BETA))
      TOP=D*SIN(BETA)
      ELSE
      A=(B+FM*Y)*Y
      TOP=B+FM2*Y
      ENDIF
      c=SQRT(G*A/TOP)
      QMAX=V*A
      WRITE(*,112) QMAX,Y,V,c,A,TOP
112   FORMAT(' Critical conditions:',/,' Q=',F9.2,' Y=',F8.4,' V=',F8.4,
     &' c=',F8.4,' A=',F9.2,' Top=',F8.2)
      IF(IUNIT.NE.0 .AND. IUNIT.NE.6) WRITE(IUNIT,112) QMAX,Y,V,c,A,TOP
      YC=Y
      ENDIF
      DELYN=(Ye-Yb)/FLOAT(No-1)
      DO 9 I=1,No
      YN=Yb+FLOAT(I-1)*DELYN
      IM=IFIX((YN-.01)/DY)+1
      IF(IM.LT.1) IM=1
      IF(IM.GT.299) THEN
      WRITE(*,*)' Table not large enough IM=',IM
      STOP
      ENDIF
      FAC=(YN-(.01+DY*FLOAT(IM-1)))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      V=WW+VOW
      IF(ICIR.GT.0) THEN
      BETA=ACOS(1.-YN/RAD)
      TOP=D*SIN(BETA)
      A=SRAD*(BETA-COS(BETA)*SIN(BETA))
      ELSE
      A=(B+FM*YN)*YN
      TOP=B+FM2*YN
      ENDIF
      c=SQRT(G*A/TOP)
      Q=A*V
      DQY=SQRT(G*TOP*A)+V*TOP
      Fr=SQRT(Q**2*TOP/(G*A**3))
      WRITE(*,103) YN,Q,V,c,WW,A,TOP,DQY,Fr
      IF(IUNIT.NE.0.AND.IUNIT.NE.6) WRITE(IUNIT,103) YN,Q,V,c,WW,A,TOP,
     &DQY,Fr
103   FORMAT(F8.2,F9.2,5F8.3,F8.1,F7.3,F8.1)
9     CONTINUE
      END
      FUNCTION FWC(BETA)
      SINB=SIN(BETA)
      FWC=SINB/SQRT(BETA/SINB-COS(BETA))
      RETURN
      END