      PARAMETER (N=26,NN=15)
      EXTERNAL EQUAT, EQUAT1
      REAL X(20),Z(20),Y(N),AR(N),P(N),T(N)
      COMMON D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),DD(NN),NR,NL,
     &IR,IR1,IL,IL1
      READ(3,*) NVALUE,IOUT
      IF(NVALUE.GT.20) THEN
      WRITE(*,100)
100   FORMAT(' Program dimension to allow only 20 coordinate pairs')
      STOP
      ENDIF
      READ(3,*)(X(I),Z(I),I=1,NVALUE)
      ZSTA=Z(1)
      IMIN=1
      YMAX=ZSTA
      DO 10 I=2,NVALUE
      IF(Z(I).GE.ZSTA) GO TO 5
      ZSTA=Z(I)
      IMIN=I
5     IF(Z(I).GT.YMAX) YMAX=Z(I)
10    CONTINUE
      IF(Z(IMIN+1).LT.ZSTA+1.E-5) THEN
      T(1)=X(IMIN+1)-X(IMIN)
      P(1)=T(1)
      IR1=IMIN+1
      ELSE
      T(1)=0.
      P(1)=0.
      IR1=IMIN
      ENDIF
      AA=0.
      PP=P(1)
      AR(1)=0.
      Y(1)=0.
      NR=0
      DO 12 I=IR1,NVALUE
      NR=NR+1
      XR(NR)=X(I)
12    YR(NR)=Z(I)
      CALL SPLINESU(NR,YR,XR,D2XR,DD,0)
      NL=0
      DO 14 I=IMIN,1,-1
      NL=NL+1
      XL(NL)=X(I)
14    YL(NL)=Z(I)
      CALL SPLINESU(NL,YL,XL,D2XL,DD,0)
      IR=1
      IR1=2
      IL=1
      IL1=2
      DYY=(YMAX-ZSTA)/FLOAT(N-1)
      Y1=ZSTA
      DO 40 I=2,N
      YY=DYY*FLOAT(I-1)+ZSTA
      Y(I)=YY-ZSTA
41    IF(YY.LE.YR(IR) .OR. IR1.EQ.NR) GO TO 42
      IR=IR1
      IR1=IR1+1
      GO TO 41
42    IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 43
      IR1=IR
      IR=IR-1
      GO TO 42
43    DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
44    IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 45
      IL=IL1
      IL1=IL1+1
      GO TO 44
45    IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 46
      IL1=IL
      IL=IL-1
      GO TO 45
46    DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      T(I)=XXR-XXL
      CALL SIMPR(EQUAT,Y1,YY,AA,1.E-4,11)
      AR(I)=AR(I-1)+AA
      CALL SIMPR(EQUAT1,Y1,YY,PP,1.E-4,11)
      P(I)=P(I-1)+PP
40    Y1=YY
      WRITE(IOUT,300)
300   FORMAT(' No.    Depth      Area Perimeter   Top Width')
      DO 50 I=1,N
50    WRITE(IOUT,311) I,Y(I),AR(I),P(I),T(I)
311   FORMAT(I4,5F10.3)
      RETURN
      END
      FUNCTION EQUAT(YY)
      PARAMETER (NN=15)
      COMMON D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),DD(NN),NR,NL,
     &IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      EQUAT=XXR-XXL
      RETURN
      END
      FUNCTION EQUAT1(YY)
      PARAMETER (NN=15)
      COMMON D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),DD(NN),NR,NL,
     &IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      DX=XR(IR1)-XR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XR(IR)-(3.*B*B-1.)*D2XR(IR1))*DY/6.
      EQUAT1=SQRT(Z**2+1.)
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      DX=XL(IL1)-XL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XL(IL)-(3.*B*B-1.)*D2XL(IL1))*DY/6.
      EQUAT1=EQUAT1+SQRT(Z**2+1.)
      RETURN
      END