      EXTERNAL EQUAT
      COMMON D2L(21),D2R(21),XL(21),XR(21),ZL(21),ZR(21),DZL,DZR,IL,IL1,
     &IR,IR1,MI,MIR
      REAL D(21),A(31),P(31),T(31),X(41),Z(41)
      WRITE(*,*)' Give: INPUT,IOUT,N(No. pts),NY(No. dely),ERR'
      READ(*,*) INPUT,IOUT,N,NY,ERR
      IF(INPUT.EQ.0 .OR. INPUT.EQ.5) WRITE(*,*)' Give',N,' pairs of x z'
      READ(INPUT,*) (X(I),Z(I),I=1,N)
      MI=1
      ZMIN=Z(1)
      DO 2 I=2,N
      IF(Z(I).GE.ZMIN) GO TO 4
      MI=I
2     ZMIN=Z(I)
4     ZMAX=Z(1)
      IF(Z(N).GT.ZMAX) ZMAX=Z(N)
      YMAX=ZMAX-ZMIN
      DO 5 I=1,MI
      ZL(I)=Z(MI+1-I)
5     XL(I)=X(MI+1-I)
      MIR=0
      DO 6 I=MI,N
      MIR=MIR+1
      ZR(MIR)=Z(I)
6     XR(MIR)=X(I)
      IF(Z(N).GT.ZMAX) ZMAX=Z(N)
      D2L(1)=0.
      D(1)=0.
      DO 10 J=2,MI-1
      JM=J-1
      JP=J+1
      FAC=(ZL(J)-ZL(JM))/(ZL(JP)-ZL(JM))
      FA1=FAC*D2L(JM)+2.
      D2L(J)=(FAC-1.)/FA1
10    D(J)=(6.*((XL(JP)-XL(J))/(ZL(JP)-ZL(J))-(XL(J)-XL(JM))/(ZL(J)-ZL(
     &JM)))/(ZL(JP)-ZL(JM))-FAC*D(JM))/FA1
      D2YN=0.
      DN=0.
      D2L(N)=(DN-D2YN*D(MI-1))/(D2YN*D2L(MI-1)+1.)
      DO 20 J=MI,1,-1
20    D2L(J)=D2L(J)*D2L(J+1)+D(J)
      D2R(1)=0.
      D(1)=0.
      DO 12 J=2,MIR-1
      JM=J-1
      JP=J+1
      FAC=(ZR(J)-ZR(JM))/(ZR(JP)-ZR(JM))
      FA1=FAC*D2R(JM)+2.
      D2R(J)=(FAC-1.)/FA1
12    D(J)=(6.*((XR(JP)-XR(J))/(ZR(JP)-ZR(J))-(XR(J)-XR(JM))/(ZR(J)-ZR(
     &JM)))/(ZR(JP)-ZR(JM))-FAC*D(JM))/FA1
      D2YN=0.
      DN=0.
      D2R(N)=(DN-D2YN*D(MIR-1))/(D2YN*D2R(MIR-1)+1.)
      DO 22 J=MIR,1,-1
22    D2R(J)=D2R(J)*D2R(J+1)+D(J)
      IL1=1
      IF(ZR(2).EQ.ZR(1)) THEN
      IR1=2
      T(1)=XR(2)-XR(1)
      ELSE
      IR1=1
      T(1)=0.
      ENDIF
      IL=IL1+1
      DELY=YMAX/FLOAT(NY-1)
      IR=IR1+1
      DZL=XL(IL)-ZL(IL1)
      DZR=XR(IR)-XR(IR1)
      XL1=XL(IL1)
      XR1=XR(IR1)
      PP=T(1)
      AA=0.
      ZZ1=ZMIN
      DELY2=DELY*DELY
      WRITE(IOUT,300)
300   FORMAT(' No.    Depth      Area Perimeter   Top Width')
      WRITE(IOUT,311) 0,0.,AA,PP,T(1)
      DO 50 I=2,NY
      YY=DELY*FLOAT(I-1)
      ZZ=YY+ZMIN
      CALL SIMPR(EQUAT,ZZ1,ZZ,DAA,ERR,20)
      AA=AA+DAA  
      AL=(ZL(IL)-ZZ)/DZL
      BL=1.-AL
      AR=(ZR(IR)-ZZ)/DZR
      BR=1.-AR
      DL6=DZL*DZL/6.
      DR6=DZR*DZR/6.
      XLL=AL*XL(IL1)+BL*XL(IL)+DL6*((AL*AL-1.)*AL*D2L(IL1)+(BL*BL-1.)*BL
     &*D2L(IL))
      XRR=AR*XR(IR1)+BR*XR(IR)+DR6*((AR*AR-1.)*AR*D2R(IR1)+(BR*BR-1.)*BR
     &*D2R(IR))
      T(I)=XRR-XLL
      PP=PP+SQRT(DELY2+(XL1-XLL)**2)+SQRT(DELY2+(XRR-XR1)**2)
      P(I)=PP
      A(I)=AA
      XL1=XLL
      XR1=XRR
      ZZ1=ZZ
50    WRITE(IOUT,311) I,YY,A(I),P(I),T(I)
311   FORMAT(I4,5F10.3)
      END
      FUNCTION EQUAT(ZZ)
      COMMON D2L(21),D2R(21),XL(21),XR(21),ZL(21),ZR(21),DZL,DZR,IL,IL1,
     &IR,IR1,MI,MIR
10    IF(ZZ.LT.ZL(IL) .OR. IL.EQ.MI) GO TO 15
      IL1=IL
      IL=IL+1
      DZL=ZL(IL)-ZL(IL1)
      GO TO 10
15    IF(ZZ.GT.ZL(IL1) .OR. IL1.EQ.1) GO TO 20
      IL=IL1
      IL1=IL1-1
      DZL=ZL(IL)-ZL(IL1)
      GO TO 15
20    IF(ZZ.LT.ZR(IR) .OR. IR.EQ.MIR) GO TO 25
      IR1=IR
      IR=IR+1
      DZR=ZR(IR)-ZR(IR1)
      GO TO 20
25    IF(ZZ.GT.ZR(IR1) .OR. IR1.EQ.1) GO TO 30
      IR=IR1
      IR1=IR1-1
      DZR=ZR(IR)-ZR(IR1)
      GO TO 25
30    AL=(ZL(IL)-ZZ)/DZL
      BL=1.-AL
      AR=(ZR(IR)-ZZ)/DZR
      BR=1.-AR
      DL6=DZL*DZL/6.
      DR6=DZR*DZR/6.
      XLL=AL*XL(IL1)+BL*XL(IL)+DL6*((AL*AL-1.)*AL*D2L(IL1)+(BL*BL-1.)*BL
     &*D2L(IL))
      XRR=AR*XR(IR1)+BR*XR(IR)+DR6*((AR*AR-1.)*AR*D2R(IR1)+(BR*BR-1.)*BR
     &*D2R(IR))
      EQUAT=XRR-XLL
      RETURN
      END