C This program determines the maximum point outflow at an intermediate position
C  in a trapezoidal channel
      PARAMETER(N=200)
      REAL W(N+10)
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y)) 
      WRITE(*,*)' Give: Yo,Qo,g,b,m'
      READ(*,*) Yo,Qo,G,B,FM
      Ao=(B+FM*Yo)*Yo
      FM2=2.*FM
      Co=SQRT(G*Ao/(B+FM2*Yo))
      Vo=Qo/Ao
1     DY=(Yo-.01)/FLOAT(N-1) 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01 
      WF1=FW(Y) 
      W(1)=0. 
      DO 6 I=2,N+10
      SUM=0. 
      DO 5 J=1,10 
      WF=FW(Y+DY2*FLOAT(J)) 
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM 
6     Y=Y+DY 
      Wo=W(N)
      VOC=Vo-Wo
      VOCU=Vo+Wo
      WRITE(2,200) Yo,Qo,Vo,Ao,Co,Wo
200   FORMAT(' Yo=',F6.3,', Qo=',F6.1,', Vo=',F6.3,', Ao=',F7.3,
     &', co=',F7.3,', wo=',F7.3)
      VOW=Vo-Wo 
      VOWU=Vo+Wo
      Y=.7*Yo
      M=0
10    A=(B+FM*Y)*Y
      C=SQRT(G*A/(B+FM2*Y))
      IM=IFIX((Y-.01)/DY)+1
      FAC=(Y-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      F=(VOWU-WW)**2-C**2
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 12
      FF=F
      YY=Y
      Y=1.005*Y
      GO TO 10
12    DIF=(Y-YY)*FF/(F-FF)
      Y=YY-DIF
      IF(ABS(DIF).GT. 2.E-6 .AND. M.LT.30) GO TO 10
      A=(B+FM*Y)*Y
      C=SQRT(G*A/(B+FM2*Y))
      IM=IFIX((Y-.01)/DY)+1
      FAC=(Y-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      DQ=2.*A*(Wo-WW)
      Vd=WW+VOC
      Qd=A*Vd
      Vu=VOCU-WW
      Qu=A*Vu
      WRITE(2,100) Y,C,A,DQ,Vu,Qu,Vd,Qd,WW
100   FORMAT(' Y=',F7.3,' c=',F7.3,' A=',F7.2,' DQ=',F7.3,' Vu=',F7.3,
     &/,' Qu=',F7.2,' Vd=',F7.3,' Qd=',F7.2,' w=',F7.3)
      END