C This program determines the maximum point outflow at an intermediate position
C  in a circular channel
      PARAMETER(N=200)
      REAL W(N+10)
      WRITE(*,*)' Give: Yo,Qo,g,D'
      READ(*,*) Yo,Qo,G,D
      RAD=.5*D
      RAD2=RAD*RAD
      SGD=SQRT(G*D)
      BETA=ACOS(1.-Yo/RAD)
      Ao=RAD2*(BETA-COS(BETA)*SIN(BETA))
      Vo=Qo/Ao
      Co=SQRT(G*Ao/(D*SIN(BETA)))
1     DY=(YO-.01)/FLOAT(N-1) 
      Y=.01
      B1=ACOS(1.-Y/RAD)
      WF1=SGD*FW(B1) 
      W(1)=0. 
      DO 6 I=2,N+10
      SUM=0.
      Y=Y+DY
      B2=ACOS(1.-Y/RAD)
      DB=(B2-B1)/10.
      DB2=.5*DB
      DO 5 J=1,10
      WF=SGD*FW(B1+DB*FLOAT(J))
      SUM=SUM+DB2*(WF1+WF)
5     WF1=WF
      W(I)=W(I-1)+SUM
6     B1=B2
      Wo=W(N)
      VOC=Vo-Wo
      VOCU=Vo+Wo
      WRITE(2,200) Yo,Qo,Vo,Ao,Co,Wo
200   FORMAT(' Yo=',F6.3,', Qo=',F6.1,', Vo=',F6.3,', Ao=',F7.3,
     &', co=',F7.3,', wo=',F7.3)
      VOW=Vo-Wo 
      VOWU=Vo+Wo
      Y=.7*Yo
      M=0
10    BETA=ACOS(1.-Y/RAD)
      A=RAD2*(BETA-SIN(BETA)*COS(BETA))
      C=SQRT(G*A/(D*SIN(BETA)))
      IM=IFIX((Y-.01)/DY)+1
      FAC=(Y-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      F=VOWU-WW-C
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 12
      FF=F
      YY=Y
      Y=1.005*Y
      GO TO 10
12    DIF=(Y-YY)*FF/(F-FF)
      Y=YY-DIF
      IF(ABS(DIF).GT. 2.E-6 .AND. M.LT.30) GO TO 10
      BETA=ACOS(1.-Y/RAD)
      A=RAD2*(BETA-SIN(BETA)*COS(BETA))
      C=SQRT(G*A/(D*SIN(BETA)))
      IM=IFIX((Y-.01)/DY)+1
      FAC=(Y-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      DQ=2.*A*(Wo-WW)
      Vd=WW+VOC
      Qd=A*Vd
      Vu=VOCU-WW
      Qu=A*Vu
      WRITE(2,100) Y,C,A,DQ,Vu,Qu,Vd,Qd,WW
100   FORMAT(' Y=',F7.3,' c=',F7.3,' A=',F7.2,' DQ=',F7.3,' Vu=',F7.3,
     &/,' Qu=',F7.2,' Vd=',F7.3,' Qd=',F7.2,' w=',F7.3)
      END
      FUNCTION FW(BETA)
      SINB=SIN(BETA)
      FW=SINB/SQRT(BETA/SINB-COS(BETA))
      RETURN
      END