C This program generalizes GATETR so that it allow 4 cases:  (1) Yo1,Vo1,Yo2 & Vo2
C given, (2) Yo1 &  Yo2 given, (3) Yo1 & Q given, and (4) Yo2 & Q given
C  It also allow three new conditions: (a) Y2 given, (b) V2 given and (c) Q2 given
C The difference in this program and GATETRG.FOR is that the table for the stage
C  variable is dimensionless w'.
      PARAMETER (N=200)
      CHARACTER*2 UNK(7)/'Y1','V1','V2','Y3','V3','Wu','Wd'/
     &,GATEN(3)/'Y2','V2','Q2'/
      INTEGER*2 INDX(7),NEW/0/
      REAL F(7),FF(7),D(7,7)
      COMMON B,FM,BH,FM3,Y2,W(200),X(7),DY,VOW,Yo1,Vo1,Yo2,Vo2,G,G2,
     &Ao1,Ao2,Ao1G,Ao2G,A2,FMON1,FMON2,V2,Q2,CONV,FMB,IQ
      FC(YP)=SQRT((1.+2.*YP)/(YP+YP*YP))
99    WRITE(*,*)' Give: g,b,m,IOUT'
      READ(*,*) G,B,FM,IOUT
      G2=2.*G
      FM2=2.*FM
      FM3=FM/3.
      BH=B/2.
      CONV=SQRT(G*B/FM)
      FMB=FM/B
1     WRITE(*,200)
200   FORMAT(' Give case number:',/,' 1 - Yo1,Vo1,Yo2 & Vo2 given',/,
     &' 2 - Yo1 & Yo2 given'/' 3 - Yo1 & Q given'/' 4 - Yo2 & Q given')
      READ(*,*) ICASE
      IF(ICASE.EQ.1) THEN
      WRITE(*,*)' Give: Yo1,Vo1,Yo2,Vo2'
      READ(*,*) Yo1,Vo1,Yo2,Vo2
      Qo=Vo1*(B+FM*Yo1)*Yo1
      ELSE IF(ICASE.EQ.2) THEN
      WRITE(*,*)' Give: Yo1 & Yo2'
      READ(*,*) Yo1,Yo2
      Ao1=(B+FM*Yo1)*Yo1
      Ao2=(B+FM*Yo2)*Yo2
      Qo=SQRT(G2/(1./Ao2**2-1./Ao1**2)*(Yo1-Yo2))
      Vo1=Qo/Ao1
      Vo2=Qo/Ao2
      ELSE IF(ICASE.EQ.3) THEN
      WRITE(*,*)' Give: Yo1 & Q'
      READ(*,*) Yo1,Qo
      Vo1=Qo/((B+FM*Yo1)*Yo1)
      Eo=Yo1+Vo1**2/G2
      Yo2=Yo1/5.
      NCT=0
2     F1=Eo-Yo2-(Qo/((B+FM*Yo2)*Yo2))**2/G2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 3
      FF1=F1
      YY=Yo2
      Yo2=1.005*Yo2
      GO TO 2
3     DIF=(Yo2-YY)*FF1/(F1-FF1)
      Yo2=YY-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT. 1.E-6) GO TO 2
      Vo2=Qo/((B+FM*Yo2)*Yo2)
      ELSE IF(ICASE.EQ.4) THEN
      WRITE(*,*)' Give: Yo2 & Q'
      READ(*,*) Yo2,Qo
      Vo2=Qo/((B+FM*Yo2)*Yo2)
      Eo=Yo2+Vo2**2/G2
      Yo1=5.*Yo2
      NCT=0
4     F1=Eo-Yo1-(Qo/((B+FM*Yo1)*Yo1))**2/G2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 5
      FF1=F1
      YY=Yo1
      Yo1=1.005*Yo1
      GO TO 4
5     DIF=(Yo1-YY)*FF1/(F1-FF1)
      Yo1=YY-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT. 1.E-6) GO TO 4
      Vo1=Qo/((B+FM*Yo1)*Yo1)
      ELSE
      GO TO 1
      ENDIF
6     WRITE(*,*)' New condition by gate gives: (1) Y2, (2) V2 or (3) Q2'
      WRITE(*,*)' Give: 1, 2 or 3'
      READ(*,*) IQ
      WRITE(*,*)' Give:',GATEN(IQ)
      IF(IQ.EQ.1) THEN
      READ(*,*) Y2
      ELSE IF(IQ.EQ.2) THEN
      READ(*,*) V2
      UNK(3)='Y2'
      ELSE IF(IQ.EQ.3) THEN
      READ(*,*) Q2
      UNK(3)='Y2'
      ELSE
      GO TO 6
      ENDIF
      WRITE(*,*)' You supply guesses for unknowns? Yes=1, No=0'
      READ(*,*) J
      IF(J.EQ.1) THEN 
      WRITE(*,100) UNK
100   FORMAT(' Give guesses for:',6(A3,','),A3)
      READ(*,*) X
      ELSE
      IF(IQ.EQ.1) THEN
      XT=Y2/Yo2
      X(3)=Vo2/XT
      ELSE IF( IQ.EQ.2) THEN
      XT=.7*V2/Vo2
      X(3)=.5*(SQRT((B/FM)**2+2.8*Qo/(V2*FM))-B/FM)
      ELSE
      XT=Q2/Qo
      X(3)=.5*(SQRT((B/FM)**2+4.*Q2/(1.4*Vo2*FM))-B/FM)
      ENDIF
      Q=XT*Qo
      X(1)=1.2*Yo1
      X(2)=Q/((B+FM*X(1))*X(1))
      X(4)=.85*Yo2
      X(5)=Vo2
      X(6)=.6*Vo2
      X(7)=.6*Vo2
      ENDIF
      Ao1=(B+FM*Yo1)*Yo1
      Ao1G=Ao1/G
      Ao2=(B+FM*Yo2)*Yo2
      Ao2G=Ao2/G
      IF(IQ.EQ.1) THEN
      A2=(B+FM*Y2)*Y2
      FMON2=(BH+FM3*Y2)*Y2*Y2
      ENDIF
      FMON1=(BH+FM3*Yo1)*Yo1**2
      IF(NEW.EQ.0) THEN
      DY=1.5/FLOAT(N)
      DY1=DY/10.
      DYH=DY1/2.
      YP1=.01
      RC=FC(.01)
      W(1)=.138
      DO 10 I=2,N
      SUM=0.
      DO 7 J=1,10
      YP=YP1+DY1*FLOAT(J)
      RC1=FC(YP)
      SUM=SUM+DYH*(RC+RC1)
7     RC=RC1
      YP1=YP
10    W(I)=W(I-1)+SUM
      ENDIF
      IM=(FMB*Yo2-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(FMB*Yo2-.01-DY*FLOAT(IM-1))/DY
      VOW=Vo2-(W(IM)+FAC*(W(IM+1)-W(IM)))*CONV
      NCT=0
12    SUM=0.
      CALL FUN(F)
      DO 20 J=1,7
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 15 I=1,7
15    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
20    X(J)=XT
      CALL SOLVEQ(7,1,7,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 30 I=1,7
      X(I)=X(I)-F(I)
30    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,', SUM=',E12.5,/7F9.3)
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 12
      WRITE(*,120)(UNK(I),X(I),I=1,7)
      IF(IOUT.NE.6) THEN
      IF(IQ.EQ.1) THEN
      V2=X(3)
      ELSE
      Y2=X(3)
      ENDIF
      IF(IQ.LT.3) Q2=V2*((B+FM*Y2)*Y2)
      WRITE(IOUT,121) Yo1,Vo1,Yo2,Vo2,Y2,V2,Q2
121   FORMAT(' Yo1=',F8.3,' Vo1=',F8.3,/' Yo2=',F8.3,' Vo2=',F8.3,/
     &' Y2=',F8.3,' V2=',F8.3,' Q2=',F9.1)
      WRITE(IOUT,120)(UNK(I),X(I),I=1,7)
      ENDIF
120   FORMAT(A3,' = ',F10.3)
      WRITE(*,*)' Do your want to solve another problem? (1=Yes,0=No)'
      READ(*,*) NEW
      IF(NEW.EQ.1) GO TO 99
      END
      SUBROUTINE FUN(F)
      REAL F(7)
      COMMON B,FM,BH,FM3,Y2,W(200),X(7),DY,VOW,Yo1,Vo1,Yo2,Vo2,G,G2,
     &Ao1,Ao2,Ao1G,Ao2G,A2,FMON1,FMON2,V2,Q2,CONV,FMB,IQ
      A1=(B+FM*X(1))*X(1)
      IF(IQ.EQ.1) THEN
      V2=X(3)
      ELSE
      Y2=X(3)
      A2=(B+FM*Y2)*Y2
      IF(IQ.EQ.3) V2=Q2/A2
      FMON2=(BH+FM3*Y2)*Y2*Y2
      ENDIF
      A3=(B+FM*X(4))*X(4)
      F(1)=X(1)+X(2)**2/G2-Y2-V2**2/G2
      F(2)=X(2)*A1-V2*A2
      F(3)=FMON1+(X(6)+Vo1)**2*Ao1G-(BH+FM3*X(1))*X(1)**2-(X(6)+X(2))**
     &2*A1/G
      F(4)=(X(6)+Vo1)*Ao1-(X(6)+X(2))*A1
      F(5)=FMON2+(X(7)-V2)**2*A2/G-(BH+FM3*X(4))*X(4)**2-(X(7)-X(5))**2
     &*A3/G
      F(6)=(X(7)-V2)*A2-(X(7)-X(5))*A3
      IM=(FMB*X(4)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(FMB*X(4)-.01-DY*FLOAT(IM-1))/DY
      F(7)=X(5)-CONV*(W(IM)+FAC*(W(IM+1)-W(IM)))-VOW
      RETURN
      END