C  Solve flow from triagular grate, B is width of grate, but area is based on
C   having a trigular gutter.
C  This program obtains a series of these solution.  It reads in table of values
C from solution by GUTTERSS, and computes the lengths of grates requires.
      REAL YY(1),YTT(1)
      COMMON FM,FMS,C,FN,HM,G,Q,QS1,CD,X,SO
      EQUIVALENCE (Y,YY(1))
      WRITE(6,*)'Give:INPUT,IOUT,L,b,m,n,So,DX,g,Cd,Fac A'
      READ(5,*) INPUT,IOUT,FL,B,FM,FN,SSO,DXO,G,CD,FA
      DXS=1.
      IF(G.GT.30.) THEN
      C=1.486
      ELSE
      C=1.
      ENDIF
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      G8=.125*G
      G2=2.*G
      CD=CD*SQRT(G2)*FA*B
      KK=0
1     READ(INPUT,*,END=199) NUM,QS,YS,XS,YL,YR,QTOT
C  This statement makes DX less than the lengths of grate needed & might be elim.
      IF(NUM.EQ.15) DXO=.2*DXO
2     IF(KK.EQ.0) THEN
      YC=YR
      SO=SSO
      QB=QS*XS
      DX=DXO
      ELSE
      YC=YL
      SO=-SSO
      QB=QS*(FL-XS)
      DX=.25*DXO
      ENDIF
      Y=.95*YC
      A=HM*YC*YC
      QS1=CD*SQRT(YC)
C      WRITE(IOUT,100)0.,YC,QB,YC+(QB/A)**2/G2,QS1,QB/(FM*SQRT(G8*YC**5))
C100   FORMAT(F10.2,5F10.3)
      X1=0.
      Q=QB
10    X=X1+DX
      CALL RUKUST(1,DXS,X1,X,1.E-4,YY,YTT)
      QS2=CD*SQRT(ABS(Y))
      QSA=.5*(QS1+QS2)
      Q=Q-QSA*DX
      A=HM*Y**2
C      WRITE(IOUT,100)X,Y,Q,Y+(Q/A)**2/G2,QSA,Q/(FM*SQRT(G8*Y**5))
      QS1=QS2
      X1=X
      IF(Y.GT. .1 .AND. Q.GT.0.) GO TO 10
      IF(KK.EQ.0) THEN
      FLR=X
      KK=1
      GO TO 2
      ELSE
      WRITE(IOUT,145) NUM,QS,YS,XS,YL,YR,QTOT,FLR,X,FLR+X
145   FORMAT(I5,F10.6,5F8.4,3F8.2)
      KK=0
      GO TO 1
      ENDIF
199   STOP
      END
      SUBROUTINE SLOPE(XX,Y,DYX)
      REAL Y(1),DYX(1)
      COMMON FM,FMS,C,FN,HM,G,Q,QS1,CD,X,SO
      YY=Y(1)
      IF(YY.LT. 1.E-4) YY=.0001
      A=HM*YY**2
      QS=CD*SQRT(YY)
      QQ=Q-.5*(QS1+QS)*(XX-X)
      IF(QQ.LT.0. .OR. YY.LT.0.) THEN
      DYX(1)=0.
      ELSE
      SF=(FN*QQ/C*((YY+FMS*YY)/A)**.66666667/A)**2
      DYX(1)=(SO-SF+QQ*QS/(G*A**2))/(1.-QQ*QQ*(FM*YY)/(G*A**3))
      ENDIF
      RETURN
      END