      PARAMETER (MG=6,ME=3*MG-1)
      REAL F[ALLOCATABLE](:),FFF[ALLOCATABLE](:),D[ALLOCATABLE](:,:)  
      INTEGER*2 INDX[ALLOCATABLE](:)
      LOGICAL DONE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      READ(2,*) NG,IOUT,TOL,ERR,FN,FM,G
      IF(NG.LE.MG) GO TO 1
      WRITE(*,*)' Program dimensioned to only',MG,' channels'
      STOP
1     NE=3*NG-1
      ALLOCATE(F(NE),FFF(NE),D(NE,NE),INDX(NE))
      HMIN=1.E-8
      G2=2.*G
      G8=.125*G
      FMS=1.+SQRT(FM*FM+1.)
      HM=.5*FM
      DONE=.FALSE.
      CC=1.486
      IF(G.LT.20.) CC=1.
      DO 10 I=1,NG
      READ(2,*) SOO(I),FL(I),FLG(I),QS(I),DX(I),DXG(I),B,FRAC,CD(I)
      CD(I)=CD(I)*SQRT(G2)*FRAC*B
      QT(I)=FL(I)*QS(I)
      II=3*I
      IF(I.LT.NG) THEN
      READ(2,*) X(II-2),X(II-1),X(II)
      ELSE
      READ(2,*) X(II-2),X(II-1)
      ENDIF
10    CONTINUE
      YC=.7*X(1)
      NCT=0
20    CALL FUN(NE,F)
      WRITE(*,210) (F(JJ),JJ=1,NE)
210   FORMAT(' F',(7F10.4,F9.4))
      DO 30 JJ=1,NE
      IF(ABS(X(JJ)).LT.1.E-5) THEN
      DXX=.005
      ELSE
      DXX=.005*X(JJ)
      ENDIF
      X(JJ)=X(JJ)+DXX
      CALL FUN(NE,FFF)
      DO 25 I=1,NE
25    D(I,JJ)=(FFF(I)-F(I))/DXX
30    X(JJ)=X(JJ)-DXX
      CALL SOLVEQ(NE,1,NE,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 40 I=1,NE
40    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,(F(I),I=1,NE)
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,(8F10.4))
      WRITE(*,*)' Give FAC'
      READ(*,*) FAC
      DO 41 I=1,NE
41    X(I)=X(I)-FAC*F(I)
      IF(NCT.LT.30 .AND. SUM.GT.ERR) GO TO 20
      WRITE(IOUT,120)
120   FORMAT(' No    Yl     Yr    Qout  (Fr)l  (Fr)r')
      DO 50 JJ=1,NG
      II=3*JJ
      IF(JJ.EQ.1) THEN
      Frr=SQRT(QT(JJ)**2*FM*X(2)/(G*(HM*X(2)**2)**3))
      Frl=0.
      ELSE
      Frr=SQRT((QT(JJ)+X(II-3))**2*FM*X(II-1)/(G*(HM*X(II-1)**2)**3))
      Frl=SQRT(X(II-2)**2*FM*X(II-2)/(G*(HM*X(II-2)**2)**3))
      ENDIF
      IF(JJ.LT.NG) THEN
      WRITE(IOUT,151) JJ,X(II-2),X(II-1),X(II),Frl,Frr
      ELSE
      WRITE(IOUT,151) JJ,X(II-2),X(II-1),0.,Frl,Frr
      ENDIF
151   FORMAT(I3,5F7.3)
50    CONTINUE
      DONE=.TRUE.
      CALL FUN(NE,F)
      END
      SUBROUTINE FUN(NE,F)
      PARAMETER (MG=6,ME=3*MG-1)
      LOGICAL DONE
      EXTERNAL DYX,DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(NE)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      IF(DONE) WRITE(IOUT,100)
100   FORMAT(/,'       x          Y         Q        E          A       
     & Fr       q*',/,1X,69('-'))
      H1=.2
      DO 60 J=1,NG
      I=3*J
      SO=SOO(J)
      DXGH=.5*DXG(J)
      XX=0.
      Y(1)=X(I-2)
      IF(DONE) THEN
      WRITE(IOUT,111) J
111   FORMAT(' Gutter-Grate #',I3)
      A=HM*Y(1)**2
      Q=0.
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,110) XX,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
      ENDIF
10    XZ=XX+DX(J)
      IF(XZ.GT.FL(J)) XZ=FL(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*XZ
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT.FL(J)) GO TO 10
      F(I-2)=X(I-1)-Y(1)
      IF(I.GE.NE) GO TO 65
      H1=.002
      XX=0.
      Y(1)=X(I-1)
      SQSTAR=0.
      QS1=CD(J)*SQRT(Y(1))
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XX,Y(1),Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5
     &)),QS1
      ENDIF
30    XZ=XX+DXG(J)
      IF(XZ.GT.FLG(J)) XZ=FLG(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      QS2=CD(J)*SQRT(Y(1))
      SQSTAR=SQSTAR+DXGH*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*FL(J)-SQSTAR
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5)),
     &QS2
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.FLG(J)) GO TO 30
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      IF(J.LT.NG) THEN
      F(I-1)=X(I+1)-Y(1)
      F(I)=Q-X(I)-SQSTAR
      ELSE
      F(I-1)=X(I)-Y(1)
      F(I)=Q-SQSTAR
      ENDIF
60    CONTINUE
65    IF(DONE) RETURN
      Q=QS(NG)*FL(NG)+X(I-3)
      F(NE)=Q**2*FM*X(NE)/(G*(HM*X(NE)**2)**3)-.95
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      PARAMETER (MG=6,ME=3*MG-1)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,ZZ,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      YY=ABS(Y(1))
      Q=QS(J)*XX
      IF(J.GT.1) Q=Q+X(3*(J-1))
      YCC=CRIT(Q)
      IF(YY.LT.YC) YY=1.05*YCC
      A=HM*YY**2
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS(J)/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      PARAMETER (MG=6,ME=3*MG-1)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      YY=ABS(Y(1))
1     QS2=CD(J)*SQRT(YY)
      Q=QS(J)*FL(J)-SQSTAR-.5*(XP-XX)*(QS1+QS2)
      IF(J.GT.1) Q=Q+X(3*(J-1))
      YCC=CRIT(Q)
      IF(YY.LT.YCC) THEN
      YY=1.05*YCC
      GO TO 1
      ENDIF
      A=HM*YY**2
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END
      FUNCTION CRIT(QQ)
      PARAMETER (MG=6,ME=3*MG-1)
      LOGICAL DONE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      Q=QQ
      IF(ABS(Q).LT. .25) THEN
      CRIT=YC
      ELSE
      NCT=0
      YC1=YC
      QFM=Q*Q*FM
1     F=QFM*YC1-G*(HM*YC1**2)**3
      DYC=.01*YC1
      YCC=YC1+DYC
      DIF=DYC*F/(QFM*YCC-G*(HM*YCC**2)**3-F)
      YC1=YC1-DIF
      NCT=NCT+1
      IF(NCT.LT.20 .AND. ABS(DIF).GT. 1.E-6) GO TO 1
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',F,DIF,YC,Q
      CRIT=YC1
      ENDIF
      RETURN
      END