      PARAMETER (MG=6,ME=3*MG-2)
      REAL F[ALLOCATABLE](:),D[ALLOCATABLE](:,:),FF(3)
      INTEGER*2 INDX[ALLOCATABLE](:)
      LOGICAL DONE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      HMIN=1.E-8
      READ(2,*) NG,IOUT,TOL,ERR,FN,FM,G
      IF(NG.LE.MG) GO TO 1
      WRITE(*,*)' Program dimensioned to only',MG,' channels'
      STOP
1     NE=3*NG-2
      ALLOCATE(F(NE),D(NE,NE),INDX(NE))
      G2=2.*G
      G8=.128*G
      FMS=1.+SQRT(FM*FM+1.)
      HM=.5*FM
      DONE=.FALSE.
      CC=1.486
      IF(G.LT.20.) CC=1.
      DO 10 I=1,NG
      READ(2,*) SOO(I),FL(I),FLG(I),QS(I),DX(I),DXG(I),B,FRAC,CD(I)
      CD(I)=CD(I)*SQRT(G2)*FRAC*B
      QT(I)=FL(I)*QS(I)
      II=3*I
      IF(I.LT.NG) THEN
      READ(2,*) X(II-2),X(II-1),X(II)
      ELSE
      READ(2,*) X(II-2)
      ENDIF
10    CONTINUE
      YC=.7*X(II-2)
      NCT=0
20    CALL FUN(NE,F,FF,0)
      DO 22 I=1,NE
      DO 22 J=1,NE
22    D(I,J)=0.
C Determines Jacobian for first channel-grate
      DXX=.005*X(1)
      X(1)=X(1)+DXX
      CALL FUN(NE,F,FF,1)
      D(1,1)=(FF(1)-F(1))/DXX
      X(1)=X(1)-DXX
      D(1,2)=1.
      DXX=.005*X(2)
      X(2)=X(2)+DXX
      CALL FUN(NE,F,FF,2)
      D(2,2)=(FF(2)-F(2))/DXX
      D(3,2)=(FF(3)-F(3))/DXX
      X(2)=X(2)-DXX
C Determines Jacobian for rest of channel-grates
      DO 30 JJ=2,NG-1
Changes Qo(i-1)
      II=3*JJ-3
      D(II,II)=-1.
      DXX=.005*X(II)
      X(II)=X(II)+DXX
      CALL FUN(NE,F,FF,II+3)
      D(II+1,II)=(FF(1)-F(II+1))/DXX
      D(II+2,II)=(FF(2)-F(II+2))/DXX
      D(II+3,II)=(FF(3)-F(II+3))/DXX
      X(II)=X(II)-DXX
Changes Yl(i) - diagonal element
      II=II+1
      DXX=.005*X(II)
      X(II)=X(II)+DXX
      CALL FUN(NE,F,FF,II)
      D(II,II)=(FF(1)-F(II))/DXX
      X(II)=X(II)-DXX
      D(II-2,II)=1.
      D(II,II+1)=1.
Changes Yr(i)
      II=II+1
      IF(II.GT.NE) GO TO 30
      DXX=.005*X(II)
      X(II)=X(II)+DXX
      CALL FUN(NE,F,FF,II)
      D(II,II)=(FF(2)-F(II))/DXX
      D(II+1,II)=(FF(3)-F(II+1))/DXX
      X(II)=X(II)-DXX
30    CONTINUE
      DXX=.005*X(II)
      II=II+1
      X(II)=X(II)+DXX
      II=II+1
      CALL FUN(NE,F,FF,II)
      D(II,II-1)=(FF(1)-F(II))/DXX
      X(II-1)=X(II-1)-DXX
      D(II,II)=1.
      D(II-1,II-1)=-1.
C      WRITE(*,210) (F(I),I=1,NE)
C210   FORMAT(' F=',/,(8F10.4))
      CALL SOLVEQ(NE,1,NE,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 40 I=1,NE
40    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,(F(I),I=1,NE)
      WRITE(*,*)' Give FAC'
      READ(*,*) FAC
      DO 42 I=1,NE
42    X(I)=X(I)-FAC*F(I)
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,(8F10.4))
      IF(NCT.LT.30 .AND. SUM.GT.ERR) GO TO 20
      WRITE(IOUT,120)
120   FORMAT(' No    Yl     Yr    Qout  (Fr)l  (Fr)r')
      DO 50 JJ=1,NG-1
      II=3*JJ
      IF(JJ.EQ.1) THEN
      Frr=SQRT(QT(JJ)**2*FM*X(2)/(G*(HM*X(2)**2)**3))
      Frl=0.
      ELSE
      Frr=SQRT((QT(JJ)+X(II-3))**2*FM*X(II-1)/(G*(HM*X(II-1)**2)**3))
      Frl=SQRT(X(II-3)**2*FM*X(II-2)/(G*(HM*X(II-2)**2)**3))
      ENDIF
50    WRITE(IOUT,151) JJ,X(II-2),X(II-1),X(II),Frl,Frr
151   FORMAT(I3,5F7.3)
      WRITE(IOUT,151) NG,X(NE),YC,QS(NG)*FL(NG)+X(II)
      DONE=.TRUE.
      CALL FUN(NE,F,FF,0)
      END
      SUBROUTINE FUN(NE,F,FF,K)
      PARAMETER (MG=6,ME=3*MG-2)
      LOGICAL DONE
      EXTERNAL DYX,DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(NE),FF(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      IF(DONE) WRITE(IOUT,100)
100   FORMAT(/,'       x          Y         Q        E          A       
     & Fr       q*',/,1X,69('-'))
      IF(K.EQ.0) THEN
      J1=1
      J2=NG-1
      IODE=0
      ELSE
      IF(K.EQ.NE) GO TO 62
      J1=(K-1)/3+1
      J2=J1
      IODE=MOD(K,3)
      ENDIF
      DO 60 J=J1,J2
      I=3*J
      SO=SOO(J)
      IF(IODE.EQ.2) GO TO 20
      H1=.1
      XX=0.
      Y(1)=X(I-2)
      IF(DONE) THEN
      WRITE(IOUT,111) J
111   FORMAT(' Gutter-Grate #',I3)
      A=HM*Y(1)**2
      Q=0.
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,110) XX,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*Y(1)
     &**5))
      ENDIF
      FLM=FL(J)-1.E-6
10    XZ=XX+DX(J)
      IF(XZ.GT.FL(J)) XZ=FL(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*XZ
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*Y(1)
     &**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT.FLM) GO TO 10
      IF(K.EQ.0) THEN
      F(I-2)=X(I-1)-Y(1)
      ELSE
      FF(1)=X(I-1)-Y(1)
      ENDIF
      IF(IODE.EQ.1) RETURN
20    H1=.002
      XX=0.
      Y(1)=X(I-1)
      SQSTAR=0.
      QS1=CD(J)*SQRT(Y(1))
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XX,Y(1),Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*
     &Y(1)**5)),QS1
      ENDIF
      FLM=FLG(J)-1.E-6
30    XZ=XX+DXG(J)
      IF(XZ.GT.FLG(J)) XZ=FLG(J)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      QS2=CD(J)*SQRT(Y(1))
      SQSTAR=SQSTAR+.5*(XZ-XX)*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS(J)*FL(J)-SQSTAR
      IF(J.GT.1) Q=Q+X(I-3)
      WRITE(IOUT,130) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*Y(1)
     &**5)),QS2
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.FLM) GO TO 30
      Q=QS(J)*FL(J)
      IF(J.GT.1) Q=Q+X(I-3)
      IF(K.EQ.0) THEN
      F(I-1)=X(I+1)-Y(1)
      F(I)=Q-X(I)-SQSTAR
      ELSE
      FF(2)=X(I+1)-Y(1)
      FF(3)=Q-X(I)-SQSTAR
      ENDIF
60    CONTINUE
C  Solves critical flow eq. at end of last gutter(assuming last grate is
C    long enough to take in all flow with supercritical flow at its first.
      IF(K.GT.0 .AND. K.LT.NE) RETURN
62    I=3*NG-3
      Q=QS(NG)*FL(NG)+X(I)
      YC=CRIT(Q)
      Y(1)=1.05*YC
      J=NG
      XX=FL(J)
65    XZ=XX-DX(J)
      IF(XZ.LT.0.) XZ=0.
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      Q=QS(J)*XZ+X(I)
      A=HM*Y(1)**2
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G8*Y(1)
     &**5))
      ENDIF
      XX=XZ
      IF(XZ.GT. 1.E-3) GO TO 65
      IF(K.EQ.0) THEN
      F(I+1)=X(I+1)-Y(1)
      ELSE
      FF(1)=X(I+1)-Y(1)
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      PARAMETER (MG=6,ME=3*MG-2)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,ZZ,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      YY=ABS(Y(1))
      A=HM*YY**2
      Q=QS(J)*XX
      IF(J.GT.1) Q=Q+X(3*(J-1))
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      IF(FR2.GT. .95) FR2=.95
      DY(1)=(SO-SF-2.*Q*QS(J)/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      PARAMETER (MG=6,ME=3*MG-2)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      YY=Y(1)
      QS2=CD(J)*SQRT(YY)
      A=HM*YY**2
      Q=QS(J)*FL(J)-SQSTAR-.5*(XP-XX)*(QS1+QS2)
      IF(J.GT.1) Q=Q+X(3*(J-1))
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END
      FUNCTION CRIT(Q)
      PARAMETER (MG=6,ME=3*MG-2)
      LOGICAL DONE
      COMMON /TRAS/X(ME),DX(MG),SOO(MG),SO,FM,FMS,QS(MG),QT(MG),CC,FN,HM
     &,G,G2,G8,FL(MG),FLG(MG),DXG(MG),CD(MG),TOL,QS1,XX,HMIN,SQSTAR,DONE
     &,IOUT,NG,J,YC
      NCT=0
      YC1=YC
      QFM=Q*Q*FM
1     F=QFM*YC1-G*(HM*YC1**2)**3
      DYC=.01*YC1
      YCC=YC1+DYC
      DIF=DYC*F/(QFM*YCC-G*(HM*YCC**2)**3-F)
      YC1=YC1-DIF
      NCT=NCT+1
      IF(NCT.LT.20 .AND. ABS(DIF).GT. 1.E-6) GO TO 1
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',F,DIF,YC1,Q
      CRIT=YC1
      RETURN
      END