C Solves the problem of side flow into a triangular gutter.
C This program modifies GUTTER to allow q* to be a linear function of x
      INTEGER*2 INDX(4)
      LOGICAL DONE,UP
      REAL F(4),D(4,4),FFF(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,DQS,CC,FN,HM,G,G2,G5,FL,DX,GM2,TOL,
     &DQSL,FLSQ,DONE,UP,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,m,L,g,DX,beg q*, end q*'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FL,G,DX,QS,DQS
      DONE=.FALSE.
      DQS=DQS-QS
      DQSL=DQS/(2.*FL)
      FLSQ=FL*FL
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      G5=.125*G
      GM2=G5*FM*FM
      GM=6.*GM2
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) X(4)
      QE=QS*X(4)+DQSL*X(4)**2
      QE2=QE*QE
      YC=((QE/(.3*FM))**2/G)**.3333333
      NCT=0
1     YC5=YC**5
      DIF=(YC*(QE2-GM2*YC5))/(QE2-GM*YC5)
      YC=YC-DIF
      NCT=NCT+1
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 1
      IF(NCT.EQ.30) WRITE(*,*)' Critical depth failed. DIF=',DIF
      X(1)=YC
      QE=QS*(FL-X(4))+DQSL*(FLSQ-X(4)**2)
      QE2=QE*QE
      NCT=0
      YC=((QE/(.3*FM))**2/G)**.3333333
2     YC5=YC**5
      DIF=(YC*(QE2-GM2*YC5))/(QE2-GM*YC5)
      YC=YC-DIF
      NCT=NCT+1
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 2
      IF(NCT.EQ.30) WRITE(*,*)' Critical depth failed. DIF=',DIF
      X(2)=YC
      X(3)=.75*(X(1)+X(2))
      WRITE(*,*)' Guesses for x',X
      GM2=FM*GM2
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,4
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,4
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,4
20    SUM=SUM+ABS(F(I))
      WRITE(*,*)' Give Mult. factor  SUM=',SUM,' F=',F
      READ(*,*) FAC
      DO 21 I=1,4
21    X(I)=X(I)-FAC*F(I)
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,4F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(3,100) X
100   FORMAT(' Yc1=',F8.3,', Yc2=',F8.3,', Depth at Q=0',F8.3,' Xs=',
     &F8.1)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE,UP
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,DQS,CC,FN,HM,G,G2,G5,FL,DX,GM2,TOL,
     &DQSL,FLSQ,DONE,UP,IOUT
      F(1)=FM*X(1)*(QS*X(4)+DQSL*X(4)**2)**2-GM2*X(1)**6
      F(2)=FM*X(2)*(QS*(FL-X(4))+DQSL*(FLSQ-X(4)**2))**2-GM2*X(2)**6
      HMIN=.001
      UP=.TRUE.
      IF(DONE) THEN
      A=HM*X(1)**2
      Q=-QS*X(4)-DQSL*X(4)**2
      WRITE(IOUT,100) 0.,X(1),Q,X(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G5*X(
     &1)**5)),QS
      ENDIF
100   FORMAT('       x          Y         Q        E        A        Fr
     &        q*'
     &,/,1X,67('-'),/,F10.1,6F10.3)
      H1=.1
      XX=0.
      Y(1)=1.1*X(1)
10    XZ=XX+DX
      IF(XZ.GT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*(XZ-X(4))+DQSL*(XZ**2-X(4)**2)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)/(FM*SQRT(G5*
     &Y(1)**5)),QS+DQS*XZ/FL
110   FORMAT(F10.1,6F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT. X(4)) GO TO 10
      F(3)=X(3)-Y(1)
      H1=-.1
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS*(FL-X(4))+DQSL*(FLSQ-X(4)**2)
      WRITE(IOUT,100) FL,X(2),Q,X(2)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*X(2)**5
     &)),QS+DQS
      ENDIF
      UP=.FALSE.
      XX=FL
      Y(1)=1.1*X(2)
20    XZ=XX-DX
      IF(XZ.LT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*(XZ-X(4))+DQSL*(XZ**2-X(4)**2)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*Y(1)**5)),
     &QS+DQS*XZ/FL
      ENDIF
      XX=XZ
      IF(XZ.GT. X(4)) GO TO 20
      F(4)=X(3)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE,UP
      REAL Y(1),DY(1)
      COMMON /TRAS/X(4),SO,FM,FMS,QS,DQS,CC,FN,HM,G,G2,G5,FL,DX,GM2,TOL,
     &DQSL,FLSQ,DONE,UP,IOUT
      A=HM*Y(1)**2
      QSP=QS+DQS*XX/FL
      Q=QS*(XX-X(4))+DQSL*(XX**2-X(4)**2)
      SF=FN*Q/CC*(FMS*Y(1)/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*Y(1)/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QSP/(G*A**2))/(1.-FR2)
      RETURN
      END