C Solves the problem of side flow into a triangular gutter, and the outflow
C from grates in its bottom.
C  Yl=X(1), Yr=X(2), Ys=X(3), Yo=X(4), Xs=X(5), Xo=X(6)
      INTEGER*2 INDX(6)
      LOGICAL DONE,UP
      REAL F(6),D(6,6),FFF(6)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(6),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,XX,DONE,UP,IOUT
      WRITE(*,*)' Give:IO,TOL,ERR,n,So,m,L,Lgrate,g,DX,DXG,q*,b,frac,Cd'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FL,FLG,G,DX,DXG,QS,B,FRAC,CD
      DONE=.FALSE.
      DXGH=DXG/2.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      CD=CD*SQRT(G2)*FRAC*B
      G5=.125*G
      GM2=G5*FM*FM
      GM=6.*GM2
      GM2=FM*GM2
      WRITE(*,*)' GIVE guess for:Yl,Yr,Ys,Yo,Xs & Xo'
      READ(*,*) X
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,6
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,6
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(6,1,6,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,6
C      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,*)' Give Mult. factor  SUM=',SUM,' F=',F
      READ(*,*) FA1,FA2,FA3
      DO 21 I=1,6
      IF(I.LT.5) THEN
      X(I)=X(I)-FA1*F(I)
      ELSE IF(I.EQ.5) THEN
      X(I)=X(I)-FA2*F(I)
      ELSE
      X(I)=X(I)-FA3*F(I)
      ENDIF
21    CONTINUE
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,6F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(3,100) X
100   FORMAT(' Yl=',F7.3,', Yr=',F7.3,', Ys=',F7.3,', Yo=',F7.3,', Xs=',
     &F8.2,', Xo=',F7.3)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE,UP
      EXTERNAL DYX,DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(6)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(6),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,XX,DONE,UP,IOUT
      HMIN=1.E-6
      UP=.TRUE.
      IF(DONE) THEN
      A=HM*X(1)**2
      Q=QS*X(5)
      WRITE(IOUT,100) 0.,X(1),Q,X(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*X(1)**5
     &))
      ENDIF
100   FORMAT(/,'       x          Y         Q        E        A         
     & Fr',/,1X,59('-'),/,F10.1,5F10.3)
      H1=.1
      XX=0.
      Y(1)=X(1)
10    XZ=XX+DX
      IF(XZ.GT.X(5)) XZ=X(5)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*(X(5)-XZ)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*Y(1)**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT. X(5)) GO TO 10
      F(1)=X(3)-Y(1)
      H1=-.1
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS*(FL-X(5))
      WRITE(IOUT,100) FL,X(2),Q,X(2)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*X(2)**5
     &))
      ENDIF
      UP=.FALSE.
      XX=FL
      Y(1)=X(2)
20    XZ=XX-DX
      IF(XZ.LT.X(5)) XZ=X(5)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*(XZ-X(5))
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*Y(1)**5))
      ENDIF
      XX=XZ
      IF(XZ.GT. X(5)) GO TO 20
      F(2)=X(3)-Y(1)
      H1=.005
      UP=.TRUE.
      XX=0.
      SQSTAR=0.
      QS1=CD*SQRT(X(2))
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS*(FL-X(5))
      WRITE(IOUT,120) 0.,X(2),Q,QS1,X(2)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*
     &X(2)**5))
120   FORMAT(/,'       x          Y         Q        q*        E         
     &A           Fr',/,1X,69('-'),/,F10.1,6F10.3)
      ENDIF
      Y(1)=X(2)
30    XZ=XX+DXG
      IF(XZ.GT.X(6)) XZ=X(6)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      IF(Y(1).LE. 0.) THEN
      QS2=0.
      ELSE
      QS2=CD*SQRT(Y(1))
      ENDIF
      SQSTAR=SQSTAR+DXGH*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*(FL-X(5))-SQSTAR
      WRITE(IOUT,130) XZ,Y,Q,QS2,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*Y(1)**
     &5))
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.X(6)) GO TO 30
      F(3)=X(4)-Y(1)
      F(5)=(FL-X(5))*QS-SQSTAR
      H1=-.005
      UP=.FALSE.
      XX=FLG
      SQSTAR=0.
      QS1=CD*SQRT(X(1))
      IF(DONE) THEN
      A=HM*X(1)**2
      Q=QS*X(5)
      WRITE(IOUT,120) 0.,X(1),Q,QS1,X(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*
     &X(1)**5))
      ENDIF
      Y(1)=X(1)
40    XZ=XX-DXG
      IF(XZ.LT.X(6)) XZ=X(6)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      IF(Y(1).LE.0.) THEN
      QS2=0.
      ELSE
      QS2=CD*SQRT(Y(1))
      ENDIF
      SQSTAR=SQSTAR+DXGH*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*X(5)-SQSTAR
      WRITE(IOUT,130) XZ,Y,Q,QS2,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*Y(1)**
     &5))
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.GT.X(6)) GO TO 40
      F(4)=X(4)-Y(1)
      F(6)=X(5)*QS-SQSTAR
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE,UP
      REAL Y(1),DY(1)
      COMMON /TRAS/X(6),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,XDUM,DONE,UP,IOUT
      YY=ABS(Y(1))
      A=HM*YY**2
      Q=QS*(XX-X(5))
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      LOGICAL DONE,UP
      REAL Y(1),DY(1)
      COMMON /TRAS/X(6),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,XX,DONE,UP,IOUT
      IF(Y(1).LE. 0.) THEN
      QS2=0.
      YY=.01
      ELSE
      QS2=CD*SQRT(Y(1))
      YY=Y(1)
      ENDIF
      A=HM*YY**2
      IF(UP) THEN
      Q=QS*(FL-X(5))-SQSTAR-.5*(XP-XX)*(QS1+QS2)
      IF(Q.LT.0.) Q=0.
      ELSE
      Q=SQSTAR+.5*(XX-XP)*(QS1+QS2)-QS*X(5)
      IF(Q.GT.0.) Q=0.
      ENDIF
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END