C Solves the problem of side flow into a triangular gutter.
C Asks for new So and then obtains a series of solutions
      INTEGER*2 INDX(4)
      LOGICAL UP
      REAL F(4),D(4,4),FFF(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,QT,FL,DX,GM2,TOL,
     &UP,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,m,L,g,DX,q*'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FL,G,DX,QS
      QT=FL*QS
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      YC=.8
      ELSE
      CC=1.
      YC=.25
      ENDIF
      G2=2.*G
      G5=.125*G
      GM2=G5*FM*FM
      GM=6.*GM2
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) X(4)
      QE=QS*X(4)
      QE2=QE*QE
      NCT=0
1     YC5=YC**5
      DIF=(YC*(QE2-GM2*YC5))/(QE2-GM*YC5)
      YC=YC-DIF
      NCT=NCT+1
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 1
      IF(NCT.EQ.30) WRITE(*,*)' Critical depth failed. DIF=',DIF
      X(1)=YC
      QE=QS*(FL-X(4))
      QE2=QE*QE
      NCT=0
      YC=2.*YC
2     YC5=YC**5
      DIF=(YC*(QE2-GM2*YC5))/(QE2-GM*YC5)
      YC=YC-DIF
      NCT=NCT+1
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 2
      IF(NCT.EQ.30) WRITE(*,*)' Critical depth failed. DIF=',DIF
      X(2)=YC
      X(3)=X(1)+X(2)
      WRITE(*,*)' Guesses for x',X
      GM2=FM*GM2
50    NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,4
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,4
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,4
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,4F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(3,100) SO,X
100   FORMAT(F8.6,3F8.3,F8.2)
      WRITE(*,*)' Give new So (10=STOP)'
      READ(*,*) SO
      IF(SO.GT.9.) STOP
      GO TO 50
      END
      SUBROUTINE FUN(F)
      LOGICAL UP
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,QT,FL,DX,GM2,TOL,
     &UP,IOUT
      F(1)=FM*X(1)*(QS*X(4))**2-GM2*X(1)**6
      F(2)=FM*X(2)*(QS*(FL-X(4)))**2-GM2*X(2)**6
      HMIN=.001
      UP=.TRUE.
      H1=.1
      XX=0.
      Y(1)=1.1*X(1)
10    XZ=XX+DX
      IF(XZ.GT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      XX=XZ
      IF(XZ.LT. X(4)) GO TO 10
      F(3)=X(3)-Y(1)
      H1=-.1
      UP=.FALSE.
      XX=FL
      Y(1)=1.1*X(2)
20    XZ=XX-DX
      IF(XZ.LT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      XX=XZ
      IF(XZ.GT. X(4)) GO TO 20
      F(4)=X(3)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL UP
      REAL Y(1),DY(1)
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,QT,FL,DX,GM2,TOL,
     &UP,IOUT
      A=HM*Y(1)**2
      Q=QS*(XX-X(4))
      SF=FN*Q/CC*(FMS*Y(1)/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*Y(1)/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END