      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),DTG2
     &,CN,DX,DT2,SO,B,G,DV,DELT,H,FEK,VaN,N,II,IOUT,LINEAR,ITYPE
      REAL GIVTIM(40),GIVDWS(40),KE
      WRITE(*,*)' Give input and output units: IN & IOUT'
      READ(*,*) IN,IOUT
      READ(IN,*) NT,N,LINEAR,DELT,Q,FN,SO,B,G,FL,H,KE
      READ(IN,*) (YK(I),I=N,1,-1)
C      READ(IN,*) (YK(I),I=1,N)
      READ(IN,*) ITYPE,MGIV,(GIVTIM(I),GIVDWS(I),I=1,MGIV)
C  ITYPE=1 then Y(N)-given; ITYPE=2 then V(N)-given; ITYPE=3 then Q(N)-given
C Unknowns: Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=XR, Va(5)=VL, Va(6)=VR, 
C   Va(7)=YL, Va(8)=YR.
C For upstream BC Va(1)=V, Va(2)=Y, Va(3)=XR, Va(4)=VR, Va(5)=YR
C For downstream BC Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=VL, Va(5)=YL
      DT2=DELT/2.
      DTG2=G*DELT
      DX=FL/FLOAT(N-1)
      FEK=(KE+1.)/(2.*G)
      CN=FN
      IF(G.GT.30.) CN=CN/1.486
      ITAB=100
      DO 5 I=1,N
      Y(I)=YK(I)
      VK(I)=Q/(B*Y(I))
5     V(I)=VK(I)
      WRITE(IOUT,100) 0,0.
      WRITE(IOUT,101) (Y(I),I=1,N)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(Q,I=1,N)
      C=SQRT(G*Y(2))
      Va(3)=1.-(V(2)+C)*DELT/DX
      Va(4)=(C-V(2))*DELT/DX
      IGIV=2
      TIME=0.
      DO 50 K=1,NT
      TIME=TIME+DELT
10    IF(GIVTIM(IGIV).GE.TIME .OR. IGIV.EQ.MGIV) GO TO 20
      IGIV=IGIV+1
      GO TO 10
20    IG=IGIV-1
      VaN=GIVDWS(IG)+(TIME-GIVTIM(IG))/(GIVTIM(IGIV)-GIVTIM(IG))*
     &(GIVDWS(IGIV)-GIVDWS(IG))
      CALL SOLVE
      WRITE(IOUT,100) K,TIME
100   FORMAT(/,' K=',I3,', Depth, Velocity & Flowrate for Time=',F8.1,
     &' sec.')
      WRITE(IOUT,101) (Y(I),I=1,N)
101   FORMAT(1X,16F7.2)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(V(I)*B*Y(I),I=1,N)
102   FORMAT(1X,16F7.1)
      DO 40 I=1,N
      YA=V(I)
      V(I)=2.*YA-VK(I)
      VK(I)=YA
      YA=Y(I)
      Y(I)=2.*YA-YK(I)
40    YK(I)=YA
50    CONTINUE
      END
      SUBROUTINE SOLVE
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),DTG2
     &,CN,DX,DT2,SO,B,G,DV,DELT,H,FEK,VaN,N,II,IOUT,LINEAR,ITYPE
      DO 50 I=1,N
      II=I
      IP=I+1
      IM=I-1
      NCT=0
      Va(1)=V(I)
      Va(2)=Y(I)
C  Va(3) IS (XL-Xi-1)/Dx, or  XL=X(I-1)+Dx*Va(3)
C  Va(4) IS (XR-Xi)/Dx, or  XR=X(I)+Dx*Va(4)
      IF(I.EQ.1 .OR. I.EQ.N) THEN
      NEQ=5
      Va(4)=VK(I)
      Va(5)=YK(I)
      ELSE
      NEQ=8
      Va(5)=VK(IM)+Va(3)*(VK(I)-VK(IM))
      Va(7)=YK(IM)+Va(3)*(YK(I)-YK(IM))
      Va(6)=VK(I)+Va(4)*(VK(IP)-VK(I))
      Va(8)=YK(I)+Va(4)*(YK(IP)-YK(I))
      ENDIF
15    CALL FUNCT(0)
      DO 20 J=1,NEQ
20    F1(J)=F(J)
      DO 22 J=1,NEQ
      CALL FUNCT(J)
      DO 22 J1=1,NEQ
22    D(J1,J)=(F(J1)-F1(J1))/DV
      DO 30 L=1,NEQ-1
      DO 30 M=NEQ,L+1,-1
      IF(ABS(D(M,L)).LT. 1.E-15) GO TO 30
      FAC=D(M,L)/D(L,L)
      F1(M)=F1(M)-FAC*F1(L)
      DO 28 J=L+1,NEQ
28    D(M,J)=D(M,J)-FAC*D(L,J)
30    CONTINUE
      M=NEQ
      Z(M)=F1(M)/D(M,M)
      DIF=ABS(Z(M))
      Va(M)=Va(M)-Z(M)
31    M1=M-1
      SUM=0.
      DO 32 J=M,NEQ
32    SUM=SUM+Z(J)*D(M1,J)
      IF(ABS(D(M1,M1)).LT.1.E-10) THEN
      Z(M1)=0.
      ELSE
      Z(M1)=(F1(M1)-SUM)/D(M1,M1)
      ENDIF
      M=M1
      Va(M)=Va(M)-Z(M)
      DIF=DIF+ABS(Z(M))
      IF(M.GT.1) GO TO 31
      NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .00001) GO TO 15
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',I,DIF
      IF(DX/(SQRT(G*Va(2))-Va(1)).LT.DELT) THEN
      WRITE(*,190) I,DELT,Va(1),Va(2)
190   FORMAT('At time step',I4,' DELT=',F8.2,' too large for slope of ch
     &aracteristics,  V =',F8.2,' Y=',F8.2,/,' DELT reduced to 1/2')
      IF(IOUT.NE.6) WRITE(IOUT,190) I,DELT,Va(1),Va(2)
      DELT=DELT/2.
      TIME=TIME-DELT
      DT2=DELT/2.
      DTG2=G*DELT
      GO TO 15
      ENDIF
      V(I)=Va(1)
50    Y(I)=Va(2)
200   FORMAT(' I=',2I5,/8F10.3)
      RETURN
      END
      SUBROUTINE FUNCT(J)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),DTG2
     &,CN,DX,DT2,SO,B,G,DV,DELT,H,FEK,VaN,N,I,IOUT,LINEAR,ITYPE
      IM=I-1
      IP=I+1
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      IF(ABS(DV).LT. 1.E-5) DV=SIGN(1.E-5,DV)
      Va(J)=Va(J)+DV
      ENDIF
      A=B*Va(2)
      C=SQRT(G*Va(2))
      SF=(CN*Va(1)*((B+2.*Va(2))/A)**.66666667)**2
      IF(I.EQ.1) THEN
C Upstream BC H=Y+(1+Ke)V**2/(2g)
      AR=B*Va(5)
      CR=SQRT(G*Va(5))
      SFR=(CN*Va(4)*((B+2.*Va(5))/AR)**.66666667)**2
      F(1)=DT2*(C-Va(1)+CR-Va(4))-DX*Va(3)
      F(2)=Va(1)+2.*(CR-C)-Va(4)-DTG2*(SO-.5*(SF+SFR))
      F(3)=H-Va(2)-FEK*Va(1)**2
      IF(LINEAR.EQ.1) THEN
      F(4)=Va(4)-VK(1)-Va(3)*(VK(2)-VK(1))
      F(5)=Va(5)-YK(1)-Va(3)*(YK(2)-YK(1))
      ELSE
      F(4)=Va(4)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     & VK(3)-VK(2)))
      F(5)=Va(5)-YK(1)-.5*Va(3)*((3.-Va(3))*(YK(2)-YK(1))+(Va(3)-1.)*(
     & YK(3)-YK(2)))
      ENDIF
      ELSE IF(I.EQ.N) THEN
C Downstream BC 
      AL=B*Va(5)
      CL=SQRT(G*Va(5))
      SFL=(CN*Va(4)*((B+2.*Va(5))/AL)**.66666667)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+C+Va(4)+CL)
      F(2)=Va(1)+2.*(C-CL)-Va(4)-DTG2*(SO-.5*(SF+SFL))
      IF(ITYPE-2) 1,2,3
1     F(3)=Va(2)-VaN
      GO TO 4
2     F(3)=Va(1)-VaN
      GO TO 4
3     F(3)=VaN-A*Va(1)
4     IF(LINEAR.EQ.1) THEN
      F(4)=Va(4)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(5)=Va(5)-YK(IM)-Va(3)*(YK(I)-YK(IM))
      ELSE
      F(4)=Va(4)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(5)=Va(5)-YK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(YK(IM)-YK(I-2))+Va(3
     &)*(YK(I)-YK(IM)))
      ENDIF
      ELSE
C Regular points
      AL=B*Va(7)
      CL=SQRT(G*Va(7))
      SFL=(CN*Va(5)*((B+2.*Va(7))/AL)**.66666667)**2
      AR=B*Va(8)
      CR=SQRT(G*Va(8))
      C=SQRT(G*Va(2))
      SFR=(CN*Va(6)*((B+2.*Va(8))/AR)**.6666666667)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+C+Va(5)+CL)
      F(2)=Va(1)+2.*(C-CL)-Va(5)-DTG2*(SO-.5*(SF+SFL))
      F(3)=DT2*(C-Va(1)+CR-Va(6))-DX*Va(4)
      F(4)=Va(1)-Va(6)+2.*(CR-C)-DTG2*(SO-.5*(SF+SFR))
      IF(LINEAR.EQ.1) THEN
      F(5)=Va(5)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(7)=Va(7)-YK(IM)-Va(3)*(YK(I)-YK(IM))
      ELSE
      IF(I.EQ.2) THEN
      F(5)=Va(5)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     &VK(3)-VK(2)))
      F(7)=Va(7)-YK(1)-.5*Va(3)*((3.-Va(3))*(YK(2)-YK(1))+(Va(3)-1.)*(
     &YK(3)-YK(2)))
      ELSE
      F(5)=Va(5)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(7)=Va(7)-YK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(YK(IM)-YK(I-2))+Va(3
     &)*(YK(I)-YK(IM)))
      ENDIF
      ENDIF
      IF(LINEAR.EQ.1) THEN
      F(6)=Va(6)-VK(I)-Va(4)*(VK(IP)-VK(I))
      F(8)=Va(8)-YK(I)-Va(4)*(YK(IP)-YK(I))
      ELSE
      IF(IP.EQ.N) THEN
      F(6)=Va(6)-VK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(VK(I)-VK(IM))+Va(4)*
     &(VK(N)-VK(I)))
      F(8)=Va(8)-YK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(YK(I)-YK(IM))+Va(4)*
     &(YK(N)-YK(I)))
      ELSE
      F(6)=Va(6)-VK(I)-.5*Va(4)*((3.-Va(4))*(VK(IP)-VK(I))+(Va(4)-1.)*(
     &VK(I+2)-VK(IP)))
      F(8)=Va(8)-YK(I)-.5*Va(4)*((3.-Va(4))*(YK(IP)-YK(I))+(Va(4)-1.)*(
     &YK(I+2)-YK(IP)))
      ENDIF
      ENDIF
      ENDIF
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END