      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),FMS,DTDX,
     &DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,N,II,IOUT,LINEAR
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      INTEGER IPRT(10)
      WRITE(*,*)' Give input and output units: IN, IOUT & Freq'
      READ(*,*) IN,IOUT,NFREQ
      WRITE(*,*)' Give NPRT & then list'
      READ(*,*) JPRT,(IPRT(I),I=1,JPRT)
      READ(IN,*) NT,N,LINEAR,DELT,Q,FN,SO,B,FM,Yo,Dy,G,FL
C Unknowns: Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=XR, Va(5)=VL, Va(6)=VR,
C   Va(7)=YL, Va(8)=YR.
C Upstr. Va(1)=Y,Va(2)=XR,Va(3)=VR,Va(4)=YR
C Downs. Va(1)=Y,Va(2)=XL,Va(3)=VL,Va(4)=YL
      JPRT=1
      DT2=DELT/2.
      DTG2=G*DELT
      DX=FL/FLOAT(N-1)
      DTDX=DELT/DX
      PIEL=3.1415927*DX/FL
      CN=FN
      IF(G.GT.30.) CN=CN/1.486
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      ITAB=100
      Yo=Yo-Dy/2.
      IF(FM.GT. 0.) CALL STAGE
      DO 5 I=1,N
      YK(I)=Yo+DY*SIN(FLOAT(I-1)*PIEL)
      Y(I)=YK(I)
      VK(I)=Q/((B+FM*YK(I))*YK(I))
5     V(I)=VK(I)
      C=SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2)))
      WRITE(IOUT,100) 0,0.0
      WRITE(IOUT,101) (Y(I),I=1,N)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(V(I)*(B+FM*Y(I))*Y(I),I=1,N)
      DO 6 I=1,N
6     WRITE(4,333) DX*FLOAT(I-1),Y(I),V(I),V(I)*(B+FM*Y(I))*Y(I)
333   FORMAT(F8.1,3F10.3)
      DO 50 K=1,NT
      TIME=DELT*FLOAT(K)
      CALL SOLVE
      WRITE(IOUT,100) K,TIME
100   FORMAT(/,' K=',I3,', Depth, Velocity & Flowrate for Time=',F8.1,
     &' sec.')
      WRITE(IOUT,101) (Y(I),I=1,N)
101   FORMAT(1X,16F7.2)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(V(I)*(B+FM*Y(I))*Y(I),I=1,N)
102   FORMAT(1X,16F7.1)
      IF(MOD(K,NFREQ).EQ.0.OR.IPRT(JPRT).EQ.K) THEN
      IF(IPRT(JPRT).EQ.K) JPRT=JPRT+1
      WRITE(4,'(30X)')
      DO 39 I=1,N
39    WRITE(4,333) DX*FLOAT(I-1),Y(I),V(I),V(I)*(B+FM*Y(I))*Y(I)
      ENDIF
      DO 40 I=1,N
      YA=V(I)
      c=SQRT(G*Y(I))
      IF(DX/(YA+c).LT.DELT .OR. DX/(c-YA).LT.DELT) WRITE(7,335) I,TIME,
     &YA,Y(I),c,DX/(YA+c),DX/(c-YA)
335   FORMAT(I3,F8.1,5F9.3)
      V(I)=2.*YA-VK(I)
      VK(I)=YA
      YA=Y(I)
      Y(I)=2.*YA-YK(I)
40    YK(I)=YA
50    CONTINUE
      END
      SUBROUTINE SOLVE
      INTEGER*2 INDX(8)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),FMS,DTDX,
     &DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,N,II,IOUT,LINEAR
      DO 50 I=1,N
      II=I
      IP=I+1
      IM=I-1
      NCT=0
C  Va(3) IS (XL-Xi-1)/Dx, or  XL=X(I-1)+Dx*Va(3)
C  Va(4) IS (XR-Xi)/Dx, or  XR=X(I)+Dx*Va(4)
      IF(I.EQ.1) THEN
      NEQ=4
      Va(1)=Y(I)
      Va(2)=DTDX*SQRT(G*(B+FM*Y(1))*Y(1)/(B+FM2*Y(1)))
      Va(3)=Va(2)*V(2)
      Va(4)=Y(1)+Va(2)*(Y(2)-Y(1))
      ELSE IF(I.EQ.N) THEN
      NEQ=4
      Va(1)=Y(I)
      Va(2)=1.-(V(N)+SQRT(G*(B+FM*Y(N))*Y(N)/(B+FM2*Y(N))))*DTDX
      Va(3)=V(N-1)-(1.-Va(2))*V(N-1)
      Va(4)=Y(N-1)+(1.-Va(2))*(Y(N)-Y(N-1))
      ELSE
      NEQ=8
      Va(1)=V(I)
      Va(2)=Y(I)
      IF(I.EQ.2) THEN
      Va(3)=1.-(V(2)+SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2))))*DTDX
      Va(4)=(SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2)))-V(2))*DTDX
      ENDIF
      Va(5)=VK(IM)+Va(3)*(VK(I)-VK(IM))
      Va(7)=YK(IM)+Va(3)*(YK(I)-YK(IM))
      Va(6)=VK(I)+Va(4)*(VK(IP)-VK(I))
      Va(8)=YK(I)+Va(4)*(YK(IP)-YK(I))
      ENDIF
15    CALL FUNCT(0)
      DO 20 J=1,NEQ
20    F1(J)=F(J)
      DO 22 J=1,NEQ
      CALL FUNCT(J)
      DO 22 J1=1,NEQ
22    D(J1,J)=(F(J1)-F1(J1))/DV
      CALL SOLVEQ(NEQ,1,8,D,F1,1,DD,INDX)
      DIF=0.
      DO 30 J=1,NEQ
      Va(J)=Va(J)-F1(J)
30    DIF=DIF+ABS(F1(J))
      NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .000002) GO TO 15
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',I,DIF
      IF(I.GT.1 .AND. I.LT.N) THEN
      V(I)=Va(1)
      Y(I)=Va(2)
      ELSE
      Y(I)=Va(1)
      ENDIF
50    CONTINUE
      RETURN
      END
      SUBROUTINE FUNCT(J)
      PARAMETER (EX=.66666667)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),FMS,DTDX,
     &DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,N,I,IOUT,LINEAR
      IM=I-1
      IP=I+1
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      IF(ABS(DV).LT. 1.E-5) DV=SIGN(1.E-5,DV)
      Va(J)=Va(J)+DV
      ENDIF
      IF(I.EQ.1) THEN
C Upstream BC (Y(1) specified)
      A=(B+FM*Va(1))*Va(1)
      C=SQRT(G*A/(B+FM2*Va(1)))
      AR=(B+FM*Va(4))*Va(4)
      CR=SQRT(G*AR/(B+FM2*Va(4)))
      SFR=(CN*Va(3)*((B+FMS*Va(4))/AR)**EX)**2
      F(1)=DT2*(C+CR-Va(3))-DX*Va(2)
      F(2)=WSTAGE(Va(4))-WSTAGE(Va(1))-Va(3)-DTG2*(SO-.5*SFR)
      IF(LINEAR.EQ.1) THEN
      F(3)=Va(3)-VK(1)-Va(2)*(VK(2)-VK(1))
      F(4)=Va(4)-YK(1)-Va(2)*(YK(2)-YK(1))
      ELSE
      F(3)=Va(3)-VK(1)-.5*Va(2)*((3.-Va(2))*(VK(2)-VK(1))+(Va(2)-1.)*(
     & VK(3)-VK(2)))
      F(4)=Va(4)-YK(1)-.5*Va(2)*((3.-Va(2))*(YK(2)-YK(1))+(Va(2)-1.)*(
     & YK(3)-YK(2)))
      ENDIF
      ELSE IF(I.EQ.N) THEN
C Downstream BC
      A=(B+FM*Va(1))*Va(1)
      C=SQRT(G*A/(B+FM2*Va(1)))
      AL=(B+FM*Va(4))*Va(4)
      CL=SQRT(G*AL/(B+FM2*Va(4)))
      SFL=(CN*Va(3)*((B+FMS*Va(4))/AL)**EX)**2
      F(1)=DX*(1.-Va(2))-DT2*(C+Va(3)+CL)
      F(2)=WSTAGE(Va(1))-Va(3)-WSTAGE(Va(4))-DTG2*(SO-.5*SFL)
      IF(LINEAR.EQ.1) THEN
      F(3)=Va(3)-VK(IM)-Va(2)*(VK(I)-VK(IM))
      F(4)=Va(4)-YK(IM)-Va(2)*(YK(I)-YK(IM))
      ELSE
      F(3)=Va(3)-VK(I-2)-.5*(Va(2)+1.)*((2.-Va(2))*(VK(IM)-VK(I-2))+Va(2
     &)*(VK(I)-VK(IM)))
      F(4)=Va(4)-YK(I-2)-.5*(Va(2)+1.)*((2.-Va(2))*(YK(IM)-YK(I-2))+Va(2
     &)*(YK(I)-YK(IM)))
      ENDIF
      ELSE
C Regular points
      A=(B+FM*Va(2))*Va(2)
      C=SQRT(G*A/(B+FM2*Va(2)))
      SF=(CN*Va(1)*((B+FMS*Va(2))/A)**EX)**2
      AL=(B+FM*Va(7))*Va(7)
      CL=SQRT(G*AL/(B+FM2*Va(7)))
      SFL=(CN*Va(5)*((B+FMS*Va(7))/AL)**EX)**2
      AR=(B+FM*Va(8))*Va(8)
      CR=SQRT(G*AR/(B+FM2*Va(8)))
      SFR=(CN*Va(6)*((B+FMS*Va(8))/AR)**EX)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+C+Va(5)+CL)
      WS=WSTAGE(Va(2))
      F(2)=Va(1)+WS-Va(5)-WSTAGE(Va(7))-DTG2*(SO-.5*(SF+SFL))
      F(3)=DT2*(C-Va(1)+CR-Va(6))-DX*Va(4)
      F(4)=Va(1)-WS-Va(6)+WSTAGE(Va(8))-DTG2*(SO-.5*(SF+SFR))
      IF(LINEAR.EQ.1) THEN
      F(5)=Va(5)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(7)=Va(7)-YK(IM)-Va(3)*(YK(I)-YK(IM))
      ELSE
      IF(I.EQ.2) THEN
      F(5)=Va(5)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     &VK(3)-VK(2)))
      F(7)=Va(7)-YK(1)-.5*Va(3)*((3.-Va(3))*(YK(2)-YK(1))+(Va(3)-1.)*(
     &YK(3)-YK(2)))
      ELSE
      F(5)=Va(5)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(7)=Va(7)-YK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(YK(IM)-YK(I-2))+Va(3
     &)*(YK(I)-YK(IM)))
      ENDIF
      ENDIF
      IF(LINEAR.EQ.1) THEN
      F(6)=Va(6)-VK(I)-Va(4)*(VK(IP)-VK(I))
      F(8)=Va(8)-YK(I)-Va(4)*(YK(IP)-YK(I))
      ELSE
      IF(IP.EQ.N) THEN
      F(6)=Va(6)-VK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(VK(I)-VK(IM))+Va(4)*
     &(VK(N)-VK(I)))
      F(8)=Va(8)-YK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(YK(I)-YK(IM))+Va(4)*
     &(YK(N)-YK(I)))
      ELSE
      F(6)=Va(6)-VK(I)-.5*Va(4)*((3.-Va(4))*(VK(IP)-VK(I))+(Va(4)-1.)*(
     &VK(I+2)-VK(IP)))
      F(8)=Va(8)-YK(I)-.5*Va(4)*((3.-Va(4))*(YK(IP)-YK(I))+(Va(4)-1.)*(
     &YK(I+2)-YK(IP)))
      ENDIF
      ENDIF
      ENDIF
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END
      FUNCTION WSTAGE(YY)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),FMS,DTDX,
     &DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,N,II,IOUT,LINEAR
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      IF(FM.LT.1.E-5) THEN
      WSTAGE=2.*SQRT(G*YY)
      ELSE
      YYY=FM*YY/B
      IF(ITAB.LT.400) THEN
      I1=ITAB+1
      ELSE
      ITAB=299
      I1=400
      ENDIF
      IF(YYY.LT.YST(I1)) THEN
 10   IF(YYY.LT.YST(ITAB)) THEN
      ITAB=ITAB-1
      IF(ITAB.GT.1) GO TO 10
      ENDIF
      I1=ITAB+1
      ELSE
20    IF(YYY.GT. YST(I1)) THEN
      I1=I1+1
      IF(I1.LT.400) GO TO 20
      ENDIF
      ITAB=I1-1
      ENDIF
      WSTAGE=W(ITAB)+(YYY-YST(ITAB))/(YST(I1)-YST(ITAB))*(W(I1)-W(ITAB))
      WSTAGE=SQRT(G*B/FM)*WSTAGE
      ENDIF
      RETURN
      END
      SUBROUTINE STAGE
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      FC(YP)=SQRT((1.+2.*YP)/(YP+YP*YP))
      DY=.005
      DY1=DY/10.
      DYH=DY1/2.
      N=(2.-.01)/DY+1
      YST(1)=.01
      RC=FC(.01)
      W(1)=.138
      DO 10 I=2,N
      SUM=0.
      DO 5 J=1,10
      YP=YST(I-1)+DY1*FLOAT(J)
      RC1=FC(YP)
      SUM=SUM+DYH*(RC+RC1)
5     RC=RC1
      YST(I)=YP
10    W(I)=W(I-1)+SUM
      RETURN
      END
      
      
