      PARAMETER (ND=5,EPS=1.E-6) 
      COMPLEX C(ND+1),ROOTS(ND),AD(ND+1),Z1,Z2,Z3 
      EPS1=2.*EPS*EPS 
10    WRITE(6,*)' Give: Q,b,m,g'
      READ(5,*) Q,B,FM,G
      Q2G=Q*Q/G
      YS=((Q/B)**2/g)**.3333333
      Yc=CRIT(Q,B,FM,g,YS)
      Ac=(B+FM*Yc)*Yc
      FMc=.5*B*Yc*Yc+FM*Yc**3/3.+Q**2/(g*Ac)
      WRITE(*,120) Yc,FMc,FMc
120   FORMAT(' Yc=',F8.3,' Momc=',F8.3,' Give Mom>',F8.3)
5     READ(*,*) F
      Fp=F/Yc**3
      C(6)=CMPLX(FM*FM/3.,0.) 
      C(5)=CMPLX(5.*FM*B/(6.*Yc),0.) 
      C(4)=CMPLX(.5*(B/Yc)**2,0.) 
      C(3)=CMPLX(-Fp*FM,0.) 
      C(2)=CMPLX(-Fp*B/Yc,0.)
      C(1)=CMPLX(Ac**3/(Yc**5*(B+2.*FM*Yc)),0.)
      DO 20 J=1,ND+1 
20    AD(J)=C(J) 
      DO 30 J=ND,1,-1 
      Z1=CMPLX(0.,0.) 
      CALL LAGU(AD,J,Z1,EPS) 
      IF(ABS(AIMAG(Z1)).LE.EPS1*ABS(REAL(Z1))) Z1=CMPLX(REAL(Z1),0.) 
      ROOTS(J)=Z1 
      Z2=AD(J+1) 
      DO 30 JJ=J,1,-1 
      Z3=AD(JJ) 
      AD(JJ)=Z2 
30    Z2=Z1*Z2+Z3 
      DO 50 J=2,ND 
      Z1=ROOTS(J) 
      DO 40 I=J-1,1,-1 
      IF(REAL(ROOTS(I)).LE.REAL(Z1)) GO TO 50 
40    ROOTS(I+1)=ROOTS(I) 
      I=0 
50    ROOTS(I+1)=Z1 
      WRITE(6,69)
69    FORMAT('     Complex Roots of Eq.  Actual Depth')
      DO 60 I=1,ND
      IF(AIMAG(ROOTS(I)).NE. 0.) GO TO 59 
      IF(REAL(ROOTS(I)).LT. 0.) GO TO 59 
      YP=REAL(ROOTS(I))
      WRITE(6,70) ROOTS(I),YP*Yc
      GO TO 60
59    WRITE(6,70) ROOTS(I) 
60    CONTINUE
70    FORMAT(3F12.4) 
      WRITE(6,*)' Give 1 if to solve another problem, otherwise 0' 
      READ(5,*) I 
      IF(I.EQ.1) GO TO 10 
      STOP 
      END 
      SUBROUTINE LAGU(C,ND,Z1,EPS) 
      COMPLEX C(ND+1),Z1,DX,ZO,Z2,Z3,Z4,Z5,DZ,SS,Z6,Z7,Z8,ZERO,XX,FF 
      ZERO=CMPLX(0.,0.) 
      DO 20 ITER=1,50 
      Z2=C(ND+1) 
      Z3=ZERO 
      Z4=ZERO 
      DO 10 J=ND,1,-1 
      Z4=Z1*Z4+Z3 
      Z3=Z1*Z3+Z2 
10    Z2=Z1*Z2+C(J) 
      IF(CABS(Z2).LE.1.E-8) THEN 
      DX=ZERO 
      ELSE IF(CABS(Z3).LE.1.E-8.AND.CABS(Z4).LE.1.E-8) THEN 
      DX=CMPLX(CABS(Z2/C(ND+1))**(1./FLOAT(ND)),0.) 
      ELSE 
      Z5=Z3/Z2 
      Z8=Z5*Z5 
      DZ=Z8-2.*Z4/Z2 
      XX=(ND-1)*(ND*DZ-Z8) 
      YY=ABS(REAL(XX)) 
      ZZ=ABS(AIMAG(XX)) 
      IF(YY.LT.1.E-12 .AND. ZZ .LT.1.E-12) THEN 
      SS=ZERO 
      ELSE IF (YY.GE.ZZ) THEN 
      FF=(1./YY)*XX 
      SS=SQRT(YY)*CSQRT(FF) 
      ELSE 
      FF=(1./ZZ)*XX 
      SS=SQRT(ZZ)*CSQRT(FF) 
      ENDIF 
      Z6=Z5+SS 
      Z7=Z5-SS 
      IF(CABS(Z6).LT.CABS(Z7)) Z6=Z7 
      DX=FLOAT(ND)/Z6 
      ENDIF 
      ZO=Z1-DX 
      IF(Z1.EQ.ZO) RETURN 
      Z1=ZO 
      IF(CABS(DX).LE.EPS*CABS(Z1)) RETURN 
20    CONTINUE 
      WRITE(6,*)' FAILED TO CONVERGE' 
      RETURN 
      END
      FUNCTION CRIT(Q,B,FM,g,YS)
      M=0
1     F=Q*Q*(B+2.*FM*YS)-g*((B+FM*YS)*YS)**3
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      F1=F
      YS1=YS
      YS=1.005*YS
      GO TO 1
      ENDIF
      DIF=(YS-YS1)*F1/(F-F1)
      YS=YS1-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 1
      CRIT=YS
      RETURN
      END