      EXTERNAL DYX,FUN 
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAV 
      COMMON /TRAN/CMA,CDG,HW,G,XO,BO,FMO,FN,SO,Q,QS1,DB,DM,DELX,ADELX5 
     &,YB,TOL,QSTART,QB,NPRINT,IOUT,MPRT
      WRITE(6,* )'GIVE IOUT,TOL,DELX,YB,QB,QSTART,FN,SO,BO,FMO,B2,FM2,Es
     &t.L,Hw,Cd,g,MPRT,MAX,ERR'
      READ(5,*)IOUT,TOL,DELX,YB,QB,QSTART,FN,SO,BO,FMO,B2,FM2,XBEG,HW,CD
     &,G,MPRT,MAX,ERR
      CDG=.666667*CD*SQRT(2.*G) 
      CMA=1. 
      IF(G.GT.30.) CMA=1.486
      DB=(B2-BO)/XBEG
      DM=(FM2-FMO)/XBEG 
      ADELX5=.5*DELX 
      QS1=CDG*(YB-HW)**1.5
      NPRINT=0
C Newton Method
      FL=XBEG
      NCT=0
10    FF=FUN(FL)
      DIF=FF/(FUN(FL+1.)-FF)
      FL=FL-DIF
      DB=(B2-BO)/FL
      DM=(FM2-FMO)/FL 
      NCT=NCT+1
      X=FL
      IF(NCT.LT.MAX .AND. ABS(DIF).GT.ERR) GO TO 10
      IF(NCT.EQ.MAX) WRITE(*,*)' Did not converge'
      WRITE(IOUT,110) FL
110   FORMAT(' Length of side weir needed=',F8.2)
      WRITE(*,110) FL
      NPRINT=1
C Call to print out w.s. profile
      DIF=FUN(FL)
      END 
      SUBROUTINE DYX(X,Y,YPRIME) 
      REAL Y(1),YPRIME(1) 
      COMMON /TRAN/CMA,CDG,HW,G,XO,BO,FMO,FN,SO,QO,QS1,DB,DM,DELX,ADELX5
     &,YB,TOL,QSTART,QB,NPRINT,IOUT,MPRT
      B=BO+DB*X 
      FM=FMO+DM*X 
      A=(B+FM*Y(1))*Y(1) 
      T=B+2.*FM*Y(1) 
      P=B+2.*SQRT(FM*FM+1.)*Y(1) 
      IF(Y(1).GT.HW) THEN
      QS=CDG*(Y(1)-HW)**1.5
      ELSE
      QS=0.
      ENDIF
      Q=QO-.5*(X-XO)*(QS1+QS) 
      SF=(FN*Q*(P/A)**.66666667/(CMA*A))**2 
      A2=A*A*G 
      FR2=Q*Q*T/(A*A2)
      YPRIME(1)=(SO-SF+Q*QS/A2+Q*Q/(A*A2)*Y(1)*(DB+Y(1)*DM))/(1.-FR2) 
      RETURN 
      END
      FUNCTION FUN(XX)
      EXTERNAL DYX
      REAL Y(1),XP(1),YP(1,1),WK1(1,13),YPRIME(1) 
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAV 
      COMMON /TRAN/CMA,CDG,HW,G,XO,BO,FMO,FN,SO,Q,QS1,DB,DM,DELX,ADELX5
     &,YB,TOL,QSTART,QB,NPRINT,IOUT,MPRT
      H1=.01
      Q=QB
      XO=XX
      X=XX
      Y(1)=YB
      IF(NPRINT.GT.0) WRITE(IOUT,100) X,Y,QB,QS1,SQRT(Q**2*(B+2.*FM*Y(1)
     &)/(G*((B+FM*Y(1))*Y(1))**3))
      MP=0
2     XZ=X+DELX 
      CALL ODESOL(Y,YPRIME,1,X,XZ,TOL,H1,0.,1,XP,YP,WK1,DYX)
      IF(Y(1).GT.HW) THEN
      QS2=CDG*(Y(1)-HW)**1.5
      ELSE
      QS2=0.
      ENDIF
      XO=XZ 
      Q=Q-ADELX5*(QS1+QS2) 
      QS1=QS2  
      X=XZ 
      B=BO+DB*X 
      FM=FMO+DM*X 
      IF(NPRINT.EQ.0) GO TO 5
      MP=MP+1
      IF(MOD(MP,MPRT).EQ.0) WRITE(IOUT,100) X,Y,Q,QS1,SQRT(Q**2*(B+2.*FM
     &*Y(1))/(G*((B+FM*Y(1))*Y(1))**3))
100   FORMAT(1X,F8.1,F10.3,F10.2,F10.4,F10.3) 
5     IF(X .GT. 0.) GO TO 2 
99    FUN=QSTART-Q
      RETURN
      END