C This program is the same as SOLGBRO except it has a prompt at the end of the
C main program so a series of solutions can be obtained in which the bottom
C widths of Channels 2 and 3 can be reduces, as requested in Problem 270.
      PARAMETER (N=20,M=60,N2=12)
      LOGICAL*1 TRUX(M+3)
      LOGICAL*1 IPERM,NTRAN,UPSRES,JUMP,JUMP1,LSTA,INF
      REAL F(M),F1(M),D(M,M),KL(N),L(N),LT(N),SQOUT(3)
      INTEGER*2 INDX(M)
      CHARACTER*8 CHDOWN(0:6)/' Spatial','Branch 1','  Branch',' Uniform
     &','    Gate','Critical','Reservo.'/
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN(N),SO(N),L,LT,B(N),FM(N),DZ(N),KL,DB(N),DFM(N),YG(
     &N),QOUT(N),X(M),WSTA(3),CD(3),H,G2,G,CC,TOL,PERM,TOPW,YO,QN,Q2G,BB
     &,FMM,SQSTAR,XO,QSTA1,ITYP(N),ICTL(N),JN(M),NI(N2),ISTA(4),NODEU(3)
     &,NJ,NO,NO2,NO3,NEQS,NSTA,JSTA,IJ,IPERM,NTRAN,UPSRES,JUMP,LSTA,INF
      DATA IN,IOUT/2,3/
      IPERM=.FALSE.
      NTRAN=.TRUE.
      UPSRES=.TRUE.
C ICTL = -3,-2,-1,0,1,2 OR 3 for types of downstream controls,
C -3=If downstr. end of channel is start of lateral outflow/inflow.
C -2=If downstr. branch connects to single ch. of same size(Yi=Yi+1) and QOUT=0,
C  i.e. Ei=Ei+1 is not available.
C -1=Downstream end of channel is branch.
C  0=uniform, 1=gate, 2=critical, 3=reser. 
C  YG is depth behind gate for gate; = 0 for critical;=res. depth if reservoir.
C  DB and DFM are changes (+ or -) across transition of b and m.
C IN UNKNOWN VECTOR X, Q's COME 1ST; UPSTREAM DEPTHS NEXT & then DOWNS. DEPTHS
C AND IF JUMP IN CH. # 1 THEN Yj1,Yj2 & x, are last three unknowns.
C i.e. Q(I)=X(I);YU(I)=X(I+NO); YG(I)=X(I+NO2); [Yj1,Yj2,x]
      READ(IN,*) NJ,NO,(ITYP(I),B(I),FM(I),FN(I),SO(I),L(I),LT(I),DZ(I),
     &DB(I),DFM(I),KL(I),YG(I),ICTL(I),I=1,NO)
      NO2=2*NO
      NO3=3*NO
      YO=0.
      JUMP=.FALSE.
      INF=.FALSE.
      DO 1 I=1,NO3+3
1     TRUX(I)=.TRUE.
C  If Q1 is specified give 0 for H, and if jump occurs then give ups. supercr.
C   depth for H but precede with a minus sign.
C If CD is negative then inflow case & magnitude of CD is lateral inflow q* &
C  WSTA=comp. vel. Uq, otherwise WSTA is height of weir.
C  If lateralinfow/outflow X(I)=flowrate at end of this section.
      READ(IN,*) TOL,ERR,H,G,NSTA,(ISTA(I),WSTA(I),CD(I),I=1,NSTA)
      ISTA(NSTA+1)=100
      IUPS=1
      IF(H.LT. 1.E-5) THEN
      UPSRES=.FALSE.
      IUPS=2
      TRUX(1)=.FALSE.
      IF(H.LT.-1.E-5) THEN
      YO=ABS(H)
      TRUX(NO+1)=.FALSE.
      JUMP=.TRUE.
      ENDIF
      ENDIF
      IF(G.GT. 30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      NI(1)=0
      II=1
      NCT=0
      DO 2 J=1,NJ
C In giving channel nos. that join at junction the first listed will have its flowrate
C positive, and all other will have their flowrate subtracted therefrom unless preceded
C by a minus, i.e. the energy eqs. are from downstream of first to upstream of other numbers
C or E(1)downst=E(I)upst, unless preceded by a minus, in which case E(1)downstr=E(I)downstr.
      READ(IN,*) JI,(JN(I),I=II,II+JI-1),QOUT(J)
      IF(NSTA.GT.NCT) THEN
      IF(ICTL(IABS(JN(II))).EQ.-3) THEN
      NCT=NCT+1
      NODEU(NCT)=J
      ENDIF
      ENDIF
      II=II+JI
2     NI(J+1)=II-1
      DO 3 I=1,NSTA
      IF(CD(I).GT.0.) CD(I)=.666667*CD(I)*SQRT(G2)
3     CONTINUE
      DO 4 I=1,NO
      IF(ICTL(I).EQ.3) X(I+NO2)=YG(I)
4     CONTINUE
      DO 6 I=1,NO
      KL(I)=(KL(I)+1.)/G2
      IF(ICTL(I).EQ.3 .OR. ICTL(I).EQ.0) THEN
      READ(IN,*) X(I),X(I+NO)
      IF(ICTL(I).EQ.0) X(I+NO2)=X(I+NO)
      TRUX(I+NO2)=.FALSE.
      ELSE
      READ(IN,*) X(I),X(I+NO),X(I+NO2)
      ENDIF
6     CONTINUE
      IF(YO.GT.0.) THEN
C Guess for 1-depth upst. jump, 2-downst. jump, & 3-position of jump, x
      READ(IN,*) X(NO3+1),X(NO3+2),X(NO3+3)
      NO3=NO3+3
      X(NO+1)=YO
      ENDIF
11    NCT=0
      JUMP1=JUMP
15    JUMP=JUMP1
      LSTA=.FALSE.
      CALL FUN(F)
      DO 16 I=1,NSTA
16    SQOUT(I)=QOUT(NODEU(I))
      J=0
      DO 20 II=IUPS,NO3
      IF(.NOT.TRUX(II) ) GO TO 20
      J=J+1
      DX=.01*X(II)
      X(II)=X(II)+DX
      JUMP=JUMP1
      CALL FUN(F1)
      DO 17 I=1,NEQS
17    D(I,J)=(F1(I)-F(I))/DX
      X(II)=X(II)-DX
      DO 18 I=1,NSTA
18    QOUT(NODEU(I))=SQOUT(I)
20    CONTINUE
      CALL SOLVEQ(NEQS,1,M,D,F,1,DD,INDX)
      DIF=0.
      J=0
      DO 30 I=IUPS,NO3
      IF(TRUX(I)) THEN
      J=J+1
      X(I)=X(I)-F(J)
      DIF=DIF+ABS(F(J))
      ELSE
      IF(I.EQ.NO+1 .AND. IUPS.EQ.2) GO TO 30
      IF(ICTL(I-NO2).EQ.0) X(I)=X(I-NO)
      IF(ICTL(I-NO2).LT.-1) X(I)=X(I-NO+1)
      ENDIF
30    CONTINUE
      NCT=NCT+1
      IF(NCT.LT.30 .AND. DIF.GT.ERR) GO TO 15
      WRITE(IOUT,100) NO,WSTA(3)
100   FORMAT(/,' Solution to',I3,' Channel Problem (Weir Height in Chann
     &el 12 =',F5.2,' ft)',/,1X,90('-'),/,
     &' No Ty      b    m     n      So      L    dz    db    dm     Yu  
     &   Yd       Q Downstream',/,1X,90('-'))
      DO 50 I=1,NO
50    WRITE(IOUT,110) I,ICTL(I),B(I),FM(I),FN(I),SO(I),L(I)+LT(I),DZ(I),
     &DB(I),DFM(I),X(I+NO),X(I+NO2),X(I),CHDOWN(ICTL(I)+3)
110   FORMAT(I3,I3,F7.2,F5.2,F6.3,F8.6,F7.0,3F6.2,2F7.3,F8.2,1X,A8)
      IF(JUMP1) WRITE(IOUT,120) X(NO3-2),X(NO3-1),X(NO3)
120   FORMAT(' Hydraulic jump in Channel 1 with conjugate depths:',
     &2F10.3,/,' At position, x =',F10.1)
      WRITE(7,130) B(2),(X(I),I=1,NO)
      WRITE(8,131) B(2),(X(I),I=NO+1,NO2)
      WRITE(9,131) B(2),(X(I),I=NO2+1,NO3)
130   FORMAT(F7.2,17F6.1)
131   FORMAT(F7.2,17F6.3)
      WRITE(*,*)' Give Width for Channels 2 and 3 (If neg /=STOP)'
      READ(*,*) B(2)
      B(3)=B(2)
      IF(B(2).GT.0.) GO TO 11
      END
      SUBROUTINE FUN(F)
      PARAMETER (N=20,M=60,N2=12)
      EXTERNAL DYX
      LOGICAL*1 IPERM,NTRAN,UPSRES,JUMP,JMP,LSTA,INF
      REAL KL(N),L(N),LT(N),F(M),Y(1),DY(1),W(1,13),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN(N),SO(N),L,LT,B(N),FM(N),DZ(N),KL,DB(N),DFM(N),YG(
     &N),QOUT(N),X(M),WSTA(3),CD(3),H,G2,G,CC,TOL,PERM,TOPW,YO,QN,Q2G,BB
     &,FMM,SQSTAR,XO,QSTA1,ITYP(N),ICTL(N),JN(M),NI(N2),ISTA(4),NODEU(3)
     &,NJ,NO,NO2,NO3,NEQS,NSTA,JSTA,IJ,IPERM,NTRAN,UPSRES,JUMP,LSTA,INF
      JSTA=0
      II=1
      IF(UPSRES) THEN
      BB=B(1)
      FMM=FM(1)
      F(II)=H-X(NO+1)-KL(1)*(X(1)/AR(1,X(NO+1)))**2
      II=II+1
      ENDIF
C  Uniform flow or GVF eqs
      IPERM=.TRUE.
      DO 20 I=1,NO
      IJ=I
      BB=B(I)
      FMM=FM(I)
      IF(ICTL(I).EQ.0) THEN
      F(II)=CC*AR(I,X(NO+I))**1.6666667*SQRT(SO(I))-FN(I)*X(I)*PERM**
     &.6666667
      ELSE
      IF(L(I)+LT(I).LT.1.E-5) GO TO 20
      JMP=.FALSE.
      IF(JUMP) THEN
      JMP=.TRUE.
      XX=0.
      XZ=X(NO3)
      Y(1)=YO
      GO TO 12
      ELSE
      XX=L(I)+LT(I)-1.E-5
      IF(ISTA(JSTA+1).GT.I) GO TO 10
      JSTA=JSTA+1
      LSTA=.TRUE.
      IF(CD(JSTA).LT.0.) THEN
      INF=.TRUE.
      SQSTAR=XX*CD(JSTA)
      ELSE
      INF=.FALSE.
      SQSTAR=0.
      IF(X(NO2+I).LT.WSTA(JSTA)) THEN
      QSTA1=0.
      ELSE
      QSTA1=CD(JSTA)*(X(NO2+I)-WSTA(JSTA))**1.5
      ENDIF
      ENDIF
      XO=XX
      XZ=XX-1.
      GO TO 11
10    XZ=0.
11    Y(1)=X(NO2+I)
      ENDIF
12    IF(ICTL(I).EQ.2) Y(1)=1.15*Y(1)
      QN=(FN(I)/CC)**2*ABS(X(I))*X(I)
      Q2G=X(I)**2/G
13    H1=-.05
      HMIN=.00001
14    CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      IF(XZ.LT. .001 .OR.JUMP) GO TO 16
      IF(INF) GO TO 15
      IF(Y(1).LT. WSTA(JSTA)) THEN
      QSTA2=0.
      ELSE
      QSTA2=CD(JSTA)*(Y(1)-WSTA(JSTA))**1.5
      ENDIF
      SQSTAR=SQSTAR+.5*(QSTA1+QSTA2)
      QSTA1=QSTA2
15    XX=XZ
      XO=XZ
      XZ=XZ-1.
      IF(XZ.GT. .001) THEN
      GO TO 14
      ELSE
      QOUT(NODEU(JSTA))=SQSTAR
      ENDIF
16    IF(JMP) THEN
      F(II)=X(NO3-2)-Y(1)
      II=II+1
      YY1=X(NO3-2)
      YY2=X(NO3-1)
      BB=B(I)
      FMM=FM(I)
      F(II)=YY1*YY1*(.5*B(I)+YY1*FM(I)/3.)-YY2*YY2*(.5*B(I)+YY2*FM(I)/3.
     &)+X(I)**2/G*(1./AR(I,YY1)-1./AR(I,YY2))
      II=II+1
      XX=L(I)+LT(I)
      XZ=X(NO3)
      Y(1)=X(NO2+1)
      JMP=.FALSE.
      GO TO 13
      ENDIF
      IF(JUMP) THEN
      JUMP=.FALSE.
      F(II)=X(NO3-1)-Y(1)
      ELSE
      F(II)=X(NO+I)-Y(1)
      ENDIF
      ENDIF
      LSTA=.FALSE.
      II=II+1
20    CONTINUE
C  Energy & Continuity Eqs.
      IPERM=.FALSE.
      DO 28 I=1,NJ
      I1=NI(I)+1
      I2=NI(I+1)
      JI=IABS(JN(I1))
      II1=II
      II=II+1
      F(II1)=X(JI)*FLOAT(JN(I1)/JI)-QOUT(I)
      BB=B(JI)+DB(JI)
      FMM=FM(JI)+DFM(JI)
      EN=X(NO2+JI)+(X(JI)/AR(JI,X(NO2+JI)))**2/G2
      DO 28 J=I1+1,I2
      JI1=JN(J)
      JI=IABS(JI1)
      QQ=X(JI)
      DO 25 KI=1,NSTA
      IF(NODEU(KI).EQ.I) QQ=X(JN(I1))
25    CONTINUE
      BB=B(JI)
      FMM=FM(JI)
      IIIJ=NO+JI
      IF(JI1.LT.0) IIIJ=IIIJ+NO
      F(II)=EN-X(IIIJ)-KL(JI)*(QQ/AR(JI,X(IIIJ)))**2-DZ(JI)
      II=II+1
28    F(II1)=F(II1)-X(JI)*FLOAT(JI1/JI)
C Downstream eqs
      DO 30 I=1,NO
      IF(ICTL(I).LE.0 .OR. ICTL(I).EQ.3) GO TO 30
      NTRAN=.FALSE.
      BB=B(I)+DB(I)
      FMM=FM(I)+DFM(I)
      IF(ICTL(I).EQ.2) THEN
      IPERM=.TRUE.
      AA=AR(I,X(NO2+I))
      F(II)=X(I)**2*TOPW-G*AA**3
      ELSE
      IPERM=.FALSE.
      F(II)=X(NO2+I)+(X(I)/AR(I,X(NO2+I)))**2/G2-YG(I)-KL(I)*(X(I)/AR(I,
     &YG(I)))**2
      ENDIF
      NTRAN=.FALSE.
      II=II+1
30    CONTINUE
      NEQS=II-1
      RETURN
      END
      FUNCTION AR(I,YY)
      PARAMETER (N=20,M=60,N2=12)
      LOGICAL*1 IPERM,NTRAN,UPSRES,JUMP,LSTA,INF
      REAL KL(N),L(N),LT(N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN(N),SO(N),L,LT,B(N),FM(N),DZ(N),KL,DB(N),DFM(N),YG(
     &N),QOUT(N),X(M),WSTA(3),CD(3),H,G2,G,CC,TOL,PERM,TOPW,YO,QN,Q2G,BB
     &,FMM,SQSTAR,XO,QSTA1,ITYP(N),ICTL(N),JN(M),NI(N2),ISTA(4),NODEU(3)
     &,NJ,NO,NO2,NO3,NEQS,NSTA,JSTA,IJ,IPERM,NTRAN,UPSRES,JUMP,LSTA,INF
      IF(ITYP(I).EQ.1) THEN
      IF(NTRAN) THEN
      BB=B(I)
      FMM=FM(I)
      ENDIF
      AR=(BB+FMM*YY)*YY
      IF(IPERM) THEN
      PERM=BB+2.*YY*SQRT(1.+FMM*FMM)
      TOPW=BB+2.*FMM*YY
      ENDIF
      ELSE
      COSB=1.-2.*YY/BB
      BETA=ACOS(COSB)
      AR=.25*BB**2*(BETA-SIN(BETA)*COSB)
      IF(IPERM) THEN
      PERM=BETA*BB
      TOPW=BB*SIN(BETA)
      ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      PARAMETER (N=20,M=60,N2=12)
      LOGICAL*1 IPERM,NTRAN,UPSRES,JUMP,LSTA,INF
      REAL KL(N),L(N),LT(N),Y(1),DY(1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/FN(N),SO(N),L,LT,B(N),FM(N),DZ(N),KL,DB(N),DFM(N),YG(
     &N),QOUT(N),X(M),WSTA(3),CD(3),H,G2,G,CC,TOL,PERM,TOPW,YO,QN,Q2G,BB
     &,FMM,SQSTAR,XO,QSTA1,ITYP(N),ICTL(N),JN(M),NI(N2),ISTA(4),NODEU(3)
     &,NJ,NO,NO2,NO3,NEQS,NSTA,JSTA,IJ,IPERM,NTRAN,UPSRES,JUMP,LSTA,INF
      IF(XX.LE.L(IJ)) THEN
      NTRAN=.TRUE.
      DAX=0.
      ELSE
      NTRAN=.FALSE.
      FLEN=(XX-L(IJ))/LT(IJ)
      BB=B(IJ)+FLEN*DB(IJ)
      FMM=FM(IJ)+FLEN*DFM(IJ)
      DAX=Y(1)*(DB(IJ)+Y(1)*DFM(IJ))/LT(IJ)
      ENDIF
      AA=AR(IJ,Y(1))
      IF(LSTA) THEN
      IF(INF) THEN
      QQ=X(IJ)+(L(IJ)+LT(IJ)-XX)*CD(JSTA)
      FQ=(QQ/AA-WSTA(JSTA))*CD(JSTA)/(G*AA)-(.5*BB+FMM*Y(1)/3.)*(Y(1)/AA
     &)**2*DAX+QQ*CD(JSTA)/(G*AA**2)
      ELSE
      IF(Y(1).LT.WSTA(JSTA)) THEN
      QSTA=0.
      ELSE
      QSTA=CD(JSTA)*(Y(1)-WSTA(JSTA))**1.5
      ENDIF
      QQST=.5*(QSTA+QSTA1)
      QQ=X(IJ)+SQSTAR+ABS(XO-XX)*QQST
      FQ=QQ*QQST/(G*AA**2)
      ENDIF
      ELSE
      FQ=0.
      ENDIF
      A3=AA**3
      SF=QN*(ABS(PERM/AA)**.666666667/AA)**2
      DY(1)=(SO(IJ)-SF+DAX/A3+FQ)/(1.-Q2G*TOPW/A3)
      RETURN
      END