      WRITE(*,*)' Give: g,b,Yo,Vo,DelQ,(dqdt)1,(dqdt)2,X,XL,N,DELT,TEND'
      READ(*,*) G,B,Yo,Vo,DELQ,dqdt1,dqdt2,X,XL,N,DELT,TEND
      dqdtt1=dqdt1/B
      dqdtt2=dqdt2/B
      co=SQRT(G*Yo)
      VOCO=Vo-2.*co
      Qo=B*Vo*Yo
      sqo=Qo/B
      XLX=XL-X
      Qo2=Qo-DELQ
      sqo2=Qo2/B
      Vo2=Qo2/(B*Yo)
      VOCOD=-Vo2-2.*co
      DT=XLX/(co-Vo2)-X/(co+Vo)
      WRITE(3,105) co,Qo,Vo,VOCO,Qo2,Vo2,VOCOD,DT
105   FORMAT(' co=',F8.3,' Upstream: Qo=',F10.3,' Vo=',F8.3,' Vo+2co=',
     &F8.3,/,' Downstream: Qo=',F10.3,' Vo=',F8.3,' 2co-Vo=',F8.3,
     &' Dtime=',F7.1)
      qo2end=(Qo2+dqdt2*TEND)/B
      qo1end=(Qo+dqdt1*TEND)/B
      cu=co
      cd=co
      cua=1.02*co
      cda=.98*co
      tu=0.
      tariv=X/(Vo+co)
      DO 10 I=1,N+1
      td=DELT*FLOAT(I-1)
      IF(td.GT.DT) tu=td-DT
      NCT=0
      IF(td.LT.TEND) THEN
      qd=-(Qo2+dqdt2*td)/B
      ELSE
      qd=-qo2end
      ENDIF
      IF(tu.LT.TEND) THEN
      q=(Qo+dqdt1*tu)/B
      ELSE
      q=qo1end
      ENDIF 
      Yav=Yo
      Vav=Vo
      NCT=0
3     F=(cu**2/G)*(2.*cu+VOCO)-q
      F1=((cu+.001)**2/G)*(2.*(cu+.001)+VOCO)-q
      DF=(F1-F)/.001
      NCT=NCT+1
      DIF=F/DF
      cu=cu-DIF
      IF(ABS(DIF).LT. .0000001 .AND. NCT.LT.10) GO TO 3
      NCT=0
4     F=(cd**2/G)*(2.*cd+VOCOD)-qd
      F1=((cd+.001)**2/G)*(2.*(cd+.001)+VOCOD)-qd
      DF=(F1-F)/.001
      NCT=NCT+1
      DIF=F/DF
      cd=cd-DIF
      IF(cd.GT.co) cd=co-(cd-co)
      IF(ABS(DIF).LT. .0000001 .AND. NCT.LT.10) GO TO 4
7     IF(tu.LT.tariv) GO TO 6
      NCT=0
1     Yua=cua**2/G
      Vua=2.*cua+VOCO
      F=ABS(ABS(Yua*Vua)-sqo)/dqdtt1+X/(Vua+cua)-tu
      NCT=NCT+1
      IF(MOD(NCT,2).NE.0) THEN
      F1=F
      cu1=cua
      cua=1.001*cua
      GO TO 1
      ENDIF
      cua=cu1-F1*(cua-cu1)/(F-F1)
      IF(ABS(cua-cu1).GT. 1.E-8 .AND. NCT.LT.30) GO TO 1
      NCT=0
2     Yda=cda**2/G
      Vda=2.*cda+VOCOD
      F=ABS(ABS(Yda*Vda)-sqo2)/dqdtt2+XLX/(Vda+cda)-td
      NCT=NCT+1
      IF(MOD(NCT,2).NE.0) THEN
      F1=F
      cd1=cda
      cda=1.001*cda
      GO TO 2
      ENDIF
      cda=cd1-F1*(cda-cd1)/(F-F1)
      IF(cda.GT.co) cda=co-(cda-co)
      IF(ABS(cda-cd1).GT. 1.E-8 .AND. NCT.LT.30) GO TO 2
      IF(NCT.EQ.30) WRITE(*,*)' Did not converge',cda,cd1
      cav=.5*(cua+cda)
      Yup=cua**2/G
      Ydo=cda**2/G
      Yav=.5*(Yup+Ydo)
      Vup=2.*cua+VOCO
      Vdo=2.*cda+VOCOD
      Vav=.5*(Vup-Vdo)
      WRITE(4,110) tu,td,cua,cda,cav,Yup,Ydo,Yav,Vup,Vdo,Vav,Vav*Yav
110   FORMAT(2F6.1,10F8.3)
6     Yu=cu**2/g
      Vu=2.*cu+VOCO
      Yd=cd**2/G
      Vd=2.*cd+VOCOD
10    WRITE(3,100) tu,cu,Yu,Vu,q,td,cd,Yd,Vd,qd
100   FORMAT(2(F6.1,4F8.3),4F8.3)
      END
      