C Iteratively solve for subcr. or supercr. depth in a 
C Circular channel for a given E.  The program
C computes Yc and Ec and gives a minimum allowable E.
      PARAMETER (PI=3.14159265)
1     WRITE(*,*)' Give: Q,D,g & 1=SUBCR. or 2=SUPERCR.'
      READ(*,*) Q,D,g,ITYPE
      IF(Q.LT.1.E-5) STOP
      IF(ITYPE.EQ.1) THEN
      PII=2.*PI
      AW1=.95*D
      ELSE
      PII=4.*PI
      AW1=.8*D
      ENDIF
      YS=((Q/(.5*D))**2/g)**.3333333
      Yc=CRIT(Q,D,g,YS)
      BETA=ACOS(1.-2.*Yc/D)
      Ec=Yc+(Q/(.25*D*D*(BETA-COS(BETA)*SIN(BETA))))**2/(2.*g)
5     NCT=0
      WRITE(*,120) Yc,Ec
120   FORMAT(' Yc=',F8.3,' Ec=',F8.3,' Give E>Ec')
      READ(*,*) E
      E3=E/3.
2     AW=AW1
      qs=Q/AW
      THETA=ACOS(((6.75*qs*qs/g-E**3)/27.)/E3**3)
      Y=E3*(1.-2.*COS((THETA+PII)/3.))
      NCT=NCT+1
      BETA=ACOS(1.-2.*Y/D)
      AW1=D*D*(BETA-COS(BETA)*SIN(BETA))/(4.*Y)
      WRITE(*,*) NCT,AW,AW1,qs
      IF(ABS(AW1-AW).GT.1.E-4 .AND. NCT.LT.40) GO TO 2
      WRITE(6,100) Q,D,E,g,Y
100   FORMAT(' Q=',F8.3,' D=',F8.3,' E=',F8.3,' g=',F8.2,
     &' Depth Y=',F9.3)
      WRITE(6,130)
130   FORMAT(/,' Give: 0=STOP, 1=Dif. E but same size, 2=Dif. size')
      READ(*,*) NCT
      IF(NCT.EQ.1) THEN
      GO TO 5
      ELSE IF(NCT.EQ.2) THEN
      GO TO 1
      ELSE
      STOP
      ENDIF
      END
      FUNCTION CRIT(Q,D,g,YS)
      M=0
1     BETA=ACOS(1.-2.*YS/D)
      F=Q*Q*(D*SIN(BETA))-g*(.25*D*D*(BETA-COS(BETA)*SIN(BETA)))**3
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      F1=F
      YS1=YS
      YS=1.005*YS
      GO TO 1
      ENDIF
      DIF=(YS-YS1)*F1/(F-F1)
      YS=YS1-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 1
      CRIT=YS
      RETURN
      END
