      PARAMETER (PI=3.14159265)
      PI2=2.*PI
      PI4=4.*PI
      WRITE(3,100) 
100   FORMAT(' Using cubic Eq. for dimensionless Momentum Function'/,
     &'  m''    Y1m''   Y2m''   Y3m''    Y1e''   Y2e''   Y3e''')
      WRITE(4,105)
105   FORMAT(' Using cubic Eq. for dimensionless cubic Energy Equation'/
     &,'  E''    Y1e''   Y2e''   Y3e''    Y1m''   Y2m''   Y3m''')
      DO 10 I=0,20
      E=1.5+.05*FLOAT(I)
      F=E
      E3=E/3.
      FACM=-1.632993*SQRT(F)
      T=ACOS((1.5/F)**1.5)
      Y1M=FACM*COS(T/3.)
      Y2M=FACM*COS((T+PI2)/3.)
      Y3M=FACM*COS((T+PI4)/3.)
      THETA=ACOS(((6.75-E**3)/27.)/E3**3)
      Y1E=E3*(1.-2.*COS(THETA/3.))
      Y2E=E3*(1.-2.*COS((THETA+PI2)/3.))
      Y3E=E3*(1.-2.*COS((THETA+PI4)/3.))
      WRITE(3,110) F,Y1M,Y2M,Y3M,1./Y1E,1./Y3E,1./Y2E
10    WRITE(4,110) E,Y1E,Y2E,Y3E,1./Y1M,1./Y3M,1./Y2M
110   FORMAT(F5.2,2(F8.4,2F7.4))
      END