C Solves 3 roots from the momentum function iteratively adjusting q & m
C Same as Program ROOTMTR.FOR with critical depth Yc computed and printed
      PARAMETER (PI=3.14159265)
1     WRITE(*,*)' Give: Q,b,m,g,0=subcr. or 1=supercr.'
      READ(*,*) Q,B,FM,g,ITYPE
      IF(Q.LT.1.E-5) STOP
      Q2G=Q**2/G
      YS=((Q/B)**2/g)**.3333333
      Yc=CRIT(Q,B,FM,g,YS)
      Ac=(B+FM*Yc)*Yc
      FMc=.5*B*Yc*Yc+FM*Yc**3/3.+Q**2/(g*Ac)
5     WRITE(*,120) Yc,FMc,FMc
120   FORMAT(' Yc=',F8.3,' Momc=',F8.3,' Give Mom>',F8.3)
      READ(*,*) FTOT
      IF(ITYPE.EQ.0) THEN
      PII=2.*PI
      YY=(FTOT/FMc)*Yc
      ELSE
      PII=4.*PI
      YY=(FMc/FTOT)*Yc
      ENDIF
      NCT=0
8     Y=YY
      Bav=B+FM*Y
      C=Bav/(B+.6666667*FM*Y)
      qg=C*(Q/Bav)**2/g
      F=C*FTOT/Bav
      FF=2.*SQRT(.6666667*F)
      THETA=ACOS(qg/(.6666667*f)**1.5)
      YY=-FF*COS((THETA+PII)/3.)
      NCT=NCT+1
      WRITE(*,*) NCT,YY,Y
      IF(ABS(Y-YY).GT. 1.E-4 .AND. NCT.LT.30) GO TO 8
      WRITE(6,100)Q,B,FM,FTOT,g,YY,SQRT(Q2G*(B+2.*FM*YY)/((B+FM*YY)*YY)
     &**3)
100   FORMAT(' Q=',F8.3,' b=',F8.3,' m=',F8.2,/,' Mom=',F8.3,' g=',F8.2,
     &/,' Depth=',F9.3,' Froude No.=',F8.2,/)
      WRITE(6,130)
130   FORMAT(/,' Give: 0=STOP, 1=Dif. Mom. but same size, 2=Dif. size')
      READ(*,*) NCT
      IF(NCT.EQ.1) THEN
      GO TO 5
      ELSE IF(NCT.EQ.2) THEN
      GO TO 1
      ELSE
      STOP
      ENDIF
      END
      FUNCTION CRIT(Q,B,FM,g,YS)
      M=0
1     F=Q*Q*(B+2.*FM*YS)-g*((B+FM*YS)*YS)**3
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      F1=F
      YS1=YS
      YS=1.005*YS
      GO TO 1
      ENDIF
      DIF=(YS-YS1)*F1/(F-F1)
      YS=YS1-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 1
      CRIT=YS
      RETURN
      END