C Iteratively solve for subcr. or supercr. depth in a 
C trapezoidal channel for a given E.  The different between this program
C and ROOTSTR is that it computes Yc and Ec and gives a minimum allowable E.
      PARAMETER (PI=3.14159265)
1     WRITE(*,*)' Give: Q,b,m,g & 1=SUBCR. or 2=SUPERCR.'
      READ(*,*) Q,B,FM,g,ITYPE
      IF(Q.LT.1.E-5) STOP
      YS=((Q/B)**2/g)**.3333333
      Yc=CRIT(Q,B,FM,g,YS)
      Ec=Yc+(Q/((B+FM*Yc)*Yc))**2/(2.*g)
      WRITE(*,120) Yc,Ec
120   FORMAT(' Yc=',F8.3,' Ec=',F8.3,' Give E>Ec')
5     READ(*,*) E
      NCT=0
      IF(ITYPE.EQ.1) THEN
      PII=2.*PI
      ELSE
      PII=4.*PI
      ENDIF
      AW1=(1.+.5*FM)*B
      E3=E/3.
2     AW=AW1
      qs=Q/AW
      THETA=ACOS(((6.75*qs*qs/g-E**3)/27.)/E3**3)
      Y=E3*(1.-2.*COS((THETA+PII)/3.))
      NCT=NCT+1
      AW1=B+FM*Y
C      WRITE(*,*) NCT,AW,AW1,qs
      IF(ABS(AW1-AW).GT.1.E-4 .AND. NCT.LT.40) GO TO 2
      WRITE(6,100) Q,B,FM,E,g,Y
100   FORMAT(' Q=',F8.3,' b=',F8.3,' m=',F8.2,/,' E=',F8.3,' g=',F8.2,
     &' Depth Y=',F9.3)
      WRITE(6,130)
130   FORMAT(/,' Give: 0=STOP, 1=Dif. E but same size, 2=Dif. size')
      READ(*,*) NCT
      IF(NCT.EQ.1) THEN
      GO TO 5
      ELSE IF(NCT.EQ.2) THEN
      GO TO 1
      ELSE
      STOP
      ENDIF
      END
      FUNCTION CRIT(Q,B,FM,g,YS)
      M=0
1     F=Q*Q*(B+2.*FM*YS)-g*((B+FM*YS)*YS)**3
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      F1=F
      YS1=YS
      YS=1.005*YS
      GO TO 1
      ENDIF
      DIF=(YS-YS1)*F1/(F-F1)
      YS=YS1-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 1
      CRIT=YS
      RETURN
      END
