      PARAMETER (N=3)
      INTEGER*2 ITYP(N)
      REAL F(N),F1(N),D(N,N),KL1,KE1,Yo(2)
      COMMON /TRAS/Q,FM1,B2,H,G2,KL1,KE1,FL,TOL,e,C,SO,SQG,QV4,SG,Q2G
     &,Yd,Ad,FMS,FM2,X(3),Ed,A,Rh
      WRITE(*,*)' Give kinematic viscosity'
      READ(*,*) VISC
      WRITE(*,*)' Give:Q,m1,e,So,H,Ke,KL,g,L,b2,TOL,ERR,Cc,Yg1,dYg,N'
      READ(*,*) Q,FM1,e,SO,H,KE1,KL1,G,FL,B2,TOL,ERR,CC,YG1,DYG,NGATE
      e=e/12. 
      FM2=2.*FM1
      FMS=2.*SQRT(FM1*FM1+1.)
      G2=2.*G
      Q2G=Q**2/G2
      KL1=1.+KL1
      KE1=1.+KE1
      WRITE(*,*)' Give guess for: b1,Y1 & Y2'
      READ(*,*) X
      SG=SQRT(G)
      SQG=-SQRT(32.*G)
      QV4=4.*Q/VISC
      C=SQG*ALOG10(e/(((X(1)+FM1*X(2))*X(2))/(X(1)+FM2*X(2))))
      Yo(1)=.98*X(2)
      Yo(2)=.9*X(1)
      CALL OPEN(Yo)
      WRITE(3,110) H,KE1-1.,Q,FM1,12.*e,SO,B2,KL1-1.,FL,Yo
110   FORMAT(' H =',F7.1,', Ke =',F6.3,', Q =',F8.1,', m1 =',F7.2,', e =
     &',F8.4,',',/,' So =',F9.6,', b2 =',F8.1,', KL =',F6.3,', L =',F8.1
     &,/,' No gate-Uniform Flow: Yo =',F8.3,', bo =',F9.3,/1X,77('-'),/,
     &4X,'YG',4X,'Yd',7X,'b',6X,'Y1',6X,'Y2',6X,'Yu',6X,'Yo',6X,'Yc',
     &6X,'Cd',6X,'Cu'/,1X,77('-') )
      DO 50 KK=1,NGATE
      YG=YG1+DYG*FLOAT(KK-1)
      Yd=CC*YG
      Ad=(B2*Yd)**2
      Ed=Yd+KL1*Q2G/Ad
      NCT=0
1     SUM=0.
      CALL FUN(F1)
      DO 10 J=1,N
      XX=X(J)
      X(J)=1.005*X(J)
      CALL FUN(F)
      DO 5 I=1,N
5     D(I,J)=(F(I)-F1(I))/(X(J)-XX)
10    X(J)=XX
      CALL SOLVEQ(N,1,N,D,F1,1,DET,ITYP)
      DO 15 I=1,N
      IF(F1(I).GT. 0. .AND. F1(I).GT. .5*X(I)) THEN
      X(I)=X(I)-.25*F1(I)
      IF(X(I).LT. 0.) X(I)=ABS(X(I))
      ELSE
      X(I)=X(I)-F1(I)
      ENDIF
15    SUM=SUM+ABS(F1(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM
      IF(SUM.GT.ERR .AND. NCT.LT.20) GO TO 1
      IF(NCT.EQ.20) WRITE(*,*)' Did not Converge',SUM
50    WRITE(3,100) YG,CC*YG,X,YGATE(),YNORM(),((Q/B2)**2/G)**.33333333,
     &CHEZYC(X(2),X(1)),CHEZYC(X(3),X(1))
100   FORMAT(2F7.2,F8.2,5F8.3,2F8.2)
      END
      SUBROUTINE FUN(F)
      REAL F(3),KL1,KE1,Y(1),YW(1)
      COMMON /TRAS/Q,FM1,B2,H,G2,KL1,KE1,FL,TOL,e,C,SO,SQG,QV4,SG,Q2G
     &,Yd,Ad,FMS,FM2,X(3),Ed,A,Rh
      F(1)=H-X(2)-KE1*Q2G/((X(1)+FM1*X(2))*X(2))**2
      F(2)=X(3)+Q2G/((X(1)+FM1*X(3))*X(3))**2-Ed
      Y(1)=X(3)
      DXS=-1.
      CALL RUKUST(1,DXS,FL,0.,TOL,Y,YW)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE SLOPE(XX,Y,DY)
      REAL Y(1),DY(1),KL1,KE1
      COMMON /TRAS/Q,FM1,B2,H,G2,KL1,KE1,FL,TOL,e,C,SO,SQG,QV4,SG,Q2G
     &,Yd,Ad,FMS,FM2,X(3),Ed,A,Rh
      SF=(Q/(CHEZYC(ABS(Y(1)),X(1))*A))**2/Rh
      DY(1)=(SO-SF)/(1.-.5*Q2G*(X(1)+FM2*Y(1))/A**3)
      RETURN
      END
      FUNCTION YNORM()
      COMMON /TRAS/Q,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,e,C,SO,SQG,QV4,SG,Q2G
     &,Yd,Ad,FMS,FM2,X(3),Ed,A,Rh
      Y=X(2)
      M=0
1     QQ=CHEZYC(Y,X(1))*A*SQRT(SO*Rh)
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 3
      Y1=Y
      Y=1.005*Y
      F=Q-QQ
      GO TO 1
3     DIF=(Y-Y1)*F/(Q-QQ-F)
      Y=Y1-DIF
      IF(ABS(DIF).GT. .000001 .AND. M.LT.40) GO TO 1
      IF(M.EQ.40) WRITE(*,*) ' YNORM failed to converge'
      YNORM=Y
      RETURN
      END
      FUNCTION YGATE()
      COMMON /TRAS/Q,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,e,C,SO,SQG,QV4,SG,Q2G
     &,Yd,Ad,FMS,FM2,X(3),Ed,A,Rh
      M=0
      Y=.95*X(3)
1     F=Y+Q2G/(B2*Y)**2-Ed
      Y1=1.005*Y
      DIF=(Y1-Y)*F/(Y1+Q2G/(B2*Y1)**2-Ed-F)
      Y=Y-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' YGATE failed to converge'
      YGATE=Y
      RETURN 
      END
      SUBROUTINE OPEN(Yo)
      COMMON /TRAS/Q,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,e,C,SO,SQG,QV4,SG,Q2G
     &,Yd,Ad,FMS,FM2,X(3),Ed,A,Rh
      REAL DJ(2,2),F1(2),F2(2),Yo(2)
      INTEGER*2 ITYP(2)
      M=0
      QNS=Q/SQRT(SO)
1     A=(Yo(2)+FM1*Yo(1))*Yo(1)
      F1(1)=QNS-CHEZYC(Yo(1),Yo(2))*A*SQRT(Rh)
      F1(2)=H-Yo(1)-Q2G*FKE1/A**2
      DO 4 J=1,2
      YOO=Yo(J)
      Yo(J)=1.005*Yo(J)
      A=(Yo(2)+FM1*Yo(1))*Yo(1)
      F2(1)=QNS-CHEZYC(Yo(1),Yo(2))*A*SQRT(Rh)
      F2(2)=H-Yo(1)-Q2G*FKE1/A**2
      DO 2 I=1,2
2     DJ(I,J)=(F2(I)-F1(I))/(Yo(J)-YOO)
4     Yo(J)=YOO
      CALL SOLVEQ(2,1,2,DJ,F1,1,DET,ITYP)
      Yo(1)=Yo(1)-F1(1)
      Yo(2)=Yo(2)-F1(2)
      M=M+1
      IF(ABS(F1(1))+ABS(F1(2)).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' OPEN failed to converge'
      RETURN
      END
      FUNCTION CHEZYC(YY,B)
      COMMON /TRAS/Q,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,e,C,SO,SQG,QV4,SG,Q2G
     &,Yd,Ad,FMS,FM2,X(3),Ed,A,Rh
      A=(B+FM1*YY)*YY
      P=B+FM2*YY
      Rh=A/P
1     C1=C
      C=SQG*ALOG10(e/Rh+.884*C/(SG*QV4/P))
      IF(ABS(C-C1).GT. 1.E-4) GO TO 1
      CHEZYC=C
      RETURN
      END