      PARAMETER (N=3)
      INTEGER*2 ITYP(N)
      REAL F(N),F1(N),D(N,N),KL1,KE1,Y(1),YW(1),XPREV(N)
      COMMON /TRAS/B1,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS
      WRITE(*,*)' Give:b1,m1,n,So,H,Ke,KL,g,L,b2,TOL,ERR,Cc,Yg1,dYg,N,DS
     &o,NS'
      READ(*,*) B1,FM1,FN,SO1,H,KE1,KL1,G,FL,B2,TOL,ERR,CC,YG1,DYG,NGATE
     &,DSo,NS
      CU=1.486
      DXS=1.
      FM2=2.*FM1
      FMS=2.*SQRT(FM1*FM1+1.)
      IF(G.LT. 30.) CU=1.
      G2=2.*G
      KL1=1.+KL1
      KE1=1.+KE1
      WRITE(*,*)' Give guess for: Q,Y1 & Y2'
      READ(*,*) X
      Yo=.98*X(2)
      CALL OPEN(Yo,Qo)
      WRITE(3,110) H,KE1-1.,B1,FM1,FN,SO1,B2,KL1-1.,FL,Yo,Qo
110   FORMAT(' H =',F7.1,', Ke =',F6.3,', b1 =',F8.1,', m1 =',F7.2,', n 
     &=',F8.4,',',/,' So =',F9.6,', b2 =',F8.1,', KL =',F6.3,', L =',F8.
     &0,/,' No gate-Uniform Flow: Yo =',F8.3,', Qo =',F8.2,/1X,92('-')
     &,/,4X,'So',6X,'YG',4X,'Yd    Frd',5X,'Q',6X,'Y1',6X,'Y2',
     &6X,'Yu    Fru',4X,'Yo',6X,'Yc','   Volume Del Vol.'/,1X,92('-') )
      DELL=FL/10.
      DELL5=.5*DELL
      DV=0.
      DO 51 KK=1,NGATE
      YG=YG1+DYG*FLOAT(KK-1)
      Yd=CC*YG
      Ad=(B2*Yd)**2
      IF(KK.EQ.1) GO TO 3
      DO 2 I=1,N
2     X(I)=XPREV(I)
3     DO 50 KI=1,NS
      SO=SO1+DSO*FLOAT(KI-1)
      WRITE(4,111) SO
111   FORMAT(/' So =',F10.6)
      NCT=0
1     SUM=0.
      CALL FUN(F1)
      DO 10 J=1,N
      XX=X(J)
      X(J)=1.005*X(J)
      CALL FUN(F)
      DO 5 I=1,N
5     D(I,J)=(F(I)-F1(I))/(X(J)-XX)
10    X(J)=XX
      CALL SOLVEQ(N,1,N,D,F,1,DET,ITYP)
      DO 15 I=1,N
      X(I)=X(I)-F(I)
15    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      IF(SUM.GT.ERR .AND. NCT.LT.20) GO TO 1
      IF(NCT.EQ.20) WRITE(*,*)' Did not Converge',SUM
      YGA=YGATE(X(1))
      YNOR=YNORM(X(1))
      FRD=SQRT((X(1)/B2)**2/(G*Yd**3))
      FRU=SQRT((X(1)/B2)**2/(G*YGA**3))
      X1=FL
      Y(1)=X(2)
      A=B2*YGA
      A1=(B1+FM1*X(2))*X(2)
      WRITE(4,201)
201   FORMAT('    x         Y        E       M      VOL.')    
      WRITE(4,200) X1,Y,Y(1)+(X(1)/A)**2/G2,.5*YGA**2+X(1)**2/(G*A),0
200   FORMAT(F8.2,3F9.3,I7)
      VOL=10.*(A+A1)
      DO 18 K=1,10
      X2=FL-DELL*FLOAT(K)
      CALL RUKUST(1,DXS,X1,X2,TOL,Y,YW)
      A=(B1+FM1*Y(1))*Y(1)
      VOL=VOL+DELL5*(A+A1)
      WRITE(4,200) X2,Y,Y(1)+(X(1)/A)**2/G2,.5*YGA**2+X(1)**2/(G*A),
     &INT4(VOL+.5)
18    X1=X2
      IF(KK.GT.1) DV=VOL-VOL1
      WRITE(3,100) SO,YG,CC*YG,FRD,X,YGA,FRU,YNOR,((X(1)/B2)**2/G)**
     &.3333333,INT4(VOL+.5),INT4(DV+.5)
      DO 19 I=1,N
19    XPREV(I)=X(I)
50    VOL1=VOL
51    WRITE(3,'(1X)')
100   FORMAT(F8.5,2F7.2,F5.2,F8.2,3F8.3,F5.2,2F8.3,I7,I6)
      END
      SUBROUTINE FUN(F)
      REAL F(3),KL1,KE1,Y(1),YW(1)
      COMMON /TRAS/B1,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS
      QN=(FN*X(1)/CU)**2
      Q2G=X(1)**2/G2
      F(1)=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      F(2)=X(3)+Q2G/((B1+FM1*X(3))*X(3))**2-Yd-KL1*Q2G/Ad
      Y(1)=X(3)
      CALL RUKUST(1,DXS,FL,0.,TOL,Y,YW)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE SLOPE(XX,Y,DY)
      REAL Y(1),DY(1),KL1,KE1
      COMMON /TRAS/B1,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS
      AREA=(B1+FM1*Y(1))*Y(1)
      SF=QN*(B1+FMS*Y(1))**1.33333333/AREA**3.3333333
      DY(1)=(SO-SF)/(1.-.5*Q2G*(B1+FM2*Y(1))/AREA**3)
      RETURN
      END
      FUNCTION YNORM(Q)
      COMMON /TRAS/B1,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS
      QQ=CU*SQRT(SO)/FN
      Y=X(2)
      M=0
1     F=Q-QQ*((B1+FM1*Y)*Y)**1.6666667/(B1+FMS*Y)**.666667
      Y1=1.005*Y
      DIF=(Y1-Y)*F/(Q-QQ*((B1+FM1*Y1)*Y1)**1.6666667/(B1+FMS*Y1)
     &**.666667-F)
      Y=Y-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' YNORM failed to converge'
      YNORM=Y
      RETURN
      END
      FUNCTION YGATE(Q)
      COMMON /TRAS/B1,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS
      M=0
      Y=.9*X(3)
      QQ=Q**2/G2
      ED=FKL1*QQ/Ad+Yd
1     F=Y+QQ/(B2*Y)**2-ED
      Y1=1.005*Y
      DIF=(Y1-Y)*F/(Y1+QQ/(B2*Y1)**2-ED-F)
      Y=Y-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' YGATE failed to converge'
      YGATE=Y
      RETURN 
      END
      SUBROUTINE OPEN(Yo,Qo)
      COMMON /TRAS/B1,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),DXS
      M=0
      QQ=Cu*SQRT(SO)/FN
1     AREA=(B1+FM1*Yo)*Yo
      Qo=QQ*AREA**1.66666667/(B1+FMS*Yo)**.66666667
      F=H-Yo-FKE1*(Qo/AREA)**2/G2
      Y1=1.005*Yo
      A=(B1+FM1*Y1)*Y1
      DIF=(Y1-Yo)*F/(H-Y1-FKE1*(QQ*A**1.6666667/(B1+FMS*Y1)**.6666667/A
     &)**2/G2-F)
      Yo=Yo-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' OPEN failed to converge'
      Qo=QQ*AREA**1.66666667/(B1+FMS*Yo)**.66666667
      RETURN
      END