      PARAMETER (N=3)
      INTEGER*2 ITYP(N)
      REAL F(N),F1(N),D(N,N),KL1,KE1,Yo(2)
      COMMON /TRAS/Q,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),Ed
      WRITE(*,*)' Give:Q,m1,n,So,H,Ke,KL,g,L,b2,TOL,ERR,Cc,Yg1,dYg,N'
      READ(*,*) Q,FM1,FN,SO,H,KE1,KL1,G,FL,B2,TOL,ERR,CC,YG1,DYG,NGATE
      CU=1.486
      FM2=2.*FM1
      FMS=2.*SQRT(FM1*FM1+1.)
      IF(G.LT. 30.) CU=1.
      G2=2.*G
      QN=(FN*Q/CU)**2
      Q2G=Q**2/G2
      KL1=1.+KL1
      KE1=1.+KE1
      WRITE(*,*)' Give guess for: b1,Y1 & Y2'
      READ(*,*) X
      Yo(1)=.98*X(2)
      Yo(2)=.9*X(1)
      CALL OPEN(Yo)
      WRITE(3,110) H,KE1-1.,Q,FM1,FN,SO,B2,KL1-1.,FL,Yo
110   FORMAT(' H =',F7.1,', Ke =',F6.3,', Q =',F8.1,', m1 =',F7.2,', n =
     &',F8.4,',',/,' So =',F9.6,', b2 =',F8.1,', KL =',F6.3,', L =',F8.1
     &,/,' No gate-Uniform Flow: Yo =',F8.3,', bo =',F9.3,/1X,61('-'),/,
     &4X,'YG',4X,'Yd',7X,'b',6X,'Y1',6X,'Y2',6X,'Yu',6X,'Yo',6X,'Yc',/,
     &1X,61('-') )
      DO 50 KK=1,NGATE
      YG=YG1+DYG*FLOAT(KK-1)
      Yd=CC*YG
      Ad=(B2*Yd)**2
      Ed=Yd+KL1*Q2G/Ad
      NCT=0
1     SUM=0.
      CALL FUN(F1)
      DO 10 J=1,N
      XX=X(J)
      X(J)=1.005*X(J)
      CALL FUN(F)
      DO 5 I=1,N
5     D(I,J)=(F(I)-F1(I))/(X(J)-XX)
10    X(J)=XX
      CALL SOLVEQ(N,1,N,D,F1,1,DET,ITYP)
      DO 15 I=1,N
      IF(F1(I).GT. 0. .AND. F1(I).GT. .5*X(I)) THEN
      X(I)=X(I)-.25*F1(I)
      IF(X(I).LT. 0.) X(I)=ABS(X(I))
      ELSE
      X(I)=X(I)-F1(I)
      ENDIF
15    SUM=SUM+ABS(F1(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM
      IF(SUM.GT.ERR .AND. NCT.LT.20) GO TO 1
      IF(NCT.EQ.20) WRITE(*,*)' Did not Converge',SUM
50    WRITE(3,100) YG,CC*YG,X,YGATE(),YNORM(),((Q/B2)**2/G)**.33333333
100   FORMAT(2F7.2,F8.2,5F8.3)
      END
      SUBROUTINE FUN(F)
      REAL F(3),KL1,KE1,Y(1),YW(1)
      COMMON /TRAS/Q,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),Ed
      F(1)=H-X(2)-KE1*Q2G/((X(1)+FM1*X(2))*X(2))**2
      F(2)=X(3)+Q2G/((X(1)+FM1*X(3))*X(3))**2-Ed
      Y(1)=X(3)
      DXS=-1.
      CALL RUKUST(1,DXS,FL,0.,TOL,Y,YW)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE SLOPE(XX,Y,DY)
      REAL Y(1),DY(1),KL1,KE1
      COMMON /TRAS/Q,FM1,B2,H,G2,KL1,KE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),Ed
      AREA=(X(1)+FM1*Y(1))*Y(1)
      SF=QN*(X(1)+FMS*Y(1))**1.33333333/AREA**3.3333333
      DY(1)=(SO-SF)/(1.-.5*Q2G*(X(1)+FM2*Y(1))/AREA**3)
      RETURN
      END
      FUNCTION YNORM()
      COMMON /TRAS/Q,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),Ed
      QQ=CU*SQRT(SO)/FN
      Y=X(2)
      M=0
1     F=Q-QQ*((X(1)+FM1*Y)*Y)**1.6666667/(X(1)+FMS*Y)**.666667
      Y1=1.005*Y
      DIF=(Y1-Y)*F/(Q-QQ*((X(1)+FM1*Y1)*Y1)**1.6666667/(X(1)+FMS*Y1)
     &**.666667-F)
      Y=Y-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' YNORM failed to converge'
      YNORM=Y
      RETURN
      END
      FUNCTION YGATE()
      COMMON /TRAS/Q,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),Ed
      M=0
      Y=.95*X(3)
1     F=Y+Q2G/(B2*Y)**2-Ed
      Y1=1.005*Y
      DIF=(Y1-Y)*F/(Y1+Q2G/(B2*Y1)**2-Ed-F)
      Y=Y-DIF
      M=M+1
      IF(ABS(DIF).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' YGATE failed to converge'
      YGATE=Y
      RETURN 
      END
      SUBROUTINE OPEN(Yo)
      COMMON /TRAS/Q,FM1,B2,H,G2,FKL1,FKE1,FL,TOL,FN,SO,CU,QN,Q2G,Yd,
     & Ad,FMS,FM2,X(3),Ed
      REAL DJ(2,2),F1(2),F2(2),Yo(2)
      INTEGER*2 ITYP(2)
      M=0
      QNS=FN*Q/(CU*SQRT(SO))
1     A=(Yo(2)+FM1*Yo(1))*Yo(1)
      F1(1)=QNS-A*(A/(Yo(2)+FMS*Yo(1)))**.6666667
      F1(2)=H-Yo(1)-Q2G*FKE1/A**2
      DO 4 J=1,2
      YOO=Yo(J)
      Yo(J)=1.005*Yo(J)
      A=(Yo(2)+FM1*Yo(1))*Yo(1)
      F2(1)=QNS-A*(A/(Yo(2)+FMS*Yo(1)))**.6666667
      F2(2)=H-Yo(1)-Q2G*FKE1/A**2
      DO 2 I=1,2
2     DJ(I,J)=(F2(I)-F1(I))/(Yo(J)-YOO)
4     Yo(J)=YOO
      CALL SOLVEQ(2,1,2,DJ,F1,1,DET,ITYP)
      Yo(1)=Yo(1)-F1(1)
      Yo(2)=Yo(2)-F1(2)
      M=M+1
      IF(ABS(F1(1))+ABS(F1(2)).GT. .000001 .AND. M.LT.20) GO TO 1
      IF(M.EQ.20) WRITE(*,*) ' OPEN failed to converge'
      RETURN
      END