C Solves problem of flow into a mild channel from a reservoir. Another 
C reservoir exists at the downstream end of the channel with Y2=H2
      EXTERNAL DYX
      REAL F(2),D(2,2),X(2),W(1,13),KE,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,FM,H,H2,G,G2,KE,FL,TOL,FN,SO,Q2G,X,FM2,FMS,QN,CC
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B,FM,H,L,g,H2,KE'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B,FM,H,FL,G,H2,KE
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KE=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Y1'
      READ(*,*) X
      NCT=0
1     DO 10 I=1,2
      F(I)=FUN(I)
      DO 10 J=1,2
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      F(2)=F(2)-FAC*F(1)
      DIF1=F(2)/D(2,2)
      X(2)=X(2)-DIF1
      SUM=ABS(DIF1)
      DIF=(F(1)-D(1,2)*DIF1)/D(1,1)
      SUM=SUM+ABS(DIF)
      X(1)=X(1)-DIF
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM,X
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,100) X
100   FORMAT(' Q =',F10.2,' Y1 =',F10.3)
      WRITE(*,*)' Give No. of Pts for profile'
      READ(*,*) N
      IF(N.LT.2) STOP
      DELX=FL/FLOAT(N)
      Y(1)=H2
      H1=-.01
      HMIN=.00001
      XX=FL
      QN=(FN*X(1)/CC)**2
      Q2G=2.*Q2G
      WRITE(IOUT,110) FL,H2
17    XZ=XX-DELX
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      WRITE(IOUT,110) XZ,Y
110   FORMAT(F8.1,F8.3)
      XX=XZ
      IF(XZ.GT.0.) GO TO 17
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(2),W(1,13),KE,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,FM,H,H2,G,G2,KE,FL,TOL,FN,SO,Q2G,X,FM2,FMS,QN,CC
      Q2G=X(1)**2/G2
      GO TO (1,2),II
1     FUN=H-X(2)-KE*Q2G/((B+FM*X(2))*X(2))**2
      RETURN
2     Y(1)=H2
      H1=-.01
      HMIN=.00001
      XX=FL
      XZ=0.
      QN=(FN*X(1)/CC)**2
      Q2G=2.*Q2G
      CALL ODESOL(Y,DY,1,FL,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KE,X(2)
      COMMON /TRAS/B,FM,H,H2,G,G2,KE,FL,TOL,FN,SO,Q2G,X,FM2,FMS,QN,CC
      P=B+FMS*Y(1)
      A=(B+FM*Y(1))*Y(1)
      SF=QN*((P/A)**.666666667/A)**2
      DY(1)=(SO-SF)/(1.-Q2G*(B+FM2*Y(1))/A**3)
      RETURN
      END