C  Program to solve jump between two known depths. Q also known. 
C Unknowns are conjugates depth across jump and its position x.  
C  The trapezoidal channel can be nonprismatic, i.e. db/dx & dm/dx are given.
      PARAMETER (N=3)
      EXTERNAL DYX
      CHARACTER*3 UNK(N)/'Y2u','Y2d','x  '/
      REAL F(N),F1(N),D(N,N),X(N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,FN,So,FL,G,G2,TOL,CC,QN,X,Y1,Y3,QSG,Q,DB,DM
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,b1,m1,n,So,L,Q,Y1,Y3,g,db/dx,dm/dx'
      READ(*,*) IOUT,TOL,ERR,B1,FM1,FN,So,FL,Q,Y1,Y3,G,DB,DM
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      QSG=Q*Q/G
      QN=(FN*Q/CC)**2
      WRITE(*,*)' GIVE guess for:'
      DO 2 I=1,N
      WRITE(*,3) UNK(I)
2     READ(*,*) X(I)
3     FORMAT(1X,A3,' =',\)
50    NCT=0
1     CALL FUN(F)
      DO 10 J=1,N
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(F1)
      DO 5 I=1,N
5     D(I,J)=(F1(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(N,1,N,D,F,1,DD,INDX)
      SUM=0.
      DO 15 I=1,N
      X(I)=X(I)-F(I)
15    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I2,' SUM=',E12.5,3F10.4)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,*)' Solution:'
      DO 20 I=1,N
20    WRITE(IOUT,100) UNK(I),X(I)
100   FORMAT(1X,A3,' =',F10.3)
      END
      SUBROUTINE FUN(F)
      EXTERNAL DYX
      REAL X(3),F(3),W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,FN,So,FL,G,G2,TOL,CC,QN,X,Y1,Y3,QSG,Q,DB,DM
      HMIN=.00001
      DO 10 I=1,2
      IF(I.EQ.1) THEN
      H1=1.
      XX=0.
      YY=X(1)
      Y(1)=Y1
      ELSE
      H1=-1.
      XX=FL
      YY=X(2)
      Y(1)=Y3
      ENDIF
      XZ=X(3)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
10    F(I)=YY-Y(1)
      B=B1+DB*X(3)
      FM=FM1+DM*X(3)
      F(3)=.5*B*(X(1)**2-X(2)**2)+FM*(X(1)**3-X(2)**3)/3.+QSG*(1./((B+
     &FM*X(1))*X(1))-1./((B+FM*X(2))*X(2)))
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(3)
      COMMON /TRAS/B1,FM1,FN,So,FL,G,G2,TOL,CC,QN,X,Y1,Y3,QSG,Q,DB,DM
      YY=Y(1)
      B=B1+XX*DB
      FM=FM1+XX*DM
      A=(B+FM*YY)*YY
      RRH=(B+2.*SQRT(FM*FM+1.)*YY)/A
      A3=A**3
      QDA=QSG/A3*((DB+DM*YY)*YY)
      DY(1)=(So-QN*(RRH**.6666667/A)**2+QDA)/(1.-QSG*(B+2.*FM*YY)/A3)
      RETURN
      END