      PARAMETER (N2=8,N=12,M=36)
      LOGICAL*2 IPERM,NTRAN
      REAL F(M),F1(M),D(M,M),FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),
     &X(M),QOUT(N2),LT
      INTEGER*2 INDX(M),ITYP(N),ICTL
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/NJ,NO,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M)
      DATA IN,IOUT/2,3/
      IPERM=.FALSE.
      NTRAN=.TRUE.
C NJ=No. of Junctions, NO=No. channels
C  ITYP = 1 for trapezoidal channels, otherwise channel is circular.
C ICTL = 1,2 OR 3 for types of downstream controls, gate=1,critical=2,
C reser=3.  YG is depth behind gate for gate; = 0 for critical;res. depth if
C reservoir.   DB and DFM are changes (+ or -) across transition of b and m.
C IN UNKNOWN VECTOR X (NO-1) Q's COMES 1ST; (NO) UPSTREAM DEPTHS NEXT & 
C NO DOWNSTREAM DEPTHS 
C i.e. Q(I)=X(I) for I=1 to NO;YU(I)=X(I+NO) for I=1 to NO; 
C YD(I)=X(I+2*NO) for I=1 to NO
      READ(IN,*) NJ,NO,(ITYP(I),B(I),FM(I),FN(I),SO(I),L(I),DZ(I),KL(I)
     &,I=1,NO),LT,DB,DFM,YG,ICTL
      NEQS=3*NO
      NO2=2*NO
      READ(IN,*) TOL,ERR,H,G
      NI(1)=0
      II=1
      QOUTS=0.
      DO 2 J=1,NJ
C  JN is neg. channel No. if flow is from Junction.
      READ(IN,*) JI,(JN(I),I=II,II+JI-1),QOUT(J)
      QOUTS=QOUTS+QOUT(J)
      II=II+JI
2     NI(J+1)=II-1
      READ(IN,*)(X(I),I=1,NEQS) ! GUESSES (NO Q'S 1ST, then Yu next,Yd
      IF(G.GT. 30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      DO 10 I=1,NO
10    KL(I)=(KL(I)+1.)/G2
      NCT=0
20    CALL FUN(F)
      DO 30 J=1,NEQS
      DX=.015*X(J)
      X(J)=X(J)+DX
      CALL FUN(F1)
      DO 25 I=1,NEQS
25    D(I,J)=(F1(I)-F(I))/DX
      X(J)=X(J)-DX
30    CONTINUE
      CALL SOLVEQ(NEQS,1,M,D,F,1,DD,INDX)
      DIF=0.
      DO 40 I=1,NEQS
      X(I)=X(I)-F(I)
40    DIF=DIF+ABS(F(I))
      NCT=NCT+1
      WRITE(*,101) NCT,DIF,(X(I),I=1,NEQS)
101   FORMAT(' NCT =',I3,' SUM =',E12.5,/(8F10.3))
      IF(NCT.LT.30 .AND. DIF.GT.ERR) GO TO 20
      WRITE(IOUT,100) NO
100   FORMAT(' Solution to',I3,' Channel at Junction',/,1X,65('-'),/,
     &' No      b    m     n      So      L    dz     Yu     Yd       Q'
     &,/,1X,65('-'))
      DO 50 I=1,NO
50    WRITE(IOUT,110) I,B(I),FM(I),FN(I),SO(I),L(I),DZ(I),X(I+NO),X(I+
     &NO2),X(I)
110   FORMAT(I3,F7.2,F5.2,F6.3,F8.6,F7.0,F6.2,2F7.3,F8.2)
      END
      SUBROUTINE FUN(F)
      PARAMETER (N2=8,N=12,M=36)
      EXTERNAL DYX
      LOGICAL*2 IPERM,NTRAN
      REAL F(M),FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),X(M),Y(1),DY(1),
     &W(1,13),XP(1),YP(1,1),LT,QOUT(N2)
      INTEGER*2 ITYP(N),ICTL
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/NJ,NO,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M)
      H1=-.05
      HMIN=.0000001
      II=1
      F(II)=H-X(NO+1)-KL(1)*(X(1)/AR(1,X(NO+1)))**2
      DO 10 I=1,NJ
      I1=NI(I)+1
      I2=NI(I+1)
      II=II+1
      JI=IABS(JN(I1))
      II1=II
      IF(JN(I1).LT.0) THEN
      NN=NO
      NM=NO2
      ELSE
      NN=NO2
      NM=NO
      ENDIF
      F(II1)=REAL(JI/JN(I1))*X(JI)-QOUT(I)
      EN=X(NN+JI)+(X(JI)/AR(JI,X(NN+JI)))**2/G2
      DO 10 J=I1+1,I2
      JI=IABS(JN(J))
      II=II+1
      F(II)=EN-X(NM+JI)-KL(JI)*(X(JI)/AR(JI,X(NM+JI)))**2-DZ(JI)
10    F(II1)=F(II1)+X(JI)*REAL(JI/JN(J))
      DO 20 I=1,NO
      JI=I
      II=II+1
      XX=L(I)
      XZ=0.
      IPERM=.TRUE.
      QQ=X(I)
      Y(1)=X(NO2+I)
      IF(I.EQ.NO) THEN
      IF(ICTL.EQ.2) Y(1)=1.2*Y(1)
      XX=XX+LT-1.E-5
      ENDIF
      QN=(FN(I)*QQ/CC)**2
      Q2G=QQ**2/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
20    F(II)=X(NO+I)-Y(1)
      II=II+1
      NTRAN=.FALSE.
      BB=B(NO)+DB
      FMM=FM(NO)+DFM
      IF(ICTL.EQ.1) THEN
      F(II)=X(NEQS)+(X(NO)/AR(NO,X(NEQS)))**2/G2-YG-KL(NO)*
     &(X(NO)/AR(NO,YG))**2
      NTRAN=.TRUE.
      ELSE IF(ICTL.EQ.2) THEN
      AA=AR(NO,X(NEQS))
      IPERM=.FALSE.
      F(II)=X(NO)**2*TOPW-G*AA**3
      ELSE
      F(II)=X(NEQS)-YG
      ENDIF
      NTRAN=.TRUE.
      RETURN
      END
      FUNCTION AR(I,YY)
      PARAMETER (N2=8,N=12,M=36)
      LOGICAL*2 IPERM,NTRAN
      REAL FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),X(M),LT,QOUT(N2)
      INTEGER*2 ITYP(N),ICTL
      COMMON /TRAS/NJ,NO,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M)
      IF(ITYP(I).EQ.1) THEN
      IF(NTRAN) THEN
      BB=B(I)
      FMM=FM(I)
      ENDIF
      AR=(BB+FMM*YY)*YY
      IF(IPERM) THEN
      PERM=BB+2.*YY*SQRT(1.+FMM*FMM)
      TOPW=BB+2.*FMM*YY
      ENDIF
      ELSE
      COSB=1.-2.*YY/B(I)
      BETA=ACOS(COSB)
      AR=.25*B(I)**2*(BETA-SIN(BETA)*COSB)
      IF(IPERM) THEN
      PERM=BETA*B(I)
      TOPW=B(I)*SIN(BETA)
      ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      PARAMETER (N2=8,N=12,M=36)
      LOGICAL*2 IPERM,NTRAN
      REAL FN(N),SO(N),L(N),B(N),FM(N),DZ(N),KL(N),X(M),Y(1),DY(1),LT,
     &QOUT(N2)
      INTEGER*2 ITYP(N),ICTL
      COMMON /TRAS/NJ,NO,NO2,NEQS,ITYP,ICTL,FN,SO,L,LT,B,FM,DZ,KL
     &,DB,DFM,YG,X,H,G,G2,CC,TOL,PERM,TOPW,QOUT,QOUTS,QN,Q2G,BB,FMM,
     &IPERM,NTRAN,JI,NI(N2+1),JN(M)
      IF(XX.LE.L(JI)) THEN
      NTRAN=.TRUE.
      DAX=0.
      ELSE
      NTRAN=.FALSE.
      FLEN=(XX-L(JI))/LT
      BB=B(JI)+FLEN*DB
      FMM=FM(JI)+FLEN*DFM
      DAX=Q2G*Y(1)*(DB+Y(1)*DFM)/LT
      ENDIF
      AA=AR(JI,Y(1))
      A3=AA**3
      SF=QN*(ABS(PERM/AA)**.666666667/AA)**2
      DY(1)=(SO(JI)-SF+DAX/A3)/(1.-Q2G*TOPW/A3)
      RETURN
      END