      CHARACTER CH(8)*3/'m1 ','b1''','b'' ','Y1''','Q  ','So1','n  ',
     &'g  '/,CH1*5,FMT*15/'(A4,'' = '',F8.3)'/
      COMMON X(8),Cu
      REAL F(2),FF(2),D(2,2)
      INTEGER*2 INDX(2)
      EQUIVALENCE (X(1),FM),(X(2),B1P),(X(3),BP),(X(4),Y1P),(X(5),Q),
     &(X(6),So1),(X(7),FN),(X(8),G)
      WRITE(*,*)' Give output unit'
      READ(*,*) IOUT
1     WRITE(*,*)' Give 2 numbers for 2 unknowns'
      WRITE(*,100) (I,CH(I),I=1,6)
100   FORMAT(I3,' - ',A3)
      READ(*,*) IU1,IU2
      IF(IU1.LT.0 .OR. IU1.GT.6 .OR. IU2.LT.0 .OR. IU2.GT.6) STOP
      WRITE(*,*)' Provide values for:'
      DO 10 I=1,8
      CH1='     '
      IF(I.EQ.IU1 .OR. I.EQ.IU2) CH1='Guess'
      WRITE(*,105) CH1,CH(I)
105   FORMAT(A6,1X,A3,' = ',\)
10    READ(*,*) X(I)
      Cu=1.486
      IF(G.LT.25.) Cu=1.
      NCT=0
15    CALL FUN(F)
      II=0
      DO 20 I=1,6
      IF(I.NE.IU1 .AND. I.NE.IU2) GO TO 20
      XX=X(I)
      X(I)=1.005*X(I)
      II=II+1
      CALL FUN(FF)
      DO 25 J=1,2
25    D(J,II)=(FF(J)-F(J))/(X(I)-XX)
      X(I)=XX
20    CONTINUE
      CALL SOLVEQ(2,1,2,D,F,1,DD,INDX)
      X(IU1)=X(IU1)-F(1)
      X(IU2)=X(IU2)-F(2)
      NCT=NCT+1
      WRITE(*,*) ' NCT=',NCT,F,X(IU1),X(IU2)
      IF(NCT.LT.30 .AND. (ABS(F(1))+ABS(F(2))).GT.5.E-5) GO TO 15
      IF(NCT.EQ.30) WRITE(*,*)' Did not converge', F
      WRITE(*,110) CH(IU1),X(IU1),CH(IU2),X(IU2)
110   FORMAT(' Solution:',2(A4,' ='F9.4))
      IF(IOUT.NE.6 .AND. IOUT.NE.0) WRITE(IOUT,110) CH(IU1),X(IU1),
     &CH(IU2),X(IU2)
      Fr1=SQRT(FM**3*(1.+2.*Y1P)/(B1P**2*(BP*(Y1P+Y1P**2))**3))
      WRITE(*,*)' Variables:'
      DO 30 I=1,7
      FMT(14:14)='3'
      IF(I.EQ.6) FMT(14:14)='6'
      IF(IOUT.NE.6 .AND. IOUT.NE.0) WRITE(IOUT,FMT) CH(I),X(I)
30    WRITE(*,FMT) CH(I),X(I)
      FMT(14:14)='3'
      IF(IOUT.NE.6 .AND. IOUT.NE.0) WRITE(IOUT,FMT) 'Fr1',Fr1
      WRITE(*,FMT) 'Fr1',Fr1
      WRITE(*,*)' To solve another problem give 1 (0=STOP)'
      READ(*,*) IU1
      IF(IU1.GT.0) GO TO 1
      END
      SUBROUTINE FUN(F)
      REAL F(2)
      COMMON X(8),Cu
      EQUIVALENCE (X(1),FM),(X(2),B1P),(X(3),BP),(X(4),Y1P),(X(5),Q),
     &(X(6),So1),(X(7),FN),(X(8),G)
      AP=Y1P+Y1P**2
      F(1)=Y1P*BP+.5*FM**3/(BP*B1P*AP)**2-1.5*FM
C      F(1)=(Y1P*BP-1.5*FM)*(BP*B1P*AP)**2+.5*FM**3
      QP=FN/(Cu*SQRT(So1)*Q**.06666667*(BP**3*B1P**2/G)**.5333333)
      F(2)=QP-AP**1.666667/(FM*(FM+2.*SQRT(FM*FM+1.)*Y1P)**.6666667)
      RETURN
      END