      REAL F(10),D(10,10),X(10),KN(20)
      INTEGER*2 INDX(10)
50    WRITE(6,*)' HOW MAY EQS'
      READ(5,*) N
      IF(N .EQ. 0) STOP
      WRITE(6,*)' HOW MANY KNOWNS?'
      READ(5,*) NK
      WRITE(6,*)' GIVE ME THESE KNOWN VALUES.'
      READ(5,*) (KN(I),I=1,NK)
      WRITE(6,*) ' PROVIDE',N,' ESTIMATES OF UNKNOWNS'
      READ(5,*)(X(I),I=1,N)
      NCT=0
1     DO 10 I=1,N
      F(I)=FUN(I,X,DX,0,N,KN)
      DO 10 J=1,N
      DX=.005*X(J)
10    D(I,J)=(FUN(I,X,DX,J,N,KN)-F(I))/DX
      WRITE(6,304)(F(I),I=1,N)
304   FORMAT(5F12.4)
      CALL SOLVEQ(N,1,10,D,F,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 20 I=1,N
      DIF=DIF+ABS(F(I))
20    X(I)=X(I)-F(I)
      IF(NCT .LT. 20 .AND. DIF .GT. .0001) GO TO 1
      IF(NCT .EQ. 20) WRITE(6,*)' DID NOT CONVERGE',DIF
      WRITE(6,100) (I,X(I),I=1,N)
100   FORMAT(' SOLUTION',/10('-'),/(5(' ,X(',I2,')=',F10.4)))
      GO TO 50
      END
      FUNCTION FUN(I,X1,DX,J,N,KN)
      REAL X(10),X1(10),KN(20)
      DO 10 K=1,N
10    X(K)=X1(K)
      IF(J .GT. 0) X(J)=X(J)+DX
      RY=X(3)/KN(4)
      GO TO (1,2,3,4,5,6,7),I
1     FUN=SIN(X(4))-SQRT(.5*RY*(RY+1.))/KN(3)
      GO TO 50
2     FUN=TAN(X(2))-(RY-1.)*TAN(X(4))/(RY+TAN(X(4))**2)
      GO TO 50
3     FUN=X(1)-.5*(KN(1)-KN(2))/TAN(X(2))
      GO TO 50
4     FUN=X(1)-X(6)-X(7)
      GO TO 50
5     FUN=.5*KN(2)-X(7)*TAN(X(5)-X(2))
      GO TO 50
6     FUN=.5*KN(1)-X(6)*TAN(X(4))
      GO TO 50
7     FUN=KN(5)/X(3)-TAN(X(5))/TAN(X(5)-X(2))
50    RETURN
      END
