      CHARACTER*2 VAR(9)/'Y1','Y2','Y3','Y ','q ','b ','So','n ','g '/
      CHARACTER PT(2)*7/'(Guess)','       '/,FMT*15/'(A3,'' ='',F10.3)'/
      INTEGER*2 IUN(3),INDX(3)
      REAL F(3),FF(3),DJ(3,3)
      COMMON X(9),Cu,G2,IBC
      EQUIVALENCE (Y1,X(1)),(Y2,X(2)),(Y3,X(3)),(Y,X(4)),(Q,X(5)),(B,X(6
     &)),(So,X(7)),(FN,X(8)),(G,X(9))
      WRITE(*,*) ' Give 1 if upstream reservoir, or 2 if upst. channel'
      READ(*,*) IBC
      IF(IBC.EQ.1) VAR(1)='H '
      WRITE(*,*)' Give the numbers of the 3 unknowns'
      WRITE(*,100)(I,VAR(I),I=1,7)
100   FORMAT(I4,2X,A2)
      READ(*,*) IUN
      WRITE(*,*)' Provide value (or guess) for variable.'
      DO 10 I=1,9
      II=2
      DO 5 J=1,3
      IF(IUN(J).EQ.I) II=1
5     CONTINUE
      WRITE(*,110) I,PT(II),VAR(I)
110   FORMAT(I4,1X,A7,1X,A2,' =',\)
10    READ(*,*) X(I)
      G2=2.*G
      Cu=1.486
      IF(G.LT.20.) Cu=1.
      NCT=0
20    SUM=0.
      CALL FUN(F)
      DO 40 I=1,3
      XX=X(IUN(I))
      X(IUN(I))=1.01*X(IUN(I))
      CALL FUN(FF)
      DO 30 J=1,3
30    DJ(J,I)=(FF(J)-F(J))/(X(IUN(I))-XX)
40    X(IUN(I))=XX
      CALL SOLVEQ(3,1,3,DJ,F,1,DD,INDX)
      DO 50 I=1,3
      X(IUN(I))=X(IUN(I))-F(I)
50    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 20
      WRITE(3,*)' Solution:'
      DO 60 I=1,9
      IF(I.EQ.7 .OR. I.EQ.8) THEN
      FMT(14:14)='6'
      ELSE
      FMT(14:14)='3'
      ENDIF
60    WRITE(3,FMT) VAR(I),X(I)
      END
      SUBROUTINE FUN(F)
      REAL F(3)
      COMMON X(9),Cu,G2,IBC
      EQUIVALENCE (Y1,X(1)),(Y2,X(2)),(Y3,X(3)),(Y,X(4)),(Q,X(5)),(B,X(6
     &)),(So,X(7)),(FN,X(8)),(G,X(9))
      IF(IBC.EQ.1) THEN
      F(1)=Y1-Y-(Q/Y2)**2/G2
      ELSE
      F(1)=Y1+(Q/Y1)**2/G2-Y-(Q/Y2)**2/G2
      ENDIF
      F(2)=.5*(Y**2-Y3**2)+Q**2/G*(1./Y2-1./Y3)
      F(3)=FN*B*Q*(B+2.*Y3)**.666667-Cu*(B*Y3)**1.666667*SQRT(So)
      RETURN
      END