      LOGICAL*2 ISTEAD
      INTEGER*2 INDX(4)
      REAL F(4),F1(4),D(4,4)
      COMMON g,G2,qo,Vo,T,Yd,dqdt,Xs,Ys,Vs,X(4),ISTEAD
      EQUIVALENCE (Y2,X(1)),(V2,X(2)),(v,X(3)),(Yo,X(4))
      WRITE(*,*) ' Give: Yo,Vo,Yd,IOUT,NT,DELT,dqdt,g'
      READ(*,*) Yo,Vo,Yd,IOUT,NT,DELT,dqdt,g
      ISTEAD=.TRUE.
      Ys=Yo
      Vs=Vo
      G2=2.*g
      Xs=0.
      Y2=1.2*Yo
      V2=.55*Vo
      v=1.8*Vo
      NCT=0
5     CALL FUNCT(F1)
      DO 20 J=1,3
      X1=X(J)
      X(J)=1.005*X1
      CALL FUNCT(F)
      DO 10 I=1,3
10    D(I,J)=(F(I)-F1(I))/(X(J)-X1)
20    X(J)=X1
      CALL SOLVEQ(3,1,4,D,F1,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 30 J=1,3
      X(J)=X(J)-F1(J)
30    DIF=DIF+ABS(F1(J))
      IF(NCT.LT.20 .AND. DIF.GT.1.E-5) GO TO 5
      WRITE(IOUT,100) X,Vs,Yd
100   FORMAT(' Steady Solution: Y2=',F8.3,' V2=',F8.3,' v=',F8.3,/,
     &' Yo=',F8.3,' Vo=',F8.3,' Yd=',F8.3)
      ISTEAD=.FALSE.
      V2=-V2
      Vo=V2
      qo=Vo*X(1)
      Yo=Y2
      WRITE(IOUT,110)
110   FORMAT(1X,49('-'),/,' Time     Y2       V2       v        Yo        
     & x'/,1X,49('-'))
      WRITE(IOUT,120) 0.,X,Xs
      DO 80 K=1,NT
      NCT=0
      T=DELT*FLOAT(K)
      v1=v
      Xs=Xs+DELT*v
40    CALL FUNCT(F1)
      DO 60 J=1,4
      X1=X(J)
      X(J)=1.005*X1
      CALL FUNCT(F)
      DO 50 I=1,4
50    D(I,J)=(F(I)-F1(I))/(X(J)-X1)
60    X(J)=X1
      CALL SOLVEQ(4,1,4,D,F1,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 70 J=1,4
      X(J)=X(J)-F1(J)
70    DIF=DIF+ABS(F1(J))
      WRITE(*,*)' NCT',NCT,DIF
      IF(NCT.LT.20 .AND. DIF.GT.1.E-5) GO TO 40
80    WRITE(IOUT,120) T,X,Xs
120   FORMAT(F5.1,4F9.3,F9.1)
      END
      SUBROUTINE FUNCT(F)
      REAL F(4)
      LOGICAL*2 ISTEAD
      COMMON g,G2,qo,Vo,T,Yd,dqdt,Xs,Ys,Vs,X(4),ISTEAD
      F(1)=(ABS(X(2))+X(3))*X(1)-(ABS(Vs)+X(3))*Ys
      F(2)=.5*(X(1)/Ys)*(X(1)/Ys+1.)-(ABS(Vs)+X(3))**2/(g*Ys)
      IF(ISTEAD) THEN
      F(3)=X(1)+X(2)**2/G2-Yd-((X(1)*X(2))/Yd)**2/G2
      ELSE
      F(3)=X(2)-Vo+2.*(SQRT(g*X(4))-SQRT(g*X(1)))
      F(4)=T-(X(1)*X(2)-qo)/dqdt-Xs/(3.*SQRT(g*X(1))+Vo-2.*SQRT(g*X(4)))
      ENDIF
      RETURN
      END