C  Solves a supertransition using the 11 iterative steps outlined in the text
      WRITE(*,*)' Give: Q,b1,n1,So1,b2,n2,So2,g'
      READ(*,*) Q,B1,FN1,SO1,B2,FN2,SO2,G
      Cu=1.486
      IF(G.LT.20.) Cu=1.
      Yo1=.5*B1
      Yo2=.5*B2
      Q2G=Q*Q/G
      CALL YNORMAL(Yo1,Fn1,So1,B1,Q,Cu)
      CALL YNORMAL(Yo2,Fn2,So2,B2,Q,Cu)
      FR1=SQRT(Q2G*B1/(B1*Yo1)**3)
      Y2=.5*(Yo1+Yo2)
      NCT=0
10    Y2Y1=Y2/Yo1
      BETA=ASIN(SQRT(.5*Y2Y1*(Y2Y1+1.))/FR1)
      THETA=ATAN(((Y2Y1-1.)*TAN(BETA))/(Y2Y1+TAN(BETA)**2))
      FL=.5*(B1-B2)/TAN(THETA)
      X=.5*B1/TAN(BETA)
      Z=FL-X
      BETAP=THETA+ATAN(.5*B2/Z)
      Y3Y2=TAN(BETAP)/TAN(BETAP-THETA)
      Y2N=Yo2/Y3Y2
      NCT=NCT+1
      DIF=Y2N-Y2
      WRITE(*,*) NCT,Y2N,Y2,DIF
      Y2=Y2N
      IF(NCT.LT.30 .AND. ABS(DIF).GT. .01) GO TO 10
      WRITE(*,100) X,Z,FL,BETA,THETA,BETAP,Y2
100   FORMAT(' x =',F10.2,/,' z =',F10.2,/,' L =',F10.2,/,' beta =',
     &F10.4,/,' theta =',F10.4,/,' betap =',F10.4,/,' Y2 =',F8.2)
      END
      SUBROUTINE YNORMAL(Yo,Fn,So,B,Q,C)
      M=0
      C1=Fn*Q
      C2=C*SQRT(So)
1     F=C1*(B+2.*Yo)**.6666667-C2*(B*Yo)**1.6666667
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      F1=F
      Yoo=Yo
      Yo=1.005*Yo
      GO TO 1
      ENDIF
      DIF=(Yo-Yoo)*F1/(F-F1)
      Yo=Yoo-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. M.LT.30) GO TO 1
      RETURN
      END