      PARAMETER (ND=5,EPS=1.E-5) 
      REAL M1(8)/.25,.5,.75,1.,1.25,1.5,1.75,2.0/,YP(6),
     &BP1(6)/.8,1.,1.25,1.5,1.75,2.0/ 
      COMPLEX C(ND+1),ROOTS(ND),AD(ND+1),Z1,Z2,Z3 
      EPS1=2.*EPS*EPS 
      DO 90 M=1,8
      FM3=.5*M1(M)**3
      F15=1.5*M1(M)
      F3=3.*M1(M)
      WRITE(3,100) M1(M),BP1
100   FORMAT(' For upstream side slope of m =',F7.2,/1X,52('-'),/
     &'   b''',6F8.2,/1X,52('-'))
      DO 90 I=1,91
      BP=.5+.05*FLOAT(I-1)
      CCC=FM3/BP**3
      C(6)=CMPLX(1.,0.) 
      C(5)=CMPLX(2.-F15/BP,0.) 
      C(4)=CMPLX(1.-F3/BP,0.) 
      C(3)=CMPLX(-F15/BP,0.)
      C(2)=CMPLX(0.,0.)
      DO 85 K=1,6
      C(1)=CMPLX(CCC/BP1(K)**2,0.)
      DO 20 J=1,ND+1 
20    AD(J)=C(J) 
      DO 30 J=ND,1,-1 
      Z1=CMPLX(0.,0.) 
      CALL LAGU(AD,J,Z1,EPS) 
      IF(ABS(AIMAG(Z1)).LE.EPS1*ABS(REAL(Z1))) Z1=CMPLX(REAL(Z1),0.) 
      ROOTS(J)=Z1 
      Z2=AD(J+1) 
      DO 30 JJ=J,1,-1 
      Z3=AD(JJ) 
      AD(JJ)=Z2 
30    Z2=Z1*Z2+Z3 
      DO 50 J=2,ND 
      Z1=ROOTS(J) 
      DO 40 I1=J-1,1,-1 
      IF(REAL(ROOTS(I1)).LE.REAL(Z1)) GO TO 50 
40    ROOTS(I1+1)=ROOTS(I1) 
      I1=0 
50    ROOTS(I1+1)=Z1 
      IF(ABS(AIMAG(ROOTS(5))).LT. 0.00004) THEN
      YP(K)=REAL(ROOTS(5))
      ELSE
      YP(K)=0.
      ENDIF
85    CONTINUE
90    WRITE(3,70) BP,YP 
70    FORMAT(F5.2,6F8.4) 
      END 
      SUBROUTINE LAGU(C,ND,Z1,EPS) 
      COMPLEX C(ND+1),Z1,DX,ZO,Z2,Z3,Z4,Z5,DZ,SS,Z6,Z7,Z8,ZERO,XX,FF 
      ZERO=CMPLX(0.,0.) 
      DO 20 ITER=1,50 
      Z2=C(ND+1) 
      Z3=ZERO 
      Z4=ZERO 
      DO 10 J=ND,1,-1 
      Z4=Z1*Z4+Z3 
      Z3=Z1*Z3+Z2 
10    Z2=Z1*Z2+C(J) 
      IF(CABS(Z2).LE.1.E-8) THEN 
      DX=ZERO 
      ELSE IF(CABS(Z3).LE.1.E-8.AND.CABS(Z4).LE.1.E-8) THEN 
      DX=CMPLX(CABS(Z2/C(ND+1))**(1./FLOAT(ND)),0.) 
      ELSE 
      Z5=Z3/Z2 
      Z8=Z5*Z5 
      DZ=Z8-2.*Z4/Z2 
      XX=(ND-1)*(ND*DZ-Z8) 
      YY=ABS(REAL(XX)) 
      ZZ=ABS(AIMAG(XX)) 
      IF(YY.LT.1.E-12 .AND. ZZ .LT.1.E-12) THEN 
      SS=ZERO 
      ELSE IF (YY.GE.ZZ) THEN 
      FF=(1./YY)*XX 
      SS=SQRT(YY)*CSQRT(FF) 
      ELSE 
      FF=(1./ZZ)*XX 
      SS=SQRT(ZZ)*CSQRT(FF) 
      ENDIF 
      Z6=Z5+SS 
      Z7=Z5-SS 
      IF(CABS(Z6).LT.CABS(Z7)) Z6=Z7 
      DX=FLOAT(ND)/Z6 
      ENDIF 
      ZO=Z1-DX 
      IF(Z1.EQ.ZO) RETURN 
      Z1=ZO 
      IF(CABS(DX).LE.EPS*CABS(Z1)) RETURN 
20    CONTINUE 
      WRITE(6,*)' FAILED TO CONVERGE',DX 
      RETURN 
      END