      LOGICAL NFS
      INTEGER*2 INDX(4)
      REAL F(4),F1(4),D(4,4),Y(1),XP(1),YP(1,1),W(1,13)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ B,FM,FM2,FM3,FMS,BH,CUN,Qo,Q2G,X(4),Yb,Y3,Yu,Yd,XPOS
     &,DT5,XPOO,FL,Qb,DXS,G,VJUMP,So,DX,Yo(15),INIT,TOL,H11,HMIN
      WRITE(*,*)' Give: Qo,Ke,g,b,m,n,So,L,Yb,Y3 & Guess for Yu,Yd,x'
      READ(*,*) Qo,FKE,G,B,FM,FN,So,FL,Yb,Y3,(X(I),I=1,3)
      H11=.5
      HMIN=1.E-5
      TOL=1.E-5
      BH=.5*B
      FKe=FKe+1.
      FM3=FM/3.
      FMS=2.*SQRT(FM*FM+1.)
      FM2=2.*FM
      G2=2.*G
      CU=1.486
      IF(G.LT.20.) CU=1.
      CUN=FN/CU
      H=Yb+FKe*(Qo/((B+FM*Yb)*Yb))**2/G2
      WRITE(*,*)' Qo=',Qo
      Q2G=Qo*Qo/G
      INIT=0
C  Solve steady-state variables Yu=X(1); Yd=X(2); x=X(3)
      NCT=0
10    SUM=0.
      CALL FUN1(F)
      DO 14 I=1,3
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN1(F1)
      DO 12 J=1,3
12    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
14    X(I)=XX
      CALL SOLVEQ(3,1,4,D,F,1,DD,INDX)
      DO 15 I=1,3
      X(I)=X(I)-F(I)
15    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM,(X(I),I=1,3)
      IF(SUM.GT. 1.E-3 .AND. NCT.LT.20) GO TO 10
      WRITE(3,100) Qo,H,(X(I),I=1,3)
      WRITE(6,100) Qo,H,(X(I),I=1,3)
100   FORMAT(' Steady-State Jump: Qo=',F8.2,', H=',F8.3,/,' Yu=',F8.3,
     &', Yd=',F8.3,', x=',F8.2)
      Yu=X(1)
      Yd=X(2)
      XPOS=X(3)
      DX=(FL-XPOS)/14.
      Yo(1)=X(2)
      H11=1.
      NFS=.TRUE.
      Y(1)=X(2)
      XX1=XPOS
      DO 16 I=2,15
      XX=XX1+DX
      CALL ODESOLF(Y,DY,1,XX1,XX,TOL,H11,HMIN,1,XP,YP,W,DYX,NFS)
      Yo(I)=Y(1)
      NFS=.FALSE.
16    XX1=XX
      WRITE(3,102) (XPOS+DX*FLOAT(I-1),Yo(I),I=1,15)
102   FORMAT(' GVF-Profile Downstream of Jump',/,(5(F8.1,F8.3)))
      WRITE(*,*)' Give: Qb,Dt,Nt & INIT for interp.,1=linear,2=with -x**
     &2, 3= with -(xw-x)**2'
      READ(*,*) Qb,DT,NT,INIT
      NCT=0
      Yb=Yb*Qb/Qo
17    FF=H-Yb-(Qb/((B+FM*Yb)*Yb))**2/G2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 18
      FF1=FF
      YY=Yb
      Yb=1.005*Yb
      GO TO 17
18    DIF=(Yb-YY)*FF1/(FF-FF1)
      Yb=YY-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.30) GO TO 17
      WRITE(3,104) Qb,Yb,DT,INIT
104   FORMAT(' New flowrate Qb=',F8.1,', New Depth Yb=',F8.3,', Dt=',
     &F8.1,', INIT=',I2)
C  Yu=X(1),v=X(2),Qu=X(3),x=X(4)
      DT5=.5*DT 
      WRITE(3,108)
108   FORMAT(' Time   Yu  Jump Vel.    Qu       x      Yd      Vd      V
     &u',/,1X,61('-'))
      VJUMP=0.
      X(2)=1.
      X(3)=Qo
      X(4)=XPOS+DT
      XPOO=XPOS
      DO 50 K=1,NT
      ITIME=IFIX(DT*FLOAT(K)+.5)
      NCT=0
20    SUM=0.
      CALL FUN2(F)
      DO 24 I=1,4
      XX=X(I)
      IF(ABS(X(I)).GT. 0.1) THEN
      X(I)=1.005*X(I)
      ELSE
      X(I)=X(I)+.002
      ENDIF
      CALL FUN2(F1)
      DO 22 J=1,4
22    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
24    X(I)=XX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      DO 26 I=1,4
      X(I)=X(I)-F(I)
26    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM
      IF(SUM.GT. 1.E-4 .AND. NCT.LT.20) GO TO 20
      WRITE(3,110) ITIME,X,Yd,Qo/((B+FM*Yd)*Yd),Qb/((B+FM*X(1))*X(1))
110   FORMAT(I5,2F8.3,2F8.2,3F8.3)
      VJUMP=X(2)
      XPOS=X(4)
      IF(XPOS.GE.FL) STOP
50    X(4)=X(4)+DT*VJUMP
      END
      SUBROUTINE FUN1(F)
      REAL F(4),Y(1),XP(1),YP(1,1),W(1,13)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ B,FM,FM2,FM3,FMS,BH,CUN,Qo,Q2G,X(4),Yb,Y3,Yu,Yd,XPOS
     &,DT5,XPOO,FL,Qb,DXS,G,VJUMP,So,DX,Yo(15),INIT,TOL,H11,HMIN
      F(1)=(BH+FM3*X(1))*X(1)**2+Q2G/((B+FM*X(1))*X(1))-(BH+FM3*X(2))*X(
     &2)**2-Q2G/((B+FM*X(2))*X(2))
      H11=2.
      Y(1)=Yb
      CALL ODESOLF(Y,DY,1,0.,X(3),TOL,H11,HMIN,1,XP,YP,W,DYX,.TRUE.)
      F(2)=X(1)-Y(1)
      H11=-.001
      Y(1)=Y3
      CALL ODESOLF(Y,DY,1,FL,X(3),TOL,H11,HMIN,1,XP,YP,W,DYX,.TRUE.)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE FUN2(F)
      REAL F(4),Y(1),XP(1),YP(1,1),W(1,13)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ B,FM,FM2,FM3,FMS,BH,CUN,Qo,Q2G,X(4),Yb,Y3,Yu,Yd,XPOS
     &,DT5,XPOO,FL,Qb,DXS,G,VJUMP,So,DX,Yo(15),INIT,TOL,H11,HMIN
C  Yu=X(1),v=X(2),Qu=X(3),x=X(4)
      Au=(B+FM*X(1))*X(1)
      M=(X(4)-XPOO)/DX+1
      IF(M.GT.14) THEN
      Yd=Yo(15)
      ELSEIF(M.LT.1) THEN
      Yd=Yo(1)
      ELSE
      FAC=(X(4)-XPOO-DX*FLOAT(M-1))/DX
      Yd=Yo(M)+FAC*(Yo(M+1)-Yo(M))
      ENDIF
      Ad=(B+FM*Yd)*Yd
      F(1)=(X(3)/Au-X(2))*Au-(Qo/Ad-X(2))*Ad
      F(2)=(BH+FM3*X(1))*X(1)**2+(X(3)/Au-X(2))**2*Au/G-(BH+FM3*Yd)*
     &Yd**2-(Qo/Ad-X(2))**2*Ad/G
      Y(1)=Yb
      CALL ODESOLF(Y,DY,1,0.,X(4),TOL,H11,HMIN,1,XP,YP,W,DYX,.TRUE.)
      F(3)=X(1)-Y(1)
      F(4)=XPOS+DT5*(VJUMP+X(2))-X(4)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/ B,FM,FM2,FM3,FMS,BH,CUN,Qo,Q2G,X(4),Yb,Y3,Yu,Yd,XPOS
     &,DT5,XPOO,FL,Qb,DXS,G,VJUMP,So,DX,Yo(15),INIT,TOL,H11,HMIN
      A=(B+FM*Y(1))*Y(1)
      IF(INIT.GT.0) GO TO 10
      SF=(Qo*CUN*((B+FMS*Y(1))/A)**.6666667/A)**2
      DY(1)=(So-SF)/(1.-Qo**2*(B+FM2*Y(1))/(G*A**3))
      RETURN
10    IF(INIT.EQ.1) THEN
      qs=(Qb-X(3))/X(4)
      Q=Qb+XX/X(4)*(X(3)-Qb)
      ELSE IF(INIT.EQ.2) THEN
      C=(Qb-X(3))/X(4)**2
      qs=2.*C*XX
      Q=Qb-C*XX**2
      ELSE
      C=(Qb-X(3))/X(4)**2
      z=X(4)-XX
      qs=2.*C*z
      Q=Qo+C*z**2
      ENDIF
      SF=(Q*CUN*((B+FMS*Y(1))/A)**.6666667/A)**2
      DY(1)=(So-SF+Q*qs/(G*A**2))/(1.-Q**2*(B+FM2*Y(1))/(G*A**3))
      RETURN
      END