C Solves UCW with upstream gate instantly raised with uniform flow downstream
C The assumptions are: (1) Q = constant from beg. to wave, and (2) Yb is allowed to vary
C but flowrate at beginning is held constant as specified.
      REAL Y(1),YTT(1)
      COMMON B,FM,FM2,FMS,G,QbS,CUN,SO
      WRITE(*,*)' Give: g,b,m,n,So,Qo & Guess for Yo'
      READ(*,*) G,B,FM,FN,SO,Qo,Yo
      BH=.5*B
      FM3=FM/3.
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      G2=2.*G
      CU=1.486
      IF(G.LT.20.) CU=1.
      QN=FN*Qo
      CUS=CU*SQRT(So)
      NCT=0
10    FF=QN*(B+FMS*Yo)**.6666667-CUS*((B+FM*Yo)*Yo)**1.6666667
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 15
      FF1=FF
      YY=Yo
      Yo=1.005*Yo
      GO TO 10
15    DIF=(Yo-YY)*FF1/(FF-FF1)
      Yo=YY-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.20) GO TO 10
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      HCA1=(BH+FM3*Yo)*Yo*Yo
      WRITE(3,100) Qo,Yo,Vo
      WRITE(6,100) Qo,Yo,Vo
100   FORMAT(' Qo =',F8.1,',  Normal Depth Yo =',F8.3,', Vo =',F8.3)
      WRITE(*,*)' Give: New Q2, Dt, NT & Guess for Yb'
      READ(*,*) Qb,DT,NT,Yb
      QbS=Qb*Qb
      CUN=FN/CU*Qb
      HC1=HCA1/Ao
      NCT=0
17    A=(B+FM*Yb)*Yb
      HCA2=(BH+FM3*Yb)*Yb*Yb
      FF=G*(HCA2/Ao-HC1)/(1.-Ao/A)-((Qb-Qo)/(A-Ao)-Vo)**2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 18
      FF1=FF
      Yb2=Yb
      Yb=1.005*Yb
      GO TO 17
18    DIF=(Yb-Yb2)*FF1/(FF-FF1)
      Yb=Yb2-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.30) GO TO 17
      A=(B+FM*Yb)*Yb
      WV=(Qb-Qo)/(A-Ao)
      Y2=Yb
      WRITE(6,105) Qb,Yb,A,SQRT(ABS(G*A/(B+FM2*Yb))),WV
      WRITE(3,105) Qb,Yb,A,SQRT(G*A/(B+FM2*Yb)),WV
105   FORMAT(' For New Q=',F8.2,/' Depth Upst. wave Y2=',F8.3,' A=',F8.2
     &,/' Celerity =',F8.3,' Wave Velocity=',F8.3)
      WRITE(3,108)
108   FORMAT(/' Time  Pos. x   Yb'/,1X,21('-'))
      WRITE(3,110) 0,0.,Yb
      DO 50 K=1,NT
      TIME=DT*FLOAT(K)
      DIST=TIME*WV
      Y(1)=Y2
      CALL RUKUST(1,DXS,DIST,0.,1.E-4,Y,YTT)
50    WRITE(3,110) IFIX(TIME),DIST,Y(1)
110   FORMAT(I5,F8.1,F8.3)
      END
      SUBROUTINE SLOPE(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON B,FM,FM2,FMS,G,QbS,CUN,SO
      A=(B+FM*Y(1))*Y(1)
      SF=(CUN*((B+FMS*Y(1))/A)**.6666667/A)**2
      DY(1)=(SO-SF)/(1.-QbS*(B+FM2*Y(1))/(G*A**3))
      RETURN
      END