      REAL F[ALLOCATABLE](:),W[ALLOCATABLE](:)
      REAL VO(9)/0.,.05,.1,.15,.2,.25,.3,.35,.4/
      REAL YO(80)
      DO 1 I=1,80
1     YO(I)=.2+.01*FLOAT(I-1)
      DY=.002
      YPE=.99
      YP1=.01
      BET1=ACOS(1.-2.*YP1)
      RC=FC(YP1,CP)
      W1=BET1*RC
      YP11=YP1
      N=(YPE-YP1)/DY+2.
      ALLOCATE(F(N+5),W(N+5))
      W(1)=W1
      DO 10 I=2,N
      SUM=0.
      YP=YP1+DY
      BET2=ACOS(1.-2.*YP)
      DBET=(BET2-BET1)/10.
      DBE2=.5*DBET
      DO 5 J=1,10
      RC1=FC(BET1+DBET*FLOAT(J),CP)
      SUM=SUM+DBE2*(RC+RC1)
5     RC=RC1
      BET1=BET2
      YP1=YP
      W(I)=W(I-1)+SUM
10    F(I)=W(I)+CP
      YP=YP11
      DO 20 J=1,9
      WRITE(3,100) VO(J)
100   FORMAT(/,' For initial dim. Vel., Vo''= ',F8.2,/1X,47('-'),/,1X
     &'  Yo''       Yc''       Vc''       Ac''        Qc''',/1X,47('-'))
      DO 20 I=1,80
      IYP=ABS((YO(I)-YP11)/DY)+1.
      K=IYP
      SUM=W(IYP)+VO(J)
15    IF(SUM.GT.F(K)) GO TO 16
      K=K-1
      IF(K.GT.0) GO TO 15
16    FAC=(SUM-F(K))/(F(K+1)-F(K))
      YPM=YP11+DY*(FLOAT(K)+FAC)
      BETA=ACOS(1.-2.*YPM)
      CP=.5*SQRT(BETA/SIN(BETA)-COS(BETA))
      AP=.25*(BETA-COS(BETA)*SIN(BETA))
20    WRITE(3,110) YO(I),YPM,CP,AP,CP*AP
110   FORMAT(F8.3,4F10.6)
      DEALLOCATE(F,W)
      END
      FUNCTION FC(BETA,CP)
      SINB=SIN(BETA)
      CP=SQRT(BETA/SINB-COS(BETA))
      FC=SINB/CP
      CP=.5*CP
      RETURN
      END