C PROGRAM IS DESIGNED ONLY FOR DISPERSIVE WAVES IN WHICH THE DEPTH DECREASES
C  i.e.  values of the stage f. w generated only up to Yo
C boundary condition is dH/dt(H=res. head) rather than dQ/dt as in program YTIMEX.FOR
      PARAMETER (N=200) 
      CHARACTER*2 UN/'ft'/
      REAL W(N),X(20) 
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y)) 
      WRITE(6,*)' Give:Ho,(1 & Vo or 2 & Qo),b,m,Ke,dH/dt,Tstart,Tend,Dt
     &,g,IOUT,Stations' 
      READ(5,*) HO,I,QO,B,FM,FKE,DHT,TST,TE,DT,G,IOUT,NSTA
      G2=2.*G
      FKE=(1.+FKE)/G2
      NCT=0
      YO=.9*HO
      IF(I.EQ.1) THEN
      VO=QO
      T=FKE*VO**2
11    F=HO-YO-T
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 12
      YY=YO
      YO=1.005*YO
      F1=F
      GO TO 11
12    DIF=(YO-YY)*F1/(F-F1)
      YO=YY-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 11
      QO=VO*(B+FM*YO)*YO
      ELSE
13    F=HO-YO-FKE*(QO/((B+FM*YO)*YO))**2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 14
      YY=YO
      YO=1.005*YO
      F1=F
      GO TO 13
14    DIF=(YO-YY)*F1/(F-F1)
      YO=YY-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. NCT.LT.30) GO TO 13
      VO=QO/((B+FM*YO)*YO)
      ENDIF
      WRITE(IOUT,220) YO,VO,QO,HO
220   FORMAT(' Initial conditions: Yo=',F8.4,' Vo=',F8.4,' Qo=',F9.2,' H
     &o=',F8.3)
      IF(NSTA.LT.1) GO TO 1 
      WRITE(6,*)' Give x distances for',NSTA 
      READ(5,*)(X(I),I=1,NSTA) 
1     DY=(YO-.01)/FLOAT(N-1) 
      FM2=2.*FM 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01 
      WF1=FW(Y) 
      W(1)=0. 
      DO 10 I=2,N 
      SUM=0. 
      DO 5 J=1,10 
      WF=FW(Y+DY2*FLOAT(J)) 
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM 
10    Y=Y+DY 
      VOW=VO-W(N) 
      WRITE(IOUT,110) 0.,UN
      IM=N-1 
      NT=(TE-TST)/DT+1.99 
      DO 40 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      H=HO+DHT*T
      Y=YO
      IF(IT.EQ.0) THEN
      V=VO
      ELSE
      NCT=0
31    IM=IFIX((Y-.01)/DY+.99)
      IF(IM.GE.N) IM=N-1
      FAC=(Y-(.01+FLOAT(IM)*DY))/DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      F=H-Y-FKE*V**2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 32
      YY=Y
      Y=1.005*Y
      F1=F
      GO TO 31
32    DIF=(Y-YY)*F1/(F-F1)
      Y=YY-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.30) GO TO 31
      IM=IFIX((Y-.01)/DY+.99)
      FAC=(Y-(.01+FLOAT(IM)*DY))/DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      ENDIF
      Q=V*(B+FM*Y)*Y
40    WRITE(IOUT,100) IT,Y,V,Q,H
100   FORMAT(I8,2F8.3,F9.2,F8.3)
110   FORMAT(' For Station at x =',F8.0,A3,/,1X,41('-'),/,
     &' Time(s)',5X,'Y',7X,'V',8X,'Q',7X,'H',/,1X,41('-')) 
      DXO=VO+SQRT(G*(((B+FM*YO)*YO)/(B+FM2*YO)))
      DO 60 K=1,NSTA 
      IM=N-1
      WRITE(IOUT,*)
      WRITE(IOUT,110) X(K),UN
      F=X(K)/DXO-TST 
      Y=YO
      DO 60 I=1,NT 
      T=TST+DT*FLOAT(I-1) 
      IT=T+.99 
      IF(T*DXO.LE.X(K)) THEN 
      WRITE(IOUT,100) IT,YO,VO,QO,HO
      ELSE 
      NCT=0
45    IM=IFIX((Y-.01)/DY+.99)
      IF(IM.GE.N) IM=N-1
      FAC=(Y-(.01+FLOAT(IM)*DY))/DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      H=Y+FKE*V**2
      A=(B+FM*Y)*Y 
      F=(HO-H)/ABS(DHT)+X(K)/(V+SQRT(G*A/(B+FM2*Y)))-T
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 48
      F1=F
      YY=Y
      Y=1.005*Y
      GO TO 45
48    DIF=(Y-YY)*F1/(F-F1)
      Y=YY-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. NCT.LT.30) GO TO 45
      IM=IFIX((Y-.01)/DY+.99)
      IF(IM.GE.N) IM=N-1
      FAC=(Y-(.01+FLOAT(IM)*DY))/DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      H=Y+FKE*V**2
      Q=V*(B+FM*Y)*Y 
      WRITE(IOUT,100) IT,Y,V,Q,H
      ENDIF 
60    CONTINUE 
      STOP 
      END