% This script carries out the solution of dx/dY as needed for Example No.1
% in Appendix C.  It calls on quad for each new increment
% of DELY integration as does the Fortran program APPC1A.FOR  
% each new increment of DELY.
% Notice that a different function axprime is used to define dx/dY then
% used by script APPEC1.m or APPEC1a.m for two reasons.  First, numerical
% integration does not need both the independent and dependent variables,
% so X is eliminated, and second, vector arithmetric is required now.
disp('Give the following input values');
DELY=input('DELY = '); XB=input('XB = '); Q=input('Q = '); FN=input('n =');
SO=input('So ='); B=input('b =');FM=input('m = ');YBEG=input('beg Y =');
YEND=input('end Y ='); Cu=input('Cu =');  FNQ=FN*Q/Cu;
if Cu==1.
    g=9.81;
else
    g=32.2;
end
Q2=Q^2/g; 
fid=input('Should output be written to file? (2=yes,1=no)');
if fid>1 
    FILN=input('Give name of this file');
    fid=fopen(FILN,'w');
end
X=XB; 
Y=YBEG; 
fprintf('      Y         x\n');
fprintf(fid,'%10.3f %10.3f\n',Y,XB);
ICONT=1;
YO=Y;  II=0;
while ICONT==1
    II=II+1;
    YZ=YO+DELY*II;
    DELX=quad(@(Y)axprime(Y,B,FM,FN,SO,Q2,FNQ),Y,YZ);
    Y=YO+DELY*II;
    X=X+DELX;
    fprintf(fid,'%10.3f %10.3f\n',Y,X);
    if DELY<0
        if Y <= YEND
            ICONT=0;
        end
    else
        if Y>= YEND
            ICONT=0;
        end
    end
end