% Program to generate geometric properties of an irregular channel.
% This MATLAB program does the same thing as the PASCAL program GEONAT.PAS
% given in Appendix A
N1=25; N2=20;
X=zeros(1,N1);Y=zeros(1,N1);Y1=zeros(1,N2);T=zeros(1,N2);A=zeros(1,N2);P=zeros(1,N2);
POSCOR=0;WIDCOR=0;LINEAR=0;
fprintf(1,'Give no. of pts, and then this many pairs\n');
fprintf(1,'Precede no. with a - to change type of interpolation %f2.0\n',LINEAR);
fprintf(1,'Add 100 to no. if on file\n');
if((POSCOR==0) & (WIDCOR==0))
fprintf(1,'Give 1000 if x & elev for y are given\n');
fprintf(1,'Give 2000 if x=TOP width & y=depth are given\n');
end
N=input('N=');
    if(N<0)
        N=abs(N);
        if LINEAR==0
            LINEAR=1;
        else
            LINEAR=0;
        end
    end
if(N==1000)
    POSCOR=1; fprintf(1,'x & elev for y data expected\n');
    N=input('N=');
end
if(N==2000)
    WIDCOR=1; fprintf(1,'x=TOP & y=depth data expected\n');
    N=input('N=');
end
fid=0;
if(abs(N)>100)
    N=abs(N)-100;
    FILN=input('Give file name containing input data ');
    fid=fopen(FILN);
    XY=fscanf(fid,'%f\n');
for i=1:N
        X(i)=XY(2*i-1); Y(i)=XY(2*i);
end
fclose(fid);
else
    for i=1:N
        X(i)=input('x=');
        Y(i)=input('y=');
    end
end
if(POSCOR==1)
    YM=Y(1);
    if(Y(N)>YM)
        for i=1:N
            Y(i)=YM-Y(i);
        end
    end
end
if(WIDCOR==1)
    if(Y(1)>0.)
        N=N+1;
        for i=N:-1:2
            X(i)=X(i-1);  Y(i)=Y(i-1);
        end
        X(1)=0.; Y(1)=0.;
    end
    YM=Y(N); YMI=X(N)/2.;
    for i=1:N
        X(N+i-1)=YMI+X(i)/2.; Y(N+i-1)=YM-Y(i);
    end
    YMI=2.*YMI;
    for i=1:N-1
        Y(i)=Y(2*N-i);  X(i)=YMI-X(2*N-i);
    end
end
NM=N-1;  YM=Y(1); YMI=YM;
if(Y(N)<YMI) 
    YMI=Y(N);
end
for i=2:N
    if(Y(i)>YM)
        YM=Y(i);  IL=i;
    end
end
DY=(YM-YMI)/N2;AA=0.;PP=0.; XR1=X(IL); XL1=XR1; DY2=0.5*DY;DYS=DY*DY;
YY=YM; IR=IL+1; IL=IL-1;
for i=1:N2
    YY=YY-DY;
    if(LINEAR==1) 
        while (YY<Y(IL)) & (IL>1)
            IL=IL-1;
        end
        while (YY<Y(IR)) & (IR<N)
            IR=IR+1;
        end
        XL=X(IL+1)+(YY-Y(IL+1))/(Y(IL)-Y(IL+1))*(X(IL)-X(IL+1));
        XR=X(IR-1)+(YY-Y(IR-1))/(Y(IR)-Y(IR-1))*(X(IR)-X(IR-1));
    else
% Uses Lagrange's formula for quadratic interpolation        
        while (YY<Y(IL-1)) & (IL>2)
            IL=IL-1;
        end
        while (YY<Y(IR+1)) & (IR<NM)
            IR=IR+1;
        end
  XL=(YY-Y(IL))*(YY-Y(IL+1))*X(IL-1)/((Y(IL-1)-Y(IL))*(Y(IL-1)-Y(IL+1)))...
     +(YY-Y(IL-1))*(YY-Y(IL+1))*X(IL)/((Y(IL)-Y(IL-1))*(Y(IL)-Y(IL+1)))...
     +(YY-Y(IL-1))*(YY-Y(IL))*X(IL+1)/((Y(IL+1)-Y(IL-1))*(Y(IL+1)-Y(IL))); 
  XR=(YY-Y(IR))*(YY-Y(IR-1))*X(IR+1)/((Y(IR+1)-Y(IR))*(Y(IR+1)-Y(IR-1)))...
     +(YY-Y(IR+1))*(YY-Y(IR-1))*X(IR)/((Y(IR)-Y(IR+1))*(Y(IR)-Y(IR-1)))...
     +(YY-Y(IR+1))*(YY-Y(IR))*X(IR-1)/((Y(IR-1)-Y(IR+1))*(Y(IR-1)-Y(IR)));
    end
    Y1(i)=YM-YY; T(i)=abs(XR-XL);
    AA=AA+DY*abs(XR1-XL1)+DY2*(abs(XR-XR1)+abs(XL1-XL));A(i)=AA;
    PP=PP+sqrt(DYS+(XR-XR1)^2)+sqrt(DYS+(XL1-XL)^2);P(i)=PP;
    XR1=XR; XL1=XL;
end
IOUT=input('Should output be written to file? (1=yes,0=no) ');
if(IOUT==1)
       FILNO=input('Give name of this file ');
       fido=fopen(FILNO,'w');
else
    fido=1;
end
fprintf(fido,'       Depth   Top Width     Area   Perimeter\n');
for i=1:N2
    fprintf(fido,'%10.2f %10.2f %10.2f %10.2f\n',Y1(i),T(i),A(i),P(i));
end
if(fido~=1)
    fclose(fido);
end
    
    