% This script accomplishes the tasks of the Fortran, C & Pascal
% programs whose listing are given in Appendix B.  As written all
% of these programs require that the input pairs of x y be in
% ascending order of magnitude of x.  What would you add to the 
% logic to allow descending order of x?  What changes would you
% make to have the output (interpolated) Y's correspond to a
% list of input X's?
N=input('Give no. of pairs of points ');  NM=N-1;
M=input('Give no. of output values ');
X=zeros(1,N); Y=zeros(1,N); D2Y=zeros(1,N); D=zeros(1,NM);
ITY=input('Give 0 for nat., or 1 for derivative end cond. ');
fid=input('Give 1 if input from keyboard, 2 otherwise ');
if fid ~=1
FILN=input('Give this file name ');
fid=fopen(FILN);
XY=fscanf(fid,'%f\n');
for i=1:N
   X(i)=XY(2*i-1);  Y(i)=XY(2*i);
end
fclose(fid);
else
    for i=1:N
        X(i)=input('x = '); Y(i)=input('y = ');
    end
end
if ITY == 0
    D2Y(1)=0.;  D(1)=0.;
else
    DY1=input('Give 1st derivative BC condition ');
    DYN=input('Give end derivative BC conditon ');
    D2Y(1)=-0.5; D(1)=3.*((Y(2)-Y(1))/(X(2)-X(1))-DY1)/(X(2)-X(1));  
end
for J=2:NM
   JM=J-1;
   JP=J+1;
   FAC=(X(J)-X(JM))/(X(JP)-X(JM));
   FA1=FAC*D2Y(JM)+2.0;
   D2Y(J)=(FAC-1.)/FA1;
   D(J)=(6.*((Y(JP)-Y(J))/(X(JP)-X(J))-(Y(J)-Y(JM))/(X(J)-X(JM)))/...
    (X(JP)-X(JM))-FAC*D(JM))/FA1;
   if ITY == 0
       D2YN=0.0; DN=0.0;
   else
       D2YN=0.5; DN=3.*(D2YN-(Y(N)-Y(NM)))/(X(N)-X(NM))^2;
   end
end
D2Y(N)=(DN-D2YN*D(NM))/(D2YN*D2Y(NM)+1.);
fido=input('Should output be written to file? 0=yes, 1=no ');
if fido < 1
    FILNO=input('Give name of this file ');
    fido=fopen(FILNO,'w')'
end
for J=NM:-1:1
   D2Y(J)=D2Y(J)*D2Y(J+1)+D(J);
end
XX=X(1); DELX=(X(N)-XX)/(M-1);
fprintf(fido,'%10.4f %10.4f\n',XX,Y(1));
JP=2;  J=1; DX=X(2)-X(1);
for I=2:M
    XX=XX+DELX;
    while (XX > X(JP)) & (JP < N)
        J=JP; JP=JP+1; DX=X(JP)-X(J);
    end
    A=(X(JP)-XX)/DX; B=1.-A;
    YY=A*Y(J)+B*Y(JP)+((A*A-1.)*A*D2Y(J)+(B*B-1.)*B*D2Y(JP))*DX*DX/6.;
    fprintf(fido,'%10.4f %10.4f\n',XX,YY);
end
 