% This script uses the function simpr to carry out the numerical
% integration required in Example Problem 1 in Appendix B. 
X=pi/2;
CLOIN2=4*X*(X^2-7)*sin(X)-(X^4-14*X^2+28)*cos(X);
X=0;
CLOIN1=4*X*(X^2-7)*sin(X)-(X^4-14*X^2+28)*cos(X);
FINT=simpr(inline('x.^2.0.*(x.^2-2).*sin(x)','x'),0,pi/2);
disp(['Closed form integral = ' num2str(CLOIN2-CLOIN1)]);
disp(['Numerical integral = ' num2str(FINT)]);