% This script solves problem such #11 in "Problem: (For you to work) that
% are given in Appendix A.  In other words is solve for one of the following
% variables: A, beta, D or Y given the other three.  Notice that with the
% angle beta as one of the variables it is not necessary to solve an
% implicit equation as is done with script appendixAhwk11
var='AbDY'; u=zeros(1,4);
 % The vector u represent the variables as follows:
 % u(1) = A (area)
 % u(2) = b (angle beta in radians)
 % u(3) = D (diameter)
 % u(4) = Y (depth)
for i=1:4
    disp([var(i) ' = ' num2str(i) ' ']);
end
ic=input('Give the number for the unknown ');
disp('Give value to known variables');
switch ic
    case 1   
        for i=[2 3 4]  
            if i==2
               u(i)=input([var(i) ' (radians) = ']);
            else
               u(i)=input([var(i) ' = ']);
            end
        end
        u(1)=u(3)^2/4*(u(2)-cos(u(2))*sin(u(2)));
    case 2
       for i=[3 4]
          u(i)=input([var(i) ' = ']);
       end
       u(2)=acos(1-2*u(4)/u(3));
    case 3
        for i=[1 2 4]
            if i==2
               u(i)=input([var(i) ' (radians) = ']);
            else
               u(i)=input([var(i) ' = ']);
            end
        end
        u(3)=sqrt(4*u(1)/(u(2)-cos(u(2))*sin(u(2))));
    case 4
        for i=[2 3]
            if i==2
               u(i)=input([var(i) ' (radians) = ']);
            else
               u(i)=input([var(i) ' = ']);
            end
        end
        u(4)=u(3)/2*(1-cos(u(2)));
end
fprintf(1,'unknown %c = % 10.4f\n',var(ic),u(ic));
P=u(2)*u(3); T=u(3)*sin(u(2));
if ic==1 | ic==3 
    Rh=u(1)/P;
    fprintf(1,'P =%8.4f, T =%8.4f, Rh =%8.4f\n',P,T,Rh);
else
    fprintf(1,'P =%8.4f, T =%8.4f\n',P,T);
end