% To do the interpolation requested in this problem the table produced in
% #12 is copied into a matrix named cross_sect. The columns in this table
% are: (1) Depth, (2) Top Width, (3) Area and (4) Wetted Perimeter.
% Spline interpolation is used utilizing the MATHLAB built-in function
% spline as shown by the  script below.  The results from executing this
% script in the command window is as follows, that contains the requested
% interpolated values.
%>>appendixAhwk14
%Top1 =  68.5273
%Top2 = 145.2781
%P1 =    70.9980
%P2 =   149.0310
%A1 =   189.1166
%A2 =   586.7361
cross_sect=[0.86       6.06       2.59       6.29
      1.71      13.71      11.04      14.14
      2.57      21.04      25.89      21.76
      3.42      29.10      47.32      30.24
      4.28      38.87      76.38      40.34
      5.13      49.84     114.30      51.69
      5.99      62.00     162.11      64.30
      6.84      75.97     221.09      78.60
      7.70      91.43     292.65      94.37
      8.55     108.36     378.06     111.59
      9.41     126.76     478.58     130.28
     10.26     146.73     595.50     150.50
     11.12     168.21     730.13     172.22
     11.97     191.20     883.78     195.43
     12.83     215.69    1057.72     220.15
     13.68     241.70    1253.26     246.36
     14.54     268.87    1471.53     273.76
     15.39     296.36    1713.16     301.76
     16.25     324.95    1978.77     331.05
 ];
Top1=spline(cross_sect(:,1),cross_sect(:,2),6.4)
Top2=spline(cross_sect(:,1),cross_sect(:,2),10.2)
P1=spline(cross_sect(:,1),cross_sect(:,4),6.4)
P2=spline(cross_sect(:,1),cross_sect(:,4),10.2)
A1=spline(cross_sect(:,1),cross_sect(:,3),6.4)
A2=spline(cross_sect(:,1),cross_sect(:,3),10.2)