% This script solves problem such #6 in "Problem: (For you to work) that
% are given in Appendix A.  To solve this problem you would give D = 36
% Q = 10 & V = 4.  The solution you should get is:A = 2.5000, beta = 1.3367
% Y = 1.1521,P = 4.0102, T = 2.9182, Rh = 0.6234
D = input('D = ')/12; Q=input('Q = '); V=input('V = ');  beta=pi/2;
A=Q/V
feq=inline('D^2/4*(beta-cos(beta)*sin(beta))-A','beta','D','A');
option=optimset('display','off');
beta=fsolve(feq,beta,option,D,A)
Y=D/2*(1-cos(beta))
P=D*beta
T=D*sin(beta)
Rh=A/P