%This script handles problem such as Problem 15 in Chapter 1 by performing
%several numerical integrations.  The script expands upon EXPRB5_1.m, and
%utilizes the function velocitye and flowratee.
global I1 I2 NP NX NE YP VP X Y VS D2VP D2VS D2Y
FILN=input('Give file name containing input data ');
fid=fopen(FILN);
ypvp=fscanf(fid,'%f');
fclose(fid);
NP=ypvp(1);
for i=1:NP
    YP(i)=ypvp(2*i); VP(i)=ypvp(2*i+1);
end
ii=2*NP+2;
NX=ypvp(ii);
for i=1:NX
    X(i)=ypvp(3*i+ii-2);Y(i)=ypvp(3*i+ii-1);VS(i)=ypvp(3*i+ii);
end
D2VP=splinesu(YP,VP,NP,0);
D2Y=splinesu(X,Y,NX,0);
D2VS=splinesu(X,VS,NX,0);
NE=0;
I1=1; I2=2;
AREA=simpr('flowratee',0,X(NX),1.e-5,15);
fprintf(1,'Area =%10.4f\n',AREA);
NE=1;
while NE<3
    NE=NE+1; I1=1; I2=2;
qPRIM=simpr('velocitye',0,1,1.e-5,15);
fprintf(1,'Integral of dimensionless velocity^%d profile=%10.4f\n',NE,qPRIM);
I1=1; I2=2;
DQ=simpr('flowratee',0,X(NX),1.e-5,15);
fprintf(1,'Integral with respect to x %10.4f\n',DQ*qPRIM);
end