% This script solve Chezy's equation in combination with Chezy's C
% equation.  It allows any of the variable to be selected as the unknown.
% It performs the same tasks as the Fortran program CH2PR2.FOR.
F=zeros(2,1); D=zeros(2,2); 
A=@(b,m,Y) (b+m*Y)*Y;
Rh=@(A,b,m,Y) A/(b+2*Y*sqrt(m^2+1));
F1=@(C,SQG,Rh1,Re,G8,e) C+SQG*log10(e/(12*Rh1)+G8*C/Re);
F2=@(Q,C,AR,Rh1,S) Q-C*AR*sqrt(Rh1*S);
icont=1
while icont
x=input('Give:1-e,2-b,3-m,4-Y,5-Q,6-S,g & vis in [ ] ');
IUN=input('Give number of unknown ');
e=x(1);b=x(2);m=x(3);Y=x(4);Q=x(5);S=x(6); g=x(7);visc=x(8);
G8=.884/sqrt(g); SQG=sqrt(32*g);C=SQG*log10(12*Rh(A(b,m,Y),b,m,Y/e));
DIF=1; DIF1=1;nct=0;
while (abs(DIF)+abs(DIF1) > 0.001) & (nct<20)
    AR=A(b,m,Y); Rh1=Rh(AR,b,m,Y); Re=4*Q*Rh1/(visc*AR);
    F(1)=F1(C,SQG,Rh1,Re,G8,e); F(2)=F2(Q,C,AR,Rh1,S); C=.98*C;
    D(1,1)=(F(1)-F1(C,SQG,Rh1,Re,G8,e))/(.02040816*C);
    D(2,1)=(F(2)-F2(Q,C,AR,Rh1,S))/(.02040816*C); C=C/0.98;
    switch IUN
        case 1
            e=.95*e; XUNK=e;
        case 2
            b=.95*b; XUNK=b;
        case 3
            m=.95*m; XUNK=m;
        case 4
            Y=.95*Y;  XUNK=Y;
        case 5
            Q=.95*Q;  XUNK=Q;
        case 6
            S=.95*S;  XUNK=S;
    end
    AR=A(b,m,Y); Rh1=Rh(AR,b,m,Y); Re=4*Q*Rh1/(visc*AR);
    D(1,2)=(F(1)-F1(C,SQG,Rh1,Re,G8,e))/(.05263158*XUNK);
    D(2,1)=(F(2)-F2(Q,C,AR,Rh1,S))/(.05263158*XUNK);
        switch IUN
        case 1
            e=e/0.95;
        case 2
            b=b/0.95;
        case 3
            m=m/0.95;
        case 4
            Y=Y/0.95; 
        case 5
            Q=Q/0.95;
        case 6
            S=S/0.95; 
    end
    FAC=D(2,1)/D(1,1); D(2,2)=D(2,2)-FAC*D(1,2); F(2)=F(2)-FAC*F(1);
    DIF=F(2)/D(2,2);
    switch IUN
        case 1
            e=e-DIF; x(1)=e;
        case 2
            b=b-DIF; x(2)=b;
        case 3
            m=m-DIF;  x(3)=m;
        case 4
            Y=Y-DIF;  x(4)=Y;
        case 5
            Q=Q-DIF;  x(5)=Q;
        case 6
            S=S-DIF;  x(6)=S;
    end
    DIF1=(F(1)-DIF*D(1,2))/D(1,1);  C=C-DIF1; nct=nct+1;
end
fprintf('Solution: C= %10.3f\n',C);
for i=1:6
    fprintf('%d = %10.5f\n',i,x(i));
end
icont=input('Solve another problem? (0=no, 1=yes) ');
end