%This script is designed to solve for Q, Y, b or m (of if circular D),
%given the value of the momentum function.  It other words it can be used
%in conjunction with script "momentum.m" to solve problems involving
%momentum.  The function "fmomensol.m" is used by this script to define the
%momentum function being solved.
cx='QYbm';   N=4;
g=input('Give g = '); itype=input('Give type of channel (0=trap,1=cir) ');
if itype, N=3; cx(3)='D'; cx(4)=[]; end;
MOM=input('Give value of momentum function L^3 ');
disp('Give number of the unknown');
for i=1:N
    fprintf('%3.0f  %s\n',i,cx(i));
end
nuk=input(' '); disp('Give value to variables');
for i=1:N
    if i==nuk
        var(i)=input([cx(i) '(guess) = ']);
    else
        var(i)=input([cx(i) '(known) = ']);
    end
end
opt=optimset('display','off');  unk=var(nuk);
unk=fsolve('fmomensol',unk,opt,itype,nuk,g,MOM,var);
var(nuk)=unk;
if itype
    cosb=1-2*var(2)/var(3); beta=acos(cosb);
    A=.25*var(3)^2*(beta-sin(beta)*cosb); T=var(3)*sin(beta);
else
    A=(var(3)+var(4)*var(2))*var(2); T=var(3)+2*var(4)*var(2);
end
E=var(2)+(var(1)/A)^2/(2*g); Fr=sqrt(var(1)^2*T/(g*A^3));
fprintf('E =%9.4f, Fr =%9.4f, unknown = %9.4f\n',E,Fr,unk);
for i=1:N
    fprintf('%s  =%9.4f\n',cx(i),var(i));
end


