%This script solve Example Problem 9 in Chapter 4.  It is essentially
%script solgvfa with a for loop to vary the value of the downstream channel
%width b2.  The dialog in the command window to solve Example Problem 9 is
%as follows: (the solution is included)
%>>ep9ch4
%Give:b1,m1,n,So,H,L,KL,KE,g in [ ] [5 1.2 .015 .0005 3.5 300 .025 .05 9.81]
%Give guesses for: Q,Y1 & Y2 in [ ] [35 3.5 3.6]
%Give starting value for b2 3
%Give final value for b2 8
%Give increment for b2 .5
%   b2          Q          Y1         Y2        Yc
%    3.00      34.69      3.434      3.557      2.389
%    3.50      40.24      3.410      3.521      2.379
%    4.00      45.66      3.381      3.478      2.368
%    4.50      50.95      3.348      3.427      2.355
%    5.00      56.07      3.309      3.367      2.340
%    5.50      60.99      3.265      3.296      2.323
%    6.00      65.68      3.215      3.211      2.303
%    6.50      70.10      3.159      3.109      2.280
%    7.00      74.21      3.095      2.980      2.254
%    7.50      78.01      3.020      2.801      2.226
%    8.00      82.00      2.924      2.442      2.204
global b1 m1 n So b2 H L KL KE1 Cu g g2 Q2G QN
var=input('Give:b1,m1,n,So,H,L,KL,KE,g in [ ] ');
b1=var(1);m1=var(2);n=var(3);So=var(4);H=var(5);L=var(6);
KL=var(7);KE=var(8);g=var(9);  Cu=1.; g2=2*g;KE1=KE+1;
if g>20
    Cu=1.486;
end
X=zeros(1,3);
X=input('Give guesses for: Q,Y1 & Y2 in [ ] ');
b2b=input('Give starting value for b2 ');
b2f=input('Give final value for b2 ');
db2=input('Give increment for b2 ');
option=optimset('display','off','TolX',1.e-4);
fprintf('     b2          Q         Y1         Y2        Yc\n'); 
for b2=b2b:db2:b2f
XX=fsolve('fsolgvfa',X',option);
fprintf('%8.2f %10.2f %10.3f %10.3f %10.3f\n',b2,XX',((XX(1)/b2)^2/g)^.333333);
X=XX;
end