%This script is the MATLAB conversion of Program HVARYX.FOR used to solve
%Example Problem 6 in Chapter 6.  To solve this problem the input consists
%first of [1.824 1.692 2 .005 .2 9.81 10 10 4] followed by [0 100 200 300]
%The solution tables are display on the monitor.  What changes would you
%make so that the output may be written to a file if desired?
var=input('Give: Yo,Vo,Ho,dH/dt,Ke,g,NT,Dt,NS enclosed in [ ] ');
Yo=var(1);Vo=var(2);Ho=var(3);dHdt=var(4);Ke=var(5);g=var(6);NT=var(7);
IDT=var(8);NS=var(9);
disp(['Give ' num2str(NS) 'positions for x in [ ]']);
x=input('x''s = '); op=optimset('display','off');
co=sqrt(g*Yo); dcdt=sqrt(g)*abs(dHdt); Voc=Vo-2*co; Voco=Vo+co;EK=(1+Ke)/2;
for i=1:NS
    c=co; xx=x(i); fprintf(1,'\n');
    fprintf(1,'At station  x = %8.1f\n   Time    H      c       Y       V       q\n',xx);
    fprintf(1,'---------------------------------------------\n');
    tim1=xx/Voco;  ii=tim1/IDT; kk=1;
    for k=0:ii
      kk=kk+1;
      fprintf(1,'%6.0f %7.3f %7.3f %7.3f %7.3f %7.3f\n',k*IDT,Ho,c,c^2/g,2*c+Voc,c^2/g*(2*c+Voc));
    end
        for k=kk:NT
        time=k*IDT; c=c-dcdt*(time-tim1);
        fun=inline('time-abs(Ho-(c^2+EK*(2*c+Voc)^2)/g)/abs(dHdt)-xx/(3*c+Voc)','c','Ho',...
            'EK','g','dHdt','xx','Voc','time');
        c=fsolve(fun,c,op,Ho,EK,g,dHdt,xx,Voc,time);
        H=(c^2+EK*(2*c+Voc)^2)/g;
        fprintf(1,'%6.0f %7.3f %7.3f %7.3f %7.3f %7.3f\n',time,H,c,c^2/g,2*c+Voc,c^2/g*(2*c+Voc));
        tim1=time;
        end
end
    