%This script is the MATLAB version of Program UNTYPE4.FOR listed in the
%text to solve Ex. Problem 4 in Chapter 6.  Rather than using the Newton
%method it used the MATLAB built-in function fsolve to repeatedly solve the
%equation given in this Ex. Prb. The same input is used namely
%[6 4 30 2400 1500 32.2 7200]

var=input('Give:Yo,Vo,DT,DTDY,x,g,TE within [ ] ');
Yo=var(1);Vo=var(2);DT=var(3);DTDY=var(4);x=var(5);g=var(6);TE=var(7);
co=sqrt(g*Yo); TS=x/(Vo+co); N=(TE-TS)/DT; C1=3*DTDY/g; VOC=Vo-2*co;
C2=DTDY*VOC/g; DYo=Yo*DTDY; c=.95*co; opt=optimset('display','off');
for i=0:N
    t=TS+i*DT;  C3=t-DYo;
    c=fsolve(inline('((C1*c+C2)*c+3*C3)*c+VOC*C3-x','c','C1','C2','C3','VOC','x'),c,opt,C1,C2,C3,VOC,x);
    Y=c^2/g; V=2*(c-co)+Vo;
    fprintf('%5.0f %7.3f %7.3f %7.3f %7.2f\n',t,c,Y,V,V*Y);
end