      PARAMETER (N=4)
      REAL F(N),D(N,N),X(N),KL1,KE1,KL,KE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,H,G,G2,KL1,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,Y4,
     &A4,QSG
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3)),(Y3,X(4))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,b1,m1,b2,H,L,YG,g,KL,KE,Cc,Ns,
     &YG2'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B1,FM1,B2,H,FL,YG,G,KL,KE,CCO,NS,YG2
      WRITE(IOUT,200)
200   FORMAT('  Gate  Flowrate      Depths (meters)',/,
     &'   (m)  (m**3/s) at Beg.C. at End C. at End T.')
      DYG=(YG-YG2)/FLOAT(NS-1)
      Y4=CCO*YG
      A4=(Y4*B2)**2
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KL1=1.+KL
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Y1,Y2,Y3'
      READ(*,*) X
50    NCT=0
1     DO 10 I=1,N
      F(I)=FUN(I)
      DO 10 J=1,N
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
C   Solves system of equations using Gaussian Elimination
      DO 12 J=1,N-1
      DO 12 I=J+1,N
      FAC=D(I,J)/D(J,J)
      F(I)=F(I)-FAC*F(J)
      DO 12 K=J+1,N
12    D(I,K)=D(I,K)-FAC*D(J,K)
      F(N)=F(N)/D(N,N)
      X(N)=X(N)-F(N)
      SUM=ABS(F(N))
      DO 16 I=N-1,1,-1
      FAC=0.
      DO 14 J=I+1,N
14    FAC=FAC+D(I,J)*F(J)
      F(I)=(F(I)-FAC)/D(I,I)
      X(I)=X(I)-F(I)
16    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I2,F12.2,4F10.4)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,100) YG,X
100   FORMAT(F6.2,4F10.3)
      YG=YG-DYG
      IF(YG.LT.YG2-.01) STOP
      Y4=CCO*YG
      A4=(Y4*B2)**2
      GO TO 50      
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(4),W(1,13),KL1,KE1,Y(1),DY(1),
     &XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,H,G,G2,KL1,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,Y4,
     &A4,QSG
      H1=-.05
      HMIN=.001
      Q2G=X(1)*X(1)/G2   
      GO TO (1,2,3,4),II
1     FUN=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      RETURN
2     FUN=X(3)+Q2G/((B1+FM1*X(3))*X(3))**2-X(4)-
     &KL1*Q2G/(B2*X(4))**2
      RETURN
3     FUN=X(4)+Q2G/(B2*X(4))**2-Y4-Q2G/A4
      RETURN
4     Y(1)=X(3)
      XX=FL
      XZ=0.
      QN=(FN*X(1)/CC)**2
      QSG=X(1)*X(1)/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KL1,KE1,X(4)
      COMMON /TRAS/B1,FM1,B2,H,G,G2,KL1,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,Y4,
     &A4,QSG
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3)),(Y3,X(4))
      P=B1+2.*SQRT(FM1*FM1+1.)*Y(1)
      A=(B1+FM1*Y(1))*Y(1)
      SF=QN*((P/A)**.666666667/A)**2
      T=B1+2.*FM1*Y(1)
      DY(1)=(SO-SF)/(1.-QSG*T/A**3)
      RETURN
      END