C  Uses Newton Method to solve q=(c**2/g)*(2c+Vo-2co)
1     WRITE(*,*)' Give: Yo,Vo,q & g'
      READ(*,*) Yo,Vo,q,g
      IF(Yo.LT.1.E-5) STOP
      co=SQRT(g*Yo)
      VOC=(Vo-2.*co)
      GQ=g*q
      c=.9*co
      M=0
5     F=c*c*(2.*c+VOC)-GQ
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      CC=c
      c=1.005*c
      GO TO 5
      ENDIF
      DIF=(c-CC)*FF/(F-FF)
      c=CC-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 5
      IF(M.EQ.30) WRITE(*,*)' Failed to converge',DIF,c
      Y=c*c/g
      V=2.*c+Vo-2.*co
      WRITE(6,100) Yo,Vo,q,g,c,Y,V,V+C
100   FORMAT(' Yo=',F8.4,' Vo=',F8.3,' q=',F8.3,' g=',F8.2,/
     &' c=',F9.5,' Y=',F9.5,' V=',F9.5,' dx/dt=',F9.5)
      GO TO 1
      END