C Solves critical flow and Energy simultaneously for any 2 unknowns
      CHARACTER*17 FMT/'(1X,A1,'' ='',F9.3)'/
      CHARACTER*1 CX(6)/'b','m','Q','H','Y','K'/
      CHARACTER*5 CH(0:1)/'value','guess'/
      REAL F(2),F1(2),D(2,2)
      INTEGER*2 ID(6),INDX(2)
      COMMON X(6),G,FKE,ITYPE
      WRITE(*,*)' Give: g,entrance loss C. & 0=TRAP or 1=CIRLCE'
      READ(*,*) G,FKE,ITYPE
      IF(ITYPE.EQ.1) THEN
      CX(1)='D'
      CX(2)=' '
      ENDIF
      X(6)=FKE
      FKE=(1.+FKE)/(2.*G)
1     DO 10 I=1,5
      IF(ITYPE.EQ.1 .AND. I.EQ.2) GO TO 10
      WRITE(*,'(I2,2X,A1)') I,CX(I)
10    ID(I)=0
2     WRITE(*,*)' Give two numbers for 2 unknown variables'
      READ(*,*) I1,I2
      IF(I1.LT.1 .OR. I1.GT.7 .OR. I2.LT.1 .OR. I2.GT.7) GO TO 2
      ID(I1)=1
      ID(I2)=1
      DO 20 I=1,5
      IF(ITYPE.EQ.1 .AND. I.EQ.2) GO TO 20
      WRITE(*,100) CH(ID(I)),CX(I)
100   FORMAT(' Give ',A5,' for ',A1,' = ',\)
      READ(*,*) X(I)
20    CONTINUE
      NCT=0
30    SUM=0.
      CALL FUN(F)
      I1=0
      DO 40 I=1,5
      IF(ID(I).EQ.0) GO TO 40
      XX=X(I)
      I1=I1+1
      X(I)=1.005*X(I)
      CALL FUN(F1)
      DO 35 J=1,2
35    D(J,I1)=(F1(J)-F(J))/(X(I)-XX)
      X(I)=XX
40    CONTINUE
      CALL SOLVEQ(2,1,2,D,F,1,DD,INDX)
      I1=0
      DO 50 I=1,5
      IF(ID(I).EQ.0) GO TO 50
      I1=I1+1
      SUM=SUM+ABS(F(I1))
      X(I)=X(I)-F(I1)
50    CONTINUE
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 30
      WRITE(*,*)' Solution:'
      DO 60 I=1,6
      IF(ITYPE.EQ.1 .AND. I.EQ.2) GO TO 60
      WRITE(*,FMT) CX(I),X(I)
60    CONTINUE
      WRITE(*,*)' Give 1 to solve another prob. (0=STOP)'
      READ(*,*) I2
      IF(I2.EQ.1) GO TO 1
      END
      SUBROUTINE FUN(F)
      REAL F(2)
      COMMON X(6),G,FKE,ITYPE
      IF(ITYPE.EQ.1) THEN
      BETA=ACOS(1.-2.*X(5)/X(1))
      A=.25*X(1)**2*(BETA-COS(BETA)*SIN(BETA))
      T=X(1)*SIN(BETA)
      ELSE
      A=(X(1)+X(2)*X(5))*X(5)
      T=X(1)+2.*X(2)*X(5)
      ENDIF
      F(1)=X(3)**2*T-G*A**3
      F(2)=X(4)-X(5)-FKE*(X(3)/A)**2
      RETURN
      END