/* Solves Critical and Specific Energy for Y & Q by substituting Critical Eq.
   into Energy and first solving for Y and thereafter Q.  (This is the procedure
   to use with a pocket calculator)  See program E_CR to solve any 2 variables. */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
float b,m,d,h,c; int itype;
void areap(float y,float *a,float *t){float cosb,beta;
 if(itype){cosb=1.-2.*y/d;beta=acos(cosb);*t=d*sin(beta);*a=.25*d*d*(beta-cosb*sin(beta));}
  else {*t=b+2.*y*m; *a=(b+m*y)*y;return; } }
float fun(float y){float *a,*t; areap(y,a,t);return(h-y-c*(*a)/(*t));}
void main(void){float g,dif,ke,y,f,q,*a,*t; int nct=0;
 printf("Give: g(0=trap or 1=cir)\n"); scanf("%f %d",&g,&itype);
 if(itype){printf("Give: D,H,Ke\n"); scanf("%f %f %f",&d,&h,&ke);}
  else {printf("Give: b,m,H,Ke\n"); scanf("%f %f %f %f",&b,&m,&h,&ke);}
 y=.7*h; c=.5*(1.+ke);
do{f=fun(y); dif=.05*f/(fun(y+.05)-f); y-=dif;printf("%d %f %f\n",++nct,dif,y);
  }while((nct<30) && (fabs(dif)>1.e-5));
 areap(y,a,t); q=sqrt(g*pow((*a),3.)/(*t));
 printf("Solution: Y = %8.3f Q = %10.2f\n",y,q);
}