C Solves Critical and Specific Energy for Y & Q by substituting Critical Eq.
C into Energy and first solving for Y and thereafter Q.  (This is the procedure
C to use with a pocket calculator)  See program E_CR to solve any 2 variables.
      COMMON B,FM,D,H,C,ITYPE
      WRITE(*,*)' Give: g,(0=trap or 1=cir)'
      READ(*,*) G,ITYPE
      IF(ITYPE.EQ.0) THEN
      WRITE(*,*)' Give: b,m,H,Ke'
      READ(*,*) B,FM,H,FKE
      ELSE
      WRITE(*,*)' Give: D,H,Ke'
      READ(*,*) D,H,FKE
      ENDIF
      C=.5*(1.+FKE)
      Y=.7*H
      NCT=0
10    F=FUN(Y)
      DIF=.05*F/(FUN(Y+.05)-F)
      Y=Y-DIF
      NCT=NCT+1
      WRITE(*,*) NCT,DIF,Y
      IF(NCT.LT.30 .AND. ABS(DIF).GT. 1.E-5) GO TO 10
      CALL AREAP(Y,A,T)
      Q=SQRT(G*A**3/T)
      WRITE(*,100) Y,Q
100   FORMAT(' Solution: Y =',F8.3,' Q =',F10.2)
      END
      SUBROUTINE AREAP(Y,A,T)
      COMMON B,FM,D,H,C,ITYPE
      IF(ITYPE.EQ.1) THEN
      COSB=1.-2.*Y/D
      BETA=ACOS(COSB)
      T=D*SIN(BETA)
      A=.25*D*D*(BETA-COSB*SIN(BETA))
      ELSE
      T=B+2.*Y*FM
      A=(B+FM*Y)*Y
      ENDIF
      RETURN
      END
      FUNCTION FUN(Y)
      COMMON B,FM,D,H,C,ITYPE
      CALL AREAP(Y,A,T)
      FUN=H-Y-A*C/T
      RETURN
      END