//Solves the problem of outflow from grates in its bottom of a triangular channel.
// The case being solved is when Q = Qout at the end of the grate and a specified 
// flowrate Qin enters at its beginning.
// y2=x[0], y1=x[1]
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
float x[2],so,fm,fms,qin,qout,cc,fn,hm,g,g2,g8,dxg,tol,flg,dxgh,cd,sqstar,qs1,xx; int done;
FILE *filo,*fil1;
extern void solveq(int n,float **a,float *b,int itype,float *dd,int *indx);
extern void rukust(int ne,float *dxs,float xbeg,float xend,float err,float *y,float *ytt);
void slope(float xp,float *y,float *dy){ float yy,qs2,a,q,sf,fr2;
 yy=*y; qs2=cd*sqrt(yy); a=hm*yy*yy; q=qin-sqstar-.5*(xp-xx)*(qs1+qs2);
 sf=fn*q/cc*pow(fms*yy/a,.66666667)/a; sf=sf*abs(sf); fr2=q*q*fm*yy/(g*a*a*a);
 dy[0]=(so-sf+q*qs2/(g*a*a))/(1.-fr2); return;
}  // end of slope
void fun(float *f) { float a,xz,q,qs2,dxs[1],y[1],yyt[1];  int i;
 dxs[0]=.1; xx=0.; sqstar=0.,qs1=cd*sqrt(x[1]); y[0]=x[1];
 if(done){a=hm*x[1]*x[1];
 fprintf(filo,"       x          Y         Q        q*        E         A           Fr\n");
 for(i=0;i<69;i++) fprintf(filo,"-");fprintf(filo,"\n");
 fprintf(filo,"%10.1f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f\n",0.,x[1],qin,qs1,x[1]+pow(qin/a,2.)/g2,a,\
  qin/(fm*sqrt(g8*pow(x[1],5.))));}
L30: xz=xx+dxg; if(xz>flg) xz=flg;
 rukust(1,dxs,xx,xz,tol,y,yyt); qs2=cd*sqrt(y[0]); sqstar+=dxgh*(qs1+qs2);
 if(done){a=hm*y[0]*y[0]; q=qin-sqstar;
 fprintf(filo,"%10.3f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f\n",xz,y[0],q,qs2,y[0]+pow(q/a,2.)/g2,a,\
  q/(fm*sqrt(g8*pow(y[0],5.))));}
 qs1=qs2; xx=xz; if(xz<flg) goto L30;
 f[0]=x[0]-y[0]; f[1]=qin-qout-sqstar;  return;
}  // end of fun
void main(void){char fname[20]; int i,j,nct,iii,iij,kkk=1,indx[2];
 float f[2],**d,fff[2],b,dxx,sum,frr,fr1,frac,err,*dd;
d=(float**)malloc(2*sizeof(float*));for(i=0;i<2;i++)d[i]=(float*)malloc(2*sizeof(float));
 printf("Give name of output file\n");scanf("%s",fname);
 if((filo=fopen(fname,"w"))==NULL){printf("Cannot open file");exit(0);}
 printf("GIVE:TOL,ERR,FN,SO,FM,FLG,G,DXG,Qin,Qout,B,FRAC,CD\n");
 scanf("%f %f %f %f %f %f %f %f %f %f %f %f %f",&tol,&err,&fn,&so,&fm,&flg,&g,&dxg,&qin,&qout,&b,&frac,&cd);
 done=0; dxgh=.5*dxg; hm=.5*fm; fms=1.+sqrt(fm*fm+1.);cc=1.; if(g>25.) cc=1.486;
 g2=2.*g; cd*=sqrt(g2)*frac*b; g8=.125*g;
 printf("GIVE guess for: Y2 & Y1\n");scanf("%f %f",&x[0],&x[1]);
L7: nct=0;
L8: fun(f);  printf("NCT=%d,%f %f\n",nct,f[0],f[1]);
for(j=0;j<2;j++){ dxx=.005*x[j]; x[j]+=dxx; fun(fff);
  for(i=0;i<2;i++) d[i][j]=(fff[i]-f[i])/dxx; x[j]-=dxx;}
solveq(2,d,f,1,dd,indx);  nct++; sum=0.;
 for(i=0;i<2;i++){x[i]-=f[i]; sum+=fabs(f[i]);}
 printf("NCT= %d SUM= %f\n %10.3f %9.3f\n",nct,sum,x[0],x[1]);
if((nct<30) && (sum>err)) goto L8;
 printf("Give:1=write profiles, 2=just Y's, 3 = both\n"); scanf("%d",&iii);
if((iii>2)&& kkk){printf("Give name for other file\n");scanf("%s",fname);kkk=0;
 if((fil1=fopen(fname,"w"))==NULL){printf("Cannot open file");exit(0);}}
 frr=sqrt(qin*qin*fm*x[1]/(g*pow(hm*x[1]*x[1],3.)));
 fr1=sqrt(qout*qout*fm*x[0]/(g*pow(hm*x[0]*x[1],3.)));
 if(iii>1){fprintf(filo,"%7.3f %6.3f %6.3f %6.3f\n",x[0],x[1],frr,fr1);if(iii==2) goto L45;}
 fprintf(fil1," Y2=%7.3f Y1=%7.3f (Fr)u=%7.3f (Fr)d=%7.3f\n",x[0],x[1],frr,fr1);
 done=1; fun(f);
L45:printf("Give 1 to solve another problem or 0 = STOP\n");scanf("%d",&iij);
if(iij==0) goto L46; printf("Give new Qin & Qout\n");scanf("%f %f",&qin,&qout);goto L7;
L46: fclose(filo); if(kkk==0) fclose(fil1);
}