C Solves the problem of outflow from grates in its bottom of a triangular channel.
C  The case being solved is when Q = Qout at the end of the grate and a specified 
C  flowrate Qin enters at its beginning.
C  Y2=X(1), Y1=X(2)
      INTEGER*2 INDX(2)
      EXTERNAL DYX
      LOGICAL DONE
      REAL F(2),D(2,2),FFF(2)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(2),SO,FM,FMS,Qin,Qout,CC,FN,HM,G,G2,G8,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,XX,DONE,IOUT
      WRITE(*,*)'Give:IO,TOL,ERR,n,So,m,Lgrate,g,DXG,Qin,Qout,b,frac,Cd'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FLG,G,DXG,Qin,Qout,B,FRAC,CD
      IOU1=IOUT+1
      DONE=.FALSE.
      DXGH=DXG/2.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      CD=CD*SQRT(G2)*FRAC*B
      G8=.125*G
      WRITE(*,*)' GIVE guess for:Y2 & Y1'
      READ(*,*) X
7     NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,2
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,2
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(2,1,2,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,2
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,6F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(*,*)' Give:1=write profiles, 2=just Y''s, 3=both'
      READ(*,*) III
      Frr=SQRT(Qin**2*FM*X(2)/(G*(HM*X(2)**2)**3))
      Frl=SQRT(Qout**2*FM*X(1)/(G*(HM*X(1)**2)**3))
      IF(III.GT.1) THEN
      WRITE(IOU1,151) Qin,Qout,X,Frr,Frl
151   FORMAT(2F8.2,4F7.3)
      IF(III.EQ.2) GO TO 45
      ENDIF
      WRITE(IOUT,100) Qin,Qout,X,Frr,Frl
100   FORMAT(' Qin=',F8.3,', Qout=',F8.3,/,' Y2=',F7.3,', Y1=',F7.3,
     &', (Fr)u=',F7.3,', (Fr)d=',F7.3)
      DONE=.TRUE.
      CALL FUN(F)
      DONE=.FALSE.
45    WRITE(*,*)' Give 1 to solve another problem or 0 = STOP'
      READ(*,*) III
      IF(III.EQ.0) STOP
      WRITE(*,*)' Give new Qin & Qout'
      READ(*,*) Qin,Qout
      GO TO 7
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(2)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(2),SO,FM,FMS,Qin,Qout,CC,FN,HM,G,G2,G8,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,XX,DONE,IOUT
      HMIN=1.E-9
      H1=.005
      XX=0.
      SQSTAR=0.
      QS1=CD*SQRT(X(2))
      Y(1)=X(2)
      IF(DONE) THEN
      A=HM*X(2)**2
      WRITE(IOUT,120) 0.,X(2),Qin,QS1,X(2)+(Qin/A)**2/G2,A,Qin/(FM*SQRT(
     &G8*X(2)**5))
120   FORMAT(/,'       x          Y         Q        q*        E         
     &A           Fr',/,1X,69('-'),/,F10.1,6F10.3)
      ENDIF
30    XZ=XX+DXG
      IF(XZ.GT.FLG) XZ=FLG
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      QS2=CD*SQRT(Y(1))
      SQSTAR=SQSTAR+DXGH*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=Qin-SQSTAR
      WRITE(IOUT,130) XZ,Y,Q,QS2,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**
     &5))
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.FLG) GO TO 30
      F(1)=X(1)-Y(1)
      F(2)=Qin-Qout-SQSTAR
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(2),SO,FM,FMS,Qin,Qout,CC,FN,HM,G,G2,G8,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,XX,DONE,IOUT
      YY=Y(1)
      QS2=CD*SQRT(YY)
      A=HM*YY**2
      Q=Qin-SQSTAR-.5*(XP-XX)*(QS1+QS2)
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END