C Solves the problem of side flow into a triangular gutter.
      INTEGER*2 INDX(4)
      LOGICAL DONE
      REAL F(4),D(4,4),FFF(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,FL,DX,GM2,TOL,
     &DONE,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,m,L,g,DX,q*'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FL,G,DX,QS
      DONE=.FALSE.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      G5=.125*G
      GM2=G5*FM*FM
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) X(4)
      X(1)=((QS*X(4))**2/GM2)**.2
      X(2)=((QS*(FL-X(4)))**2/GM2)**.2
      X(3)=X(1)+X(2)
      WRITE(*,*)' Guesses for x',X
      GM2=FM*GM2
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,4
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,4
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,4
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,4F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(3,100) X
100   FORMAT(' Yc1=',F8.3,', Yc2=',F8.3,', Depth at Q=0',F8.3,' Xs=',
     &F8.1)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,FL,DX,GM2,TOL,
     &DONE,IOUT
      F(1)=FM*X(1)*(QS*X(4))**2-GM2*X(1)**6
      F(2)=FM*X(2)*(QS*(FL-X(4)))**2-GM2*X(2)**6
      HMIN=.001
      IF(DONE) THEN
      A=HM*X(1)**2
      Q=QS*X(4)
      WRITE(IOUT,100) 0.,X(1),Q,X(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*X(1)**5
     &))
      ENDIF
100   FORMAT('       x          Y         Q        E        A        Fr'
     &,/,1X,57('-'),/,F10.1,5F10.3)
      H1=.1
      XX=0.
      Y(1)=1.1*X(1)
10    XZ=XX+DX
      IF(XZ.GT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*(X(4)-XZ)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*Y(1)**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT. X(4)) GO TO 10
      F(3)=X(3)-Y(1)
      H1=-.1
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QS*(FL-X(4))
      WRITE(IOUT,100) FL,X(2),Q,X(2)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*X(2)**5
     &))
      ENDIF
      XX=FL
      Y(1)=1.1*X(2)
20    XZ=XX-DX
      IF(XZ.LT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*(XZ-X(4))
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G5*Y(1)**5))
      ENDIF
      XX=XZ
      IF(XZ.GT. X(4)) GO TO 20
      F(4)=X(3)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(4),SO,FM,FMS,QS,CC,FN,HM,G,G2,G5,FL,DX,GM2,TOL,
     &DONE,IOUT
      A=HM*Y(1)**2
      Q=QS*(XX-X(4))
      SF=FN*Q/CC*(FMS*Y(1)/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*Y(1)/(G*A**3)
      IF(FR2.GT..95) FR2=.95
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END