C solves for position of Hyd. Jump downstream from gate with critical depth at
C  end of channel, or with a downstream water surface at elev. WS.
C  Different than GVFJMP2 in that it writes profiles
      INTEGER*2 INDX(3)
      REAL F(3),D(3,3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON/TRAS/ B,FM,FM2,TWOM,FNQ,QG2,SO,C,G,FL,YB,WS,X(3),DELX,NONE
     &,IOUT
      WRITE(6,*)'Give:IOUT,Q,b,m,So,n,L,WS,Yb,g,Delx, Est x,Y1 & Y2'
      READ(5,*) IOUT,Q,B,FM,SO,FN,FL,WS,YB,G,DELX,X
      NONE=0
      IF(FM.LT.1.E-5) THEN
      YC=((Q/B)**2/G)**.333333
      GO TO 2
      ENDIF
      QP=FM**3*Q**2/(G*B**5)
      YC=.925*(.5*qp)**.284
      NCT=0
1     FF=(YC+YC**2)**3/(1.+2.*YC)-QP
      YC1=1.01*YC
      X1=(YC1-YC)*FF/((YC1+YC1**2)**3/(1.+2.*YC1)-QP-FF)
      YC=YC-X1
      NCT=NCT+1
      IF(ABS(X1).GT.1.E-5 .AND. NCT.LT.20) GO TO 1
      YC=B*YC/FM
2     WRITE(IOUT,*)' Critical Depth =',YC
      IF(WS.LT.YC) THEN
      WRITE(IOUT,*)' Depth at end of channel is critical'
      WS=1.03*YC
      ENDIF
      C=1.
      IF(G.GT.30.) C=1.486
      QG2=Q*Q/G
      TWOM=2.*FM
      FNQ=FN*Q/C
      FM2=2.*SQRT(FM*FM+1.)
      NCT=0
3     DO 10 I=1,3
      F(I)=FUN(I)
      DO 10 J=1,3
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(3,1,3,D,F,1,DD,INDX)
      SUM=0.
      DO 12 I=1,3
      SUM=SUM+ABS(F(I))
      IF(I.EQ.1) THEN
      IF(ABS(F(I)).GT. 10.) F(I)=.2*F(I)
      ELSE
      IF(ABS(F(I)).GT.1.) F(I)=.2*F(I)
      ENDIF
12    X(I)=X(I)-F(I)
      NCT=NCT+1
C      WRITE(*,*) NCT,SUM,X
      IF(NCT.LT.30 .AND. SUM.GT. 2.E-3) GO TO 3
      WRITE(IOUT,100) X
100   FORMAT(' x =',F10.2,' Y1 =',F10.2,' Y2 =',F10.2)
      NONE=1
      WRITE(IOUT,101) 'upstream'
101   FORMAT(' Profile ',A10,' of Hydraulic Jump',/,'     x         Y  
     &     E       M')
      A=(B+FM*YB)*YB
      WRITE(IOUT,110) 0.,YB,YB+.5*QG2/A**2,(.5*B+FM/3.*YB)*YB*2+QG2/A
110   FORMAT(F9.2,2F9.3,F9.2)
      F(2)=FUN(2)
      WRITE(IOUT,101) 'downstream'
      A=(B+FM*WS)*WS
      WRITE(IOUT,110) FL,WS,WS+.5*QG2/A**2,(.5*B+FM/3.*WS)*WS*2+QG2/A
      F(3)=FUN(3)
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL Y(1),W(1,13),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON/TRAS/ B,FM,FM2,TWOM,FNQ,QG2,SO,C,G,FL,YB,WS,X(3),DELX,NONE
     &,IOUT
      WRITE(*,*) X,DELX,NONE,IOUT
      HMIN=.0001
      H1=1.
      GO TO (1,2,3),II
1     FUN=(.5*B+FM/3.*X(2))*X(2)**2+QG2/((B+FM*X(2))*X(2))-(.5*B+FM/3.*X
     &(3))*X(3)**2-QG2/((B+FM*X(3))*X(3))
      RETURN
2     Y(1)=YB
      IF(NONE.EQ.0) THEN
      CALL ODESOL(Y,DY,1,0.,X(1),1.E-6,H1,HMIN,1,XP,YP,W,DYX)
      ELSE
      X1=0.
10    X2=X1+DELX
      IF(X2.GT.X(1)) X2=X(1)
      CALL ODESOL(Y,DY,1,X1,X2,1.E-6,H1,HMIN,1,XP,YP,W,DYX)
      A=(B+FM*Y(1))*Y(1)
      WRITE(IOUT,100) X2,Y,Y(1)+.5*QG2/A**2,(.5*B+FM/3.*Y(1))*Y(1)**2+
     &QG2/A
      X1=X2
      IF(X2.LT.X(1)) GO TO 10
100   FORMAT(F9.2,2F9.3,F9.2)
      ENDIF
      FUN=X(2)-Y(1)
      RETURN
3     Y(1)=WS
      H1=-1.
      IF(NONE.EQ.0) THEN
      CALL ODESOL(Y,DY,1,FL,X(1),1.E-6,H1,HMIN,1,XP,YP,W,DYX)
      ELSE
      X1=FL
11    X2=X1-DELX
      IF(X2.LT.X(1)) X2=X(1)
      CALL ODESOL(Y,DY,1,X1,X2,1.E-6,H1,HMIN,1,XP,YP,W,DYX)
      A=(B+FM*Y(1))*Y(1)
      WRITE(IOUT,100) X2,Y,Y(1)+.5*QG2/A**2,(.5*B+FM/3.*Y(1))*Y(1)**2+
     &QG2/A
      X1=X2
      IF(X2.GT.X(1)) GO TO 11
      ENDIF
      FUN=X(3)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON/TRAS/ B,FM,FM2,TWOM,FNQ,QG2,SO,C,G,FL,YB,WS,X(3),DELX,NONE
     &,IOUT
      YY=ABS(Y(1))
      A=(B+FM*YY)*YY
      SF=(FNQ*((B+FM2*YY)/A)**.66666667/A)**2
      DY(1)=(SO-SF)/(1.-QG2*(B+TWOM*YY)/A**3)
      RETURN
      END