Program Manning_circular; 
Label L1,L2,L3; 
Const 
 UNK:array[1..5] of Char=('Q','n','S','Y','D'); 
 EX1:real=0.66666667;EX2:real=1.66666667;ERR:real=0.0001; 
Var 
 X: array[1..5] of Real; 
 P,A,F,F1,DIF,C,BETA,ARG,TM1,TM2,DD,SX,XX: Real; 
 I,IU,NCT: Integer; 
 IFT: Boolean; 
Function Expn(a,b:real):real; 
 Begin 
  If a>0 Then Expn:=exp(b*ln(a)) else if a=0 then Expn:=0 else if a<0 then 
     begin writeln('Bad Expn argument'); Expn:=0; End; 
 End; 
Procedure Parmar; 
  Begin 
   ARG:=1-2*X[4]/X[5];If abs(ARG)<0.01 Then BETA:=1.57079633 else 
   If ARG>0 Then BETA:=ArcTan(sqrt(1-ARG*ARG)/ARG) else 
   BETA:=3.14159265-ArcTan(sqrt(abs(1-ARG*ARG))/abs(ARG)); 
   TM1:=Expn(X[5]*BETA,EX1); 
   TM2:=C*Expn(0.25*X[5]*X[5]*(BETA-ARG*sin(BETA)),EX2); 
  End; 
Begin 
L3:GoToXY(1,23);ClrEol;Write('Is Prob. in: 1-SI or 2-ES units?(Give 1 or 2) '); 
   Readln(IU); If IU=1 Then C:=1 else C:=1.49; 
   GoToXY(1,23); Write('Give number of unknown'); ClrEol; 
   GoToXY(1,24); For I:=1 to 5 do Write(I,'-',UNK[I],', '); ClrEol; 
   Repeat Readln(IU) until IU in [1..5]; 
   ClrScr; GoToXY(1,5); Write('Give value to knowns'); 
   For I:=1 to 5 do If I <> IU Then 
    Begin 
     GoToXY(1,I+6); Write(UNK[I],' = '); Readln(X[I]); 
    End; 
{ Solving or initializing unknown} 
ClrScr; 
Case IU of 
 1: Begin Parmar; X[1]:=TM2*sqrt(X[3])/(TM1*X[2]); GoTo L1; End; 
 2: Begin Parmar; X[2]:=TM2*sqrt(X[3])/(TM1*X[1]); GoTo L1; End; 
 3: Begin Parmar; X[3]:=sqr(X[1]*X[2]*TM1/TM2); GoTo L1; End; 
 4: Begin X[4]:=0.005*X[5]; DD:=0.05*X[5];XX:=X[1]*X[2];SX:=sqrt(X[3]);Parmar; 
     F1:=XX*TM1-SX*TM2; 
     repeat 
       F:=F1; X[4]:=X[4]+DD; If X[4] > X[5] then X[4]:=X[5]; 
       Parmar;F1:=XX*TM1-SX*TM2; 
     until (F*F1 <= 0) or (X[4]=X[5]); 
     X[4]:=X[4]-DD/2; 
    End; 
 5: Begin X[5]:=1.01*X[4];DD:=0.05*X[4];XX:=X[1]*X[2];SX:=sqrt(X[3]); 
     Parmar; F1:=XX*TM1-SX*TM2; 
     repeat 
       F:=F1; X[5]:=X[5]+DD; 
       Parmar;F1:=XX*TM1-SX*TM2; 
     until F*F1 <= 0; 
     X[5]:=X[5]-DD/2; 
    End; 
End; 
{ Implements Newton method} 
NCT:=0; 
repeat 
  IFT:=true; 
L2:Parmar; 
   F:=XX*TM1-SX*TM2; 
   If IFT then Begin F1:=F; IFT:=false; X[IU]:=X[IU]-0.01; GoTo L2; End; 
   NCT:=NCT+1; 
   DIF:=0.01*F1/(F1-F); 
   X[IU]:=X[IU]+0.01-DIF; 
until (ABS(DIF)<ERR) or (NCT>15); 
If NCT>15 then Writeln('Did not converge - DIF= ',DIF); 
{ Writes out solution} 
L1: GoToXY(1,5); Writeln('Solution for ',UNK[IU],' = ',X[IU]); 
    GoToXY(1,8); Writeln('Problem variables'); 
    For I:=1 to 5 do Begin GoToXY(1,I+8); Writeln(UNK[I],' = ',X[I]); End; 
  GoToXY(1,23); Writeln('Do you want to solve another problem?(0no,1yes) '); 
  Readln(IU); ClrScr; 
  If IU = 1 Then GoTo L3; 
End. 

