C This program solves Example Problem 3 in Appendix as does PRESFOR.FOR but
C it call on the ODE solver RUKU4A that uses the Runge Kutta method.
C RUKU4A and the other Runge Kutta routines do not reduce the step size to
C satisfy an error requirement.  Therefore, this program call on SIMPR for
C a requested number of steps NSTEP to get the accuracy needed.
C This program is the variation of PRESFORR.FOR that has x time the depth
C so that the first moment of area is computed. 
      EXTERNAL EQUAT
      COMMON /TRAS/ H,YO,YBEF,X1,DX,II
      WRITE(*,*)' Give: X1,X2,H,YO,ERR,MAX,NSTEP'
      READ(*,*) X1,X2,H,YO,ERR,MAX,NSTEP
      AREA=0.
      YBEF=YO
      II=0
      DX=(X2-X1)/FLOAT(NSTEP)
      DO 1 I=1,NSTEP
      XE=X1+DX
      CALL SIMPR(EQUAT,X1,XE,VALUE,ERR,MAX)
      YBEF=YO
      II=1
      DUM=EQUAT(XE)
      II=0
      AREA=AREA+VALUE
1     X1=XE
      WRITE(*,"(' XcXArea=',F10.3,)") AREA 
      END
      FUNCTION EQUAT(X)
      COMMON /TRAS/ H,YO,YBEF,X1,DX,II
      Y=YBEF
      CALL RUKU4A(X,X-X1,Y)
      EQUAT=X*(H+0.7071068*X-Y)
      IF(II.EQ.1) YO=Y
      RETURN
      END
      FUNCTION SLOPE(X,Y)
      SLOPE=X+.5*Y
      RETURN
      END
