      PARAMETER (PI=3.14159265)
      REAL X(3)
      PI2=2.*PI
      PI4=4.*PI
1     WRITE(*,*)' Give: q,E,g'
      READ(*,*) q,E,g
      IF(q.LT.1.E-5) STOP
      Yc=(q*q/g)**.33333333
      Ec=1.5*Yc
      IF(E.LT.Ec) THEN
      WRITE(6,110) q,E,g,Yc,Ec
110   FORMAT(' q=',F8.3,' E=',F8.3,' g=',F8.2,/' Only 1 real root(neg.)'
     &,' Yc=',F8.3,' Ec=',F8.3)
      GO TO 1
      ENDIF
      E3=E/3.
      THETA=ACOS(((6.75*q*q/g-E**3)/27.)/E3**3)
      X(1)=E3*(1.-2.*COS(THETA/3.))
      X(2)=E3*(1.-2.*COS((THETA+PI2)/3.))
      X(3)=E3*(1.-2.*COS((THETA+PI4)/3.))
      WRITE(6,100) q,E,g,Yc,Ec,X
100   FORMAT(' q=',F8.3,' E=',F8.3,' g=',F8.2,/,' Yc=',F8.3,' Ec=',F8.3,
     &' Roots are:',/,3F9.3)
      GO TO 1
      END