#include <stdio.h>
#include <stdlib.h>
#include <math.h>
float b1,m1,b2,h,g2,kl1,ke1,l,tol,n,so,cu,qn,q2g,yd,ad,fms,fm2,dxs[1],x[3];
extern void solveq(int n,float **a,float *b,int itype,float *dd,int *indx);
extern void rukust(int neq,float *dxs,float xbeg,float xend,float error,float *y,float *ytt);
void fun(float *f){ float y[1],yw[1];
 qn=pow(n*x[0]/cu,2.);  q2g=x[0]*x[0]/g2;
 f[0]=h-x[1]-ke1*q2g/pow((b1+m1*x[1])*x[1],2.);
 f[1]=x[2]+q2g/pow((b1+m1*x[2])*x[2],2.)-yd-kl1*q2g/ad;
 y[0]=x[2];rukust(1,dxs,l,0.,tol,y,yw); f[2]=x[1]-y[0]; } //end fun
void slope(float xx,float *y, float *dy){ float area,sf;
 area=(b1+m1*y[0])*y[0]; sf=qn*pow(b1+fms*y[0],1.33333333)/pow(area,3.3333333);
 dy[0]=(so-sf)/(1.-.5*q2g*(b1+fm2*y[0])/pow(area,3.)); }// end slope
float ynorm(float q) {float qq,y,f,y1,dif;  int m;
 qq=cu*sqrt(so)/n; y=x[1]; m=0;
 do {f=q-qq*pow((b1+m1*y)*y,1.66666667)/pow(b1+fms*y,.66666667); y1=1.005*y;
  dif=(y1-y)*f/(q-qq*pow((b1+m1*y1)*y1,1.6666667)/pow(b1+fms*y1,.66666667)-f);
 y-=dif; }while ((fabs(dif)>.000001) && (++m<20)); if(m==20) printf("YNORM failed to converge\n");
 return y;}  // end ynorm
float ygate(float q){float y,qq,ed,f,y1,dif; int m;
 m=0; y=.9*x[2]; qq=q*q/g2; ed=kl1*qq/ad+yd;
 do {f=y+qq/pow(b2*y,2.)-ed;  y1=1.005*y; dif=(y1-y)*f/(y1+qq/pow(b2*y1,2.)-ed-f);
 y-=dif; } while ((fabs(dif)>.000001) && (++m<20));if(m==20) printf("YGATE failed to converge\n");
 return y;}  // end ygate
void qopen(float *yo, float *qo){float qq,area,f,y1,a,dif,yyo,qqo; int m;
 m=0; yyo=*yo; qq=cu*sqrt(so)/n;
 do {
  area=(b1+m1*yyo)*yyo;qqo=qq*pow(area,1.6666667)/pow(b1+fms*yyo,.6666667);
  f=h-yyo-ke1*pow(qqo/area,2.)/g2; y1=1.005*yyo;a=(b1+m1*y1)*y1;
  dif=(y1-yyo)*f/(h-y1-ke1*pow(qq*pow(a,1.6666667)/pow(b1+fms*y1,.6666667)/a,2.)/g2-f);
  yyo-=dif; }while ((fabs(dif)>.000001) && (++m<20));if(m==20) printf("OPEN failed to converge\n");
 qqo=qq*pow(area,1.6666667)/pow(b1+fms*yyo,.66666667); *yo=yyo;*qo=qqo; } // end qopen
void main(void){float yo[1],qo[1],*det,sum,xx,err,cc,yg1,dyg,g,yg,f1[3],f[3],**d;  int nn,kk,nct,j,i,indx[3]; FILE *fil;
d=(float**)malloc(3*sizeof(float*));for(i=0;i<3;i++)d[i]=(float*)malloc(3*sizeof(float));
dxs[0]=-1.; cu=1.486;
printf("Give: b1,m1,n,So,H,Ke,KL,g,L,b2,TOL,ERR,Cc,Yg1,dYg,nn\n");
scanf("%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %d",&b1,&m1,&n,&so,&h,&ke1,&kl1,&g,&l,&b2,&tol,&err,&cc,&yg1,&dyg,&nn);
fm2=2.*m1; fms=2.*sqrt(m1*m1+1.); if(g<30.) cu=1; g2=2.*g; kl1+=1.;ke1+=1.;
printf("Give guess for Q,Y1 & Y2\n"); scanf("%f %f %f",&x[0],&x[1],&x[2]);
yo[0]=.98*x[1];  qopen(yo,qo);
 if((fil=fopen("SOLGATE.OUT","w"))==NULL){printf("Can not open SOLGATE.OUT\n");exit(0);}
fprintf(fil," H=%7.1f, Ke=%6.3f, b1=%8.1f, m1=%7.2f, n=%8.4f,\n So=%9.6f, b2=%8.1f, KL=%6.3f, L=%8.0f\n",\
  h,ke1-1.,b1,m1,n,so,b2,kl1-1.,l);fprintf(fil," No gate-Uniform Flow: Yo=%8.3f, Qo=%8.2f\n",yo[0],qo[0]);
for(i=0;i<61;i++)fprintf(fil,"-"); fprintf(fil,"\n");
fprintf(fil,"    YG    Yd       Q      Y1      Y2      Yu      Yo      Yc\n");
for(i=0;i<61;i++)fprintf(fil,"-"); fprintf(fil,"\n");
for(kk=0;kk<nn;kk++){ yg=yg1+dyg*(float)kk; yd=cc*yg;ad=pow(b2*yd,2.); nct=0;
do {sum=0.; fun(f1); for(j=0;j<3;j++){xx=x[j];x[j]*=1.005; fun(f);
 for(i=0;i<3;i++) d[i][j]=(f[i]-f1[i])/(x[j]-xx); x[j]=xx;}
solveq(3,d,f1,1,det,indx);
for(i=0;i<3;i++){x[i]-=f1[i];sum+=fabs(f1[i]);}
} while((sum>err) && (++nct<20)); if(nct==20)printf("Did not converge %f\n",sum);
fprintf(fil,"%7.2f %6.2f %7.2f %7.3f %7.3f %7.3f %7.3f %7.3f\n",yg,yd,x[0],x[1],x[2],ygate(x[0]),ynorm(x[0]), \
pow(pow(x[0]/b2,2.)/g,.333333333));} fclose(fil);
}
