C Generates Jacobian by columns by calling subroutine FUN that supplies all eqs.
C Also calls on linear algebraic equation solver SOLVEQ
      INTEGER*2 INDX(3)
      REAL F(3),FF(3),D(3,3),X(3),KL2,KE1,KL,KE
      COMMON B1,FM1,B2,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B1,FM1,B2,H,L,g,KL,KE'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B1,FM1,B2,H,FL,G,KL,KE
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KL2=.5*KL+1.5
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Y1,Y2'
      READ(*,*) X
      NCT=0
1     CALL FUN(F)
      DO 12 J=1,3
      XX=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 10 I=1,3
10    D(I,J)=(FF(I)-F(I))/(X(J)-XX)
12    X(J)=XX
      CALL SOLVEQ(3,1,3,D,F,1,DET,INDX)
      SUM=0.
      DO 14 I=1,3
      X(I)=X(I)-F(I)
14    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,100) X
100   FORMAT(' Q =',F10.2,' Y1 =',F10.2,' Y2 =',F10.2)
      END
      SUBROUTINE FUN(F)
      EXTERNAL DYX
      REAL X(3),C(24),W(1,9),KL2,KE1,Y(1),F(3)
      COMMON B1,FM1,B2,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X
      Q2G=X(1)*X(1)/G2
      F(1)=X(3)+Q2G/((B1+FM1*X(3))*X(3))**2-KL2*((X(1)/B2)**2/G)
     &**.333333333
      F(2)=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      Y(1)=X(3)
      XX=FL
      XZ=0.
      IND=1
      QN=(FN*X(1)/CC)**2
      Q2G=X(1)*X(1)/G
      CALL DVERK(1,DYX,XX,Y,XZ,TOL,IND,C,1,W)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(N,XX,Y,YPRIME)
      REAL Y(N),YPRIME(N),KL2,KE1,X(3)
      COMMON B1,FM1,B2,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X
      P=B1+2.*SQRT(FM1*FM1+1.)*Y(1)
      A=(B1+FM1*Y(1))*Y(1)
      SF=QN*((P/A)**.666666667/A)**2
      T=B1+2.*FM1*Y(1)
      YPRIME(1)=(SO-SF)/(1.-Q2G*T/A**3)
      RETURN
      END