      EXTERNAL DYX
      REAL F(5),D(5,5),X(5)
      INTEGER*2 INDX(5)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON/TRAS/B,FM,FMS,FM2,SS,QS,G,Uqx,FL,FL1,TOL,FN,SO,CC,X,So2,WS,
     &IBC,INFLOW
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B,FM,L,L1,g,qs,Uq,Angle,BC(1=
     &Yc,2=WS or 3=Channel)'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B,FM,FL,FL1,G,QS,Uq,Angle,IBC
      IF(IBC.EQ.2) THEN
      WRITE(*,*)' Give upstream ws-elevation'
      READ(*,*) WS
      ENDIF
      IF(IBC.EQ.3) THEN
      WRITE(*,*)' Give slope of upstream channel'
      READ(*,*) So2
      So2=SQRT(So2)
      ENDIF
      Uqx=Uq*COS(.017455329*Angle)
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      SS=SQRT(SO)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      WRITE(*,*)' GIVE guess for: Q1,Q2,Y1,Y2,Yu'
      READ(*,*) X
      NCT=0
1     DO 10 I=1,5
      F(I)=FUN(I,DX,0)
      DO 10 J=1,5
      DX=.005*X(J)
10    D(I,J)=(FUN(I,DX,J)-F(I))/DX
      CALL SOLVEQ(5,1,5,D,F,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 20 I=1,5
      X(I)=X(I)-F(I)
20    DIF=DIF+ABS(F(I))
      WRITE(*,200) NCT,DIF,X
200   FORMAT(' NCT=',I2,' DIF=',E12.5,/,2F10.2,3F10.3)
      IF(NCT.LT.30 .AND. DIF.GT. ERR) GO TO 1
      WRITE(IOUT,100) X
100   FORMAT(' Q1 =',F10.2,' Q2 =',F10.2,' Y1 =',F10.2,' Y2 =',F10.2,
     &' Yu =',F10.2)
      END
      FUNCTION FUN(II,DX,J)
      EXTERNAL DYX
      REAL X(5),W(2,13),Y(1),DY(1),XP(2),YP(2,2)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON/TRAS/B,FM,FMS,FM2,SS,QS,G,Uqx,FL,FL1,TOL,FN,SO,CC,X,So2,WS,
     &IBC,INFLOW
      IF(J.GT.0) X(J)=X(J)+DX
      GO TO (1,2,3,4,5),II
1     FUN=X(1)+X(2)-FL*QS
      GO TO 10
2     IF(IBC.EQ.1) THEN
      FUN=X(1)**2*(B+FM2*X(5))-G*((B+FM*X(5))*X(5))**3
      ELSE IF(IBC.EQ.2) THEN
      FUN=WS-X(5)
      ELSE
      FUN=FN*X(1)*(B+FMS*X(5))**.666667-CC*((B+FM*X(5))*X(5))**1.666667
     &*So2
      ENDIF
      GO TO 10
3     FUN=FN*X(2)*(B+FMS*X(4))**.666667-CC*((B+FM*X(4))*X(4))**1.666667
     &*SS
      GO TO 10
4     Y(1)=X(5)
      IF(IBC.EQ.1) Y(1)=1.1*Y(1)
      INFLOW=0
      H1=.01
      HMIN=.00001
      XX=0.
      XZ=FL1
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(3)-Y(1)
      GO TO 10
5     Y(1)=X(3)
      INFLOW=1
      H1=.01
      XZ=FL
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(4)-Y(1)
10    IF(J.GT.0) X(J)=X(J)-DX
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(5)
      COMMON/TRAS/B,FM,FMS,FM2,SS,QS,G,Uqx,FL,FL1,TOL,FN,SO,CC,X,So2,WS,
     &IBC,INFLOW
      YY=ABS(Y(1))
      P=B+FMS*YY
      A=(B+FM*YY)*YY
      A2=A*A*G
      IF(INFLOW.EQ.1) THEN
      QSS=QS
      QQ=QS*XX-X(1)
      VD=QQ/A-Uqx
      ELSE
      QQ=-X(1)
      VD=0.
      QSS=0.
      ENDIF
      Q2=QQ*QQ
      SF=FN*QQ/CC*(P/A)**.666666667/A
      SF=SF*ABS(SF)
      DY(1)=(SO-SF-QSS*(QQ/A2+VD/(G*A)))/(1.-Q2*(B+FM2*YY)/(A*A2))
      RETURN
      END