      PARAMETER (N=3)
      EXTERNAL DYX
      REAL F(N),D(N,N),X(N),KL1,KE1,KL,KE,X1(N),W(2,13),XP(2),YP(2,2),
     *Y(1)
      CHARACTER*20 FNAME
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,B3,H,G,G2,KL1,KE1,FL,FL1,FLT,TOL,FN1,
     &FN2,SO1,SOT,SO2,CC,Uqx,X,X1,Y3,DB,DM,A3,Q2G,QE,QSS,FLE,IQT,IBC
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3))
      WRITE(*,*)' Give INPUT and OUTPUT unit numbers'
      READ(*,*) INPUT,IOUT
      IF(INPUT.NE.0 .AND. INPUT.NE.5) THEN
      WRITE(*,*)' Give name of INPUT file'
      READ(*,144) FNAME
      OPEN(INPUT,FILE=FNAME,STATUS='OLD')
      ENDIF
      IF(INPUT.EQ.0 .OR. INPUT.EQ.5) WRITE(*,*)' GIVE:TOL,ERR,FN1,SO1,B1
     &,FM1,FL1,FN2,SO2,B2,FM2,FL2,B3,FLT,SOT,H,QSS,G,KL,KE,Y3,Uq,ANGLE,I
     &QT,IBC'
      READ(INPUT,*) TOL,ERR,FN1,SO1,B1,FM1,FL1,FN2,SO2,B2,FM2,FL2,B3,
     &FLT,SOT,H,QSS,G,KL,KE,Y3,Uq,ANGLE,IQT,IBC
C IQT=1 outflow;IQT=2 seepage;IQT=3 bulk inflow
C IBC=1 dowsntream gate;IBC=2 critical flow;IBC=3 downstr. Reser.
      IF(IOUT.NE.6 .OR. IOUT.NE.0) THEN
      IF(INPUT.EQ.0.OR.INPUT.EQ.5)WRITE(*,*)' Give filename for output'
      READ(INPUT,144) FNAME
144   FORMAT(A20)
      OPEN(IOUT,FILE=FNAME,STATUS='NEW')
      ENDIF
      DB=(B2-B1)/FLT
      DM=(FM2-FM1)/FLT
      Uqx=Uq*COS(.17455329*ANGLE)
      FLE=FL1+FLT
      FL=FLE+FL2
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      A3=(Y3*B3)**2*G2
      KL1=1.+KL
      KE1=1.+KE
      IF(INPUT.EQ.0.OR.INPUT.EQ.5)WRITE(*,*)' GIVE guess for: Q,Y1,Y2'
      READ(INPUT,*) X
50    NCT=0
1     DO 10 I=1,N
      F(I)=FUN(I,DX,0)
      DO 10 J=1,N
      DX=.005*X(J)
10    D(I,J)=(FUN(I,DX,J)-F(I))/DX
      WRITE(*,505) X
505   FORMAT(' Unknowns',5F12.5)
      WRITE(*,510) F
510   FORMAT(' Equations ',5F12.5)
C   Solves system of equations using Gaussian Elimination
      DO 12 J=1,N-1
      DO 12 I=J+1,N
      FAC=D(I,J)/D(J,J)
      F(I)=F(I)-FAC*F(J)
      DO 12 K=J+1,N
12    D(I,K)=D(I,K)-FAC*D(J,K)
      F(N)=F(N)/D(N,N)
      X(N)=X(N)-F(N)
      SUM=ABS(F(N))
      DO 16 I=N-1,1,-1
      FAC=0.
      DO 14 J=I+1,N
14    FAC=FAC+D(I,J)*F(J)
      F(I)=(F(I)-FAC)/D(I,I)
      X(I)=X(I)-F(I)
16    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X,QE
110   FORMAT(' NCT=',I2,F12.2,4F10.4)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      QE=X(1)+QSS*FLT
      IF(IOUT.NE.0.AND.IOUT.NE.6) WRITE(*,100) X,QE
      WRITE(IOUT,100) X,QE
100   FORMAT(' Q =',F10.2,' Y1 =',F10.2,' Y2 =',F10.2,' QE =',F10.2)
      IF(INPUT.EQ.0.OR.INPUT.EQ.5) WRITE(*,*)' Give Del x for sol. of x 
     &Y values'
      READ(INPUT,*) DELX
      IF(DELX.LT. .01) GO TO 150
      H1=-.01
      HMIN=.00001
      XX=FL
      Y(1)=X(3)
      WRITE(IOUT,120) XX,Y(1)
120   FORMAT(2F10.4)
      IF(IOUT.NE.0.AND.IOUT.NE.6) WRITE(*,120) XX,Y(1)
 18   IF(XX.LE.FLE+.1 .AND. XX.GT.FL1) THEN
      XZ=XX-.1*DELX
      ELSE
      XZ=XX-DELX
      ENDIF
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      WRITE(IOUT,120) XZ,Y(1)
      IF(IOUT.NE.0.AND.IOUT.NE.6) WRITE(*,120) XZ,Y(1)
      XX=XZ
      IF(XX.GT. .01) GO TO 18
150   IF(IOUT.NE.0.AND.IOUT.NE.6) CLOSE(IOUT)
      IF(INPUT.NE.0.AND.INPUT.NE.5) CLOSE(INPUT)
      END
      FUNCTION FUN(II,DX,J)
      EXTERNAL DYX
      REAL X(3),X1(3),W(1,13),KL1,KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,B3,H,G,G2,KL1,KE1,FL,FL1,FLT,TOL,FN1,
     &FN2,SO1,SOT,SO2,CC,Uqx,X1,X,Y3,DB,DM,A3,Q2G,QE,QSS,FLE,IQT,IBC
      H1=-.05
      HMIN=.001
      DO 10 I=1,3
10    X(I)=X1(I)
      IF(J.GT.0) X(J)=X(J)+DX
      Q2G=X(1)*X(1)/G2
      QE=X(1)+FLT*QSS
      GO TO (1,2,3),II
1     FUN=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      RETURN
2     Y(1)=X(3)
      CALL ODESOL(Y,DY,1,FL,FLE,TOL,H1,HMIN,1,XP,YP,W,DYX)
      H1=-.05
      DXX=(FLE-FL1)/10.
      XX=FLE
      DO 5 I=1,10
      XZ=XX-DXX
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
5     XX=XZ
      H1=-.05
      CALL ODESOL(Y,DY,1,FL1,0.,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X1(2)-Y(1)
      RETURN
3     IF(IBC.EQ.1) THEN
      FUN=X(3)+(QE/((B2+FM2*X(3))*X(3)))**2/G2-Y3-KL1*QE*QE/A3
      ELSE IF(IBC.EQ.2) THEN
      FUN=X(3)+(QE/((B2+FM2*X(3))*X(3)))**2/G2-(1.+KL1/2.)*((QE/B3)**2/G
     &)**.333333333
      ELSE
      FUN=X(3)-Y3
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KL1,KE1,X(3),X1(3)
      COMMON /TRAS/B1,FM1,B2,FM2,B3,H,G,G2,KL1,KE1,FL,FL1,FLT,TOL,FN1,
     &FN2,SO1,SOT,SO2,CC,Uqx,X1,X,Y3,DB,DM,A3,Q2G,QE,QSS,FLE,IQT,IBC
      YY=ABS(Y(1))
      IF(XX.GT.FLE) THEN
      SO=SO2
      FN=FN2
      EXTERM=0.
      QQ=QE
      BB=B2
      FM=FM2
      ELSE IF(XX.GT.FL1) THEN
      SO=SOT
      FN=.5*(FN1+FN2)
      QQ=X(1)+QSS*(XX-FL1)
      EXTERM=(DB+DM*YY)*YY
      BB=B1+DB*(XX-FL1)
      FM=FM1+DM*(XX-FL1)
      ELSE
      EXTERM=0.
      QQ=X(1)
      SO=SO1
      FN=FN1
      BB=B1
      FM=FM1
      ENDIF
      P=BB+2.*SQRT(FM*FM+1.)*YY
      A=(BB+FM*YY)*YY
      A2=A*A*G
      IF(ABS(EXTERM).GT.0.) THEN
      IF(IQT.EQ.3) THEN
      HADX=EXTERM*(.5*BB+FM*YY/3.)*(YY/A)**2
      ENDIF
      EXTERM=EXTERM*QQ*QQ/(A*A2)-QQ*QSS/A2
      IF(IQT.EQ.2) EXTERM=EXTERM-QQ*QSS/(2.*A*A2)
      IF(IQT.EQ.3) EXTERM=EXTERM-(QQ/A-Uqx)*QSS/(G*A)-HADX
      ENDIF
      SF=((FN*QQ/CC)*(P/A)**.666666667/A)**2
      DY(1)=(SO-SF+EXTERM)/(1.-(QQ/A)*QQ/A2*(BB+2.*FM*YY))
      RETURN
      END