#include <stdio.h>
#include <stdlib.h>
#include <math.h>
const int N=7;
void dcompos(float a[N][N],int n,int indx[N],float &d)
{int i,imax,j,k;
float aamax,dum,sum,temp;
float vv[N];
 d=1.0;
 for(i=0;i<n;i++) {aamax=0.0;
  for(j=0;j<n;j++) if ((temp=fabs(a[i][j])) > aamax) aamax=temp;
  if (aamax == 0.0) printf("Singular matrix in routine DCOMPOS\n");vv[i]=1.0/aamax;}
 for(j=0;j<n;j++) {for(i=0;i<j;i++) {sum=a[i][j];
  for(k=0;k<i;k++) sum -= a[i][k]*a[k][j];a[i][j]=sum;}
 aamax=0.0;
 for(i=j;i<n;i++) {sum=a[i][j];for(k=0;k<j;k++)sum -= a[i][k]*a[k][j];
  a[i][j]=sum;if ( (dum=vv[i]*fabs(sum)) >= aamax) {aamax=dum;imax=i;}}
  if (j != imax) {for(k=0;k<n;k++) {dum=a[imax][k];a[imax][k]=a[j][k];
    a[j][k]=dum;}
  d = -(d);vv[imax]=vv[j];}
  indx[j]=imax;
  if (a[j][j] == 0.0) a[j][j]=1.e-20;
  if (j != n) {dum=1.0/(a[j][j]);for(i=j+1;i<n;i++) a[i][j] *= dum;}} free(vv);
}
void finsol(float a[N][N],int n,int indx[N],float b[N])
 {int i,ii,ip,j;  float sum;  ii=-1;
for(i=0;i<n;i++) {ip=indx[i];sum=b[ip];b[ip]=b[i];
if (ii != -1){for(j=ii;j<i;j++) sum -= a[i][j]*b[j];} else if (sum!=0.) ii=i;
 b[i]=sum;}
for(i=n-1;i>=0;i--) {sum=b[i];if(i<(n-1)){for(j=i+1;j<n;j++) sum -= a[i][j]*b[j];}
  b[i]=sum/a[i][i];}
}
void solveq(int n,float a[N][N],float b[N],int itype,float &dd,int indx[N]){
int detrm=0,eqsol=0,invsol=0,i,j;
if((itype==3)||(itype>4)) detrm=1;
if((itype==1)||(itype==4)||(itype==6)) eqsol=1;
if((itype==2)||(itype>3)) invsol=1;
dcompos(a,n,indx,dd);
if(detrm) for(i=0;i<n;i++) dd*=a[i][i];
if(eqsol) finsol(a,n,indx,b);
if(invsol){float bb[N],aa[N][N];
for(j=0;j<n;j++){ for(i=0;i<n;i++) bb[i]=0.;bb[j]=1.;finsol(a,n,indx,bb);
 for(i=0;i<n;i++) aa[i][j]=bb[i]; }
for(j=0;j<n;j++) for(i=0;i<n;i++) a[i][j]=aa[i][j]; } return;
}