      SUBROUTINE SOLVEQ(N,M,NP,A,B,ITYPE,DET,INDX)
      REAL A(NP,NP),B(NP),AA[ALLOCATABLE](:,:),BB[ALLOCATABLE](:)
      INTEGER*2 INDX(NP)
      LOGICAL DETRM,EQSOL,INVSOL,BVEC
      DETRM=.FALSE.
      EQSOL=.FALSE.
      INVSOL=.FALSE.
      BVEC=.FALSE.
C      DATA DETRM,EQSOL,INVSOL/.FALSE.,FALSE.,FALSE./,BVEC/.FALSE./
      IF(ITYPE.EQ.3 .OR. ITYPE.GT.4) DETRM=.TRUE.
      IF(ITYPE.EQ.1 .OR. ITYPE.EQ.4 .OR. ITYPE.EQ.6) EQSOL=.TRUE.
      IF(ITYPE.EQ.2 .OR. ITYPE.GT.3) INVSOL=.TRUE.
      IF(M.GT.0) BVEC=.TRUE.
      CALL DCOMPOS(A,N,NP,INDX,DET)
      IF(DETRM) THEN
      DO 40 I=1,N
40    DET=DET*A(I,I)
      ENDIF
      IF(EQSOL) CALL FINSOL(A,N,NP,INDX,B)
      IF(.NOT.INVSOL) RETURN
      IF(EQSOL) THEN
      ALLOCATE(BB(N))
      DO 43 I=1,N
43    BB(I)=B(I)
      ENDIF
      ALLOCATE(AA(N,N))
      DO 51 J=1,N
      DO 50 I=1,N
50    B(I)=0.
      B(J)=1.
      CALL FINSOL(A,N,NP,INDX,B)
      DO 51 I=1,N
51    AA(I,J)=B(I)
      DO 63 J=1,N
      DO 63 I=1,N
63    A(I,J)=AA(I,J)
      DEALLOCATE(AA)
      IF(EQSOL) THEN
      DO 65 I=1,N
65    B(I)=BB(I)
      DEALLOCATE(BB)
      ENDIF
      RETURN
      END
      SUBROUTINE DCOMPOS(A,N,NP,INDX,DET)
      DIMENSION A(NP,NP),VEC[ALLOCATABLE](:)
      INTEGER*2 INDX(NP)
      ALLOCATE(VEC(N))
      DET=1.
      DO 20 I=1,N
      AMAX=0.
      DO 10 J=1,N
      IF(ABS(A(I,J)).GT.AMAX) AMAX=ABS(A(I,J))
10    CONTINUE
      IF(AMAX.EQ.0.) STOP 'Singular matrix.'
20    VEC(I)=1./AMAX
      DO 65 J=1,N
      IF(J.EQ.1) GO TO 32
      DO 30 I=1,J-1
      TOL=A(I,J)
      DO 25 K=1,I-1
25    TOL=TOL-A(I,K)*A(K,J)
      A(I,J)=TOL
30    CONTINUE
32    AMAX=0.
      DO 45 I=J,N
      TOL=A(I,J)
      IF(J.EQ.1) GO TO 40
      DO 35 K=1,J-1
35    TOL=TOL-A(I,K)*A(K,J)
      A(I,J)=TOL
40    TEMP=VEC(I)*ABS(TOL)
      IF(TEMP.LT.AMAX) GO TO 45
      MAX=I
      AMAX=TEMP
45    CONTINUE
      IF(J.EQ.MAX) GO TO 55
      DO 50 K=1,N
      TEMP=A(MAX,K)
      A(MAX,K)=A(J,K)
50    A(J,K)=TEMP
      DET=-DET
      VEC(MAX)=VEC(J)
55    INDX(J)=MAX
      IF(J.EQ.N) GO TO 65
      IF(A(J,J).EQ.0.) A(J,J)=1.E-10
      TEMP=1./A(J,J)
      DO 60 I=J+1,N
60    A(I,J)=A(I,J)*TEMP
65    CONTINUE
      IF(A(N,N).EQ.0.) A(N,N)=1.E-10
      DEALLOCATE(VEC)
      RETURN
      END
      SUBROUTINE FINSOL(A,N,NP,INDX,B)
      DIMENSION A(NP,NP),B(NP)
      INTEGER*2 INDX(NP)
      II=0
      DO 20 I=1,N
      LL=INDX(I)
      TOL=B(LL)
      B(LL)=B(I)
      IF (II.NE.0)THEN
      DO 10 J=II,I-1
10    TOL=TOL-A(I,J)*B(J)
      ELSE IF(TOL.NE.0.) THEN
      II=I
      ENDIF
20    B(I)=TOL
      DO 40 I=N,1,-1
      TOL=B(I)
      IF(I.EQ.N) GO TO 40
      DO 30 J=I+1,N
30    TOL=TOL-A(I,J)*B(J)
40    B(I)=TOL/A(I,I)
      RETURN
      END
