#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "odesolc.h"
float v[5][10],yg[10],bg[10],b[11],fm[11],fn[11],fl[11],so[11],h,fke,tol,qn;
float soc,bc,fmc,fms,fm2,q2g,y1,ye,g,g2,q,cu;
int ngate,ibce,neq,nc;
extern void solveq(int n,float **a,float *b,int itype,float dd,int *indx);
 char fnam[20];
 FILE *fili,*filo;
 void slope(float x,float *y,float *dy){ float p,a,sf;
 p=bc+fms*y[0]; a=(bc+fmc*y[0])*y[0]; sf=qn*pow(pow(p/a,.6666667)/a,2.);
 dy[0]=(soc-sf)/(1.-2.*q2g*(bc+fm2*y[0])/pow(a,3.));
} // End of slope
void funct(float *fe) { int i,j,ig;float h11,qs1,qmg,y2,hmin=.005,h1=-.1,y[1];
 fe[0]=h-y1-fke*q2g/pow((b[0]+fm[0]*y1)*y1,2.);
 for(i=0;i<ngate;i++){j=i+1; ig=5*i;
 bc=b[i]; fmc=fm[i]; fm2=2.*fm[i]; fms=2.*sqrt(fm[i]*fm[i]+1.);soc=so[i];
 qs1=q2g/(bg[i]*bg[i]); qmg=2.*qs1; qn=pow(fn[i]*q/cu,2.);
 y2=(.59+.022*yg[i]/v[3][i])*yg[i]; h11=v[3][i]+qs1/(v[3][i]*v[3][i]);
 fe[ig+1]=v[4][i]+q2g/pow((bc+fmc*v[4][i])*v[4][i],2.)-h11;
 fe[ig+2]=h11-v[2][i]-qs1/(y2*y2);
 fe[ig+3]=.5*(v[2][i]*v[2][i]-v[1][i]*v[1][i])+qmg/y2-qmg/v[1][i];
 fe[ig+4]=v[1][i]+qs1/(v[1][i]*v[1][i])-v[0][i]-q2g/pow((b[j]+fm[j]*v[0][i])*v[0][i],2.);
 y[0]=v[4][i];
 odesolc(y,fl[i],0.,tol,h1,hmin,1);
 if(i==0) fe[ig+5]=y1-y[0]; else fe[ig+5]=v[0][i-1]-y[0]; }
 if(ibce==1) { ig+=6;
 fe[ig]=fn[ngate]*q*pow(b[ngate]+2.*v[0][ngate-1]*sqrt(fm[ngate]*fm[ngate]+1.),.66666667)
 -cu*pow((b[ngate]+fm[ngate]*v[0][ngate-1])*v[0][ngate-1],1.666667)*sqrt(so[ngate]);}
 else {y[0]=ye;if(ibce==3) fe[neq-2]=.5*q2g*(b[ngate]+2.*fm[ngate]*ye)-g*pow((b[ngate]+fm[ngate]*ye)*ye,3.);
 bc=b[ngate]; fmc=fm[ngate]; fm2=2.*fm[ngate]; fms=2.*sqrt(fm[ngate]*fm[ngate]+1.);
 soc=so[ngate]; qn=pow(fn[ngate]*q/cu,2.);
 odesolc(y,fl[ngate],0.,tol,h1,hmin,1);
 fe[neq-1]=v[0][ngate-1]-y[0];}
} // End of funct
void main(void){
 float ff[57],f[57],**dj;
 int indx[57],i,j,k,ij,nct;
 float xx,sum,wt,dd;
 printf("Give name of file that contains input data\n");scanf("%s",fnam);
 if((fili=fopen(fnam,"r"))==NULL){printf("File does not exist.\n");exit(0);}
 printf("Give name of output file\n"); scanf("%s",fnam);
 if((filo=fopen(fnam,"w"))==NULL){printf("File cannot be opened\n");exit(0);}
 fscanf(fili,"%d %d %f %f %f %f %f %f %f",&ngate,&ibce,&g,&q,&h,&fke,&y1,&ye,&tol);
 nc=ngate+1;
// Each gate v(0,i)=yd, v(1,i)=y3, v(2,i)=y, v(3,i)=y1, v(4,i)=yu;
//ibce=1 (long downstream channel so ye is uniform depth & v(0,ngate)=ye;
//ibce=2 (downstream reservoir with w.s. elevation = ye (specified));
//ibce=3 (critical depth at end of channel nc, ye = critical depth);
 for(i=0;i<ngate;i++) fscanf(fili,"%f %f",&yg[i],&bg[i]);
 for(i=0;i<nc;i++) fscanf(fili,"%f %f %f %f %f",&b[i],&fm[i],&fn[i],&fl[i],&so[i]);
// Guesses for depth y1,y,y3 for each gate;
 for(i=0;i<ngate;i++){fscanf(fili,"%f %f %f",&v[3][i],&v[2][i],&v[1][i]);
 v[4][i]=1.005*v[3][i]; v[0][i]=1.005*v[1][i];}
 if(g<25.) cu=1;  else cu=1.486;  g2=2.*g; q2g=q*q/g2; fke=1.+fke;
 neq=5*ngate+2;
 if(ibce==3) neq=neq+1; nct=0; wt=.2;
dj=(float**)malloc(neq*sizeof(float*));for(i=0;i<neq;i++)dj[i]=(float*)malloc(neq*sizeof(float));
do{ sum=0.; funct(f);
 for(i=0;i<ngate;i++) {for(j=0;j<5;j++){ij=5*i+j;
 xx=v[j][i]; v[j][i]*=1.005; funct(ff);
  for(k=0;k<neq;k++) dj[k][ij]=(ff[k]-f[k])/(v[j][i]-xx); v[j][i]=xx;} }
 ij++;xx=y1;y1*=1.005; funct(ff); for(k=0;k<neq;k++) dj[k][ij]=(ff[k]-f[k])/(y1-xx);y1=xx;
 ij++;xx=q;q*=1.005;q2g=q*q/g2; funct(ff);
  for(k=0;k<neq;k++) dj[k][ij]=(ff[k]-f[k])/(q-xx); q=xx; q2g=q*q/g2;
 if(ibce>2){ xx=ye;ye*=1.005; funct(ff);
   for(k=0;k<neq;k++) dj[k][neq-1]=(ff[k]-f[k])/(ye-xx); ye=xx;}
 solveq(neq,dj,f,1,dd,indx);
 for(i=0;i<ngate;i++) for(j=0;j<5;j++){ ij=5*i+j;
  v[j][i]-=wt*f[ij]; sum+=fabs(f[ij]);}
 y1-=wt*f[++ij]; sum+=fabs(f[ij]);
 q-=wt*f[++ij]; q2g=q*q/g2; sum+=fabs(f[ij]);
 if(ibce==3){ ye-=f[neq]; sum+=fabs(f[neq]);}
 nct++; if(sum<5.) wt=1.;
 printf("NCT=%4d SUM= %12.3f\n",nct,sum);for(i=0;i<ngate;i++){
   for(j=0;j<5;j++)printf("%8.3f",v[j][i]);printf("\n");} printf("%8.3f %7.3f %7.3f\n",y1,q,ye);
 if(wt<1.) {printf(" Current weight factor=%6.1f  Give new one\n",wt);scanf("%f",&wt);}
} while((nct<40) && (sum> 1.e-4));
 for(i=0;i<ngate;i++){for(j=0;j<5;j++) fprintf(filo,"%8.3f",v[j][i]);fprintf(filo,"\n");}
 fprintf(filo,"Y1=%8.3f Q=%10.3f Ye%8.3f\n",y1,q,ye); free(dj);fclose(fili);fclose(filo);
}
