      LOGICAL*2 ISTEAD
      INTEGER*2 INDX(6)
      REAL F(6),F1(6),D(6,6)
      COMMON g,G2,qo,qd,T,dqdt,Xs,Ys,Vs,X(6),VO2C,ISTEAD
      EQUIVALENCE (Y2,X(1)),(V2,X(2)),(v,X(3)),(Yo,X(4)),(Vo,X(5)),
     &(Yd,X(6))
      WRITE(*,*) ' Give: Yo,Vo,Yd,IOUT,NT,DELT,dqdt,g'
      READ(*,*) Yo,Vo,Yd,IOUT,NT,DELT,dqdt,g
      ISTEAD=.TRUE.
      Ys=Yo
      Vs=Vo
      Qs=Ys*ABS(Vs)
      G2=2.*g
      Xso=0.
      Y2=1.2*Yo
      V2=.55*Vo
      v=1.8*Vo
      NCT=0
5     CALL FUNCT(F1)
      DO 20 J=1,3
      X1=X(J)
      X(J)=1.005*X1
      CALL FUNCT(F)
      DO 10 I=1,3
10    D(I,J)=(F(I)-F1(I))/(X(J)-X1)
20    X(J)=X1
      CALL SOLVEQ(3,1,6,D,F1,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 30 J=1,3
      X(J)=X(J)-F1(J)
30    DIF=DIF+ABS(F1(J))
      IF(NCT.LT.20 .AND. DIF.GT.1.E-5) GO TO 5
      WRITE(IOUT,100) (X(I),I=1,4),Vs,Yd
100   FORMAT(' Steady Solution: Y2=',F8.3,' V2=',F8.3,' v=',F8.3,/,
     &' Yo=',F8.3,' Vo=',F8.3,' Yd=',F8.3)
      VO2C=-X(2)-2.*SQRT(G*X(1))
      ISTEAD=.FALSE.
      V2=-V2
      Vo=V2
      qo=Vo*X(1)
      Yo=Y2
      WRITE(IOUT,110)
110   FORMAT(1X,69('-'),/,'  t    Y2     V2    v     Yo     Vo    Yd   '
     &,'  x  v(Y2-4) qo-VoYo  av.Y'/,1X,69('-'))
      DQ1=X(3)*(X(1)-Ys)
      DQ2=Qs-X(1)*ABS(X(2))
      DQ3=Qs-.5*(X(1)*ABS(X(2))+X(4)*ABS(X(5)))
      WRITE(IOUT,120) 0,X,Xso,DQ1,DQ2,DQ3
      DO 80 K=1,NT
      NCT=0
      T=DELT*FLOAT(K)
      qd=qo+ABS(dqdt)*T
      v1=v
      Xs=Xso+DELT*v
40    CALL FUNCT(F1)
      DO 60 J=1,6
      X1=X(J)
      X(J)=1.005*X1
      CALL FUNCT(F)
      DO 50 I=1,6
50    D(I,J)=(F(I)-F1(I))/(X(J)-X1)
60    X(J)=X1
      CALL SOLVEQ(6,1,6,D,F1,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 70 J=1,6
      X(J)=X(J)-F1(J)
70    DIF=DIF+ABS(F1(J))
      WRITE(*,*)' NCT',NCT,DIF
      IF(NCT.LT.20 .AND. DIF.GT.1.E-5) GO TO 40
      DQ1=X(3)*(X(1)-Ys)
      DQ2=Qs-X(1)*ABS(X(2))
      DQ3=Qs-.5*(X(1)*ABS(X(2))+X(4)*ABS(X(5)))
      Xso=Xso+DELT*v
80    WRITE(IOUT,120) IFIX(T),X,Xs,DQ1,DQ2,DQ3
120   FORMAT(I4,F6.3,F7.3,2F6.3,F7.3,F5.3,F7.1,3F7.3)
      END
      SUBROUTINE FUNCT(F)
      REAL F(6)
      LOGICAL*2 ISTEAD
      COMMON g,G2,qo,qd,T,dqdt,Xs,Ys,Vs,X(6),VO2C,ISTEAD
      F(1)=(ABS(X(2))+X(3))*X(1)-(ABS(Vs)+X(3))*Ys
      F(2)=.5*(X(1)/Ys)*(X(1)/Ys+1.)-(ABS(Vs)+X(3))**2/(g*Ys)
      IF(ISTEAD) THEN
      F(3)=X(1)+X(2)**2/G2-X(6)-((X(1)*X(2))/X(6))**2/G2
      ELSE
      F(3)=X(2)-X(5)+2.*(SQRT(g*X(4))-SQRT(g*X(1)))
      F(4)=T-ABS(X(1)*X(2)-qo)/ABS(dqdt)-Xs/(3.*SQRT(g*X(1))+VO2C)
      F(5)=X(4)*X(5)-qd
      F(6)=X(4)+X(5)**2/G2-X(6)-(qd/X(6))**2/G2
      ENDIF
      RETURN
      END