#include <stdlib.h>
#include <stdio.h>
#include <math.h>
float h,fke,yd,ad,g,g2,fl,b,fm,so,tol,h11,hmin,cun,fms,fm2,q,a1,v1,hca1,ye,dist;
int k;
FILE *fil1,*fil2; char fnam[20];
#include "odesol.h"
extern void solveq(int n,float **a,float *b,int itype,float *dd,int *indx);
void fun1(float *f,float *x){float a,y[1];
 a=(b+fm*x[2])*x[2]; f[0]=x[2]+pow(x[0]/a,2.)/g2-yd-x[0]*x[0]/ad;
 f[1]=h-x[1]-pow(x[0]/((b+fm*x[1])*x[1]),2.)/g2; y[0]=x[2];
 odesolc(y,fl,0.,tol,h11,hmin);
 f[2]=x[1]-y[0];} // End fun1
void fun2(float *f,float *x){float a,ae,y[1];
 a=(b+fm*x[1])*x[1]; f[0]=(x[0]+v1)*a1-(x[0]+x[3]/a)*a;
 f[1]=hca1+pow(x[0]+v1,2.)*a1/g-(.5*b+fm*x[1]/3.)*pow(x[1],2.)-pow(x[0]+x[3]/a,2.)*a/g;
 ae=(b+fm*x[2])*x[2]; f[2]=x[2]+pow(x[3]/ae,2.)/g2-yd-pow(x[3],2.)/ad;
 if(k==1) f[3]=x[2]-ye; else {y[0]=x[2];
 odesolc(y,fl,dist,tol,h11,hmin);
  f[3]=x[1]-y[0];} } // End fun2
void slope(float x,float *y,float *dydx){float a,sf;
 a=(b+fm*y[0])*y[0];
  sf=pow(q*cun*pow((b+fms*y[0])/a,.66666667)/a,2.);
 dydx[0]=(so-sf)/(1.-q*q*(b+fm2*y[0])/(g*pow(a,3.)));
  return;} // End slope
void main(void){ int i,j,jj,nt,nct,m,indx[4];
 float cu,cc,yg,fn,ad1,sum,xx,q1,dl,xx1,fac,dt,y1,*dd,yo[15],ystor[16],y[1];
 float x[4],f[4],f1[4],**d;  h11=-.5;hmin=1.e-5;tol=1.e-5;
 printf("For initial condition give: g,H,Ke,Cc,Yg,L,n,b,m,So, Guess for Q,Yb,Ye\n");
 scanf("%f %f %f %f %f %f %f %f %f %f %f %f %f",&g,&h,&fke,&cc,&yg,&fl,&fn,&b,&fm,&so,&q,&x[1],&x[2]);
 fke+=1.;x[0]=q; fms=2.*sqrt(fm*fm+1.); fm2=2.*fm; yd=cc*yg; g2=2.*g;ad=pow((b+fm*yd)*yd,2.)*g2; ad1=ad;
 cu=1.486; if(g<20.) cu=1.; cun=fn/cu;
// q=x[0]; yb (upstream)=x[1]; ye (downstream)=x[2]
 nct=0;
d=(float**)malloc(3*sizeof(float*));for(i=0;i<3;i++)d[i]=(float*)malloc(3*sizeof(float));
printf("Give output filenam1\n");scanf("%s",fnam);
if((fil1=fopen(fnam,"w"))==NULL){printf("Cannot open output file\n");exit(0);}
L10: sum=0.; fun1(f,x);
for(i=0;i<3;i++){ xx=x[i]; x[i]*=1.005;
 fun1(f1,x);
  for(j=0;j<3;j++)
   d[j][i]=(f1[j]-f[j])/(x[i]-xx);
    x[i]=xx;}
 solveq(3,d,f,1,dd,indx);
 for(i=0;i<3;i++){x[i]-=f[i];sum+=fabs(f[i]);}
 if((sum>5.e-5)&&(++nct<20)) goto L10;
 printf("Steady-State Q=%8.1f,  Y1=%8.3f, Ye=%8.3f\n",x[0],x[1],x[2]);
 fprintf(fil1,"Steady-State Q=%8.1f,  Y1=%8.3f, Ye=%8.3f\n",x[0],x[1],x[2]);
 for(i=0;i<3;i++) free (*d);
d=(float**)malloc(4*sizeof(float*));for(i=0;i<4;i++)d[i]=(float*)malloc(4*sizeof(float));
 ye=x[2];y[0]=x[2];yo[14]=x[2]; q1=x[0];dl=fl/14.;xx=fl;
 for(i=13;i>=0;i--){xx1=xx-dl; odesolc(y,xx,xx1,tol,h11,hmin); xx=xx1;yo[i]=y[0];}
 for(i=14;i>6;i--)fprintf(fil1,"%8.0f %8.3f",dl*(float)i,yo[i]);fprintf(fil1,"\n");
 for(i=6;i>=0;i--)fprintf(fil1,"%8.0f %8.3f",dl*(float)i,yo[i]);fprintf(fil1,"\n");
 printf("Give: No. time steps, Dt,New Yg\n");scanf("%d %f %f",&nt,&dt,&yg);
printf("Give output filenam2\n");scanf("%s",fnam);
if((fil2=fopen(fnam,"w"))==NULL){printf("Cannot open output file\n");exit(0);}
// v=x[0];y2=x[1];ye=x[2];q2=x[3]
 yd=cc*yg; ad=pow((b+fm*yd)*yd,2.)*g2; x[3]=q1*sqrt(ad/ad1);x[2]=1.2*yo[14];
 x[1]=.95*x[2];x[0]=1.2*sqrt(g*(b+fm*x[2])*x[2]/(b+fm2*x[2])); dist=fl-.1; h11=-.5;
for(k=1;k<=nt;k++){
 m=(int)(dist/dl)+1;
  if(m<1) y1=yo[0]; else {fac=(dist-(float)(m-1)*dl)/dl;y1=yo[m-1]+fac*(yo[m]-yo[m-1]);}
 a1=(b+fm*y1)*y1; hca1=(.5*b+fm*y1/3.)*y1*y1; v1=q1/a1; if(k==1) dist=fl;nct=0;
L20:sum=0.; q=x[3]; if(k==1) ye=x[2]; fun2(f,x);
 for(i=0;i<4;i++){xx=x[i];x[i]*=1.005;fun2(f1,x);for(j=0;j<4;j++)d[j][i]=(f1[j]-f[j])/(x[i]-xx);x[i]=xx;}
 solveq(4,d,f,1,dd,indx); for(i=0;i<4;i++){x[i]-=f[i];sum+=fabs(f[i]);}
 printf("%d %f\n",++nct,sum); if((sum>1.e-5)&&(nct<20)) goto L20;
 fprintf(fil1,"%7d %7.1f ",(int)(dt*(float)(k-1)),dist);for(j=0;j<3;j++)fprintf(fil1,"%7.3f",x[j]);
  fprintf(fil1,"%8.2f",x[3]);fprintf(fil1,"%8.3f %7.3f\n",y1,v1);
 if(k>1) { y[0]=x[2];xx=fl; j=0;
L30:xx1=xx-dl; if(xx1<dist) xx1=dist;
  odesolc(y,xx,xx1,tol,h11,hmin);ystor[j++]=y[0];xx=xx1;if(xx1>dist)goto L30;jj=j-1;if(jj>7)jj=7;
 fprintf(fil2,"%6d",(int)(dt*(float)(k-1)));for(i=0;i<=jj;i++)fprintf(fil2,"%8.0f %7.3f",dl*(float)(14-i),ystor[i]);
 fprintf(fil2,"\n");if(j>7)for(i=8;i<j;i++)fprintf(fil2,"%8.0f %7.3f",dl*(float)(14-i),ystor[i]);fprintf(fil2,"\n");}
 dist-=dt*x[0]; if(dist<0.) goto L50;} // end for(k
L50:  for(i=0;i<4;i++) free(*d); fclose(fil1);fclose(fil2); exit(0);
}